//******************************************************************************
//
// Unknown Enemy
// Cinematic - Extro 1B
//
// Created by: Alex Barnfield  <alex@crius.net>
// Modified by: Jakub Majewski <qmajewski@yahoo.co.uk>
//
// Last modified: Aug 3, 2002
//
//******************************************************************************

mission extro1b;


#sector: "t.sec";
#name: 22;

#SetOutputPath("$wcue$\mission\");

#SetRooms ("cic.rom", "rec.rom");

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, UE, comms;
#include block1130;
#include block1131;

#strings spacefli;
#strings targetid;
#strings objectiv;

#SetOutputPath("$wcue$\language\pilots\");
#file "strings\pilots\srs31.pas";

#SetOutputPath("$wcue$\comms\");
#file "comms\srs31.pas";

#SetOutputPath("$wcue$\mission\");

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);

var
  x, y, z,
  m_Event,
  m_Event2,
  finalapproach = 0;

const
  EVENT_Components_Destroyed = 1,
  EVENT_Avenger_Shot = 2,

  EVENT_Redhirt_Comm1 = 5,   //There she is ma'am
  EVENT_Wu_Comm1 = 6,        //Yes but shes in pretty bad
  EVENT_Redshirt_Comm2 = 7,  //God I hope they don't
  EVENT_Wu_Comm2 = 8,        //We don't need to worry about
  EVENT_Redshirt_Comm3 = 9,  //Aye
  EVENT_Dauntless_Comm1 = 10, //Unidentified
  EVENT_Redshirt_Comm4 = 11,  //This is
  EVENT_Dauntless_Comm2 = 12; //You're cleared


function MAIN;
begin
  MS_RunGameflow(0);
  MS_RunSpaceflight(0);
end;

objective mobj_patrol
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Patrol All NAV Points"];
  status: MOBJ_Incomplete;
  counter: false;
end;


function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

function M_SpawnDamageBox(count, ax, ay, az);
//
// this function spawns "count" ships of type "shipID"
// at coordinates near the object given in "obj"
//
var
  ox, oy, oz;
begin

  while(count > 0) do begin
    ox := ax + SYS_Random(30) - 10;
    oy := ay + SYS_Random(30) - 10;
    oz := az + SYS_Random(20) + 10;

    NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 1, @M_Damagebox, @D_Null, ox, oy, oz);
    count:= count-1;
  end;
end;



// ************************* Declared Objects ***************

object Nav(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_Nav;
  navdata: 1, 50000;
end;


object Avenger(Player)
  obj: UE_SHIP_Avenger_FX;
  x: 250;
  y: 0;
  z: -10000;
  main: M_Avenger;
  pilot: PILOT_Casey2;
end;


object Dauntl2(CapShip)
  obj: UE_SHIP_Dauntless;
  x: 0;
  y: 0;
  z: 0;
  main: M_Dauntless;
  direction: 0, 0, 0;
  pilot: PILOT_Alien1;
  ActionSphere: 0;
end;

object WuComm(Ship)
  obj: UE_SHIP_Scimitar;
  x: 0;
  y: 0;
  z: 1000;
  main: M_WuComm;
  pilot: PILOT_Alien1;
  targstr: targetid["Commodore Wu"];
end;


object RedshirtComm(Ship)
  obj: UE_SHIP_Scimitar;
  x: 0;
  y: 0;
  z: 1000;
  main: M_RedshirtComm;
  pilot: PILOT_Alien1;
  targstr: targetid["Commodore's Aide"];
end;

object DauntlComm(Ship)
  obj: UE_SHIP_Scimitar;
  x: 0;
  y: 0;
  z: 1000;
  main: M_DauntlComm;
  pilot: PILOT_Dauntless;
  targstr: targetid["Dauntless"];
end;

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

// *********************** Functions ***********************



function M_Nav;
begin
  while(1) do begin
    if (NAV_WithinSphere(Avenger)) then begin
      NAV_ActivateSelf;

      SF_ActivateObject(Dauntl2, 0);
      AI_WaitSeconds(1);
      M_GetPos(Dauntl2);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 1, @M_Torpbox, @D_Null, 50, -25, -500);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 1, @M_Torpbox, @D_Null, 50, -25, -500);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 1, @M_Torpbox, @D_Null, 0, 15, -100);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 1, @M_Torpbox, @D_Null, -5, 15, -100);


      M_SpawnDamageBox(3, 103, -34, -395);
      M_SpawnDamageBox(3, 53, -27, -395);
      M_SpawnDamageBox(3, 107, -31, -405);
      M_SpawnDamageBox(3, 51, -25, -405);
      M_SpawnDamageBox(3, 100, -37, -415);
      M_SpawnDamageBox(3, 58, -30, -415);
      M_SpawnDamageBox(3, 98, -20, -425);
      M_SpawnDamageBox(3, 47, -31, -425);
      M_SpawnDamageBox(3, 103, -34, -435);
      M_SpawnDamageBox(3, 53, -27, -435);
      M_SpawnDamageBox(3, 107, -31, -445);
      M_SpawnDamageBox(3, 51, -25, -445);
      M_SpawnDamageBox(3, 100, -37, -455);
      M_SpawnDamageBox(3, 58, -30, -455);
      M_SpawnDamageBox(3, 98, -20, -465);
      M_SpawnDamageBox(3, 47, -31, -465);
      M_SpawnDamageBox(3, 103, -34, -475);
      M_SpawnDamageBox(3, 53, -27, -475);
      M_SpawnDamageBox(3, 107, -31, -485);
      M_SpawnDamageBox(3, 51, -25, -485);
      M_SpawnDamageBox(3, 100, -37, -495);
      M_SpawnDamageBox(3, 58, -30, -495);
      M_SpawnDamageBox(3, 98, -20, -505);
      M_SpawnDamageBox(3, 47, -31, -505);
      M_SpawnDamageBox(3, 103, -34, -515);
      M_SpawnDamageBox(3, 53, -27, -515);
      M_SpawnDamageBox(3, 107, -31, -525);
      M_SpawnDamageBox(3, 51, -25, -525);
      M_SpawnDamageBox(3, 100, -37, -535);
      M_SpawnDamageBox(3, 58, -30, -535);
      M_SpawnDamageBox(3, 98, -20, -545);
      M_SpawnDamageBox(3, 47, -31, -545);

      AI_WaitSeconds(4);
      m_EVENT:=EVENT_Components_Destroyed;
      AI_WaitMilliSeconds(150);
    while(NAV_WithinSphere(Avenger)) do
        AI_WaitSeconds(1);
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;


function M_Avenger;
begin
  AI_PLR_ControlAssume;
  AI_MuteComms;
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  AI_FaceObject(Dauntl2);
  SF_ActivateSelf(0);
  AI_IgnoreCollisions(1);
  SF_SetObjectFlag (OF_collidable, false);
  AI_AttackNothing(1);
  AI_SetThrottle(100);

  until(m_EVENT = EVENT_Avenger_Shot) do AI_WaitMilliSeconds(1);
  SF_SetWorldPosition(250, 125, -1150);          //-25y
  while (SF_GetZ < 370) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntl2, 250, 125, 500);
//  AI_GotoObjRelWorld(Dauntless, 250, 125, 500);  //-25y
  finalapproach:=1;

  AI_GotoObjRelWorld(Dauntl2, -15, -15, 400);
  AI_FaceObject(Dauntl2);
  HCL_AI_GotoObjRelWorld_nonblock(Dauntl2, -15, -27, 0);
  until(SF_GetDistance(Dauntl2)<80) do AI_WaitMilliSeconds(1);
  AI_SetThrottle(50);
  until(SF_GetDistance(Dauntl2)<40) do AI_WaitMilliSeconds(1);
  SYS_PlaySFX(SFX_Engines_Power_Down);
  AI_WaitSeconds(2);

  AI_SetThrottle(0);

  AI_WaitSeconds(5);
  SF_Exit;
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;


function M_Dauntless;
begin
  AI_FaceObject(Nav);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  AI_MuteComms;
  AI_SetThrottle(0);
  AI_WaitUntilActive;

  AI_WaitMilliSeconds(2500);
  SF_PrintText(1130);

  until (m_EVENT = EVENT_Components_Destroyed) do AI_WaitMilliSeconds(1);
  SF_PrintText(1131);
  //AI_WaitMilliSeconds(500);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;



function M_Camera;
begin
  SF_ActivateSelf(0);
  SF_CAM_TrackObj(Avenger);
  SF_CAM_SetFollowObj(Avenger, 30, 20, 70);
  until(m_EVENT = EVENT_Components_Destroyed) do AI_WaitMilliSeconds(100);

  M_GetPos(Dauntl2);
  SF_CAM_SetPos(x+780, y+180, z-540);
  SF_CAM_TrackObj(Dauntl2);
  AI_WaitSeconds(7);
  m_EVENT := EVENT_Avenger_Shot;


  SF_CAM_TrackObj(Avenger);
  SF_CAM_SetFollowObj(Avenger, 100, 80, -30);
  until(finalapproach) do AI_WaitMilliSeconds(1);
  M_GetPos(Avenger);
  SF_CAM_SetMotion(x+70, y, z-30, -45, 35, 500, 5); //15x
  SF_CAM_TrackPivotObjects(Avenger, Dauntl2, 3);
  AI_WaitSeconds(4);
  SF_CAM_SetPos(18, -20, -18);
  SF_CAM_SetFlyBySound(0);
  SF_CAM_TrackObj(Avenger);
  SF_CAM_HideDust;
  AI_WaitSeconds(5);
  SF_CAM_TrackNothing;
  while(1) do
    AI_WaitSeconds(1);
end;

function M_RedshirtComm;
begin
  AI_MuteComms;
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AttackNothing(1);
  AI_WaitMilliSeconds(6700);
  AI_SendSpecialComm(31, 3);
  AI_WaitMilliSeconds(3500);
  m_EVENT2:=EVENT_Wu_Comm1;
  until(m_EVENT2=EVENT_Redshirt_Comm2) do AI_WaitMilliSeconds(100);
  AI_SendSpecialComm(31, 12);//6);
  AI_WaitSeconds(3);
  m_EVENT2:=EVENT_Dauntless_Comm2;//Wu_Comm2;
  until(m_EVENT2=EVENT_Redshirt_Comm3) do AI_WaitMilliSeconds(100);
  AI_SendSpecialComm(31, 6);//8);
  AI_WaitSeconds(5);
  m_EVENT2:=EVENT_Wu_Comm2;//Dauntless_Comm1;
  until(m_EVENT2=EVENT_Redshirt_Comm4) do AI_WaitMilliSeconds(100);
  AI_SendSpecialComm(31, 10);//12);
//  m_EVENT:=EVENT_Dauntless_Comm2;
  while(1) do AI_WaitSeconds(1);

end;

function M_WuComm;
begin
  AI_MuteComms;
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AttackNothing(1);
  until(m_EVENT2=EVENT_Wu_Comm1) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(31, 5);
  AI_WaitMilliSeconds(5700);
  m_EVENT2:=EVENT_Dauntless_Comm1;//Redshirt_Comm2;
  until(m_EVENT2=EVENT_Wu_Comm2) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(31, 9);
  AI_WaitSeconds(6);
  m_EVENT2:=EVENT_Redshirt_Comm4;//3;
  while(1) do AI_WaitSeconds(1);
end;

function M_DauntlComm;
begin
  AI_MuteComms;
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Collidable, false);
  AI_IgnoreCollisions(1);
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AttackNothing(1);
  until(m_EVENT2=EVENT_Dauntless_Comm1) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(31, 11);
  AI_WaitSeconds(5);
  m_EVENT2:=EVENT_Redshirt_Comm2;//4;
  until(m_EVENT2=EVENT_Dauntless_Comm2) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(31, 13);
  AI_WaitSeconds(13);
  m_EVENT2:=EVENT_Redshirt_Comm3;
  while(1) do AI_WaitSeconds(1);
end;

function M_Torpbox;
begin
  SF_ActivateSelf(0);
  SF_SetObjectFlag (OF_alignment, ALIGN_Neutral);
  SF_BindToActionSphere(0);
  AI_IgnoreCollisions(1);
  SF_SetObjectFlag (OF_collidable, false);
  AI_FireMissile(6);
  AI_WaitSeconds(1);
  AI_ReplenishMissilesAndFuel;
  AI_FireMissile(6);
  AI_WaitSeconds(2);
  SF_DeactivateSelf(0);
  while(1) do AI_WaitSeconds(1);
end;

function M_Damagebox;
begin
  SF_ActivateSelf(0);
  SF_SetObjectFlag (OF_alignment, ALIGN_Neutral);
  SF_BindToActionSphere(0);
  AI_IgnoreCollisions(1);
  SF_SetObjectFlag (OF_collidable, false);
  SF_SubHitPoints(95);
  AI_WaitSeconds(75);
  SF_Exit;
  while(1) do
  AI_WaitSeconds(1);
end;

function D_Null;
begin
end;
