//******************************************************************************
//
// Unknown Enemy
// Cinematic - Extro 1C
//
// Created by: Alex Barnfield  <alex@crius.net>
// Modified by: Jakub Majewski <qmajewski@yahoo.co.uk>
//
// Last modified: Aug 18, 2002
//
//******************************************************************************

mission extro1c;

#name: 24;

#sector: "l.sec";

#SetOutputPath("$wcue$\mission\");

#SetRooms ("cic.rom", "rec.rom");

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, UE, comms;
#include block1120;
#include block1121;

#strings spacefli;
#strings targetid;
#strings objectiv;

#SetOutputPath("$wcue$\language\pilots\");
#file "strings\pilots\srs31.pas";

#SetOutputPath("$wcue$\comms\");
#file "comms\srs31.pas";

#SetOutputPath("$wcue$\mission\");


var
  x, y, z,
  m_Event;

const
  EVENT_Dauntless_JumpIn = 1,
  EVENT_Bug1_JumpIn = 2,
  EVENT_TwoBugs_JumpIn = 3,
  EVENT_Swarm_JumpIn = 4,
  EVENT_Hydra_JumpIn = 5;

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);

function MAIN;
begin
  MS_RunGameflow(0);
  MS_RunSpaceflight(0);
end;


function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

function M_SpawnNearObject(shipId, count, obj);
var
  ox, oy, oz;
begin
  M_GetPos(obj);

  while(count > 0) do begin
    ox := x + SYS_Random(200)-200;
    oy := y + SYS_Random(200)-200;
    oz := z;

    NAV_CreateShip(shipId, PILOT_Alien1, 1, @M_Alien, @D_Alien, ox, oy, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;

objective mobj_patrol
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Patrol All NAV Points"];
  status: MOBJ_Incomplete;
  counter: false;
end;


// ************************* Declared Objects ***************

object Nav(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_Nav;
  navdata: 1, 50000;
end;

object JumpBuoy(JumpPoint)
  x: 600;
  y: 0;
  z: -200;
end;

object Player(Player)
  obj: UE_SHIP_Scimitar;
  x: 40000;
  y: 0;
  z: 0;
  main: M_Player;
  pilot: PILOT_Casey1;
end;

object Bug1(Ship)
  obj: moray;
  x: 0;
  y: 0;
  z: -500;
  main: M_AlienD;
  pilot: PILOT_Alien1;
end;

object Bug2(Ship)
  obj: manta;
  x: -100;
  y: -200;
  z: -500;
  main: M_AlienD;
  pilot: PILOT_Alien2;
end;

object Bug3(Ship)
  obj: moray;
  x: -150;
  y: -200;
  z: -500;
  main: M_AlienD;
  pilot: PILOT_Alien3;
end;

object Hydra(CapShip)
  obj: marlin;
  x: 0;
  y: 150;
  z: -800;
  main: M_Hydra;
  pilot: PILOT_Cruiser;
  ActionSphere: 0;
  direction: 0, 0, 180;
end;

object Dauntless(CapShip)
  obj: UE_SHIP_Dauntless;
  x: 0;
  y: 0;
  z: 0;
  main: M_Dauntless;
  direction: 0, 0, 0;
  pilot: PILOT_Dauntless;
  ActionSphere: 0;
end;

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

// *********************** Functions ***********************



function M_Nav;
begin
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      until(m_EVENT=EVENT_Dauntless_JumpIn) do
        AI_WaitMilliSeconds(100);
      SF_ActivateObject(Dauntless, AO_jumpin);

      until(m_EVENT=EVENT_Bug1_JumpIn) do
        AI_WaitMilliSeconds(100);
      SF_ActivateObject(Bug1, AO_jumpin);

      until(m_EVENT=EVENT_TwoBugs_JumpIn) do
        AI_WaitMilliSeconds(100);
      SF_ActivateObject(Bug2, AO_jumpin);
      SF_ActivateObject(Bug3, AO_jumpin);

      until(m_EVENT=EVENT_Swarm_JumpIn) do
        AI_WaitMilliSeconds(100);
      NAV_CreateShip(3, PILOT_Alien1, 1, @M_Alien, @D_Alien, -140, 150, -100);
      NAV_CreateShip(3, PILOT_Alien2, 1, @M_Alien, @D_Alien, 140, -120, -100);
      AI_WaitMilliSeconds(150);
      NAV_CreateShip(3, PILOT_Alien3, 1, @M_Alien, @D_Alien, -140, 250, -100);
      NAV_CreateShip(3, PILOT_Alien4, 1, @M_Alien, @D_Alien, -150, -150, -100);
      NAV_CreateShip(3, PILOT_Alien5, 1, @M_Alien, @D_Alien, 140, 180, -100);
      AI_WaitMilliSeconds(150);
      NAV_CreateShip(3, PILOT_Alien6, 1, @M_Alien, @D_Alien, -150, -220, -100);
      NAV_CreateShip(3, PILOT_Alien7, 1, @M_Alien, @D_Alien, -230, 150, -100);
      NAV_CreateShip(3, PILOT_Alien8, 1, @M_Alien, @D_Alien, -240, 230, -100);
      NAV_CreateShip(3, PILOT_Alien9, 1, @M_Alien, @D_Alien, 210, -170, -100);
      AI_WaitMilliSeconds(150);
      NAV_CreateShip(2, PILOT_Alien1, 1, @M_Alien, @D_Alien, -140, 150, 100);
      NAV_CreateShip(2, PILOT_Alien2, 1, @M_Alien, @D_Alien, 140, -120, 100);
      AI_WaitMilliSeconds(250);
      NAV_CreateShip(2, PILOT_Alien3, 1, @M_Alien, @D_Alien, -140, 250, 100);
      NAV_CreateShip(2, PILOT_Alien4, 1, @M_Alien, @D_Alien, -150, -150, 100);
      AI_WaitMilliSeconds(250);
      NAV_CreateShip(2, PILOT_Alien5, 1, @M_Alien, @D_Alien, 140, 180, 100);
      NAV_CreateShip(2, PILOT_Alien6, 1, @M_Alien, @D_Alien, -150, -220, 100);
      AI_WaitMilliSeconds(250);
      NAV_CreateShip(2, PILOT_Alien7, 1, @M_Alien, @D_Alien, -230, 150, 100);
      NAV_CreateShip(2, PILOT_Alien8, 1, @M_Alien, @D_Alien, -240, 230, 100);
      NAV_CreateShip(2, PILOT_Alien9, 1, @M_Alien, @D_Alien, 210, -170, 100);
      AI_WaitMilliSeconds(450);
      NAV_CreateShip(3, PILOT_Alien1, 1, @M_Alien, @D_Alien, -110, 150, -100);
      NAV_CreateShip(3, PILOT_Alien2, 1, @M_Alien, @D_Alien, 120, -120, -100);
      NAV_CreateShip(3, PILOT_Alien3, 1, @M_Alien, @D_Alien, -130, 250, -100);
      AI_WaitMilliSeconds(150);
      NAV_CreateShip(3, PILOT_Alien4, 1, @M_Alien, @D_Alien, -150, -150, -100);
      NAV_CreateShip(3, PILOT_Alien5, 1, @M_Alien, @D_Alien, 140, 180, -100);
      AI_WaitMilliSeconds(250);
      NAV_CreateShip(3, PILOT_Alien6, 1, @M_Alien, @D_Alien, -150, -220, -100);
      NAV_CreateShip(3, PILOT_Alien7, 1, @M_Alien, @D_Alien, -230, 150, -100);
      NAV_CreateShip(3, PILOT_Alien8, 1, @M_Alien, @D_Alien, -240, 230, -100);
      NAV_CreateShip(3, PILOT_Alien9, 1, @M_Alien, @D_Alien, 210, -170, -100);
      AI_WaitMilliSeconds(250);
      NAV_CreateShip(2, PILOT_Alien1, 1, @M_Alien, @D_Alien, -110, 150, 100);
      NAV_CreateShip(2, PILOT_Alien2, 1, @M_Alien, @D_Alien, 140, -120, 100);
      NAV_CreateShip(2, PILOT_Alien3, 1, @M_Alien, @D_Alien, -140, 250, 100);
      NAV_CreateShip(2, PILOT_Alien4, 1, @M_Alien, @D_Alien, -150, -150, 100);
      AI_WaitMilliSeconds(350);
      NAV_CreateShip(2, PILOT_Alien5, 1, @M_Alien, @D_Alien, 160, 180, 100);
      NAV_CreateShip(2, PILOT_Alien6, 1, @M_Alien, @D_Alien, -150, -220, 100);
      AI_WaitMilliSeconds(150);
      NAV_CreateShip(2, PILOT_Alien7, 1, @M_Alien, @D_Alien, -230, 150, 100);
      NAV_CreateShip(2, PILOT_Alien8, 1, @M_Alien, @D_Alien, -215, 230, 100);
      NAV_CreateShip(2, PILOT_Alien9, 1, @M_Alien, @D_Alien, 210, -170, 100);
      AI_WaitMilliSeconds(250);
      NAV_CreateShip(3, PILOT_Alien1, 1, @M_Alien, @D_Alien, 115, 176, -100);
      NAV_CreateShip(3, PILOT_Alien2, 1, @M_Alien, @D_Alien, -150, -200, -100);
      NAV_CreateShip(3, PILOT_Alien3, 1, @M_Alien, @D_Alien, -230, 150, -100);
      AI_WaitMilliSeconds(250);
      NAV_CreateShip(3, PILOT_Alien4, 1, @M_Alien, @D_Alien, -240, 230, -100);
      NAV_CreateShip(3, PILOT_Alien5, 1, @M_Alien, @D_Alien, 210, -170, -100);
      NAV_CreateShip(3, PILOT_Alien6, 1, @M_Alien, @D_Alien, -140, 150, -100);
      NAV_CreateShip(3, PILOT_Alien7, 1, @M_Alien, @D_Alien, 140, -120, -100);
      AI_WaitMilliSeconds(150);
      NAV_CreateShip(3, PILOT_Alien8, 1, @M_Alien, @D_Alien, -140, 250, -100);
      NAV_CreateShip(3, PILOT_Alien9, 1, @M_Alien, @D_Alien, -150, -150, -100);
      NAV_CreateShip(3, PILOT_Alien1, 1, @M_Alien, @D_Alien, 140, 180, -100);
      AI_WaitMilliSeconds(250);
      NAV_CreateShip(3, PILOT_Alien2, 1, @M_Alien, @D_Alien, -150, -220, -100);
      NAV_CreateShip(3, PILOT_Alien3, 1, @M_Alien, @D_Alien, -230, 150, -100);
      NAV_CreateShip(3, PILOT_Alien4, 1, @M_Alien, @D_Alien, -240, 230, -100);
      NAV_CreateShip(3, PILOT_Alien5, 1, @M_Alien, @D_Alien, 210, -170, -100);
      AI_WaitMilliSeconds(150);
      NAV_CreateShip(2, PILOT_Alien6, 1, @M_Alien, @D_Alien, -140, 150, 100);
      NAV_CreateShip(2, PILOT_Alien7, 1, @M_Alien, @D_Alien, 140, -120, 100);
      AI_WaitMilliSeconds(250);
      NAV_CreateShip(2, PILOT_Alien8, 1, @M_Alien, @D_Alien, -110, 150, 100);
      NAV_CreateShip(2, PILOT_Alien9, 1, @M_Alien, @D_Alien, 140, -120, 100);
      NAV_CreateShip(2, PILOT_Alien1, 1, @M_Alien, @D_Alien, -140, 250, 100);
      NAV_CreateShip(2, PILOT_Alien2, 1, @M_Alien, @D_Alien, -150, -150, 100);

      until(m_EVENT=EVENT_Hydra_JumpIn) do
        AI_WaitMilliSeconds(200);
      SF_ActivateObject(Hydra, AO_jumpin);

    while(NAV_WithinSphere(Player)) do
        AI_WaitSeconds(1);
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;


function M_Player;
begin
  AI_PLR_ControlAssume;
  AI_MuteComms;
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  AI_FaceObject(Nav);
  SF_ActivateSelf(0);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  AI_SetThrottle(0);

  AI_WaitSeconds(2);
  SF_PrintText(1120);
  AI_WaitSeconds(10);
  SF_PrintText(1121);

  AI_WaitSeconds(15);
  AI_SendSpecialCommFrom(31, 0, PILOT_Dauntless);
  AI_WaitSeconds(15);
  AI_SendSpecialCommFrom(31, 1, PILOT_Dauntless);

  until(m_EVENT=EVENT_Hydra_JumpIn) do
    AI_WaitMilliSeconds(200);
  AI_WaitSeconds(36);
  AI_SendSpecialCommFrom(31, 2, PILOT_Dauntless);

  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;


function M_Dauntless;
begin
  AI_FaceObject(Nav);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  AI_MuteComms;
  AI_WaitUntilActive;

  AI_SetThrottle(100);

  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;



function M_Camera;
begin
  SF_ActivateSelf(0);
  SF_CAM_TrackObj(JumpBuoy);
  SF_CAM_SetPos(400, 200, 300);

  AI_WaitSeconds(5);
  SF_CAM_TrackPivotObjects(JumpBuoy, Dauntless, 5);
  SF_CAM_TrackObj(Dauntless);
  m_EVENT:=EVENT_Dauntless_JumpIn;

  AI_WaitSeconds(25);
  SF_CAM_SetPos(1100, 200, -250);
  AI_WaitSeconds(25);

  m_EVENT:=EVENT_Bug1_JumpIn;
  SF_CAM_TrackObj(Bug1);
  SF_CAM_SetPos(5, 5, -400);
  AI_WaitSeconds(6);
  SF_CAM_TrackObj(Bug2);
  SF_CAM_SetPos(-80, -135, -350);
  AI_WaitSeconds(1);

  m_EVENT:=EVENT_TwoBugs_JumpIn;
  AI_WaitSeconds(5);
  m_EVENT:=EVENT_Swarm_JumpIn;
  M_GetPos(Dauntless);
  SF_CAM_SetPos(x+200, y+50, z+350);
  SF_CAM_TrackPos(0, 150, -250);
  AI_WaitSeconds(15);
  m_EVENT:=EVENT_Hydra_JumpIn;
  AI_WaitSeconds(5);
  SF_CAM_TrackObj(Dauntless);
  AI_WaitSeconds(5);
  M_GetPos(Dauntless);
  SF_CAM_SetPos(x+1000, y, z);
  SF_CAM_TrackNothing;
  AI_WaitSeconds(10);

  M_GetPos(Hydra);
  SF_CAM_TrackObj(Hydra);
  SF_CAM_SetPos(x+600, y, z);
  //SF_CAM_TrackNothing;
  AI_WaitSeconds(10);

  M_GetPos(Dauntless);
  SF_CAM_TrackObj(Dauntless);
  SF_CAM_SetPos(x+1100, y+550, z-1500);
  SF_CAM_TrackNothing;
  AI_WaitSeconds(25);
  SF_Exit;

  while(1) do
    AI_WaitSeconds(1);
end;

function M_AlienD;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Alien);
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_BindToActionSphere(0);
  AI_MuteComms;
  AI_AttackNothing(1);
  AI_FaceObject(Dauntless);
  AI_WaitUntilActive;
  AI_SetThrottle(100);
  AI_WaitSeconds(5);
  AI_AddToAttackList(Dauntless, 100);
  AI_AddToIgnoreList(Player, 100);
  AI_AttackEnemies;
  AI_AttackNothing(0);
  while (1) do
    AI_WaitSeconds(1);
end;

function D_Alien;
begin
  Result := 0;
end;

function M_Hydra;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  while(1) do
  begin
    AI_SetThrottle(75);
    AI_WaitSeconds(1);
  end;
end;

function M_Alien;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Alien);
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_BindToActionSphere(0);
  AI_MuteComms;
  SF_ActivateSelf(1);
  AI_AddToAttackList(Dauntless, 100);
  AI_AddToIgnoreList(Player, 100);
  AI_AttackEnemies;
  while (1) do
    AI_WaitSeconds(1);
end;

//  AI_AttackNothing(1);
//  AI_IgnoreCollisions(1);

//  AI_SetThrottle(100);
  //AI_WaitSeconds(5);
  //AI_IgnoreCollisions(0);
//  AI_AttackNothing(0);
