//******************************************************************************
//
// Unknown Enemy
// Cinematic - Extro 2A
//
// Created by: Jakub Majewski <qmajewski@yahoo.co.uk>
//
// Last modified: Aug 28, 2002
//
//******************************************************************************

mission extro2a;

#sector: "w.sec";
#name: 25;

#SetOutputPath("$wcue$\mission\");

#SetRooms ("cic.rom", "rec.rom");

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, UE, comms;
#include block1200;
#include block1201;
#include block1202;
#include block1203;

#strings spacefli;
#strings targetid;
#strings objectiv;

#SetOutputPath("$wcue$\language\pilots\");
#file "strings\pilots\srs32.pas";

#SetOutputPath("$wcue$\comms\");
#file "comms\srs32.pas";

#SetOutputPath("$wcue$\mission\");


var
  x, y, z,
  m_Event = 0,
  m_Event2 = 0,
  m_Comm = 0,
  finalapproach = 0;

const
  COMM_Princeton = 1,
  COMM_Valeri_1 = 2,
  COMM_Morheim_1 = 3,
  COMM_Valeri_2 = 4,
  COMM_Morheim_2 = 5,
  COMM_Valeri_3 = 6,
  EVENT_Jump = 2,
  EVENT_JumpIn = 3,
  EVENT_Launch = 4,
  EVENT_PlayerLaunch = 5,
  EVENT_BugCap = 6,
  EVENT_Triton = 7,
  EVENT_Orca = 8,
  EVENT_TowerShot = 9,
  EVENT_Camera_3 = 10,
  EVENT_Orca_2 = 11;


function MAIN;
begin
  //MS_RunGameflow(0);
  MS_RunSpaceflight(0);
  SYS_PlayMovie(9035);
end;

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior, PILOT_Vaqi);

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;


objective mobj_patrol
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Patrol All NAV Points"];
  status: MOBJ_Incomplete;
  counter: false;
end;


// ************************* Declared Objects ***************

object Nav(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_Nav;
  navdata: 1, 100000;
end;

object Player(Player)
  obj: UE_SHIP_Bearcat;
  x: -20000;
  y: -31;
  z: 10300;
  main: M_Player;
  pilot: PILOT_Casey2;
end;

object Valeri(Ship)
  obj: UE_SHIP_Box;
  x: 0;
  y: 0;
  z: 0;
  main: M_Valeri;
  targstr: targetid["Admiral's Aide"];
  pilot: PILOT_Alien1;
end;

object Morheim(Ship)
  obj: UE_SHIP_Box;
  x: 0;
  y: 0;
  z: 0;
  main: M_Morheim;
  targstr: targetid["Admiral Morheim"];
  pilot: PILOT_Alien1;
end;

object Princeton(Capship)
  obj: UE_SHIP_Princeton;
  x: 0;
  y: 0;
  z: 0;
  main: M_Princeton;
  pilot: PILOT_Dauntless;
end;

object Tireless(Capship)
  obj: UE_SHIP_Princeton;  //Actually, a Ranger
  x: -2800;
  y: 1220;
  z: -2700;
  main: M_Princeton2;
  pilot: PILOT_Confed;
end;

object Loyalty(Capship)
  obj: UE_SHIP_Tallahassee;
  x: -800;
  y: 1020;
  z: -2200;
  main: M_Tallahassee;
  pilot: PILOT_Confed;
end;

object Retaliation(Capship)
  obj: UE_SHIP_Tallahassee;
  x: -800;
  y: 220;
  z: 1900;
  main: M_Tallahassee2;
  pilot: PILOT_Confed;
end;

object PrincetonStatic(Capship)
  obj: UE_SHIP_Princeton;
  x: -20000;
  y: 0;
  z: 10000;
  main: M_PrincetonStatic;
  pilot: PILOT_Confed;
end;

object Plunkett(Capship)
  obj: UE_SHIP_Plunkett;
  x: -19500;
  y: 180;
  z: 9750;
  main: M_Plunkett;
  pilot: PILOT_Confed;
end;

object Plunkett2(Capship)
  obj: UE_SHIP_Plunkett;
  x: 600;
  y: 170;
  z: 200;
  main: M_Plunkett2;
  pilot: PILOT_Confed;
end;

object Tango(Capship)
  obj: UE_SHIP_Intrepid;
  x: -20500;
  y: -140;
  z: 10400;
  main: M_Tango;
  pilot: PILOT_Confed;
end;

object Murphy(Capship)
  obj: UE_SHIP_Murphy;
  x: -20500;
  y: -440;
  z: 12800;
  main: M_Murphy;
  pilot: PILOT_Confed;
end;

object Murphy2(Capship)
  obj: UE_SHIP_Murphy;
  x: -20900;
  y: -940;
  z: 11500;
  main: M_Murphy2;
  pilot: PILOT_Confed;
end;

object ScLeviathan(Capship)
  obj: UE_SHIP_Leviathan;
  x: 1000;
  y: -30;
  z: 7000;
  main: M_BugCap;
  direction: 76, 0, 90;
  pilot: PILOT_Confed;
end;

object ScLeviathan2(Capship)
  obj: UE_SHIP_Leviathan;
  x: 3000;
  y: 330;
  z: 9000;
  main: M_BugCap;
  direction: 92, 0, 53;
  pilot: PILOT_Confed;
end;

object ScOrca(Capship)
  obj: UE_SHIP_Orca;
  x: 100;
  y: -230;
  z: 5500;
  main: M_Orca1;
  direction: 77, 10, 31;
  pilot: PILOT_Confed;
end;

object ScOrca2(Capship)
  obj: UE_SHIP_Orca;
  x: 2400;
  y: -230;
  z: 6500;
  main: M_BugCap;
  direction: 178, 10, -24;
  pilot: PILOT_Confed;
end;

object ScOrca3(Capship)
  obj: UE_SHIP_Orca;
  x: 350;
  y: 620;
  z: 6000;
  main: M_BugCap;
  direction: 163, 10, -47;
  pilot: PILOT_Confed;
end;

object ScTriton(Capship)
  obj: UE_SHIP_Triton;
  x: 350;
  y: 130;
  z: 4500;
  main: M_BugCap;
  direction: 97, 10, -47;
  pilot: PILOT_Confed;
end;

object ScTriton2(Capship)
  obj: UE_SHIP_Triton;
  x: 750;
  y: 180;
  z: 4300;
  main: M_BugCap;
  direction: 76, -7, 0;
  pilot: PILOT_Confed;
end;

object ScTriton3(Capship)
  obj: UE_SHIP_Triton;
  x: -270;
  y: 50;
  z: 4800;
  main: M_Triton3;
  direction: 103, 10, 23;
  pilot: PILOT_Confed;
end;

object Jump(JumpPoint)
  x: 730;
  y: -130;
  z: 1000;
end;

object Camera(Camera)
  x: -20120;
  y: 180;
  z: 9120;
  main: M_Camera;
end;

object Camera2(Camera)
  x: 290;
  y: 40;
  z: 60;
  main: M_Camera2;
end;

object Camera3(Camera)
  x: -50;
  y: -100;
  z: 4800;
  main: M_Camera3;
end;

// *********************** Functions ***********************

function M_Valeri;
begin
  SF_ActivateSelf(0);
  AI_MuteComms;
  until (m_Comm = COMM_Valeri_1) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(32, 1);
  until (m_Comm = COMM_Valeri_2) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(32, 3);
  until (m_Comm = COMM_Valeri_3) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(32, 5);
  AI_WaitSeconds(10);
  SF_DeactivateSelf(0);
  while (1) do AI_WaitSeconds(1);
end;

function M_Morheim;
begin
  SF_ActivateSelf(0);
  AI_MuteComms;
  until (m_Comm = COMM_Morheim_1) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(32, 2);
  until (m_Comm = COMM_Morheim_2) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(32, 4);
  AI_WaitSeconds(10);
  SF_DeactivateSelf(0);
  while (1) do AI_WaitSeconds(1);
end;


function M_BugCap;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Alien);
  until (m_Event2 = EVENT_BugCap) do AI_WaitMilliSeconds(1);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_TowerShot) do AI_WaitMilliSeconds(1);
  HCL_DestroyChild(PART_ChildGunTurret, 7);
  HCL_DestroyChild(PART_ChildMissileTurret, 2);
  while (1) do AI_WaitSeconds(5);
end;

function M_Triton3;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Alien);
  until (m_Event2 = EVENT_BugCap) do AI_WaitMilliSeconds(1);
  SF_ActivateSelf(0);
  until (m_Event2 = EVENT_Triton) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(8);
  HCL_DestroyChild(PART_ChildGunTurret, 3);
  SYS_PlaySFX(104);
  AI_WaitSeconds(3);
  HCL_DestroyChild(PART_ChildBridge, 1);
  SYS_PlaySFX(105);
  AI_WaitSeconds(3);
  SF_DestroySelf;
  while (1) do AI_WaitSeconds(5);
end;

function M_Orca1;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Alien);
  until (m_Event2 = EVENT_BugCap) do AI_WaitMilliSeconds(1);
  SF_ActivateSelf(0);
  until (m_Event2 = EVENT_Orca) do AI_WaitMilliSeconds(1);
  SYS_PlaySFX(47);
  AI_WaitMilliSeconds(150);
  SYS_PlaySFX(47);
  AI_WaitMilliSeconds(1300);
  HCL_DestroyChild(PART_ChildEngine, 3);
  AI_WaitMilliSeconds(500);
  SYS_PlaySFX(105);
  until (m_Event = EVENT_TowerShot) do AI_WaitMilliSeconds(1);
  HCL_DestroyChild(PART_ChildGunTurret, 8);
  HCL_DestroyChild(PART_ChildMissileTurret, 4);
  until (m_Event2 = EVENT_Orca_2) do AI_WaitMilliSeconds(1);
  SF_DestroySelf;
  while (1) do AI_WaitMilliSeconds(1);
end;

function M_Nav;
begin
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      SF_ActivateObject(PrincetonStatic, 0);
      SF_ActivateObject(Plunkett, 0);
      SF_ActivateObject(Tango, 0);
      SF_ActivateObject(Murphy, 0);
      SF_ActivateObject(Murphy2, 0);

      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -34, 10450);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -34, 10450);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -34, 10450);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -34, 10450);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -34, 10450);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -34, 10450);

      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -32, 10400);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -32, 10400);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -32, 10400);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -32, 10400);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -32, 10400);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -32, 10400);

      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -33, 10350);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -33, 10350);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -33, 10350);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -33, 10350);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -33, 10350);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -33, 10350);

      // The sixth Bearcat in this row is the player
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -31, 10300);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -31, 10300);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -31, 10300);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -31, 10300);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -31, 10300);

      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -31, 10250);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -31, 10250);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -31, 10250);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -31, 10250);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -31, 10250);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -31, 10250);

      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -30, 10200);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -30, 10200);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -30, 10200);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -30, 10200);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -30, 10200);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -30, 10200);

      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -29, 10150);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -29, 10150);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -29, 10150);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -29, 10150);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -29, 10150);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -29, 10150);

      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -28, 10100);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -28, 10100);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -28, 10100);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -28, 10100);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -28, 10100);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -28, 10100);

      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -26, 10050);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -26, 10050);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -26, 10050);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -26, 10050);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -26, 10050);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -26, 10050);

      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -24, 10000);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -24, 10000);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -24, 10000);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -24, 10000);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -24, 10000);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -24, 10000);

      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -22, 9950);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -22, 9950);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -22, 9950);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -22, 9950);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -22, 9950);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -22, 9950);

      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -20035, -20, 9900);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -20020, -20, 9900);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -20000, -20, 9900);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -19980, -20, 9900);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -19960, -20, 9900);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt, @NULL, -19945, -20, 9900);

      until (m_Event = EVENT_Launch) do AI_WaitMilliSeconds(1);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitSeconds(3);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitSeconds(3);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitSeconds(3);
      m_Event := EVENT_PlayerLaunch;
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitSeconds(3);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitSeconds(3);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitSeconds(3);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitMilliSeconds(3500);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitMilliSeconds(3500);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitSeconds(4);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitSeconds(4);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      AI_WaitSeconds(4);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, -35, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, -20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 0, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 20, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 40, -34, 420);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt2, @NULL, 55, -34, 420);

      until (m_Event2 = EVENT_Triton) do AI_WaitSeconds(1);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, -100, -50, 5000);
      AI_WaitMilliSeconds(700);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 40, 50, 3800);
      AI_WaitMilliSeconds(1700);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, -180, 35, 4100);
      AI_WaitMilliSeconds(2300);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 0, -180, 4300);
      AI_WaitMilliSeconds(700);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, -100, -50, 5000);
      AI_WaitSeconds(3);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 0, 230, 4000);
      AI_WaitSeconds(2);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, -200, -80, 3700);
      AI_WaitSeconds(3);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 200, -50, 5000);
      AI_WaitMilliSeconds(1700);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 240, 50, 3800);
      AI_WaitMilliSeconds(2300);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 80, 35, 4100);
      AI_WaitMilliSeconds(3600);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 200, -180, 4300);
      AI_WaitMilliSeconds(1700);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 100, -50, 5000);
      AI_WaitSeconds(4);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 200, 230, 4000);
      AI_WaitSeconds(2);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 0, -80, 3700);
      AI_WaitSeconds(6);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, -100, -50, 5000);
      AI_WaitMilliSeconds(800);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 40, 50, 3800);
      AI_WaitSeconds(1);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, -180, 35, 4100);
      AI_WaitMilliSeconds(2200);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 0, -180, 4300);
      AI_WaitMilliSeconds(700);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, -100, -50, 5000);
      AI_WaitSeconds(2);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 0, 230, 4000);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, -200, -80, 3700);

      //Spawn fighters
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt3, @NULL, 0, 230, 5200);
      NAV_CreateShip(UE_SHIPID_Bearcat, PILOT_Confed, 0, @M_Stunt3, @NULL, -200, -80, 5200);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt3, @NULL, 0, 230, 5000);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt3, @NULL, -200, -80, 5100);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Stunt3, @NULL, 0, 30, 5100);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt3, @NULL, -200, -80, 5200);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt3, @NULL, 0, 200, 5000);
      NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Confed, 0, @M_Stunt3, @NULL, -100, -80, 5300);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt3, @NULL, 100, 130, 5200);
      NAV_CreateShip(UE_SHIPID_Avenger_B, PILOT_Confed, 0, @M_Stunt3, @NULL, -200, -280, 5300);
      NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @M_Stunt3, @NULL, 0, 130, 5000);
      NAV_CreateShip(UE_SHIPID_Epee, PILOT_Confed, 0, @M_Stunt3, @NULL, -150, -80, 5300);

      NAV_CreateShip(UE_SHIPID_Moray, PILOT_Confed, 0, @M_Stunt4, @NULL, 0, 230, 5860);
      NAV_CreateShip(UE_SHIPID_Moray, PILOT_Confed, 0, @M_Stunt4, @NULL, -200, -80, 5150);
      NAV_CreateShip(UE_SHIPID_Manta, PILOT_Confed, 0, @M_Stunt4, @NULL, 0, 230, 5100);
      NAV_CreateShip(UE_SHIPID_Moray, PILOT_Confed, 0, @M_Stunt4, @NULL, -200, -80, 5480);
      NAV_CreateShip(UE_SHIPID_Manta, PILOT_Confed, 0, @M_Stunt4, @NULL, 0, 30, 5170);
      NAV_CreateShip(UE_SHIPID_Squid, PILOT_Confed, 0, @M_Stunt4, @NULL, -200, -40, 5310);
      NAV_CreateShip(UE_SHIPID_Manta, PILOT_Confed, 0, @M_Stunt4, @NULL, 0, 200, 5050);
      NAV_CreateShip(UE_SHIPID_Moray, PILOT_Confed, 0, @M_Stunt4, @NULL, -100, -80, 5150);
      NAV_CreateShip(UE_SHIPID_Moray, PILOT_Confed, 0, @M_Stunt4, @NULL, 100, 130, 5270);
      NAV_CreateShip(UE_SHIPID_Lamprey, PILOT_Confed, 0, @M_Stunt4, @NULL, -200, -280, 5220);
      NAV_CreateShip(UE_SHIPID_Lamprey, PILOT_Confed, 0, @M_Stunt4, @NULL, 0, 130, 5050);
      NAV_CreateShip(UE_SHIPID_Lamprey, PILOT_Confed, 0, @M_Stunt4, @NULL, -150, -80, 5120);


      AI_WaitSeconds(3);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 200, -50, 5000);
      AI_WaitMilliSeconds(4200);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 240, 50, 3800);
      AI_WaitMilliSeconds(3200);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 80, 35, 4100);
      AI_WaitMilliSeconds(5300);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 200, -180, 4300);
      AI_WaitMilliSeconds(1300);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 100, -50, 5000);
      AI_WaitSeconds(5);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 200, 230, 4000);
      AI_WaitSeconds(3);
      NAV_CreateShip(UE_SHIPID_Box, PILOT_Confed, 0, @M_Box, @NULL, 0, -80, 3700);


      while(NAV_WithinSphere(Player)) do
        AI_WaitSeconds(1);
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Box;
begin
  SF_ActivateSelf(0);
  AI_WaitMilliSeconds(500);
  SF_DestroySelf;
  AI_WaitSeconds(5);
  SF_DeactivateSelf(0);
  while(1) do AI_WaitSeconds(5);
end;

function M_Player;
begin
  AI_PLR_ControlAssume;
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Collidable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  AI_SetThrottle(0);
  AI_AttackNothing(1);
  AI_IgnoreCollisions(1);
  AI_WaitSeconds(1);
  SF_PrintText(1200);
  AI_WaitSeconds(2);
  SF_PrintText(1201);
  until (m_Comm = COMM_Princeton) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(1);
  AI_SendSpecialCommFrom(32, 0, PILOT_Dauntless);
  until (m_Event = EVENT_Jump) do AI_WaitMilliSeconds(1);
  SF_DeactivateSelf(0);
  AI_WaitSeconds(5);
  SF_SetWorldPosition(0, -34, 420);
  HCL_ChangeDirection(0, 0, 0);
  until (m_Event = EVENT_PlayerLaunch) do AI_WaitMilliSeconds(1);
  SF_ActivateSelf(0);
  AI_SetThrottle(100);
  AI_WaitSeconds(2);
  until (m_Event = EVENT_TowerShot) do
    HCL_AI_GotoObjRelWorld_nonblock(Princeton, 0, -30, 7000);
  SF_SetWorldPosition(0, 0, 25000);
//  SF_DeactivateSelf(0);
  //AI_SetThrottle(100);
  AI_WaitSeconds(150);
  SF_Exit;
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Stunt;
begin
  AI_AttackNothing(1);
  AI_IgnoreCollisions(1);
  HCL_ChangeDirection(0, 0, 0);
  SF_ActivateSelf(0);
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  AI_SetThrottle(0);
  AI_MuteComms;
  until (m_Event = EVENT_Jump) do AI_WaitMilliSeconds(1);
  SF_DeactivateSelf(0);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Stunt2;
begin
  AI_AttackNothing(1);
  AI_IgnoreCollisions(1);
  HCL_ChangeDirection(0, 0, 0);
  AI_MuteComms;
  SF_ActivateSelf(0);
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  AI_SetThrottle(100);
  AI_WaitMilliSeconds(2000+(SYS_Random(500)));
  AI_GotoObjRelWorld(Princeton, 0, -30, 2600);
  SF_DeactivateSelf(0);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Stunt3;
begin
  AI_MuteComms;
  SF_ActivateSelf(0);
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Stunt4;
begin
  AI_MuteComms;
  SF_ActivateSelf(0);
  SF_SetObjectFlag(OF_Vulnerable, true);
  SF_SetObjectFlag(OF_Alignment, ALIGN_Alien);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_PrincetonStatic;
begin
  AI_WaitUntilActive;
  until (m_Event = EVENT_Jump) do AI_WaitMilliSeconds(1);
  SF_DeactivateSelf(1);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Murphy;
begin
  AI_WaitUntilActive;
  AI_MuteComms;
  AI_SetThrottle(100);
  AI_WaitSeconds(3);
  SYS_PlaySFX(SFX_Jump);
  SF_DeactivateSelf(1);
  until (m_Event = EVENT_JumpIn) do AI_WaitMilliSeconds(1);
  SF_SetWorldPosition(-2000, -340, 2300);
  HCL_ChangeDirection(0, 0, 0);
  SF_ActivateSelf(0);
  AI_SetThrottle(100);
  until (m_Event = EVENT_Camera_3) do AI_WaitMilliSeconds(1);
  AI_FaceObjRelWorld(ScLeviathan, 0, 0, 0);
  AI_SetThrottle(100);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Murphy2;
begin
  AI_WaitUntilActive;
  AI_MuteComms;
  AI_SetThrottle(100);
  AI_WaitSeconds(6);
  SYS_PlaySFX(SFX_Jump);
  SF_DeactivateSelf(1);
  until (m_Event = EVENT_JumpIn) do AI_WaitMilliSeconds(1);
  SF_SetWorldPosition(-900, -640, 1700);
  HCL_ChangeDirection(0, 0, 0);
  SF_ActivateSelf(0);
  AI_SetThrottle(100);
  until (m_Event = EVENT_Camera_3) do AI_WaitMilliSeconds(1);
  AI_FaceObjRelWorld(ScLeviathan, 0, 0, 0);
  AI_SetThrottle(100);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Tallahassee2;
begin
  until (m_Event = EVENT_JumpIn) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(12);
  SYS_PlaySFX(SFX_Jump);
  SF_ActivateSelf(1);
  AI_MuteComms;
  AI_SetThrottle(100);
  until (m_Event = EVENT_TowerShot) do AI_WaitMilliSeconds(1);
  AI_WaitMilliSeconds(50);
  SF_SetWorldPosition(-1500, 200, 3700);
//  until (m_Event = EVENT_Camera_3) do AI_WaitMilliSeconds(1);
  AI_FaceObjRelWorld(ScLeviathan, 0, 0, 0);
  AI_SetThrottle(100);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Tango;
begin
  AI_WaitUntilActive;
  AI_SetThrottle(100);
  AI_WaitSeconds(9);
  SYS_PlaySFX(SFX_Jump);
  SF_DeactivateSelf(1);
  until (m_Event = EVENT_JumpIn) do AI_WaitMilliSeconds(1);
  SF_SetWorldPosition(-500, -140, 300);
  HCL_ChangeDirection(0, 0, 0);
  AI_WaitSeconds(1);
  SYS_PlaySFX(SFX_Jump);
  SF_ActivateSelf(1);
  AI_MuteComms;
  AI_SetThrottle(100);
  AI_WaitSeconds(20);
  AI_SetThrottle(0);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Plunkett;
begin
  AI_WaitUntilActive;
  AI_SetThrottle(60);
  AI_WaitSeconds(12);
  SYS_PlaySFX(SFX_Jump);
  SF_DeactivateSelf(1);
  until (m_Event = EVENT_JumpIn) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(9);
  SF_SetWorldPosition(-1300, 540, -1700);
  HCL_ChangeDirection(0, 0, 0);
  HCL_DestroyChild(PART_ChildGunTurret, 4);
  SYS_PlaySFX(SFX_Jump);
  SF_ActivateSelf(1);
  AI_MuteComms;
  AI_SetThrottle(50);
  AI_WaitSeconds(5);
  AI_SetThrottle(0);
  AI_WaitSeconds(35);
  SF_DeactivateSelf(0);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Princeton;
begin
  until (m_Event = EVENT_JumpIn) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(7);
  SYS_PlaySFX(SFX_Jump);
  SF_ActivateSelf(1);
  AI_MuteComms;
  AI_SetThrottle(0);
  until (m_Event = EVENT_Launch) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(4);
  SYS_PlaySFX(SFX_Launch);
  AI_WaitSeconds(3);
  SYS_PlaySFX(SFX_Launch);
  AI_WaitSeconds(3);
  SYS_PlaySFX(SFX_Launch);
  AI_WaitSeconds(3);
  SYS_PlaySFX(SFX_Launch);
  AI_WaitSeconds(3);
  SYS_PlaySFX(SFX_Launch);
  AI_WaitSeconds(3);
  SYS_PlaySFX(SFX_Launch);
  AI_WaitMilliSeconds(3500);
  SYS_PlaySFX(SFX_Launch);
  AI_WaitMilliSeconds(3500);
  SYS_PlaySFX(SFX_Launch);
  AI_WaitSeconds(4);
  SYS_PlaySFX(SFX_Launch);
  AI_WaitSeconds(4);
  SYS_PlaySFX(SFX_Launch);
  AI_WaitSeconds(4);
  SYS_PlaySFX(SFX_Launch);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Tallahassee;
begin
  until (m_Event = EVENT_JumpIn) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(5);
  SYS_PlaySFX(SFX_Jump);
  SF_ActivateSelf(1);
  AI_MuteComms;
  AI_SetThrottle(100);
  AI_WaitSeconds(50);
  SF_DeactivateSelf(0);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Plunkett2;
begin
  until (m_Event = EVENT_JumpIn) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(3);
  SYS_PlaySFX(SFX_Jump);
  SF_ActivateSelf(1);
  AI_MuteComms;
  AI_SetThrottle(50);
  AI_WaitSeconds(35);
  SF_DeactivateSelf(0);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Princeton2;
begin
  until (m_Event = EVENT_JumpIn) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(12);
  SYS_PlaySFX(SFX_Jump);
  SF_ActivateSelf(1);
  AI_MuteComms;
  AI_SetThrottle(0);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Camera;
begin
  SF_CAM_TrackObj(PrincetonStatic);
  SF_ActivateSelf(0);
  SF_CAM_SetFlyBySound(0);
  AI_WaitSeconds(13);
  SF_CAM_HideDust;
  m_GetPos(Player);
  SF_CAM_SetPos(x+50, y+40, z+230);
  SF_CAM_TrackObj(Player);
  AI_WaitSeconds(2);
  m_Comm := COMM_Princeton;
  AI_WaitSeconds(9);
  m_Event := EVENT_Jump;
  AI_WaitMilliSeconds(1500);
  SF_CAM_ShowDust;
  SF_CAM_SetPos(750, -130, 1050);
  SF_CAM_TrackPos(0,0,0);
  SF_ActivateSelf(0);
  m_Event := EVENT_JumpIn;
  SF_PrintText(1202);
  AI_WaitSeconds(10);
  m_Event := EVENT_Launch;
  SF_CAM_SetFlyBySound(1);
  AI_WaitSeconds(5);
  SF_CAM_TrackPivot(0, 0, 0, 0, 50, 500, 5);
  SF_CAM_SetMotion(750, -130, 1050, 350, -130, 800, 10);
  SF_CAM_SetMotion(350, -130, 800, 250, -100, 650, 8);
  AI_WaitSeconds(4);
  m_Event2 := EVENT_BugCap;
  SF_CAM_TrackPivot(0, 50, 500, -300, -30, 2500, 10);
  m_Event2 := EVENT_Triton;
  SF_CAM_TrackPivot(-300, -30, 2500, 1000, -30, 8000, 10);
  AI_WaitSeconds(10);
  m_Event2 := EVENT_Orca;
  AI_WaitSeconds(10);
  m_Event := EVENT_TowerShot;
  AI_WaitMilliSeconds(50);
  SF_DeactivateSelf(0);
  AI_WaitMilliSeconds(8500);
  m_Comm := COMM_Valeri_1;
  AI_WaitMilliSeconds(7500);
  m_Comm := COMM_Morheim_1;
  AI_WaitMilliSeconds(4000);
  m_Comm := COMM_Valeri_2;
  AI_WaitMilliSeconds(2870);
  m_Event := EVENT_Camera_3;
  AI_WaitSeconds(2);
  m_Event2 := EVENT_Orca_2;
  AI_WaitSeconds(4);
  m_Comm := COMM_Morheim_2;
  AI_WaitMilliSeconds(8200);
  m_Comm := COMM_Valeri_3;
  AI_WaitSeconds(23);
  SF_DestroyObject(ScLeviathan);
  AI_WaitSeconds(100);
  SF_Exit;

  while(1) do AI_WaitSeconds(1);
end;

function M_Camera2;
begin
  until (m_Event = EVENT_Launch) do AI_WaitSeconds(1);
  SF_CAM_TrackPos(-105, 80, 125);
  until (m_Event = EVENT_TowerShot) do AI_WaitMilliSeconds(1);
  SF_ActivateSelf(0);
  SF_PrintText(1203);
  SF_CAM_SetMotion(290, 40, 60, -20, 70, 200, 10);
  SF_CAM_SetMotion(-20, 70, 200, -190, 80, 210, 10);
  AI_WaitSeconds(20);
  while(1) do AI_WaitSeconds(1);
end;

function M_Camera3;
begin
  until (m_Event = EVENT_Camera_3) do AI_WaitMilliSeconds(1);
  SF_CAM_TrackPos(100, -230, 5500);
  SF_ActivateSelf(0);
  SF_CAM_SetMotion(-50, -100, 4800, -1750, -150, 2000, 40);
  AI_WaitSeconds(5);
  SF_Exit;
  while(1) do AI_WaitSeconds(1);
end;

function NULL;
begin
end;
