//******************************************************************************
//
// Unknown Enemy
// Cinematic - Intro
//
// Created by: Jakub Majewski  <qmajewski@yahoo.co.uk>
// Last modified: Jun 26, 2002
//
//******************************************************************************

mission intro;

#sector: "t.sec";
#SetRooms ("cic.rom", "rec.rom");

#SetOutputPath("$wcue$\mission\");
#include block100;
#include block101;
#include block102;
#include block103;
#include block104;
#include block105;
#include block106;
#include block107;
#include block108;
#include block109;
#include block110;
#include block111;
#include block112;
#include block113;
#include block114;
#include block115;
#include block116;
#include block117;
#include block118;
#include block119;
#include block120;
#include block121;
#include block122;
#include block123;
#include block124;

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts;
#include UE;

#SetOutputPath("$wcue$\mission\");

var
  x, y, z,
  m_Event;

const
  EVENT_Jump = 1,
  EVENT_Tower = 2,
  EVENT_Burn = 3,
  EVENT_Launch = 4,
  EVENT_Done = 5;

function MAIN;
begin
  MS_RunSpaceflight(0);
end;

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

// ************************* Dauntless NAV **********************

object NavD(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_NavD;
  navdata: 1, 25000;
end;

object Player(Player)
  obj: UE_SHIP_Scimitar;
  x: 20;
  y: 200;
  z: 8300;
  main: M_Player;
  pilot: PILOT_Casey1;
end;

object Dauntless(Capship)
  obj: UE_SHIP_Dauntless;
  x: 5;
  y: 10;
  z: 50;
  main: M_Dauntless;
  direction: 180, 0, 0;
  pilot: PILOT_Dauntless;
end;

object StuntDauntless(Capship)
  obj: UE_SHIP_Dauntless;
  x: -1500;
  y: 10;
  z: 50;
  main: M_StuntDauntless;
  direction: 180, 0, 0;
  pilot: PILOT_Dauntless;
end;

object Scim(Ship)
  obj: UE_SHIP_Scimitar;
  x: 0;
  y: -24;//0;
  z: 0;
  main: M_AlphaLead;
  pilot: Pilot_Gold;
end;

object StuntScim(Ship)
  obj: UE_SHIP_Scimitar_FX;
  x: -1508;
  y: -23;//6;
  z: 50;
  main: M_StuntScim;
  direction: 180, 0, 0;
  pilot: Pilot_Gold;
end;

object StuntScim2(Ship)
  obj: UE_SHIP_Scimitar_FX;
  x: -1496;
  y: -24;//6;
  z: 65;
  main: M_StuntScim2;
  direction: 180, 0, 0;
  pilot: Pilot_Gold;
end;

object StuntScim3(Ship)
  obj: UE_SHIP_Scimitar_FX;
  x: -1518;
  y: -24;//6;
  z: 65;
  main: M_StuntScim2;
  direction: 180, 0, 0;
  pilot: Pilot_Gold;
end;

object StuntFighter1(Ship)
  obj: UE_SHIP_Epee;
  x: -1478;
  y: -23;//6;
  z: 105;
  main: M_StuntFighter;
  direction: 180, 5, 0;
  pilot: Pilot_Gold;
end;

object StuntFighter2(Ship)
  obj: UE_SHIP_Epee;
  x: -1484;
  y: -23;//6;
  z: 105;
  main: M_StuntFighter;
  direction: 180, 5, 0;
  pilot: Pilot_Gold;
end;

object StuntFighter3(Ship)
  obj: UE_SHIP_Epee;
  x: -1490;
  y: -23;//6;
  z: 105;
  main: M_StuntFighter;
  direction: 180, 5, 0;
  pilot: Pilot_Gold;
end;

object StuntFighter4(Ship)
  obj: UE_SHIP_Banshee;
  x: -1499;
  y: -23;//6;
  z: 110;
  main: M_StuntFighter;
  direction: 180, 5, 0;
  pilot: Pilot_Gold;
end;

object StuntFighter5(Ship)
  obj: UE_SHIP_Epee;
  x: -1507;
  y: -23;//6;
  z: 105;
  main: M_StuntFighter;
  direction: 180, 5, 0;
  pilot: Pilot_Gold;
end;

object StuntFighter6(Ship)
  obj: UE_SHIP_Banshee;
  x: -1515;
  y: -23;//6;
  z: 110;
  main: M_StuntFighter;
  direction: 180, 5, 0;
  pilot: Pilot_Gold;
end;

object StuntFighter7(Ship)
  obj: UE_SHIP_Scimitar;
  x: -1524;
  y: -23;//6;
  z: 105;
  main: M_StuntFighter;
  direction: 180, 5, 0;
  pilot: Pilot_Gold;
end;

object Pos1(JumpPoint)
  x: 0;
  y: -17;//10;
  z: -5000;
end;

object Pos2(JumpPoint)
  x: -1508;
  y: 16;
  z: -5000;
end;

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

function NULL;
begin
end;

function M_Alpha;
begin
  SF_SetObjectFlag(OF_Collidable, false);
  AI_IgnoreCollisions(1);
  SF_ActivateSelf(0);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  AI_AttackNothing(1);
  AI_FaceObject(Pos1);
  AI_GotoObjRange(Pos1, 2000);
  AI_AddToWing(Scim);

  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_AlphaLead;
begin
  SF_SetObjectFlag(OF_Collidable, false);
  AI_IgnoreCollisions(1);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  AI_AttackNothing(1);

  until (m_Event = Event_Launch) do AI_WaitMilliSeconds (1);
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x-8, y-24, z+5);
  SF_ActivateSelf(0);
  AI_FaceObject(Pos1);
  AI_GotoObjRange(Pos1, 2000);

  while(1) do begin
    AI_SetThrottle(100);
    AI_WaitSeconds(1);
  end;
end;

function M_NavD;
begin
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      until (m_Event = Event_Jump) do AI_WaitMilliSeconds (5);

      SF_ActivateObject(Dauntless, AO_jumpin);
      SF_ActivateObject(Pos1, AO_Appear);
      until (m_Event = EVENT_Launch) do AI_WaitMilliSeconds(100);
      AI_WaitMilliSeconds(200);
      M_GetPos(Dauntless);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Alpha, @NULL, x+4, y-24, z);
      M_GetPos(Dauntless);
      NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Confed, 0, @M_Alpha, @NULL, x-20, y-24, z);

      while(NAV_WithinSphere(Player)) do
        AI_WaitSeconds(1);
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Player;
begin
  SYS_PlayMovie(9005);
  SYS_PlaySFX(245);
  AI_PLR_ControlAssume;
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_SetObjectFlag(OF_Collidable, false);
  SF_ActivateSelf(0);

  AI_WaitSeconds(3);
  SF_PrintText(100);
  SF_PrintText(101);
  SF_PrintText(102);
  SF_PrintText(103);
  SF_PrintText(104);
  SF_PrintText(107);
  AI_WaitSeconds(10);
  SF_PrintText(108);
  SF_PrintText(109);
  AI_WaitSeconds(8);
  SF_PrintText(110);
  SF_PrintText(111);
  SF_PrintText(112);
  AI_WaitSeconds(10);
  SF_PrintText(113);
  SF_PrintText(114);
  AI_WaitSeconds(8);
  SF_PrintText(115);
  SF_PrintText(116);
  SF_PrintText(117);
  AI_WaitSeconds(10);
  SF_PrintText(118);
  SF_PrintText(119);
  AI_WaitSeconds(8);
  SF_PrintText(120);
  SF_PrintText(121);



  //SF_Exit;



  until (m_Event = EVENT_Launch) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(5);
  SF_PrintText(105);
  AI_WaitSeconds(4);
  SF_PrintText(106);

  until (m_Event = EVENT_Done) do AI_WaitMilliSeconds(1);
  SF_PrintText(122);
  SF_PrintText(123);
  SF_PrintText(124);
  AI_WaitMilliSeconds(10000);
  SF_Exit;

  while (1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Dauntless;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  while(1) do begin
    AI_SetThrottle(100);
    AI_WaitSeconds(1);
  end;
end;

function M_StuntDauntless;
begin
  SF_ActivateSelf(0);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_StuntScim;
begin
  SF_SetObjectFlag(OF_Collidable, false);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  Until (m_Event = EVENT_Burn) do AI_WaitMilliSeconds(1);
  AI_GotoObjRange(Pos2, 2000);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_StuntScim2;
begin
  SF_SetObjectFlag(OF_Collidable, false);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  Until (m_Event = EVENT_Burn) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(2);
  AI_GotoObjRange(Pos2, 2000);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_StuntFighter;
begin
  SF_SetObjectFlag(OF_Collidable, false);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;


function M_Camera;
begin
  SF_CAM_TrackObj(Pos1);
  SF_CAM_SetPos(-300, 300, -100);
  SF_CAM_SetFlyBySound(0);
  SF_ActivateSelf(0);

  AI_WaitSeconds(5);
  SF_CAM_TrackPivotObjects(Pos1, Dauntless, 20);
  m_Event := EVENT_Jump;
  AI_WaitSeconds(1);
  M_GetPos(Dauntless);
  SF_CAM_SetPos(x-200,y+80,z-280);
  AI_WaitSeconds(7);
  SF_CAM_HideDust;
  SYS_PlaySFX(240);
  SF_CAM_SetPos(-1514, -23, 47);
  SF_CAM_TrackPos(-1508, -23, 47);
  AI_WaitSeconds(3);
  SF_CAM_SetMotion(-1514, -23, 47, -1509, -17, 30, 8);
  AI_WaitMilliSeconds(4900);
  M_GetPos(Dauntless);
  SF_CAM_ShowDust;
  SF_CAM_SetPos(x-140, y+40, z-250);
  SF_CAM_TrackPos(x, y+40, z-80);
  m_Event := EVENT_Tower;
  AI_WaitSeconds(6);
  SYS_PlaySFX(241);
  AI_WaitSeconds(1);
  M_GetPos(StuntScim);
  SF_CAM_HideDust;
  SF_CAM_SetPos(x-3, y, z+5);
  SF_CAM_TrackPos(x, y, z+5);
  AI_WaitSeconds(3);
  SYS_PlaySFX(242);
  m_Event := EVENT_Burn;
  AI_WaitMilliSeconds(2950);
  m_Event := EVENT_Launch;

  M_GetPos(Dauntless);
  SF_CAM_ShowDust;
  SF_CAM_SetPos(x-50,y+40,z-300);
  SF_CAM_SetFlyBySound(1);
  SF_CAM_TrackObj(Scim);
  AI_WaitSeconds(8);
  SF_CAM_SetPos(-900, 200, -60);
  SF_CAM_TrackObj(Dauntless);
  AI_WaitSeconds(12);
  m_Event := EVENT_Done;

  while(1) do
    AI_WaitSeconds(1);
end;
