//******************************************************************************
//
// Unknown Enemy
// Cinematic 1 - Intrepid finds trouble
//
// Created by: Jakub Majewski  <qmajewski@yahoo.co.uk>
// Last modified: June 26, 2002
//
//******************************************************************************

mission scene1;

#sector: "t.sec";
#SetRooms ("cic.rom", "rec.rom");
#name: 5;

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, UE, comms;

#strings spacefli;
#strings targetid;
#strings objectiv;

#SetOutputPath("$wcue$\comms\");
#file "comms\srs33.pas";
#SetOutputPath("$wcue$\language\pilots\");
#file "strings\pilots\srs33.pas";



#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);

#SetOutputPath("$wcue$\mission\");

#file "block290.pas";
#file "block291.pas";
#file "block292.pas";

var
  x, y, z,
  m_Event,
  messagetime = 0;

const
  EVENT_HeadForBuoy = 1,
  EVENT_BuoyApproach = 2,
  EVENT_OrcaJump = 3,
  EVENT_FullJump = 4,
  EVENT_FlankView = 5,
  EVENT_Scramble = 6,
  EVENT_BugKill = 7,
  EVENT_MissileLaunch = 8,
  EVENT_BugIsDead = 9,
  EVENT_YouDie = 10,
  EVENT_AllDie = 11;

function MAIN;
begin
  MS_RunGameflow(0);
  MS_RunSpaceflight(0);
  MS_SetPilotDead(PILOT_Huntress, 1);
  MS_SetPilotDead(PILOT_Thor, 1);
end;

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

function M_SpawnNearObject(shipId, count, obj);
var
  ox, oy, oz;
begin
  M_GetPos(obj);

  while(count > 0) do begin
    ox := x + SYS_Random(50) + 500;
    oy := y + SYS_Random(50) + 500;
    oz := z + SYS_Random(50) + 500;

    NAV_CreateShip(shipId, PILOT_Alien1, 0, @M_Alien, @D_Alien, ox, oy, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;

function M_SpawnFromObject(shipId, count, obj);
var
  oz;
begin
  M_GetPos(obj);
  oz := z+50;

  while(count > 0) do begin
    NAV_CreateShip(shipId, PILOT_Drago, 0, @M_Alpha, @D_Alien, x, y, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;

objective mobj_patrol
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Patrol All NAV Points"];
  status: MOBJ_Incomplete;
  counter: false;
end;

// ************************* Declared Objects ***************

object Light1(Light)
  x: 0;
  y: 0;
  z: 0;
  LightType: LIGHT_Ambient;
  LightColor: 0.1, 0.1, 0.1;
end;

object Nav(Navpoint)
  x: -500;
  y: 45;
  z: -5000;
  main: M_Nav;
  navdata: 1, 50000;
end;

object Player(Player)
  obj: UE_SHIP_Scimitar;
  x: -500;
  y: 140;
  z: 2800;
  main: M_Player;
  pilot: PILOT_Casey2;
end;

object Thor(Ship)
  obj: UE_SHIP_Scimitar;
  x: 5500;
  y: 5500;
  z: 5500;
  main: M_Thor;
  pilot: PILOT_Thor;
  targstr: 1;
end;

object Banshee(Ship)
  obj: UE_SHIP_Banshee;
  x: 5500;
  y: 5500;
  z: 5500;
  main: M_Banshee;
  pilot: PILOT_Drago;
end;

object DeadBug(Ship)
  obj: moray;
  x: 5500;
  y: 5550;
  z: 5500;
  main: M_DeadBug;
  pilot: Pilot_Alien3;
  targstr: 2;
end;

object KillBug(Ship)
  obj: mantab;
  x: 5550;
  y: 5500;
  z: 5500;
  main: M_KillBug;
  pilot: Pilot_Alien_Ace;
  targstr: 2;
end;

object Huntress(Ship)
  obj: UE_SHIP_Scimitar;
  x: -550;
  y: 140;
  z: 2800;
  main: M_Huntress;
  pilot: Pilot_Huntress;
  targstr: 1;
  ActionSphere: 0;
end;

object Intrepid(Capship)
  obj: intrepidc;
  x: -500;
  y: 45;
  z: 3000;
  main: M_Intrepid;
  pilot: PILOT_Base_Female2;
  ActionSphere: 0;
end;

object Orca(CapShip)
  obj: orca;
  x: 100;
  y: 50;
  z: -100;
  main: M_Orca;
  direction: -90, 0, 0;
  pilot: PILOT_Cruiser;
  ActionSphere: 0;
end;

object Hydra(CapShip)
  obj: marlin;
  x: -1600;
  y: 10;
  z: 100;
  main: M_Orca;
  direction: -20, 0, 0;
  pilot: PILOT_Cruiser;
  ActionSphere: 0;
end;

object Leviathan(CapShip)
  obj: osprey;
  x: -800;
  y: 10;
  z: -200;
  main: M_Orca;
  direction: -30, 0, 0;
  pilot: PILOT_Carrier;
  ActionSphere: 0;
end;

object JumpPoint(JumpPoint)
  x: 100;
  y: 0;
  z: -50;
  main: M_Jump;
end;

function M_Jump;
begin
  SF_SetObjectFlag(OF_Collidable, false);
end;

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

// *********************** Functions ***********************

function M_Banshee;
begin
  AI_SetThrottle(0);
  AI_IgnoreCollisions(1);
  AI_FaceObject(Nav);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  //SF_SetObjectFlag(OF_collidable, false);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  AI_AttackNothing(1);
  AI_MuteComms;
  AI_WaitUntilActive;
  M_GetPos(Intrepid);
  SF_SetWorldPosition (x, y, z);
  AI_FaceObject(Nav);
  AI_GotoObjRelFrame(Intrepid, 0, 30, 1300);
  //SF_SetObjectFlag(OF_collidable, true);
  SF_SetObjectFlag(OF_vulnerable, true);
  AI_IgnoreCollisions(0);
  AI_AttackNothing(0);
  AI_AddToIgnoreList(KillBug, 100);


  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Alpha;
begin
  AI_IgnoreCollisions(1);
  AI_FaceObject(Nav);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_collidable, false);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  AI_AttackNothing(1);
  AI_MuteComms;
  SF_ActivateSelf(0);
  AI_GotoObjRelFrame(Intrepid, 0, 30, 1300);
  SF_SetObjectFlag(OF_collidable, true);
  SF_SetObjectFlag(OF_vulnerable, true);
  AI_IgnoreCollisions(0);
  AI_AttackNothing(0);
  AI_AddToIgnoreList(KillBug, 100);


  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_KillBug;
begin
  AI_IgnoreCollisions(1);
  AI_MuteComms;
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  AI_SetThrottle(0);
  AI_AttackNothing(1);
  SF_SetWorldPosition(1000, -1500, 500);
  AI_FaceObject(Nav);
  AI_WaitUntilActive;
  AI_SetThrottle(70);
  AI_ResumeComms;
  AI_SendComm(COMM_Taunt);
  AI_MuteComms;
  AI_WaitSeconds(2);
  AI_FireMissile(18);
  AI_WaitMilliSeconds(500);
  AI_FireMissile(18);
  AI_WaitMilliSeconds(500);
  AI_FireMissile(18);
  AI_SetThrottle(100);
  AI_WaitSeconds(4);
  AI_ResumeComms;
  AI_SendComm(COMM_Pilot_Report_Target_Destroyed);
  AI_MuteComms;
  AI_GotoObjRange(Intrepid, 2500);
  AI_FaceObjRelFrame(Intrepid, 0, 0, 0);
  AI_WaitMilliSeconds(500);
  AI_FireMissile(21);
  AI_AttackNothing(0);
  AI_IgnoreCollisions(0);
  AI_WaitSeconds(1);


  while(1) do
    AI_WaitSeconds(5);
end;


function M_DeadBug;
begin
  AI_IgnoreCollisions(1);
  AI_SetThrottle(0);
  AI_MuteComms;
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  SF_SetHitPoints(5);
  SF_BindToActionSphere(0);
  AI_AttackNothing(1);
  SF_SetWorldPosition(1000, -1500, 500);
  AI_FaceObject(Nav);
  AI_WaitUntilActive;
  AI_WaitSeconds(1);
  AI_SetThrottle(100);
  until (m_Event = EVENT_MissileLaunch) do AI_WaitMilliSeconds(1);

  while (1) do
    AI_WaitSeconds(1);
end;

function M_Thor;
begin
  AI_IgnoreCollisions(1);
  SF_SetObjectFlag(OF_alignment, ALIGN_Neutral);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_Vulnerable, false);
  AI_MuteComms;

  while (1) do begin
    AI_WaitMilliSeconds(1);

    if (m_Event = EVENT_HeadForBuoy) then
    begin
      AI_ResumeComms;
      AI_SendComm(56);
      AI_MuteComms;
      until (M_Event <> EVENT_HeadForBuoy) do AI_WaitMilliSeconds(5);
    end;

    if (m_Event = EVENT_BuoyApproach) then
    begin
      AI_ResumeComms;
      AI_SendComm(COMM_Pilot_Report_Nothing_Here);
      AI_MuteComms;
      until (M_Event <> EVENT_BuoyApproach) do AI_WaitMilliSeconds(5);
    end;

    if (m_Event = EVENT_FlankView) then
    begin
      M_GetPos(Orca);
      SF_SetWorldPosition(x, y+150, z-35);
      AI_FaceObject(Orca);
      AI_FaceObjRelFrame(Orca, 0, 200, 0);
      AI_SetThrottle(100);
      until (M_Event <> EVENT_FlankView) do AI_WaitMilliSeconds(5);
      SF_SetWorldPosition(6000, 6000, 6000);
      AI_SetThrottle(0);
    end;

    if (m_Event = EVENT_OrcaJump) then
    begin
      AI_ResumeComms;
      AI_SendComm(33);//COMM_Pilot_Report_Big_Event_Or_Surprise);
      AI_MuteComms;
      until (M_Event <> EVENT_OrcaJump) do AI_WaitMilliSeconds(5);
    end;

    if (m_Event = EVENT_FullJump) then
    begin
      AI_WaitSeconds(3);
      AI_ResumeComms;
      AI_SendComm(COMM_Order_Break_And_Attack);
      AI_MuteComms;
      until (M_Event <> EVENT_FullJump) do AI_WaitMilliSeconds(5);
    end;

    if (m_Event = EVENT_BugKill) then
    begin
      AI_SetThrottle(0);
      AI_WaitSeconds(3);
      AI_ResumeComms;
      AI_SendComm(COMM_Pilot_Report_Launch_Missile);
      m_Event := EVENT_MissileLaunch;
      AI_MuteComms;
      SF_SetHitPoints(5);
      AI_WaitSeconds(2);
      SF_SetWorldPosition(1000, -1500, 500);
      AI_ResumeComms;
      AI_SendComm(COMM_Pilot_Report_Target_Destroyed);
      AI_MuteComms;
      AI_FaceObject(Nav);
      m_Event := EVENT_BugIsDead;
    end;

    if (m_Event = EVENT_YouDie) then
    begin
      AI_SetThrottle(100);
      SF_SetObjectFlag(OF_Vulnerable, true);
      AI_WaitSeconds(3);
      AI_ResumeComms;
      AI_WaitSeconds(5);
    end;
  end;
end;


function M_Huntress;
begin
  AI_IgnoreCollisions(1);
  AI_MuteComms;
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  AI_AttackNothing(1);
  AI_AddToWing(Player);

  SF_ActivateSelf(0);

  while(1) do begin
    AI_SetThrottle(100);
    AI_WaitMilliSeconds(5);

    if (m_Event = EVENT_OrcaJump) then
    begin
      AI_WaitSeconds(3);
      AI_ResumeComms;
      AI_SendComm(COMM_Pilot_Report_Big_Event_Or_Surprise);
      AI_MuteComms;
      until (M_Event <> EVENT_OrcaJump) do AI_WaitMilliSeconds(5);
    end;

    if (m_Event = EVENT_FullJump) then
    begin
      AI_WaitSeconds(5);
      AI_ResumeComms;
      AI_SendComm(COMM_Pilot_Report_Attacking);
      AI_MuteComms;
      AI_AttackNothing(0);
      AI_IgnoreCollisions(0);
      AI_RemoveFromWing;
      SF_SetHitpoints(5);
      until (M_Event <> EVENT_FullJump) do AI_WaitMilliSeconds(5);
    end;
    AI_AddToIgnoreList(KillBug, 100);
  end;
end;

function M_Nav;
begin
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      until (m_Event = EVENT_OrcaJump) do AI_WaitMilliSeconds(1);
      M_SpawnNearObject(UE_SHIPID_Manta, 1, Orca);
      SF_ActivateObject(Orca, AO_jumpin);

      until (m_Event = EVENT_FullJump) do AI_WaitMilliSeconds(1);

      SF_ActivateObject(Hydra, AO_jumpin);
      M_SpawnNearObject(UE_SHIPID_Manta, 4, Orca);
      AI_WaitSeconds(1);
      SF_ActivateObject(Leviathan, AO_jumpin);
      M_SpawnNearObject(UE_SHIPID_Moray, 5, Hydra);
      AI_WaitSeconds(1);
      M_SpawnNearObject(UE_SHIPID_Manta_B, 10, Leviathan);
      M_SpawnNearObject(UE_SHIPID_Moray, 10, Hydra);

      until (m_Event = EVENT_Scramble) do AI_WaitMilliSeconds(1);

      SF_ActivateObject(Banshee, AO_appear);
      AI_WaitSeconds(1);
      M_SpawnFromObject(UE_SHIPID_Banshee, 1, Intrepid);
      AI_WaitSeconds(1);
      M_SpawnFromObject(UE_SHIPID_Banshee, 1, Intrepid);
      AI_WaitSeconds(1);
      M_SpawnFromObject(UE_SHIPID_Avenger_SAR, 1, Intrepid);

      until (m_Event = EVENT_BugKill) do AI_WaitMilliSeconds(1);
      SF_ActivateObject(DeadBug, AO_appear);

      until (m_Event = EVENT_YouDie) do AI_WaitMilliSeconds(1);
      AI_WaitSeconds(2);
      SF_ActivateObject(KillBug, AO_appear);

      while(NAV_WithinSphere(Player)) do
        AI_WaitSeconds(1);
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Player;
begin
  AI_PLR_ControlAssume;
  AI_MuteComms;
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  AI_FaceObject(Nav);
  SF_ActivateSelf(0);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  AI_SetThrottle(50);

  while (1) do begin
    AI_WaitMilliSeconds(1);

    if (m_Event = EVENT_HeadForBuoy) then
    begin
      AI_GotoObjRange(JumpPoint, 500);
      m_Event := EVENT_BuoyApproach;
      AI_WaitSeconds(1);
    end;

    if (m_Event = EVENT_BuoyApproach) then
    begin
      AI_FaceObjRelWorld(JumpPoint, -100, 15, 0);
      AI_SetThrottle(100);
      AI_WaitSeconds(2);
      m_Event := EVENT_OrcaJump;
    end;

    if (m_Event = EVENT_OrcaJump) then
    begin
      AI_WaitSeconds(3);
      m_Event := EVENT_FullJump;
      AI_FaceObjRelFrame(Orca, 200, 0, 150);
      AI_SetThrottle(100);
      AI_WaitSeconds(1);
      AI_FaceObjRelFrame(Hydra, 0, 0, 0);
      AI_SetThrottle(100);
      AI_WaitSeconds(1);
      m_Event := EVENT_FlankView;
      SF_SetHitpoints(80);
      AI_FaceObjRelFrame(Orca, 0, 200, 0);
      AI_SetThrottle(100);
      AI_WaitMilliSeconds(2);
      SF_SetWorldPosition(5000, 5000, 5000);
      SF_SetHitpoints(50);
      AI_SetThrottle(20);
    end;

    if (m_Event = EVENT_BugKill) then
    begin
      AI_WaitMilliSeconds(2500);
      SF_SetWorldPosition(1000, -1500, 500);
      AI_FaceObject(DeadBug);
      AI_PLR_LockTarget;
      AI_SetThrottle(60);
      AI_WaitSeconds(2);
      until (m_Event = EVENT_MissileLaunch) do AI_WaitMilliSeconds(1);
      AI_FireMissile(7);
      AI_WaitSeconds(2);
      until (m_Event = EVENT_BugIsDead) do AI_WaitMilliSeconds(1);
      m_Event := EVENT_YouDie;
      AI_WaitMilliSeconds(100);
      SF_SetWorldPosition(5000, 5000, 5000);
      SF_SetHitPoints(5);
    end;
  end;
end;

function M_Intrepid;
begin
  SF_SetPilotImmortal(PILOT_Huntress, 0);
  SF_SetPilotImmortal(PILOT_Thor, 0);
  AI_FaceObject(Nav);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  AI_MuteComms;

  AI_SetThrottle(100);

  while(1) do begin
    AI_SetThrottle(100);
    AI_WaitMilliSeconds(5);
    if (messagetime = true) then begin
      AI_SendSpecialComm(33, 0);
      messagetime := false;
    end;
    if (m_Event = EVENT_Scramble) then
    begin
      AI_WaitSeconds(1);
      AI_SetThrottle(100);
      AI_SendSpecialComm(33, 1);
//      SYS_PlaySFX(SFX_Scramble);
      until (m_Event <> EVENT_Scramble) do AI_WaitSeconds(1);
//      AI_WaitSeconds(5);
    end;
    if (m_Event = EVENT_AllDie) then
    begin
      AI_WaitSeconds(1);
      AI_ResumeComms;
      AI_SendComm(5);
      AI_MuteComms;
      SF_DestroySelf;
    end;
  end;
end;

function M_Orca;
begin
  AI_WaitUntilActive;

  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);

  while(1) do
  begin
    AI_SetThrottle(100);
    AI_WaitSeconds(1);
  end;
end;

function M_Camera;
var x2, y2, z2;
begin
  M_GetPos(JumpPoint);
  SF_ActivateSelf(0);
  SF_CAM_TrackPos(x-40, y+10, z);
  SF_CAM_SetPos(-30, 15, -200);

  SF_CAM_HideDust;
  SF_CAM_SetFlyBySound(0);
  AI_WaitSeconds(1);
  SF_PrintText(290);
  AI_WaitSeconds(3);
  SF_PrintText(291);
  AI_WaitSeconds(2);
  M_GetPos(Intrepid);
  SF_CAM_TrackPivot(60, 10, -50, x, y, z-1600, 10);

  M_GetPos(Player);
  SF_CAM_TrackObj(Player);
  SF_CAM_SetPos(x-50, y-15, z-130);
  AI_WaitSeconds(1);
  messagetime := true;
  //SF_PrintText(292);
  AI_WaitSeconds(9);
  m_Event := EVENT_HeadForBuoy;

  until (m_Event = EVENT_BuoyApproach) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(2);
  SF_DeactivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);



  M_GetPos(Thor);
  SF_CAM_TrackObj(Thor);
  SF_CAM_SetFollowObj(Thor, 30, 345, 55);

  until (m_Event = EVENT_FlankView) do AI_WaitMilliSeconds(1);
  AI_WaitMilliSeconds(3);
  SF_ActivateSelf(0);
  AI_WaitMilliSeconds(3800);
  SF_CAM_ShowDust;

  SF_CAM_TrackObj(Intrepid);
  SF_CAM_SetFollowObj(Intrepid, 80, 250, -460);

  m_Event := EVENT_Scramble;
  AI_WaitMilliSeconds(4500);
  SF_CAM_TrackObj(Banshee);
  SF_CAM_SetFollowObj(Banshee, 15, 20, -30);
  AI_WaitMilliSeconds(2800);
  SF_CAM_SetFollowObj(Banshee, 10, 10, 30);
  AI_WaitMilliSeconds(2700);

  //SF_CAM_TrackObj(Intrepid);
  //SF_CAM_SetFollowObj(Intrepid, 120, 350, -260);
  //AI_WaitSeconds(3);

  m_Event := EVENT_BugKill;
  AI_WaitSeconds(3);
  SF_DeactivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);

  until (m_Event = EVENT_YouDie) do AI_WaitMilliSeconds(1);
  // Major changes here
  SF_CAM_TrackObj(Thor);
  //M_GetPos(Thor);
  //SF_CAM_SetPos(x-15, y+25, z+15);
  SF_CAM_SetFollowObj(Thor, -15, 25, 15);
  SF_ActivateSelf(0);
  //SF_CAM_SetMotion(x-15, y+25, z+15, x, y-5, z-50, 1);
  //SF_CAM_SetMotion(x, y-5, z-50, x+5, y+10, z-100, 1);
  AI_WaitSeconds(2);
  SF_CAM_SetFollowObj(Thor, -5, 5, 35);
  AI_WaitSeconds(1);
  SF_CAM_TrackObj(KillBug);
  //SF_CAM_SetFollowObj(KillBug, -5, 5, -20);
  M_GetPos(KillBug);
  SF_CAM_SetPos(x+5, y-5, z+20);
  //SF_CAM_SetMotion(x+5, y-5, z+20, x-7, y-10, z-140, 3);
  //SF_CAM_SetMotion(x-7, y-10, z-140, x-10, y, z-300, 3);
  SF_CAM_SetMotion(x+5, y-5, z+20, x-2, y-7, z-40, 2);
  SF_CAM_SetMotion(x-2, y-7, z-40, x-5, y+3, z-140, 2);
  SF_CAM_SetMotion(x-5, y+3, z-140, x+1, y+5, z-220, 2);
  SF_CAM_SetMotion(x+1, y+5, z-220, x-2, y+7, z-300,  2);

  AI_WaitSeconds(2);
  //AI_WaitSeconds(10);
  M_GetPos(KillBug);
  SF_CAM_SetPos (x-5, y+5, z-20);
  SF_CAM_TrackPivotObjects(KillBug, Intrepid, 5);
  AI_WaitSeconds(3);
  M_GetPos(Intrepid);
  SF_CAM_TrackPivot(x, y, z, x+3000, y, z, 4);
  m_Event := EVENT_AllDie;
  AI_WaitSeconds(8);

  SF_Exit;

  while(1) do
    AI_WaitSeconds(1);
end;

function M_Alien;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Alien);
  SF_BindToActionSphere(0);
  AI_MuteComms;
  SF_ActivateSelf(1);
  while (1) do
    AI_WaitSeconds(1);
end;

function D_Alien;
begin
end;
