//******************************************************************************
//
//      Unknown Enemy
//      Cinematic 2 - Orca destruction
//
//      Created by Alex Barnfield  <alex@crius.net>
//      Modified by Jakub Majewski <qmajewski@yahoo.co.uk>
//
//      Last Modified August 12th 2001
//
//******************************************************************************


mission scene2;

#sector: "t.sec";
#SetRooms ("cic.rom", "rec.rom");

#SetOutputPath("$wcue$\mission\");

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, UE, comms;

#strings spacefli;
#strings targetid;
#strings objectiv;

#SetOutputPath("$wcue$\mission\");

#file "block390.pas";
#file "block391.pas";

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);

var x, y, z,
  M_Event,
  timer = 0;

const
  EVENT_Action = 1,
  EVENT_Kill = 2,
  EVENT_Attacking_Defender = 3,
  EVENT_Getaway = 4,
  EVENT_Conversation = 5,
  EVENT_External = 6,
  EVENT_Complete = 7,
  EVENT_Defender_Cue = 8,
  EVENT_Firing= 9,
  EVENT_Blade_Cue = 10,
  EVENT_Defender_Cue2 = 11;


function MAIN;
begin
  MS_RunGameFlow(0);
  MS_RunSpaceflight(0);
end;

objective mobj_patrol
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Patrol All NAV Points"];
  status: MOBJ_Incomplete;
  counter: false;
end;

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

object Light1(Light)
  x: 0;
  y: 0;
  z: 0;
  LightType: LIGHT_Ambient;
  LightColor: 0.3, 0.3, 0.3;
end;

object Nav(Navpoint)
  x: -500;
  y: 45;
  z: -5000;
  main: M_Nav;
  navdata: 1, 50000;
end;

object Player(Player)
  obj: UE_SHIP_GRATHA_BOMBER_BW;
  x: 0;
  y: -10000;
  z: -10000;
  main: M_Player;
  direction: 0, 0, 180;
  pilot: PILOT_Casey1;
end;

object Defender(Ship)
  obj: UE_SHIP_GRATHA_BOMBER_BW;
  x: 0;
  y: 5;
  z: -1990;
  main: M_Defender;
  pilot: PILOT_Defender;
  targstr: 1;
end;

object Night(Ship)
  obj: UE_SHIP_GRATHA_BOMBER_BW;
  x: -35;
  y: 0;
  z: -2000;
  main: M_Night;
  pilot: PILOT_Night;
  targstr: 1;
end;

object Blade(Ship)
  obj: UE_SHIP_GRATHA_BOMBER_BW;
  x: 25;
  y: 0;
  z: -2000;
  main: M_Blade;
  pilot: PILOT_Blade;
  targstr: 1;
end;

object Shark(Ship)
  obj: UE_SHIP_Scimitar;
  x: 5500;
  y: 5500;
  z: 5500;
  main: M_Shark;
  pilot: PILOT_Shark;
  targstr: 1;
end;

object Bloodhound(Ship)
  obj: UE_SHIP_Scimitar;
  x: 370;
  y: 30;
  z: 0;
  main: M_Bloodhound;
  pilot: PILOT_Bloodhound;
  targstr: 1;
end;

object AttackerBug(Ship)
  obj: manta;
  x: 5500;
  y: 5500;
  z: 5500;
  main: M_AttackerBug;
  pilot: PILOT_Alien4;
end;

object Moray1(Ship)
  obj: moray;
  x: 370;
  y: 30;
  z: 50;
  main: M_Moray;
  pilot: PILOT_Alien2;
end;

object Moray2(Ship)
  obj: scim;
  x: 0;
  y: -10000;
  z: -10050;
  main: M_Moray2;
  pilot: PILOT_Alien2;
end;

object Orca(Capship)
  obj: Orca;
  x: 0;
  y: 0;
  z: 0;
  main: M_Orca;
  pilot: PILOT_Carrier;
  direction: 0, 0, 0;
end;

object Camera(Camera)
  x: 0;
  y: 0;
  z: -600;
  main: M_Camera;
end;

function M_Defender;
begin
  AI_MuteComms;
  AI_IgnoreCollisions(1);
  AI_FaceObject(Orca);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  AI_AttackNothing(1);
  SF_ActivateSelf(0);
  AI_SetThrottle(100);

  until(M_EVENT = EVENT_Attacking_Defender) do begin
    AI_SetThrottle(100);
    AI_WaitMilliseconds(100);
  end;

  AI_GotoObjRelWorld(orca, -100, -400, -900);

  AI_FireMissile(6);
//  AI_AttackNothing(0);
//  AI_IgnoreCollisions(0);
  AI_WaitSeconds(2);

  HCL_AI_GotoObjRelWorld_nonblock(orca, -2000, -250, -10000);

  SF_SetWorldPosition (-1000, -400, -100);
  AI_AttackNothing(1);
  AI_IgnoreCollisions(1);
  until (m_EVENT = EVENT_External) do
    HCL_AI_GotoObjRelWorld_nonblock(Nav, -100030, -400, -100);

  SF_SetWorldPosition(0, 0, 1000);
  AI_FaceObject(Orca);
  SF_SetWorldPosition(0, 0, -5000);

  AI_SetThrottle(40);


  until (m_Event = EVENT_Defender_Cue) do AI_WaitMilliSeconds(1);
  AI_WaitMilliSeconds(15);
  AI_SendSpecialComm(33, 2);
  AI_WaitSeconds(5);
  m_Event := EVENT_Blade_Cue;

  until (m_Event = EVENT_Defender_Cue2) do AI_WaitMilliSeconds(1);
  AI_WaitMilliSeconds(15);
  AI_SendSpecialComm(33, 4);

  AI_WaitSeconds(1);
  AI_SetThrottle(100);
  m_EVENT:= EVENT_Complete;

  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Night;
begin
  AI_IgnoreCollisions(1);
  AI_FaceObject(Orca);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  AI_AttackNothing(1);
  AI_MuteComms;
  SF_ActivateSelf(0);
  AI_SetThrottle(100);
  until(M_EVENT = EVENT_Attacking_Defender) do begin
    AI_SetThrottle(100);
    AI_WaitMilliseconds(100);
  end;
  AI_GotoObjRange(orca, 650);
  AI_WaitMilliSeconds(1500);
  m_EVENT:=EVENT_Firing;
  AI_ResumeComms;
  AI_SendComm(COMM_Pilot_Report_Launch_Torp);
  AI_MuteComms;
  AI_FireMissile(6);
  AI_WaitMilliSeconds(700);
  AI_FireMissile(6);
  AI_WaitMilliSeconds(1500);
  m_EVENT:=EVENT_Getaway;
  AI_WaitMilliSeconds(300);
  until(m_EVENT = EVENT_Conversation)do
    HCL_AI_GotoObjRelWorld_nonblock(Orca, 0, 0, -3000);

  AI_WaitMilliSeconds(100);
  M_GetPos(Defender);
  SF_SetWorldPosition(x-50, y, z+100);
  AI_FaceObject(Defender);
  AI_AddToWing(Defender);

  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;



function M_Blade;
begin
  AI_IgnoreCollisions(1);
  AI_FaceObject(Orca);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  AI_AttackNothing(1);
  AI_MuteComms;
  SF_ActivateSelf(0);
  AI_SetThrottle(100);
  until(M_EVENT = EVENT_Attacking_Defender) do begin
    AI_SetThrottle(100);
    AI_WaitMilliseconds(100);
  end;
  AI_ResumeComms;
  AI_SendComm(COMM_Pilot_Report_Need_Help);
  AI_MuteComms;
  AI_GotoObjRange(orca, 650);
  AI_WaitMilliSeconds(500);
  AI_SendComm(COMM_Pilot_Report_Launch_Torp);
  AI_FireMissile(6);
  AI_AttackNothing(0);

  until (m_EVENT = EVENT_Conversation) do
    HCL_AI_GotoObjRelWorld_nonblock(Nav, -2000, 0, -10000);

  SF_SetWorldPosition(0, 0, 3000);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Blade_Cue) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(33, 3);

  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;


function M_Shark;
begin
  AI_SetThrottle(0);
  AI_IgnoreCollisions(1);
  AI_FaceObject(Nav);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  AI_MuteComms;
  AI_AttackNothing(1);
  SF_ActivateSelf(0);
  SF_SetWorldPosition (x-45, 15, z-2000);
  AI_FaceObject(Orca);
  AI_SetThrottle(85);
  until(M_EVENT = EVENT_Attacking_Defender) do begin
    AI_SetThrottle(85);
    AI_WaitMilliseconds(1);
  end;
  AI_AttackNothing(0);
  AI_AddToAttackList(1000, AttackerBug);

  AI_WaitMilliSeconds(500);
  AI_ResumeComms;
  AI_SendComm(COMM_Pilot_Report_On_My_Way);
  AI_MuteComms;
  AI_IgnoreCollisions(0);
  AI_WaitMilliSeconds(300);
  AI_FaceObject(AttackerBug);
  AI_WaitMilliSeconds(5700);
  SF_DestroyObject(AttackerBug);

  SF_SetWorldPosition (-1000, -420, -115);

  until (m_EVENT = EVENT_External)do
    HCL_AI_GotoObjRelWorld_nonblock(Nav, -100015, -420, -100);

  AI_WaitSeconds(2);

  m_GetPos(Defender);
  SF_SetWorldPosition(x-130, y, z+50);
  AI_SetThrottle(50);
  until (m_Event = EVENT_Defender_Cue) do AI_WaitMilliSeconds(1);
  AI_AddToWing(Defender);


  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Bloodhound;
begin
  AI_SetThrottle(100);

  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  AI_MuteComms;

  AI_FaceObject(Moray1);
  SF_ActivateSelf(0);
  AI_AttackNothing(1);
  AI_IgnoreCollisions(1);
  AI_AddToIgnoreList(1000, AttackerBug);
  AI_AddToAttackList(1000, Moray1);
  AI_SetThrottle(0);
  AI_WaitSeconds(4);
  AI_SetThrottle(100);
  until (m_Event = EVENT_Action) do
    HCL_AI_GotoObjRelWorld_nonblock(Bloodhound, 0, 0, 300);
//    AI_WaitMilliSeconds(1);
  AI_WaitSeconds(3);
  //AI_AttackNothing(0);
  AI_WaitMilliSeconds(700);
  AI_FireMissile(4);
  AI_WaitMilliSeconds(400);
  AI_FireMissile(4);
  AI_AttackNothing(1);
  AI_WaitMilliSeconds(700);
  m_Event := EVENT_Kill;
  until (timer = 21) do begin
    AI_WaitMilliSeconds(101);
    HCL_AI_GotoObjRelWorld_nonblock(Bloodhound, 0, 0, 300);
    timer := timer +1;
  end;
  //SF_SetWorldPosition (-1000, -420, -145);


  //AI_WaitSeconds(3);
  AI_ResumeComms;
  AI_SendComm(COMM_Taunt);
  AI_MuteComms;
  AI_AddToAttackList(1000, Orca);
//  AI_AttackNothing(0);

  until (m_EVENT = EVENT_External)do
    HCL_AI_GotoObjRelWorld_nonblock(Nav, -100015, -420, -100);

  AI_WaitSeconds(2);

  m_GetPos(Defender);
  SF_SetWorldPosition(x+150, y, z+80);
  until (m_Event = EVENT_Defender_Cue) do AI_WaitMilliSeconds(1);
  AI_WaitMilliSeconds(20);
  AI_AddToWing(Defender);


  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;


function M_Player;
begin
  AI_PLR_ControlAssume;
  SF_ActivateSelf(0);
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  AI_MuteComms;
  AI_AttackNothing(1);
  //AI_FaceObject(Nav);
  AI_IgnoreCollisions(1);
  //AI_SetThrottle(100);
  if (SF_GetNumComponentPartsObj(Orca, PART_ChildGunTurret) > 3) then begin
    AI_WaitMilliSeconds(700);
    SYS_PlaySFX(147);
    AI_WaitMilliSeconds(300);
    SF_PrintText(390);
    AI_WaitMilliSeconds(250);
    SYS_PlaySFX(147);
    AI_WaitMilliSeconds(450);
    SYS_PlaySFX(147);
    AI_WaitMilliSeconds(300);
    SYS_PlaySFX(147);
    AI_WaitMilliSeconds(250);
    SYS_PlaySFX(147);
    AI_WaitMilliSeconds(400);
    SYS_PlaySFX(147);
    AI_WaitMilliSeconds(350);
    SYS_PlaySFX(147);
    AI_WaitMilliSeconds(270);
    SYS_PlaySFX(147);
    AI_WaitMilliSeconds(480);
    SYS_PlaySFX(147);
    AI_WaitMilliSeconds(240);
    SYS_PlaySFX(147);
    SF_PrintText(391);
    until (m_Event = EVENT_Firing) do begin
      AI_WaitMilliSeconds(SYS_Random(700));
      SYS_PlaySFX(147);
    end;
  end else begin
    AI_WaitSeconds(1);
    SF_PrintText(390);
    AI_WaitSeconds(3);
    SF_PrintText(391);
    until (m_Event = EVENT_Firing) do
      AI_WaitMilliSeconds(1);
  end;
  AI_WaitMilliSeconds(700);

  AI_WaitMilliSeconds(300);
  SYS_PlaySFX(28);
  AI_WaitMilliSeconds(400);
  SYS_PlaySFX(30);
  AI_WaitMilliSeconds(500);
  SYS_PlaySFX(29);
  AI_WaitMilliSeconds(300);

  until (m_Event = EVENT_Getaway) do AI_WaitSeconds(1);
  AI_WaitMilliSeconds(1000);
  SF_DestroyObject(Orca);

  until (m_Event = EVENT_External) do AI_WaitMilliSeconds(1);
  SF_SetHitPoints(20);

  AI_WaitSeconds(2);
  M_GetPos(Defender);
  SF_SetWorldPosition(x+50, y, z+120);
  AI_FaceObject(Defender);
  AI_SetThrottle(60);
  AI_AddToWing(Defender);

  //until (m_Event = EVENT_Defender_Cue) do AI_WaitMilliSeconds(1);


  while(1) do
    AI_Waitseconds(1);
end;

function M_Camera;
begin
  SF_CAM_TrackObj(Orca);
  SF_CAM_SetFollowObj(Orca, 150, 320, -30);
  SF_ActivateSelf(0);
  AI_WaitSeconds(5);
  SF_CAM_TrackObj(Bloodhound);
  SF_CAM_SetFollowObj(Bloodhound, 25, 10, 10);
  M_Event := EVENT_Action;
  until (m_Event = EVENT_Kill) do AI_WaitMilliSeconds(1);
  M_GetPos(Moray1);
  SF_CAM_SetPos(x+9, y+5, z+190);
  AI_WaitMilliSeconds(5300);
  SF_CAM_TrackObj(Night);

  SF_CAM_SetFollowObj(Night, -35, -10, -60);
  until(M_Event = EVENT_Attacking_Defender) do AI_WaitMilliseconds(1);
  AI_Waitseconds(3);
  //SF_CAM_SetFollowObj(Night, 0, 0, 55);
  m_GetPos(Shark);
  SF_CAM_SetPos(x+25, y+15, z+55);
  SF_CAM_TrackObj(Shark);
  AI_WaitSeconds(4);
  SF_CAM_TrackObj(Night);
  SF_CAM_SetFollowObj(Night, 20, 15, -60);
  until(M_EVENT=EVENT_Firing) do AI_WaitMilliSeconds(1);
  SF_CAM_SetFollowObj(Night, 9, -10, 10);
  until(M_EVENT=EVENT_Getaway) do AI_WaitMilliSeconds(1);
  SF_CAM_TrackObj(Orca);
  M_GetPos(Orca);
  SF_CAM_SetPos(x+130, y+70, z-580);// x, y, z+300, 2);
//  AI_WaitSeconds(3);
  AI_WaitSeconds(3);

  m_Event:= EVENT_External;
  SF_CAM_SetFollowObj(Orca, 280, 5, -1100);
  SF_CAM_TrackObj(Night);
  AI_Waitseconds(7);
  m_Event := EVENT_Conversation;
  SF_DeactivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);

//  SF_CAM_TrackObj(Defender);
//  SF_CAM_SetFollowObj(Defender, -30, 15, -20);

  AI_WaitSeconds(4);
  m_Event := EVENT_Defender_Cue;
  AI_WaitMilliSeconds(15);


  until (m_Event = EVENT_Blade_Cue) do AI_WaitMilliSeconds(1);
//  AI_Waitseconds(5);
  SF_ActivateSelf(0);
//  SF_CAM_TrackObj(Defender);
//  AI_WaitSeconds(2);
  //SF_CAM_TrackPivotObjects(Defender, Player, 4);
  SF_CAM_TrackObj(Player);
  SF_CAM_SetFollowObj(Player, 18, 5, -14);
  AI_WaitSeconds(4);
  m_EVENT:= EVENT_Defender_Cue2;
//  AI_WaitSeconds(4);

  //SF_CAM_TrackPivotObjects(Player, Orca, 2);
  SF_PlayerSwitchToCam(CamId_auto, Defender);
  AI_WaitSeconds(10);

  SF_Exit;
  while(1) do
    AI_WaitSeconds(1);
end;

function M_AttackerBug;
begin
  SF_SetObjectFlag(OF_Vulnerable, false);
  AI_MuteComms;
  SF_SetObjectFlag(OF_Alignment, ALIGN_Alien);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  AI_FaceObject(Defender);
  until (m_Event = EVENT_Kill) do AI_WaitMilliSeconds(1);
  AI_WaitMilliSeconds(5300);
  SF_ActivateSelf(0);
  SF_SetWorldPosition (-50, 40, -200);
  AI_GotoObjRange(Defender,250);
  M_Event:=EVENT_Attacking_Defender;
  AI_FireMissile(18);
  AI_WaitMilliSeconds(300);
  AI_GotoObjRelWorld(orca, -100, -400, -900);
  //AI_Waitseconds(6);
  AI_WaitSeconds(12);
  SF_DeactivateSelf(0);
  //SF_DestroySelf;
  while(1) do
    AI_Waitseconds(1);
end;

function M_Moray;
begin
  AI_MuteComms;
  SF_SetObjectFlag(OF_Alignment, ALIGN_ALIEN);
  SF_SetObjectFlag(OF_Vulnerable, false);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  SF_ActivateSelf(0);
  AI_SetThrottle(0);
  AI_WaitSeconds(4);
  AI_SetThrottle(80);
  until (m_Event = EVENT_Kill) do
    HCL_AI_GotoObjRelWorld_nonblock(Moray1, 0, 0, 300);

  AI_WaitMilliSeconds(700);
  AI_ResumeComms;
  AI_SendComm(5);
  AI_WaitMilliSeconds(400);
  SF_SetObjectFlag(OF_Vulnerable, true);
  SF_DestroySelf;
  while(1) do AI_WaitSeconds(1);
end;

function M_Moray2;
begin
  AI_MuteComms;
  SF_SetObjectFlag(OF_Alignment, ALIGN_Neutral);
  SF_SetObjectFlag(OF_Vulnerable, false);
  AI_FaceObject(Player);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  AI_SetThrottle(0);
  until (m_Event = EVENT_Attacking_Defender) do
    AI_WaitSeconds(1);
  SF_ActivateSelf(0);
  AI_FireMissile(7);
  AI_FireMissile(7);
  SF_DeactivateSelf(0);
  while(1) do AI_WaitSeconds(1);
end;

function M_Orca;
begin
  SF_SaveObjectState(false);
  SF_ActivateSelf(0);
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  while(1) do AI_WaitSeconds(1);
end;

function M_Nav;
begin
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      AI_WaitSeconds(130);
      SF_Exit;
      while(NAV_WithinSphere(Player)) do AI_WaitSeconds(1);
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;
