//******************************************************************************
//
// Unknown Enemy
// Cinematic 3 - Kappa Wing in distress
//
// Created by: Jakub Majewski  <qmajewski@yahoo.co.uk>
// Last modified: Aug 10, 2002
//
//******************************************************************************

mission scene3;

#sector: "t.sec";

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, uepilots;
#include ue;
#include Comms;
#SetRooms ("cic.rom", "rec.rom");

#strings objectiv;
#strings spacefli;
#strings targetid;

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior, PILOT_Vaqi);

#SetOutputPath("$wcue$\mission\");
#file "block690.pas";
#file "block691.pas";

var
  x, y, z,
  m_Event = 0,
  m_Comm = 0,
  m_Event2 = 0,
  m_Event3 = 0;

const
  EVENT_Crossing_Time = 1,
  EVENT_Evasive = 2,
  EVENT_Chase = 3,
  EVENT_Fire = 4,
  EVENT_Trouble = 5,
  EVENT_Killbugs = 6,
  EVENT_Charge = 7,
  EVENT_Buggered = 8,
  EVENT_Ejection = 9,
  EVENT_Pod = 10,
  EVENT_Pod_Action = 11,
  EVENT_Endgame = 12,
  EVENT_Burnout = 13,
  COMM_Enemy = 1,
  COMM_Roger = 2,
  COMM_Need_Help = 3,
  COMM_Argh = 4,
  COMM_Ejecting = 5,
  COMM_Leave_Me = 6;

function MAIN;
begin
  MS_RunGameFlow(0);
  MS_RunSpaceflight(0);
  MS_SetPilotDead(PILOT_Gold, 1);
  MS_SetPilotDead(PILOT_Warrior, 1);
end;

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

#name: 17;

objective mobj_patrol
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Patrol All NAV Points"];
  status: MOBJ_Incomplete;
  counter: false;
end;

// ************************* Declared Objects ***************

object Light1(Light)
  x: 0;
  y: 0;
  z: 0;
  LightType: LIGHT_Ambient;
  LightColor: 0.3, 0.3, 0.3;
end;

object Belt1(ABStart)
  x: 0;
  y: 0;
  z: 0;
  absdata: 1,         // belt id
           6000,      // number of objects
           2100;      // diameter
end;

object Nav(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_Nav;
  navdata: 1, 50000;
end;

object Player(Player)
  obj: aaceship;
  x: -5000;
  y: -5000;
  z: -5000;
  main: M_Player;
  pilot: PILOT_Casey2;
end;

object Gold(Ship)
  obj: UE_SHIP_Scimitar;
  x: 200;
  y: 0;
  z: 0;
  main: M_Gold;
  pilot: PILOT_Gold;
  targstr: 1;
end;

object Warrior(Ship)
  obj: UE_SHIP_Scimitar;
  x: 220;
  y: 0;
  z: 0;
  main: M_Warrior;
  pilot: PILOT_Warrior;
  targstr: 1;
end;

object Pod(Ship)
  obj: ejectpil;
  x: 220;
  y: 0;
  z: 0;
  main: M_Pod;
  pilot: PILOT_Warrior;
  targstr: 1;
end;

object Bug1(Ship)
  obj: moray;
  x: 5500;
  y: 5550;
  z: 5500;
  main: M_DeadBug;
  death: D_DeadBug;
  pilot: Pilot_Alien2;
end;

object KillBug(Ship)
  obj: manta;
  x: 5550;
  y: 5500;
  z: 5500;
  main: M_KillBug;
  pilot: Pilot_Alien_Ace;
end;

object KillBug2(Ship)
  obj: manta;
  x: 5500;
  y: 5500;
  z: 5500;
  main: M_KillBug2;
  pilot: Pilot_Alien1;
end;

object Camera(Camera)
  x: 0;
  y: -10;
  z: -200;
  main: M_Camera;
end;

// *********************** Functions ***********************

function M_KillBug;
begin
  AI_IgnoreCollisions(1);
  AI_MuteComms;
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  SF_SetObjectFlag(OF_vulnerable, false);
  AI_SetThrottle(0);
  AI_AttackNothing(1);
  until (m_Event2 = EVENT_Killbugs) do AI_WaitMilliSeconds(1);
  m_GetPos(Warrior);
  SF_SetWorldPosition(x-120, y, z+230);
  AI_FaceObject(Bug1);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Charge) do AI_WaitMilliSeconds(1);
  AI_ResumeComms;
  AI_SendComm(COMM_Taunt);
  AI_MuteComms;
  //until (m_Event = EVENT_Doom) do
  AI_WaitSeconds(1);
  AI_AddToAttackList(Warrior, 1000);
  AI_AttackNothing(0);
  AI_WaitMilliSeconds(750);
  AI_FireMissile(18);
  AI_WaitMilliSeconds(500);
  m_Comm := COMM_Need_Help;
  AI_WaitMilliSeconds(200);
  m_Event2 := EVENT_Buggered;

  until (m_Event2 = EVENT_Pod) do AI_WaitMilliSeconds(1);
  AI_WaitMilliSeconds(100);
  SF_DeactivateSelf(0);
  while(1) do
    AI_WaitSeconds(1);
end;

function M_KillBug2;
begin
  AI_IgnoreCollisions(1);
  AI_MuteComms;
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  SF_SetObjectFlag(OF_vulnerable, false);
  AI_SetThrottle(0);
  AI_AttackNothing(1);
  until (m_Event2 = EVENT_Killbugs) do AI_WaitMilliSeconds(1);
  //m_GetPos(Warrior);
  AI_WaitMilliSeconds(20);
  SF_SetWorldPosition(x-100, y-5, z+225);
  AI_FaceObject(Bug1);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Charge) do AI_WaitMilliSeconds(1);
  AI_AddToWing(KillBug);

  until (m_Event2 = EVENT_Pod) do AI_WaitMilliSeconds(1);
  AI_WaitMilliSeconds(100);
  SF_DeactivateSelf(0);
  while(1) do
    AI_WaitSeconds(1);
end;

function M_DeadBug;
begin
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  AI_SetThrottle(0);
  AI_MuteComms;
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  SF_SetHitPoints(33);
  SF_BindToActionSphere(0);
  Until (m_Event = EVENT_Crossing_Time) do AI_WaitMilliSeconds(1);
  m_GetPos(Warrior);
  SF_SetWorldPosition(x-550, y, z-350);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Evasive) do
    HCL_AI_GotoObjRelWorld_nonblock(Nav, x-550, y, z+100);

  until (m_Event = EVENT_Chase) do
    HCL_AI_GotoObjRelWorld_nonblock(Nav, x-1800, y, z+100);

  AI_SetThrottle(100);

  until (m_Event2 = EVENT_Fire) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(5);
  SF_DestroySelf;

  while (1) do
    AI_WaitSeconds(1);
end;

function D_DeadBug;
begin
  if (m_Event = EVENT_Chase) then
    m_Event := EVENT_Trouble
  else
    m_Event3 := EVENT_Trouble;
end;

function M_Gold;
begin
  AI_IgnoreCollisions(1);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  AI_FaceObject(Nav);
  SF_SetWorldPosition(200, -18, -150);
  SF_ActivateSelf(0);
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_Vulnerable, false);
  AI_MuteComms;
  AI_SetThrottle(60);
  until (m_Comm = COMM_Roger) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(33, 6);
  AI_WaitSeconds(3);
  m_Event := EVENT_Chase;
  while (m_Event = EVENT_Chase) do
    HCL_AI_GotoObjRelWorld_nonblock (Nav, x-1800, y, z+80);
  AI_SetThrottle(60);
  AI_ResumeComms;
  AI_SendComm(4);
  AI_MuteComms;
  until (m_Event2 = EVENT_Buggered) do AI_WaitMilliSeconds(1);
  //AI_IgnoreCollisions(0);
  AI_AddToIgnoreList(Player, 1000);
  AI_AttackNothing(0);

  until (m_Comm = COMM_Argh) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(33, 8);
  AI_WaitMilliSeconds(500);
  SF_SetObjectFlag(OF_Vulnerable, true);
  SF_DestroySelf;

  while (1) do begin
    AI_WaitMilliSeconds(1);

  end;
end;


function M_Warrior;
begin
  SF_SetPilotImmortal(PILOT_Warrior, 1);
  AI_IgnoreCollisions(1);
  AI_MuteComms;
  SF_SetWorldPosition(200, -18, -120);
  AI_FaceObject(Nav);
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  AI_AttackNothing(1);
  AI_AddToWing(Gold);
  AI_MuteCOmms;

  SF_ActivateSelf(0);
  AI_SetThrottle(60);
  until (m_Comm = COMM_Enemy) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(33, 5);
  AI_WaitSeconds(5);
  m_Comm := COMM_Roger;
  until (m_Event2 = EVENT_Fire) do AI_WaitMilliSeconds(1);
  AI_FireMissile(7);
  AI_WaitSeconds(1);
  AI_FireMissile(7);
  until (m_Comm = COMM_Need_Help) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(33, 7);
  AI_RemoveFromWing;
  SF_SetHitPoints(20);
  until (m_Comm = COMM_Ejecting) do
    HCL_AI_GotoObjRelWorld_nonblock(Nav, x-2000, y, z);
  AI_SetThrottle(20);

  AI_SendSpecialComm(33, 9);
  AI_WaitSeconds(1);
  AI_SetThrottle(0);
  AI_WaitMilliSeconds(1950);
  m_Event2 := EVENT_Pod;
  AI_WaitMilliSeconds(1050);
  SF_SetObjectFlag(OF_Vulnerable, true);
  SF_DestroySelf;

  while(1) do begin
    AI_WaitMilliSeconds(1);
  end;
end;

function M_Nav;
begin
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      AI_WaitSeconds(180);
      SF_Exit;

      while(NAV_WithinSphere(Player)) do
        AI_WaitSeconds(1);
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Player;
begin
  AI_PLR_ControlAssume;
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Alignment, ALIGN_Alien);
  SF_ActivateSelf(0);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  AI_SetThrottle(0);
  until (m_Event = EVENT_Chase) do AI_WaitMilliSeconds(1);
  while (m_Event = EVENT_Chase) do
    HCL_AI_GotoObjRelWorld_nonblock(Nav, -5000, -5000, -3000);

  until (m_Event2 = EVENT_Killbugs) do AI_WaitMilliSeconds(1);
  //m_GetPos(Warrior);
  AI_WaitMilliSeconds(50);
  SF_SetWorldPosition(x-85, y+10, z+235);
  AI_FaceObject(Bug1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Ejection) do AI_WaitMilliSeconds(1);
  //AI_FaceObjRelWorld(Warrior, 0,0,0);
  AI_SetThrottle(100);

  until (m_Event2 = EVENT_Pod) do AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);
  AI_WaitMilliSeconds(30);
  m_GetPos(Pod);
  SF_SetWorldPosition (x-200, y+5, z);
  AI_FaceObject(Pod);
  AI_WaitSeconds(2);

  until (m_Event = EVENT_Pod_Action) do AI_WaitMilliSeconds(1);
  AI_SetThrottle(15);

  until (m_Comm = COMM_Leave_Me) do AI_WaitMilliSeconds(1);
  AI_FaceObjRelWorld(Pod, 0, 0, 0);

  until (SF_GetDistance(Pod) < 33) do
    AI_SetThrottle(30);
  SYS_PlaySFX(79);
  AI_WaitSeconds(1);
  AI_SetThrottle(0);
  AI_WaitSeconds(1);
  m_Event := EVENT_Endgame;
  AI_WaitSeconds(5);
  SF_DeactivateObject(Pod, 0);
  m_Event2 := EVENT_Burnout;
  AI_WaitMilliSeconds(600);
  AI_SetThrottle(100);
  AI_WaitSeconds(15);
  SF_Exit;

  while (1) do begin
    AI_WaitMilliSeconds(1);
  end;
end;

function M_Pod;
begin
  AI_IgnoreCollisions(1);
  AI_MuteComms;
//  SF_SetWorldPosition(200, -18, -120);
  AI_FaceObject(Nav);
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag(OF_Collidable, false);
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  AI_AttackNothing(1);

  until (m_Event2 = EVENT_Pod) do AI_WaitMilliSeconds(1);
  m_GetPos(Warrior);
  SF_SetWorldPosition(x, y+100, z);
  SF_ActivateSelf(0);
  AI_WaitMilliSeconds(40);
  AI_FaceObject(Player);
  AI_WaitMilliSeconds(1200);
  SYS_PlaySFX(12);

  until (m_Event = EVENT_Pod_Action) do AI_WaitMilliSeconds(1);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);

  until (m_Comm = COMM_Leave_Me) do AI_WaitMilliSeconds(1);
  AI_SendSpecialComm(33, 10);

  AI_WaitSeconds(30);
  SF_Exit;

  while(1) do begin
    AI_WaitMilliSeconds(1);
  end;
end;

function M_Camera;
begin
  SF_CAM_TrackPos(0, -10, 0);
  SF_ActivateSelf(0);
  SF_CAM_HideDust;
  SF_CAM_SetFlyBySound(0);
  SF_PrintText(690);
  AI_WaitSeconds(3);
  SF_PrintText(691);
  AI_WaitSeconds(4);
  SYS_PlaySFX(190);
  AI_WaitSeconds(1);
  SYS_PlaySFX(190);
  AI_WaitSeconds(1);
  SF_Cam_TrackPivot(0,-10,0,-400, -10, 0, 4);
  AI_WaitSeconds(4);
  SF_CAM_SetFlyBySound(1);
  SF_CAM_ShowDust;
  SF_CAM_TrackObj(Warrior);
  SF_CAM_SetFollowObj(Warrior, 8, 7, -45);
  AI_WaitSeconds(5);
  m_Event := EVENT_Crossing_Time;
  AI_WaitSeconds(1);
  m_Comm := COMM_Enemy;
//  AI_WaitMilliSeconds(200);
  //SF_CAM_TrackObj(Bug1);
  //SF_CAM_SetFollowObj(Bug1, 127, 9, -8);
  AI_WaitMilliSeconds(2000);
  //SF_CAM_TrackObj(Warrior);
  //SF_CAM_SetFollowObj(Warrior, 8, 7, -45);
//  AI_WaitMilliSeconds(200);
  m_Event := EVENT_Evasive;
  //AI_WaitSeconds(1);

  until (m_Event = EVENT_Chase) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(7);
  m_Event2 := EVENT_Fire;
  until (m_Event = EVENT_Trouble) do begin
    AI_WaitMilliSeconds(1);
    if (m_Event3 = EVENT_Trouble) then SF_Exit;
  end;
  AI_WaitMilliSeconds(2700);
  m_Event2 := EVENT_Killbugs;
  AI_WaitMilliSeconds(50);
  SF_CAM_TrackObj(KillBug);
  SF_CAM_SetFollowObj(KillBug, 8, 7, -65);
  AI_WaitSeconds(10);
  m_Event := EVENT_Charge;
  until (m_Event2 = EVENT_Buggered) do AI_WaitMilliSeconds(1);
  SYS_PlaySFX(111);
  SF_CAM_TrackObj(Warrior);
  SF_CAM_SetFollowOBj(Warrior, 47, 9, -8);
  AI_WaitSeconds(1);
  SYS_PlaySFX(111);
  AI_WaitSeconds(1);
  SF_CAM_TrackObj(Player);
  SF_CAM_SetFollowObj(Player, -10, -7, 23);
  AI_WaitSeconds(5);
  m_Comm := COMM_Argh;
  AI_WaitSeconds(3);
  m_Event := EVENT_Ejection;
  AI_WaitSeconds(2);
  m_Comm := COMM_Ejecting;
  AI_WaitMilliSeconds(1500);
  m_GetPos(Warrior);
  SF_CAM_SetPos(x-10, y+45, z-5);
  SF_CAM_TrackPos(x,y,z);
  SF_CAM_SetMotion(x-10, y+25, z-5, x-5, y+6, z-5, 4);
//  AI_WaitMilliSeconds(1800);
//  SF_CAM_TrackNothing;

//  until (m_Event2 = EVENT_Pod) do AI_WaitMilliSeconds(1);
  AI_WaitMilliSeconds(3850);
  m_Event := EVENT_Pod_Action;
//  SF_CAM_TrackObj(Pod);
  SF_CAM_SetFollowObj(Pod, -3, 2, -13);
  SF_CAM_TrackObj(Player);
  AI_WaitMilliSeconds(500);
  m_Comm := COMM_Leave_Me;
  AI_WaitSeconds(3);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
  SF_DeactivateSelf(0);
  until (m_Event = EVENT_Endgame) do AI_WaitMilliSeconds(1);
  SF_CAM_SetFlyBySound(0);
  SF_CAM_TrackObj(Player);
  SF_CAM_SetFollowObj(Player, 3, 14, 8);
  SF_ActivateSelf(0);
  until (m_Event2 = EVENT_Burnout) do begin
    SYS_PlaySFX(117);
    AI_WaitMilliSeconds(500);
  end;
  m_GetPos(Player);
  SF_CAM_SetPos(x-10, y+14, z+80);



  AI_WaitSeconds(5);
  SF_Exit;

  while(1) do
    AI_WaitSeconds(1);
end;
