//******************************************************************************
//
// Unknown Enemy
//
// Created by: Thomas Bruckner <thomas.bruckner@aon.at>
// Last modified: Nov 25th, 2001
//
//******************************************************************************

series enemy;

#SetOutputPath("$wcue$\mission\");
#include wcp;
#include ue;

const
  MIS_UE_Intro = 0,
  MIS_UE_0 = 1,
  MIS_UE_1 = 2,
  MIS_UE_2a = 3,
  MIS_UE_2b = 4,
  MIS_UE_Scene1 = 5,
  MIS_UE_3a = 6,
  MIS_UE_3b = 7,
  MIS_UE_4 = 8,
  MIS_UE_5a = 9,
  MIS_UE_5b = 10,
  MIS_UE_6 = 11,
  MIS_UE_Scene2 = 12,
  MIS_UE_7a = 13,
  MIS_UE_7b = 14,
  MIS_UE_8a = 15,
  MIS_UE_8b = 16,
  MIS_UE_Scene3 = 17,
  MIS_UE_Scene3b = 27,
  MIS_UE_9a = 18,
  MIS_UE_9b = 19,
  MIS_UE_10a = 20,
  MIS_UE_10b = 21,
  MIS_UE_Extro1a = 22,
  MIS_UE_Extro1b = 23,
  MIS_UE_Extro1c = 24,
  MIS_UE_Extro2a = 25,
  MIS_UE_Extro2b = 26,

  Splash_UE_1 = 0,
  Splash_UE_2a = 1,
  Splash_UE_2b = 2,
  Splash_UE_3a = 3,
  Splash_UE_3b = 4,
  Splash_UE_4a = 5,
  Splash_UE_4b = 6,
  Splash_UE_5a = 7,
  Splash_UE_5b = 8,
  Splash_UE_6a = 9,
  Splash_UE_6b = 10,
  Splash_UE_7a = 11,
  Splash_UE_7b = 12,
  Splash_UE_8a = 13,
  Splash_UE_8b = 14,
  Splash_UE_9a = 15,
  Splash_UE_9b = 16,
  Splash_UE_10a = 17,
  Splash_UE_10b = 18,
  Splash_WCP_Gold = 19;


var
  g_UE_1_Won = 0,
  g_UE_2a_Won = 0,
  g_UE_2b_Won = 0,
  g_UE_3a_Won = 0,
  g_UE_3b_Won = 0,
  g_UE_7_Won = 0,
  g_UE_8_Won = 0,
  g_UE_9_Won = 0,
  g_UE_10a_Won = 0,
  g_Secret_EasterEgg_Active = 0,

  g_Fralthi_Dead = 0,
  g_Special_Sim = 0,
  g_Shotglass_Egg = 1;

function MCP;
begin
  MCP_RunMission(MIS_UE_Intro);
  MCP_GetCallsign;
  MCP_RunMission(MIS_UE_0);

  // Only one path after 0
  MCP_ShowSplashScreen(Splash_UE_1, 30);
  MCP_RunMission(MIS_UE_1);

  // Must win 1 to stick to winning path
  if (g_UE_1_Won) then
    MCP_ShowSplashScreen(Splash_UE_2a, 30)
  else
    MCP_ShowSplashScreen(Splash_UE_2b, 30);

  if (g_UE_1_Won) then
    MCP_RunMission(MIS_UE_2a)
  else
    MCP_RunMission(MIS_UE_2b);

  // Must win 2a to stick to winning path;
  // Winning 2b has no effect - you stay on losing path
  if (g_UE_2a_Won) then
    MCP_ShowSplashScreen(Splash_UE_3a, 30)
  else
    MCP_ShowSplashScreen(Splash_UE_3b, 30);

  SYS_PlayMovie(9000);
  // Cutscene 1 - a new threat
  MCP_RunMission(MIS_UE_Scene1);

  if (g_UE_2a_Won) then
    MCP_RunMission(MIS_UE_3a)
  else
    MCP_RunMission(MIS_UE_3b);

  // Winning 3a and 3b gives you same password
  // (even though winning 3b does not lead you back to
  // the winning path)
  // Losing either leads ultimately to 5b - and death
  if ((g_UE_3a_Won) or (g_UE_3b_Won)) then
    MCP_ShowSplashScreen(Splash_UE_4a, 30)
  else
    MCP_ShowSplashScreen(Splash_UE_4b, 30);

  // Scramble for all!
  MCP_RunMission(MIS_UE_4);

  // Passwords for 5a and 5b depend entirely on 3a/b
  // So, same arrangements as before. Note that 5a is
  // thus a mission for both middle and winning paths
  if ((g_UE_3a_Won) or (g_UE_3b_Won)) then
    MCP_ShowSplashScreen(Splash_UE_5a, 30)
  else
    MCP_ShowSplashScreen(Splash_UE_5b, 30);

  if ((g_UE_3a_Won) or (g_UE_3b_Won)) then
    MCP_RunMission(MIS_UE_5a)
  else
  begin
    MCP_RunMission(MIS_UE_5b);

    // Extro 1c, to be seen only be the losers, alas
    MCP_RunMission(MIS_UE_Extro1c);
    MCP_WinningEndgame;
    MCP_EscapeMenu;
    MCP_Exit;
  end;

  // Since 5a is common for both, it does not affect
  // the player's path. Further path determined by 3a/3b
  if (g_UE_3a_Won) then begin
    MCP_ShowSplashScreen(Splash_UE_6a, 30);
    SYS_PlayMovie(9015);
  end
  else
    MCP_ShowSplashScreen(Splash_UE_6b, 30);

  // Scramble, common for all (except losers)!
  MCP_RunMission(MIS_UE_6);

  // Same as before, choice determined by 3a/3b
  if (g_UE_3a_Won) then
    MCP_ShowSplashScreen(Splash_UE_7a, 30)
  else
    MCP_ShowSplashScreen(Splash_UE_7b, 30);

  // Cutscene 2 - the good guys strike back
  // Only for players with Fralthi
  if (g_UE_3a_Won) then
    MCP_RunMission(MIS_UE_Scene2);

  // Up to mission 7, and still being haunted by 3a/b
  if (g_UE_3a_Won) then
    MCP_RunMission(MIS_UE_7a)
  else
    MCP_RunMission(MIS_UE_7b);

  // Ahh, finally another chance to screw up and get
  // off the winning path. No losing path, of course,
  // just middle.
  if (g_UE_7_Won) then
    MCP_ShowSplashScreen(Splash_UE_8a, 30)
  else
    MCP_ShowSplashScreen(Splash_UE_8b, 30);

  if (g_UE_7_Won) then
    MCP_RunMission(MIS_UE_8a)
  else
    MCP_RunMission(MIS_UE_8b);

  // Next bunch of missions are all standard procedure
  if (g_UE_8_Won) then
    MCP_ShowSplashScreen(Splash_UE_9a, 30)
  else
    MCP_ShowSplashScreen(Splash_UE_9b, 30);

   // Cutscene 3 - the return of the Devil Ray
  if (g_UE_8_Won) then
    MCP_RunMission(MIS_UE_Scene3)
  else
    MCP_RunMission(MIS_UE_Scene3b);

  if (g_UE_8_Won) then
    MCP_RunMission(MIS_UE_9a)
  else
    MCP_RunMission(MIS_UE_9b);

  if (g_UE_9_Won) then
    MCP_ShowSplashScreen(Splash_UE_10a, 30);
  //else
  //  MCP_ShowSplashScreen(Splash_UE_10b, 30);

  if (g_UE_9_Won) then
    MCP_RunMission(MIS_UE_10a)
  else
    MCP_RunMission(MIS_UE_10b);

  if (g_UE_10a_Won) then begin
    MCP_RunMission(MIS_UE_Extro1a);
    MCP_RunMission(MIS_UE_Extro2a);
  end
  else begin
    MCP_RunMission(MIS_UE_Extro1b);
    MCP_RunMission(MIS_UE_Extro2b);
  end;

  MCP_WinningEndgame;
  // That is all, dismissed!

  //MCP_ShowSplashScreen(Splash_WCP_Gold, 30);
  MCP_EscapeMenu;
  MCP_Exit;
end;

function G_RunBriefing;
begin
  GF_Exit;
end;

function G_BriefingDoorFidget;
begin
  GF_SetRoomVar (2, 1);
end;

function G_BriefingDoorHover;
begin
  if (GF_GetRoomVar(2)) then begin
    GF_SetRoomVar (2, 0);
    SYS_PlaySFX(136);
  end;
end;

function G_GFExit;
begin
  GF_ExitGame;
end;

function G_ExitDoor_Fidget;
begin
  GF_SetRoomVar (3, 1);
end;

function G_ExitDoor_Hover;
begin
  if (GF_GetRoomVar(3)) then begin
    GF_SetRoomVar (3, 0);
    SYS_PlaySFX(136);
  end;
end;

function G_QuickLoad;
begin
  GF_QuickLoad;
end;

function G_QuickLoad_Fidget;
begin
  GF_SetRoomVar (4, 1);
end;

function G_QuickLoad_Hover;
begin
  if (GF_GetRoomVar(4)) then begin
    GF_SetRoomVar (4, 0);
    SYS_PlaySFX(136);
  end;
end;

function G_QuickSave;
begin
  GF_QuickSave;
end;

function G_QuickSave_Fidget;
begin
  GF_SetRoomVar (5, 1);
end;

function G_QuickSave_Hover;
begin
  if (GF_GetRoomVar(5)) then begin
    GF_SetRoomVar (5, 0);
    SYS_PlaySFX(136);
  end;
end;

function G_RunMainTerminal;
begin
  GF_RunMainTerminal;
end;

function G_MainTerminal_Fidget;
begin
  GF_SetRoomVar (6, 1);
end;

function G_MainTerminal_Hover;
begin
  if (GF_GetRoomVar(6)) then begin
    GF_SetRoomVar (6, 0);
    SYS_PlaySFX(136);
  end;
end;

function G_ViewKillboard;
begin
  GF_RunKillboard;
end;

function G_Killboard_Fidget;
begin
  GF_SetRoomVar (7, 1);
end;

function G_Killboard_Hover;
begin
  if (GF_GetRoomVar(7)) then begin
    GF_SetRoomVar (7, 0);
    SYS_PlaySFX(136);
  end;
end;

function G_RunTrainingSimulator;
begin
  GF_RunTrainingSimulator;
end;

function G_Simulator_Fidget;
begin
  GF_SetRoomVar (8, 1);
end;

function G_Simulator_Hover;
begin
  if (GF_GetRoomVar(8)) then begin
    GF_SetRoomVar (8, 0);
    SYS_PlaySFX(136);
  end;
end;

function G_RunObjectViewer;
begin
  GF_RunObjectViewer;
end;

function G_Object_Viewer_Fidget;
begin
  GF_SetRoomVar (1, 1);
end;

function G_Object_Viewer_Hover;
begin
  if (GF_GetRoomVar(1)) then begin
    GF_SetRoomVar (1, 0);
    SYS_PlaySFX(136);
  end;
end;

function G_EnterBar;
begin
  GF_LoadRoom(1);
end;

function G_ToReadyRoom;
begin
  GF_LoadRoom(0);
end;

function G_RecDoor_Fidget;
begin
  GF_SetRoomVar (9, 1);
end;

function G_RecDoor_Hover;
begin
  if (GF_GetRoomVar(9)) then begin
    GF_SetRoomVar (9, 0);
    SYS_PlaySFX(136);
  end;
end;

function G_RunSpecialSim;
begin
  g_Special_Sim := 1;
  GF_RunTrainingSimulator;
  g_Special_Sim := 0;
end;

function G_TalkToShotglass;
begin
  if (g_Shotglass_Egg = 1) then
    SYS_PlaySFX(175);
  if (g_Shotglass_Egg = 2) then
    SYS_PlaySFX(177);
  if (g_Shotglass_Egg = 3) then begin
    SYS_PlaySFX(179);
    g_Shotglass_Egg := 0;
  end;
  g_Shotglass_Egg := g_Shotglass_Egg + 1;
end;

function G_Shotglass_Fidget;
begin
  GF_SetRoomVar (10, 1);
end;

function G_Shotglass_Hover;
begin
  if (GF_GetRoomVar(10)) then begin
    GF_SetRoomVar (10, 0);
  end;
end;

