//******************************************************************************
//
// Unknown Enemy
// Sim Mission 0 - Ferret Training
//
// Created by: Jakub Majewski <qmajewski@yahoo.co.uk>
//
// Last modified: May 30, 2002
//
//******************************************************************************


mission s0;
#SetOutputPath("$wcue$\mission\");

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, uepilots;
#include UE;
#include Comms;

#strings objectiv;
#strings spacefli;
#strings targetid;

#SetOutputPath("$wcue$\mission\");

#sector: "t.sec";

#include wcp, consts, ships;

var M_Failed = 0,
    Bad_Cargo_Dead = 0,
    Bad_Cargo_Found = 0,
    Bad_Cargo2_Dead = 0,
    Bad_Cargo2_Found = 0,
    ID = 0,
    ID2 = 0,
    CargoShutDown = 0,
    Buggered = 0,
    Enemies = 0;

external g_Secret_EasterEgg_Active;

object Nav1(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_Nav1;
  navdata: 1, 5000;
end;

object Player(Player)
  obj: ferret;
  x: 0;
  y: 1000;
  z: 0;
  main: M_Player;
  pilot: 74;
end;

function M_Player;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
  while(1) do begin
    AI_WaitSeconds(1);
    if (M_Failed = true) then begin
      SF_SetMissionFailure;
      AI_WaitSeconds(7);
      SF_Exit;
    end;
  end;
end;

object Beaufort(Capship) as "TCS Something"
  obj: UE_SHIP_Beaufort;
  x: 0;
  y: 0;
  z: 0;
  main: M_Beaufort;
  pilot: PILOT_Beaufort;
end;

function M_Beaufort;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
 SF_ActivateSelf(0);
 while (1) do begin
   AI_WaitSeconds(1);
   if (Buggered = 1) then begin
     AI_SendComm(23);
     Buggered := 0;
   end;
 end;
end;

object Rapier(Ship)
  obj: rapier4;
  x: 0;
  y: 1000;
  z: -100;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 158;
end;

object Rapier2(Ship)
  obj: rapier4;
  x: 0;
  y: 1100;
  z: -100;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 158;
end;

object Rapier3(Ship)
  obj: rapier4;
  x: 50;
  y: 1100;
  z: -100;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 158;
end;

object Rapier4(Ship)
  obj: rapier4;
  x: 0;
  y: -500;
  z: -100;
  main: M_Friendly;
  pilot: PILOT_Spyder;
  targstr: 2;
end;

object Rapier5(Ship)
  obj: rapier4;
  x: 50;
  y: -500;
  z: -100;
  main: M_Friendly;
  pilot: PILOT_Zero;
  targstr: 2;
end;

object Rapier6(Ship)
  obj: rapier4;
  x: -50;
  y: -500;
  z: -100;
  main: M_Friendly;
  pilot: PILOT_Stiletto;
  targstr: 2;
end;

object Rapier7(Ship)
  obj: rapier4;
  x: 50;
  y: 1100;
  z: -100;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 158;
end;

object Rapier8(Ship)
  obj: rapier4;
  x: 50;
  y: 1120;
  z: -100;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 158;
end;

object Rapier9(Ship)
  obj: rapier4;
  x: 50;
  y: 1150;
  z: -100;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 158;
end;

object Rapier10(Ship)
  obj: rapier4;
  x: 50;
  y: 1050;
  z: -100;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 158;
end;

object Rapier11(Ship)
  obj: rapier4;
  x: 50;
  y: 1050;
  z: -150;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 158;
end;

object Rapier12(Ship)
  obj: rapier4;
  x: 50;
  y: 1050;
  z: -200;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 158;
end;

object ConAlpha(Cargo)
  x: 0;
  y: 300;
  z: 1200;
  main: M_Cargo;
  death: D_Cargo;
end;

object ConBravo(Cargo)
  x: 130;
  y: 300;
  z: 1160;
  main: M_Cargo;
  death: D_Cargo;
end;

object ConCharlie(Cargo)
  x: 180;
  y: 400;
  z: 1200;
  main: M_Cargo2;
  death: D_Cargo;
end;

object ConDelta(Cargo)
  x: -80;
  y: 560;
  z: 1060;
  main: M_Cargo2;
  death: D_Cargo;
end;

object ConEcho(Cargo)
  x: 75;
  y: 480;
  z: 1320;
  main: M_CargoBad;
  death: D_CargoBad;
end;

object ConFoxtrot(Cargo)
  x: 40;
  y: 480;
  z: 1060;
  main: M_Cargo3;
  death: D_Cargo;
end;

object ConGamma(Cargo)
  x: -30;
  y: 600;
  z: 1110;
  main: M_Cargo3;
  death: D_Cargo;
end;

object ConHalo(Cargo)
  x: -180;
  y: 680;
  z: 1250;
  main: M_CargoBad2;
  death: D_CargoBad2;
end;

function M_Cargo;
begin
  SF_ActivateSelf(0);
  SF_SetContents(160);
  while(1) do begin
    AI_WaitSeconds(1);
    if (SF_IsIdentified) then begin
      SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
      ID := ID + 1;
      until (CargoShutDown = true) do AI_WaitSeconds(1);
      SF_DeactivateSelf(1);
    end;
  end;
end;

function M_Cargo2;
begin
  SF_ActivateSelf(0);
  SF_SetContents(167);
  while(1) do begin
    AI_WaitSeconds(1);
    if (SF_IsIdentified) then begin
      SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
      ID := ID + 1;
      until (CargoShutDown = true) do AI_WaitSeconds(1);
      SF_DeactivateSelf(1);
    end;
  end;
end;

function M_Cargo3;
begin
  SF_ActivateSelf(0);
  SF_SetContents(171);
  while(1) do begin
    AI_WaitSeconds(1);
    if (SF_IsIdentified) then begin
      SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
      ID := ID + 1;
      until (CargoShutDown = true) do AI_WaitSeconds(1);
      SF_DeactivateSelf(1);
    end;
  end;
end;

function M_CargoBad;
begin
  SF_ActivateSelf(0);
  SF_SetContents(159);
  while(1) do begin
    AI_WaitSeconds(1);
    if (SF_IsIdentified) then begin
      SF_SetObjectFlag (OF_Alignment, ALIGN_Evil_Kilrathi);
      Bad_Cargo_Found := true;
      ID := ID + 1;
      while (1) do AI_WaitSeconds(1);
    end;
  end;
end;

function M_CargoBad2;
begin
  SF_ActivateSelf(0);
  SF_SetContents(170);
  while(1) do begin
    AI_WaitSeconds(1);
    if (SF_IsIdentified) then begin
      SF_SetObjectFlag (OF_Alignment, ALIGN_Evil_Kilrathi);
      Bad_Cargo2_Found := true;
      ID := ID + 1;
      while (1) do AI_WaitSeconds(1);
    end;
  end;
end;

function D_Cargo;
begin
  M_Failed := true;
end;

function D_CargoBad;
begin
  if (Bad_Cargo_Found = true) then
    Bad_Cargo_Dead := true
  else
    M_Failed := true;
end;

function D_CargoBad2;
begin
  if (Bad_Cargo2_Found = true) then
    Bad_Cargo2_Dead := true
  else
    M_Failed := true;
end;

object Brisbania(CapShip)
  obj: UE_SHIP_Freighter;
  x: 1000;
  y: 400;
  z: -100;
  main: M_Freighter;
  pilot: PILOT_Confed;
end;

object Vega(CapShip)
  obj: UE_SHIP_Freighter;
  x: 2000;
  y: 200;
  z: 0;
  main: M_BadFreighter;
  pilot: 173;
end;

object Bonnie(CapShip)
  obj: UE_SHIP_Freighter;
  x: 3000;
  y: 0;
  z: -50;
  main: M_Freighter;
  pilot: 171;
end;

function M_Freighter;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Neutral);
  AI_SendComm(51);
  AI_SetThrottle(20);
  while (1) do begin
    AI_WaitSeconds(1);
    if (SF_GetZ > 500) then begin
      SF_DeactivateSelf(1);
      M_Failed := true;
    end;
    if (SF_GetDistance(Player) < 300) then begin
      SF_PrintText(190);
      SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
      ID2 := ID2 + 1;
      AI_SetThrottle(0);
      while(1) do AI_WaitSeconds(1);
    end;
  end;
end;

function M_BadFreighter;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Neutral);
  AI_SetThrottle(20);
  while (1) do begin
    AI_WaitSeconds(1);
    if (SF_GetZ > 500) then begin
      SF_DeactivateSelf(1);
      M_Failed := true;
    end;
    if (SF_GetDistance(Player) < 300) then begin
      SF_PrintText(191);
      SF_SetObjectFlag(OF_alignment, ALIGN_Evil_Kilrathi);
      ID2 := ID2 + 1;
      while (1) do begin
        AI_WaitSeconds(1);
        if (SF_GetNumComponentParts(PART_ChildGunTurret) = 0) then begin
          AI_WaitSeconds(1);
          SF_SetObjectFlag (OF_Alignment, ALIGN_Neutral);
          AI_WaitSeconds(1);
          SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
          AI_SetThrottle(0);
        end;
      end;
    end;
  end;
end;


function M_Kilrathi;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(1);
  Enemies := Enemies + 1;
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Kilrathi2;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  Enemies := Enemies + 1;
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

Function M_Catcount;
begin
  Enemies := Enemies - 1;
end;

function M_Friendly;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_SendComm(10);
  AI_AddToWing(Player);
  until (Enemies = 0) do AI_WaitSeconds(1);
  AI_SendComm(39);
  AI_WaitSeconds(5);
  SF_DeactivateSelf(1);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;


function M_Nav1;

var wavecount=1, wcount, commcount=0, temp, shiptype, shipref;

begin
  NAV_ActivateSelf;
  until ((ID = 8) and (Bad_Cargo_Dead = true) and (Bad_Cargo2_Dead = true)) do
    AI_WaitSeconds(1);

  CargoShutDown := true;
  AI_WaitSeconds(3);

  Buggered := 1;
  AI_WaitSeconds(1);
  Nav_CreateShip(UE_SHIPID_ConfedDrone, PILOT_Confed, 0, @M_Kilrathi, @M_Catcount, 0, 1400, 0);
  Nav_CreateShip(UE_SHIPID_ConfedDrone, PILOT_Confed, 0, @M_Kilrathi, @M_Catcount, 50, 1500, 0);
  Nav_CreateShip(UE_SHIPID_ConfedDrone, PILOT_Confed, 0, @M_Kilrathi, @M_Catcount, 0, 1600, 40);
  Nav_CreateShip(UE_SHIPID_ConfedDrone, PILOT_Confed, 0, @M_Kilrathi, @M_Catcount, -20, 1200, 0);
  Nav_CreateShip(UE_SHIPID_ConfedDrone, PILOT_Confed, 0, @M_Kilrathi, @M_Catcount, 0, 1300, 0);
  Nav_CreateShip(UE_SHIPID_ConfedDrone, PILOT_Confed, 0, @M_Kilrathi, @M_Catcount, 50, 1400, -50);
  Nav_CreateShip(UE_SHIPID_ConfedDrone, PILOT_Confed, 0, @M_Kilrathi, @M_Catcount, 27, 1600, 38);
  Nav_CreateShip(UE_SHIPID_ConfedDrone, PILOT_Confed, 0, @M_Kilrathi, @M_Catcount, 37, 1400, -46);
  if (g_Secret_EasterEgg_Active = true) then begin
    SF_ActivateObject(Rapier, 1);
    SF_ActivateObject(Rapier2, 1);
    SF_ActivateObject(Rapier3, 1);
    SF_ActivateObject(Rapier4, 1);
    SF_ActivateObject(Rapier5, 1);
    SF_ActivateObject(Rapier6, 1);
    SF_ActivateObject(Rapier7, 1);
    SF_ActivateObject(Rapier8, 1);
    SF_ActivateObject(Rapier9, 1);
    SF_ActivateObject(Rapier10, 1);
    SF_ActivateObject(Rapier11, 1);
    SF_ActivateObject(Rapier12, 1);
    g_Secret_EasterEgg_Active := false;
  end;
  AI_WaitSeconds(3);

  until (Enemies = 0) do AI_WaitSeconds(1);

  AI_WaitSeconds(6);

  SF_ActivateObject(Brisbania, 1);
  SF_ActivateObject(Vega, 1);
  SF_ActivateObject(Bonnie, 1);

  until ((ID2 = 3) and (SF_GetNumComponentPartsObj(Vega, PART_ChildGunTurret) = 0)) do
    AI_WaitSeconds(1);

  SF_SetMissionSuccess;
  AI_WaitSeconds(10);
  SF_Exit;

  while (1) do AI_WaitSeconds(1);
end;


function MAIN;
begin
  MS_RunSpaceflight(0);
end;


