//******************************************************************************
//
// Unknown Enemy
// Sim Mission 1 - Ferret Patrol
//
// Created by: Alex Barnfield <alex@crius.net>
//
// Last modified: May 17, 2002
//
//******************************************************************************


mission s1;
#SetOutputPath("$wcue$\mission\");

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, uepilots;
#include UE;
#include Comms;

#strings objectiv;
#strings spacefli;
#strings targetid;

#SetOutputPath("$wcue$\mission\");

#sector: "g.sec";


#include wcp, consts, ships;

var catsalive=0, killcount=0, totalkillcount=0;


object Player(Player)
  obj: scim;
  x: 0;
  y: 1000;
  z: 0;
  main: M_Player;
  pilot: 74;
end;

object Edge(Ship)
  obj: UE_SHIP_Ferret;
  x: 100;
  y: 1000;
  z: 0;
  main: M_Wing;
  pilot: PILOT_Edge;
end;

object Gryphon(Ship)
  obj: UE_SHIP_Ferret;
  x: -100;
  y: 1000;
  z: 0;
  main: M_Wing;
  pilot: PILOT_Gryphon;
end;


object Nav1(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_Nav1;
  navdata: 1, 20000;
  name: spacefli["Nav 1"];
end;


object Nav2(Navpoint)
  x: 20000;
  y: 0;
  z: 60000;
  main: M_Nav2;
  navdata: 2, 20000;
  name: spacefli["Nav 2"];
end;


object Nav3(Navpoint)
  x: 46000;
  y: 10000;
  z: 130000;
  main: M_Nav3;
  navdata: 3, 20000;
  name: spacefli["Nav 3"];
end;


object Nav4(Navpoint)
  x: 50000;
  y: 5000;
  z: 7000;
  main: M_Nav4;
  color: 0, 1, 1, 1;
  navdata: 4, 20000;
  name: spacefli["Nav 4"];
end;

function MAIN;
begin
  MS_RunSpaceflight(0);
end;

function M_Spawn(shipId, count, x, y, z);
//
// this function spawns "count" ships of type "shipID"
// at coordinates around x, y, z
//
var
  ox, oy, oz;
begin
  while(count > 0) do begin
    ox := x + SYS_Random(1600) - 800;
    oy := y + SYS_Random(1600) - 800;
    oz := z + SYS_Random(1600) - 800;

    NAV_CreateShip(shipId, 87, 0, @M_Kilrathi, @M_Catcount, ox, oy, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;



function M_Nav1;
var
  setup = true;
begin

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_SetPlayerNav(2);


      if (setup) then begin
        setup := false;
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;

function M_Nav2;
var
  setup = true;
begin

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_SetPlayerNav(3);



      if (setup) then begin
        M_Spawn(UE_SHIPID_Gratha_Fighter, 1, 20000, 0, 60000);
        M_Spawn(UE_SHIPID_Dralthi, 4, 20000, 0, 60000);
        M_Spawn(UE_SHIPID_Vaktoth_Fighter, 2, 20000, 0, 60000);
        setup := false;
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;

function M_Nav3;
var
  setup = true;
begin

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_SetPlayerNav(4);


      if (setup) then begin
        setup := false;
        M_Spawn(UE_SHIPID_Dralthi, 4, 46000, 10000, 130000);
        M_Spawn(UE_SHIPID_Vaktoth_Fighter, 3, 46000, 10000, 130000);
        M_Spawn(UE_SHIPID_Salthi, 3, 46000, 10000, 130000);
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;

function M_Nav4;
var
  setup = true;
begin

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        setup := false;
        M_Spawn(UE_SHIPID_Gratha_Fighter, 4, 50000, 5000, 7000);
        M_Spawn(UE_SHIPID_Dralthi, 4, 50000, 5000, 7000);
        M_Spawn(UE_SHIPID_Vaktoth_Fighter, 3, 50000, 5000, 7000);
        M_Spawn(UE_SHIPID_Salthi, 3, 50000, 5000, 7000);
        until(catsalive=0) do
          AI_WaitSeconds(1);

        SF_SetMissionSuccess;
        AI_WaitSeconds(5);
        SF_Exit;
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;


function M_Player;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Catcount;
begin
  catsalive:=catsalive-1;
  killcount:=killcount+1;
  totalkillcount:=totalkillcount+1;
end;





function M_Kilrathi;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(1);
  catsalive:=catsalive+1;
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;


function M_Wing;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  AI_AddtoWing(Player);
  while(1)do begin
    AI_Waitseconds(1);
  end;
end;


