//******************************************************************************
//
// Unknown Enemy
// Sim Mission 6 - Recovery of a Kilrathi wreck
//
// Created by: Jakub Majewski  <qmajewski@yahoo.co.uk>
// Last modified: May 17, 2002
//
//******************************************************************************

mission s6;

#AddToSearchPath("$uesrc$");

#include wcp;
#include consts;
#include UE;

#AddToSearchPath("$wcue$\language\");
#AddToSearchPath("$wcue$\language\pilots\");

#strings spacefli, targetid;

#SetOutputPath("$wcue$\mission\");
#sector: "f.sec";

var Alive = 0,
  x, y, z,
  m_Player_returns = false,
  BaitInPlace = false,
  ScoutsOut = false;
Const
  Nav_1 = 1,
  Nav_2 = 2;

object Light1(Light)
  x: 0;
  y: 0;
  z: 0;
  LightType: LIGHT_Ambient;
  LightColor: 0.3, 0.3, 0.3;
end;

object Nav1(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_Nav1;
  name: spacefli["Nav 1"];
  navdata: 1, 5000;
end;

object Player(Player)
  obj: UE_SHIP_Scimitar;
  x: 0;
  y: 0;
  z: -2500;
  main: M_Player;
  pilot: PILOT_Casey1;
end;

// The player's wing - 4 Scims

object Alpha2(Ship)
  obj: UE_SHIP_Scimitar;
  x: -50;
  y: 0;
  z: -2500;
  main: M_Alpha;
  targstr: targetid["ALPHA 2"];
  pilot: PILOT_Ocelot;
end;

object Alpha3(Ship)
  obj: UE_SHIP_Scimitar;
  x: 50;
  y: 0;
  z: -2500;
  main: M_Alpha;
  targstr: targetid["ALPHA 3"];
  pilot: PILOT_Doc;
end;

object Alpha4(Ship)
  obj: UE_SHIP_Scimitar;
  x: 100;
  y: -5;
  z: -2495;
  main: M_Alpha;
  targstr: targetid["ALPHA 4"];
  pilot: PILOT_Faris;
end;

//object Alpha5(Ship)
//  obj: UE_SHIP_Scimitar;
//  x: 150;
//  y: -5;
//  z: -2495;
//  main: M_Alpha;
//  targstr: targetid["ALPHA 5"];
//  pilot: PILOT_Warrior;
//end;

object JumpPoint(JumpPoint)
  x: 300;
  y: -300;
  z: 111000;
  actionsphere: 2;
end;

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

function M_KilFighter;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Evil_Kilrathi);
  SF_BindToActionSphere(2);
  SF_ActivateSelf(0);

  while(1) do
    AI_WaitSeconds(1);
end;

function M_KilFighter2;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Evil_Kilrathi);
  SF_BindToActionSphere(2);
  SF_ActivateSelf(1);

  while(1) do begin
    AI_WaitSeconds(1);
    if (BaitInPlace < 1) then begin
      AI_WaitSeconds(15);
      AI_AttackNothing(1);
      AI_GotoObjRange(JumpPoint, 50);
      ScoutsOut := true;
      SF_DeactivateSelf(1);
    end;
  end;
end;

function M_KilDeath;
begin
  Alive := Alive - 1;
end;

function M_SpawnNearObject(shipId, count, obj);
var
  ox, oy, oz;

begin
  x := SF_GetXObj(obj);
  y := SF_GetYObj(obj);
  z := SF_GetZObj(obj);

  while(count > 0) do begin
    ox := x + SYS_Random(100) + 200;
    oy := y + SYS_Random(100) + 200;
    oz := z + SYS_Random(100) + 200;

    if (Alive < 20) then NAV_CreateShip(shipId, PILOT_Kat_Ace1, 0, @M_KilFighter, @M_KilDeath, ox, oy, oz);
    AI_WaitMilliseconds(275);
    Alive := Alive + 1;
    count := count - 1;

  end;
end;

function M_JumpSpawn(shipId, count);
var
  ox, oy, oz;
begin
  while(count > 0) do begin
    ox := 300 + SYS_Random(100) + 20;
    oy := -300 + SYS_Random(100) + 20;
    oz := 111000 + SYS_Random(100) + 20;

    if (Alive < 20) then NAV_CreateShip(shipId, PILOT_Kat_Ace1, 0, @M_KilFighter2, @M_KilDeath, ox, oy, oz);
    AI_WaitMilliseconds(275);
    Alive := Alive + 1;
    count := count - 1;

  end;
end;

function MAIN;
begin
  MS_RunSpaceflight(0);
  Alive := 0;
end;

function M_Player;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);

  while (1) do begin
    AI_WaitSeconds(1);
  end;
end;

// *************************** Home Base (Nav 1) **********
// ********************************************************
object Princeton(Capship)
  obj: UE_SHIP_Princeton;
  x: 0;
  y: 0;
  z: 1000;
  main: M_Dauntl;
  direction: 97,0,0;
  pilot: Pilot_Dauntless;
end;

function M_Nav1;
var setup = true;
begin
  while (1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        SF_ActivateObject(Princeton, AO_appear);
        setup := false;
      end;
      if (m_Player_returns) then begin
        SF_AutopilotDisable;
        AI_WaitSeconds(5);
        SF_Exit;
      end;

      NAV_SetPlayerNav(Nav_2);

      while (NAV_WithinSphere(Player)) do AI_WaitSeconds(1);
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Dauntl;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(1);
  AI_MuteComms;

  while(1) do
    AI_WaitSeconds(1);
end;

// **************************** Kilrathi Wreck (Nav 2) ****
// ********************************************************

object Nav2(Navpoint)
  x: 0;
  y: 0;
  z: 108000;
  main: M_Nav2;
  name: spacefli["Nav 2"];
  navdata: 2, 10000;
end;

object Wreck(Capship)
  obj: kdercrui;
  x: 45;
  y: -390;
  z: 111500;
  main: M_StarBase;
  direction: 90, 15, 43;
  pilot: PILOT_Confed;
end;

object Debris(Debrsfld)
  x: 0;
  y: -350;
  z: 111000;
  absdata: 1, 300, 400;
end;

object Bait(Capship)
  obj: UE_SHIP_Freighter;
  x: 300;
  y: -300;
  z: 110000;
  main: M_Bait;
  direction: 0,0,0;
  pilot: Pilot_Confed;
end;

object Intrepid(Capship)
  obj: UE_SHIP_Intrepid;
  x: 300;
  y: -300;
  z: 109000;
  main: M_Intrepid;
  direction: 0,0,0;
  pilot: Pilot_Confed;
end;

object Corvette(ship)
  obj: kcorvett;
  x: 300;
  y: -300;
  z: 111200;
  main: M_Corvette;
  death: M_KilDeath;
  direction: 180,0,0;
  pilot: Pilot_Kat4;
end;

function M_Nav2;
var setup = true;
begin
  while (1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_SetPlayerNav(Nav_1);
      NAV_ActivateSelf;

      if (setup) then begin
        SF_AutopilotDisable;
        SF_ActivateObject(Wreck, AO_appear);
        M_SpawnNearObject(UE_SHIPID_Dralthi, 6, Wreck);

        until (Alive = 0) do AI_WaitSeconds(1);
        AI_WaitSeconds(5);
        SF_ActivateObject(Bait, AO_appear);
        AI_WaitSeconds(3);
        M_JumpSpawn(UE_SHIPID_Vaktoth_Fighter, 4);

        until (BaitInPlace) do begin
          AI_WaitSeconds(1);
          if (ScoutsOut) then begin
            SF_SetMissionFailure;
            SF_AutopilotResumeNormal;
            m_Player_returns := true;
          end;
        end;

        if (ScoutsOut < 1) then begin
          M_JumpSpawn(UE_SHIPID_Vaktoth_Bomber, 6);
          AI_WaitSeconds(1);
          M_JumpSpawn(UE_SHIPID_Vaktoth_Fighter, 6);
          AI_WaitSeconds(1);
          SF_ActivateObject(Corvette, AO_jumpin);
          until (Alive = 0) do AI_WaitSeconds(1);
          SF_ActivateObject(Intrepid, AO_appear);
          SF_SetMissionSuccess;
          AI_WaitSeconds(15);
          SF_Exit;
        end;
        setup := false;
      end;

      while (NAV_WithinSphere(Player)) do AI_WaitMilliSeconds(1);
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Alpha;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AddToWing(Player);

  while(1) do
    AI_WaitSeconds(5);
end;

function M_StarBase;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag(OF_alignment, ALIGN_Neutral);
  SF_BindToActionSphere(2);

  while(1) do
    AI_WaitSeconds(1);
end;

function M_Corvette;
begin
  AI_WaitUntilActive;
  Alive := Alive + 1;
  SF_SetObjectFlag(OF_alignment, ALIGN_EVIL_Kilrathi);
  SF_BindToActionSphere(2);

  while(1) do
    AI_WaitSeconds(1);
end;

function M_Bait;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(2);
  AI_GotoObjRange(Wreck, 700);
  AI_SetThrottle(0);
  BaitInPlace := 1;
  while(1) do
    AI_WaitSeconds(1);
end;

function M_Intrepid;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(2);
  AI_GotoObjRange(Wreck, 1300);
  AI_SetThrottle(0);
  while(1) do
    AI_WaitSeconds(1);
end;
