//******************************************************************************
//
// Unknown Enemy
// Sim Mission 7 - Corvette summer
//
// Created by: Jakub Majewski <qmajewski@yahoo.co.uk>
//
// Last modified: May 17, 2002
//
//******************************************************************************


mission s7;
#SetOutputPath("$wcue$\mission\");

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, uepilots;
#include UE;
#include Comms;

#strings objectiv;
#strings spacefli;
#strings targetid;

#SetOutputPath("$wcue$\mission\");


#sector: "w.sec";

#include wcp, consts, ships;

var catsalive=0, fuel = 0;


object Player(Player)
  obj: scim;
  x: 0;
  y: 1000;
  z: 0;
  main: M_Player;
  pilot: 74;
end;

object Wingman1(Ship)
  obj: banshee;
  x: 0;
  y: 1000;
  z: 0;
  main: M_Wingman;
  pilot: PILOT_Ocelot;
end;

object Wingman2(Ship)
  obj: banshee;
  x: 0;
  y: 1000;
  z: 0;
  main: M_Wingman;
  pilot: PILOT_Doc;
end;

object Wingman3(Ship)
  obj: banshee;
  x: 0;
  y: 1000;
  z: 0;
  main: M_Wingman;
  pilot: PILOT_Warrior;
end;

object Nav1(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_Nav1;
  navdata: 1, 5000;
end;

object Corvette1(Ship)
  obj: kcorvett;
  x: 0;
  y: 500;
  z: 500;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 82;
end;

object Corvette2(Ship)
  obj: kcorvett;
  x: 0;
  y: 500;
  z: 500;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 82;
end;

object Corvette3(Ship)
  obj: kcorvett;
  x: 0;
  y: 500;
  z: 500;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 82;
end;

object Corvette4(Ship)
  obj: kcorvett;
  x: -200;
  y: 500;
  z: 500;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 82;
end;

object Corvette5(Ship)
  obj: kcorvett;
  x: 0;
  y: 500;
  z: 500;
  main: M_Kilrathi2;
  death: M_Catcount;
  pilot: 82;
end;

function M_Player;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
  while(1) do begin
    AI_WaitMilliSeconds(1);
    if (fuel = 1) then begin
      fuel := 0;
      AI_ReplenishMissilesAndFuel;
    end;
  end;
end;


function M_Kilrathi;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Evil_Kilrathi);
  SF_ActivateSelf(1);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Kilrathi2;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Evil_Kilrathi);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Catcount;
begin
  catsalive:=catsalive-1;
end;

function M_Wingman;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_WaitSeconds(1);
  AI_AddtoWing(Player);
  while(1)do begin
    AI_Waitseconds(1);
  end;
end;

function M_Nav1;

begin
  NAV_ActivateSelf;
  SF_ActivateObject(Wingman1, 1);

  AI_Waitseconds(4);
  catsalive := 1;
  SF_ActivateObject(Corvette1, 1);

  until (catsalive = 0) do AI_WaitSeconds(1);

  AI_WaitSeconds(4);
  catsalive := 3;
  SF_ActivateObject(Corvette2, 1);
  Nav_CreateShip(UE_SHIPID_Dralthi, 87, 0, @M_Kilrathi, @M_Catcount, 0, 700, 500);
  Nav_CreateShip(UE_SHIPID_Dralthi, 88, 0, @M_Kilrathi, @M_Catcount, 0, 600, 500);

  until (catsalive = 0) do AI_WaitSeconds(1);
  SF_ActivateObject(Wingman2, 1);

  AI_WaitSeconds(4);
  catsalive := 5;
  SF_ActivateObject(Corvette3, 1);
  Nav_CreateShip(UE_SHIPID_Dralthi, 87, 0, @M_Kilrathi, @M_Catcount, 0, 700, 500);
  Nav_CreateShip(UE_SHIPID_Dralthi, 88, 0, @M_Kilrathi, @M_Catcount, 0, 600, 500);
  Nav_CreateShip(UE_SHIPID_Salthi, 90, 0, @M_Kilrathi, @M_Catcount, 0, 700, 300);
  Nav_CreateShip(UE_SHIPID_Salthi, 86, 0, @M_Kilrathi, @M_Catcount, 0, 600, 800);

  until (catsalive = 0) do AI_WaitSeconds(1);
  AI_WaitSeconds(4);
  fuel := 1;
  SF_ActivateObject(Wingman3, 1);
  AI_WaitSeconds(4);

  catsalive := 8;
  SF_ActivateObject(Corvette4, 1);
  SF_ActivateObject(Corvette5, 1);
  Nav_CreateShip(UE_SHIPID_Dralthi, 87, 0, @M_Kilrathi, @M_Catcount, 0, 700, 500);
  Nav_CreateShip(UE_SHIPID_Dralthi, 88, 0, @M_Kilrathi, @M_Catcount, 0, 600, 500);
  Nav_CreateShip(UE_SHIPID_Dralthi, 89, 0, @M_Kilrathi, @M_Catcount, 0, 800, 500);
  Nav_CreateShip(UE_SHIPID_Salthi, 87, 0, @M_Kilrathi, @M_Catcount, 300, 700, 500);
  Nav_CreateShip(UE_SHIPID_Salthi, 88, 0, @M_Kilrathi, @M_Catcount, 300, 600, 500);
  Nav_CreateShip(UE_SHIPID_Gratha_Fighter, 90, 0, @M_Kilrathi, @M_Catcount, 300, 700, 300);

  until (catsalive = 0) do AI_WaitSeconds(1);
  SF_SetMissionSuccess;
  AI_WaitSeconds(5);
  SF_Exit;

  while (1) do AI_WaitSeconds(1);
end;


function MAIN;
begin
  MS_RunSpaceflight(0);
end;


