//******************************************************************************
//
// Unknown Enemy
// Sim Mission 8 - Traitorous Nebula
//
// Created by: Alex Barnfield <alex@crius.net>
//
// Last modified: May 17, 2002
//
//******************************************************************************


mission s8;
#SetOutputPath("$wcue$\mission\");

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, uepilots;
#include UE;
#include Comms;

#strings spacefli;
#strings targetid;

#SetOutputPath("$wcue$\mission\");

#sector: "gneb.sec";

#include wcp, consts, ships;

var catsalive=0, killcount=0, totalkillcount=0, atnav5=0, success=0;


object Player(Player)
  obj: scim;
  x: 0;
  y: 1000;
  z: 0;
  main: M_Player;
  pilot: 74;
end;

object Tango(capship)
  obj: UE_SHIP_Intrepid;
  x: 500;
  y: 1000;
  z: 1200;
  main: M_Dauntless;
  pilot: PILOT_Dauntless;
end;

object Edge(Ship)
  obj: UE_SHIP_Bearcat;
  x: 100;
  y: 1000;
  z: 0;
  main: M_Wing;
  targstr: targetid["ALPHA 2"];
  pilot: PILOT_Edge;
end;

object Gryphon(Ship)
  obj: UE_SHIP_Bearcat;
  x: -100;
  y: 1000;
  z: 0;
  main: M_Wing;
  targstr: targetid["ALPHA 3"];
  pilot: PILOT_Gryphon;
end;


object Nav1(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_Nav1;
  navdata: 1, 20000;
  name: spacefli["Nav 1"];
end;


object Nav2(Navpoint)
  x: 20000;
  y: 0;
  z: 60000;
  main: M_Nav2;
  navdata: 2, 20000;
  name: spacefli["Nav 2"];
end;


object Nav3(Navpoint)
  x: 46000;
  y: 10000;
  z: 130000;
  main: M_Nav3;
  navdata: 3, 20000;
  name: spacefli["Nav 3"];
end;


object Nav4(Navpoint)
  x: 50000;
  y: 5000;
  z: 7000;
  main: M_Nav4;
  color: 0, 1, 1, 1;
  navdata: 4, 20000;
  name: spacefli["Nav 4"];
end;

object Nav5(Navpoint)
  x: 1000;
  y: 100000;
  z: 7000;
  main: M_Nav5;
  color: 0, 1, 1, 1;
  navdata: 5, 20000;
  name: spacefli["Nav 5"];
end;

object Traitor(Capship)
  obj: wc3dstry;
  x: 1000;
  y: 100000;
  z: 9500;
  main: M_Murphy;
  direction: 180, 0, 0;
  pilot: 62;              //Needs changing
end;

function MAIN;
begin
  MS_RunSpaceflight(0);
end;

function M_Spawn(shipId, count, x, y, z);
//
// this function spawns "count" ships of type "shipID"
// at coordinates around x, y, z
//
var
  ox, oy, oz, extra;
begin
  while(count > 0) do begin
    ox := x + SYS_Random(1600) - 800;
    oy := y + SYS_Random(1600) - 800;
    oz := z + SYS_Random(1600) - 800;
    extra := SYS_Random(5);

    if(extra=0) then
      extra:=43;
    if(extra=1) then
      extra:=44;
    if(extra=2) then
      extra:=48;
    if(extra=3) then
      extra:=52;
    if(extra=4) then
      extra:=56;
    NAV_CreateShip(shipId, extra, 0, @M_Kilrathi, @M_Catcount, ox, oy, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;



function M_Nav1;
var
  setup = true;
begin

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_SetPlayerNav(2);


      if (setup) then begin
        setup := false;
        SF_ActivateObject(Tango, 0);
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;

function M_Nav2;
var
  setup = true;
begin

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_SetPlayerNav(3);



      if (setup) then begin
        setup := false;
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;

function M_Nav3;
var
  setup = true;
begin

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_SetPlayerNav(4);


      if (setup) then begin

        M_Spawn(UE_SHIPID_Scimitar, 3, 46000, 10000, 130000);
        M_Spawn(UE_SHIPID_Ferret, 1, 46000, 10000, 130000);
        M_Spawn(UE_SHIPID_Epee, 2, 46000, 10000, 130000);
        setup := false;
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;

function M_Nav4;
var
  setup = true;
begin

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_SetPlayerNav(5);

      if (setup) then begin

        setup := false;

      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;


function M_Nav5;
var
  setup = true;
begin

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        atnav5:=1;

        SF_ActivateObject(Traitor, 0);
        M_Spawn(UE_SHIPID_Banshee, 1, 1000, 100000, 8500);
        M_Spawn(UE_SHIPID_Scimitar, 4, 1000, 100000, 8500);
        M_Spawn(UE_SHIPID_Ferret, 1, 1000, 100000, 8500);
        M_Spawn(UE_SHIPID_Epee, 1, 1000, 100000, 8500);
        M_Spawn(UE_SHIPID_Avenger_B, 2, 1000, 100000, 8500);
        until(catsalive=0) do
          AI_WaitSeconds(1);
        until (SF_GetNumComponentPartsObj(Traitor, PART_ChildGunTurret) = 0) do
          AI_WaitSeconds(1);
        SF_SetMissionSuccess;
        success:=1;
        setup := false;
        AI_WaitSeconds(5);
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;


function M_Player;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Catcount;
begin
  catsalive:=catsalive-1;
  killcount:=killcount+1;
  totalkillcount:=totalkillcount+1;
end;





function M_Kilrathi;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(0);
  catsalive:=catsalive+1;
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;


function M_Wing;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  AI_AddtoWing(Player);
  while(1)do begin
    AI_Waitseconds(1);
  end;
end;



function M_Murphy;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(5);
  AI_WaitUntilActive;
  until(atnav5) do
    AI_WaitSeconds(1);
  AI_SendComm(30);
  until(success) do
    AI_WaitSeconds(1);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_WaitSeconds(8);
  SF_Exit;
  while(1) do
    AI_Waitseconds(1);
end;


function M_Dauntless;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(1);
  AI_WaitUntilActive;
  AI_MuteComms;

  while(1) do
    AI_Waitseconds(1);
end;

