//******************************************************************************
//
// Unknown Enemy
// Sim Mission 9 - Attacking a Kilrathi Strike Force
//
// Created by: Jakub Majewski  <qmajewski@yahoo.co.uk>
// Last modified: May 17, 2002
//
//******************************************************************************

mission s9;

#AddToSearchPath("$uesrc$");

#include wcp;
#include consts;
#include UE;

#AddToSearchPath("$wcue$\language\");
#AddToSearchPath("$wcue$\language\pilots\");

#strings spacefli, targetid;

#SetOutputPath("$wcue$\mission\");
#sector: "i.sec";

var Alive = 0,
  x, y, z,
  capsalive = 2;

Const
  Nav_1 = 1,
  Nav_2 = 2;

object Light1(Light)
  x: 0;
  y: 0;
  z: 0;
  LightType: LIGHT_Ambient;
  LightColor: 0.3, 0.3, 0.3;
end;

object Nav1(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_Nav1;
  name: spacefli["Nav 1"];
  navdata: 1, 10000;
end;

object Player(Player)
  obj: UE_SHIP_Scimitar;
  x: 0;
  y: 0;
  z: 2500;
  main: M_Player;
  pilot: PILOT_Casey1;
end;

// The player's wing - 5 Scims, 5 Avengers

object Alpha1(Ship)
  obj: UE_SHIP_Scimitar;
  x: -100;
  y: 0;
  z: 2500;
  main: M_Alpha;
  targstr: targetid["ALPHA 1"];
  pilot: PILOT_Ocelot;
end;

object Alpha2(Ship)
  obj: UE_SHIP_Scimitar;
  x: -50;
  y: 0;
  z: 2500;
  main: M_Alpha;
  targstr: targetid["ALPHA 2"];
  pilot: PILOT_Gold;
end;

object Alpha3(Ship)
  obj: UE_SHIP_Avenger_B;
  x: 50;
  y: 0;
  z: 2500;
  main: M_Alpha;
  targstr: targetid["ALPHA 3"];
  pilot: PILOT_BloodHound;
end;

object Alpha4(Ship)
  obj: UE_SHIP_Avenger_B;
  x: 100;
  y: -5;
  z: 2495;
  main: M_Alpha;
  targstr: targetid["ALPHA 4"];
  pilot: PILOT_Huntress;
end;

object Alpha5(Ship)
  obj: UE_SHIP_Avenger_B;
  x: 150;
  y: -5;
  z: 2495;
  main: M_Alpha;
  targstr: targetid["ALPHA 5"];
  pilot: PILOT_Edge;
end;

object Bravo1(Ship)
  obj: UE_SHIP_Scimitar;
  x: -50;
  y: 0;
  z: 3000;
  main: M_BravoLeader;
  targstr: targetid["BRAVO 1"];
  pilot: PILOT_Defender;
end;

object Bravo2(Ship)
  obj: UE_SHIP_Scimitar;
  x: 50;
  y: 0;
  z: 3000;
  main: M_Bravo;
  targstr: targetid["BRAVO 2"];
  pilot: PILOT_Thor;
end;

object Bravo3(Ship)
  obj: UE_SHIP_Scimitar;
  x: -100;
  y: 0;
  z: 3000;
  main: M_Bravo;
  targstr: targetid["BRAVO 3"];
  pilot: PILOT_Hellcat;
end;


object Bravo4(Ship)
  obj: UE_SHIP_Avenger_B;
  x: 100;
  y: 0;
  z: 3000;
  main: M_Bravo;
  targstr: targetid["BRAVO 4"];
  pilot: PILOT_Warrior;
end;

object Bravo5(Ship)
  obj: UE_SHIP_Avenger_B;
  x: -150;
  y: 0;
  z: 3000;
  main: M_Bravo;
  targstr: targetid["BRAVO 5"];
  pilot: PILOT_Faris;
end;

object JumpPoint(JumpPoint)
  x: 0;
  y: -300;
  z: 6100;
end;

object Corvette1(Ship)
  obj: kcorvett;
  x: 340;
  y: 0;
  z: 4500;
  main: M_KilCorv;
  death: M_KilDeath;
  direction: 180, 0, 0;
  pilot: 82;
end;

object Corvette2(Ship)
  obj: kcorvett;
  x: -340;
  y: 0;
  z: 4500;
  main: M_KilCorv;
  death: M_KilDeath;
  direction: 180, 0, 0;
  pilot: 82;
end;

object Corvette3(Ship)
  obj: kcorvett;
  x: 0;
  y: 0;
  z: 4500;
  main: M_KilCorv;
  death: M_KilDeath;
  direction: 180, 0, 0;
  pilot: 82;
end;

object Hakhhi(Capship)
  obj: fralthi;
  x: 340;
  y: -390;
  z: 4500;
  main: M_Capship;
  death: D_Capship;
  direction: 180, 0, 0;
  pilot: 82;
end;

object Rakhitra(Capship)
  obj: fralthi;
  x: -250;
  y: -390;
  z: 4200;
  main: M_Capship;
  death: D_Capship;
  direction: 180, 0, 0;
  pilot: 82;
end;


function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

function M_KilFighter;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Evil_Kilrathi);
  SF_ActivateSelf(0);

  while(1) do
    AI_WaitSeconds(1);
end;

function M_KilFighter2;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Evil_Kilrathi);
  SF_ActivateSelf(1);

  while(1) do
    AI_WaitSeconds(1);
end;

function M_KilCorv;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Evil_Kilrathi);
  AI_WaitUntilActive;
  Alive := Alive + 1;
  while(1) do
    AI_WaitSeconds(1);
end;

function M_KilDeath;
begin
  Alive := Alive - 1;
end;

function M_SpawnNearObject(shipId, count, obj);
var
  ox, oy, oz;

begin
  x := SF_GetXObj(obj);
  y := SF_GetYObj(obj);
  z := SF_GetZObj(obj);

  while(count > 0) do begin
    ox := x + SYS_Random(100) + 200;
    oy := y + SYS_Random(100) + 200;
    oz := z + SYS_Random(100) + 200;

    if (Alive < 20) then NAV_CreateShip(shipId, PILOT_Kat_Ace2, 0, @M_KilFighter, @M_KilDeath, ox, oy, oz);
    AI_WaitMilliseconds(275);
    Alive := Alive + 1;
    count := count - 1;

  end;
end;

function M_JumpSpawn(shipId, count);
var
  ox, oy, oz;
begin
  while(count > 0) do begin
    ox := 300 + SYS_Random(100) + 20;
    oy := -300 + SYS_Random(100) + 20;
    oz := 4000 + SYS_Random(100) + 20;

    if (Alive < 20) then NAV_CreateShip(shipId, PILOT_Kat_Ace1, 0, @M_KilFighter2, @M_KilDeath, ox, oy, oz);
    AI_WaitMilliseconds(275);
    Alive := Alive + 1;
    count := count - 1;

  end;
end;

function MAIN;
begin
  MS_RunSpaceflight(0);
  Alive := 0;
end;

function M_Player;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_ActivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);

  while (1) do begin
    AI_WaitSeconds(1);
    if (capsalive = 0) then
    begin
      SF_SetMissionSuccess;
      until (Alive = 0) do AI_WaitSeconds(1);
      AI_WaitSeconds(3);
      SF_Exit;
    end;
  end;
end;

function M_Nav1;
var setup = true;
begin
  while (1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        SF_AutopilotDisable;
        AI_WaitSeconds(5);
        M_JumpSpawn(UE_SHIPID_Vaktoth_Fighter, 4);
        AI_WaitSeconds(25);
        SF_ActivateObject(Corvette3, AO_jumpin);
        AI_WaitSeconds(35);
        SF_ActivateObject(Corvette2, AO_jumpin);
        SF_ActivateObject(Corvette1, AO_jumpin);
        M_JumpSpawn(UE_SHIPID_Vaktoth_Fighter, 4);
        AI_WaitSeconds(40);
        SF_ActivateObject(Hakhhi, AO_jumpin);
        AI_WaitSeconds(40);
        M_SpawnNearObject(UE_SHIPID_Dralthi, 2, Hakhhi);
        AI_WaitSeconds(15);
        SF_ActivateObject(Rakhitra, AO_jumpin);
        AI_WaitSeconds(45);
        M_SpawnNearObject(UE_SHIPID_Salthi, 2, Rakhitra);
        AI_WaitSeconds(35);
        setup := false;
      end;

      while (NAV_WithinSphere(Player)) do begin
        if (capsalive > 1) then
          M_SpawnNearObject(UE_SHIPID_Dralthi, 2, Hakhhi);
        AI_WaitSeconds(25);
        if (capsalive > 0) then
          M_SpawnNearObject(UE_SHIPID_Dralthi, 2, Rakhitra);
        AI_WaitSeconds(35);
        if (capsalive > 1) then
          M_SpawnNearObject(UE_SHIPID_Salthi, 2, Hakhhi);
        AI_WaitSeconds(25);
        if (capsalive > 0) then
          M_SpawnNearObject(UE_SHIPID_Salthi, 2, Rakhitra);
        AI_WaitSeconds(35);
        if (capsalive > 0) then
          M_SpawnNearObject(UE_SHIPID_Gratha_Fighter, 2, Hakhhi);
        AI_WaitSeconds(35);
        if (capsalive > 1) then
          M_SpawnNearObject(UE_SHIPID_Vaktoth_Fighter, 2, Rakhitra);
        AI_WaitSeconds(30);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Alpha;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  AI_AddToWing(Player);

  while(1) do begin
    AI_WaitSeconds(1);
    if ((capsalive = 1) and (alive < 5)) then begin
      AI_ReplenishMissilesAndFuel;
      while (1) do
        AI_WaitSeconds(1);
    end;
  end;
end;

function M_BravoLeader;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_ActivateSelf(0);

  while(1) do
    AI_WaitSeconds(5);
end;

function M_Bravo;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  AI_AddToWing(Bravo1);

  while(1) do
    AI_WaitSeconds(5);
end;

function M_Capship;
begin
  AI_WaitUntilActive;
  //capsalive := capsalive + 1;
  SF_SetObjectFlag(OF_Alignment, ALIGN_Evil_Kilrathi);
  AI_SetThrottle(5);
  while(1) do
    AI_WaitSeconds(1);
end;

function D_Capship;
begin
  capsalive := capsalive - 1;
end;
