unit UE;

#include ships;
#include uepilots;

const
  UE_SFX_Static = 243,
  UE_SFX_Scramble = 244,

  UE_SHIP_Dauntless = "dauntl",
  UE_SHIP_Intrepid = "intrepidc",
  UE_SHIP_Intrepid_Wreck = "intdeb",
  UE_SHIP_Princeton = "princeton",
  UE_SHIP_Eisen = "wc3cv",
  UE_SHIP_Murphy = "wc3dstry",
  UE_SHIP_Plunkett = "wc3crusr",
  UE_SHIP_KatBase = "kstarbas",
  UE_SHIP_Hydra = "marlin",
  UE_SHIP_Leviathan = "osprey",
  UE_SHIP_Orca = "orca",
  UE_SHIP_Triton = "leatherb",
  UE_SHIP_Tallahassee = "bwtalahc",

  UE_SHIP_Freighter = "pelican",
  UE_SHIP_Fralthi = "fralthi",
  UE_SHIP_Ralari = "ralari",
  UE_SHIP_BW_Lab = "bwlabc",               // Border Worlds Lab (WC4)
  UE_SHIP_Beaufort = UE_SHIP_BW_Lab,

  UE_SHIP_Scimitar = "scim",              // Scimitar, Viper Cannon variant
  UE_SHIP_Scimitar_No_Viper = "scnovip",  // Scimitar, No Viper Cannon variant
  UE_SHIP_Scimitar_Bomber = "scimb",      // Scimitar, Bomber variant
  UE_SHIP_Scimitar_FX = "scimfx",         // Scimitar, Special FX variant

  UE_SHIP_Gratha_Fighter = "gratha",      // Gratha, Figther variant
  UE_SHIP_Gratha_Bomber = "grathtb",      // Gratha, Bomber variant
  UE_SHIP_Gratha_Fighter_BW = "grathbw",  // BW Gratha, Figther variant
  UE_SHIP_Gratha_Bomber_BW = "grathbw2",  // BW Gratha, Bomber variant

  UE_SHIP_Vaktoth = "vaktoth",           // Vaktoth
  UE_SHIP_Vaktoth_Bomber = "vaktothb",   // Vaktoth, Bomber variant
  UE_SHIP_Dralthi = "dralthi",

  UE_SHIP_Salthi = "salthi",
  UE_SHIP_ConfedDrone = "cdrone",
  UE_SHIP_Ferret = "ferret",
  UE_SHIP_Khahaf = "khahaf",
  UE_SHIP_Khahaf_No_Mines = "khahafnm",
  UE_SHIP_Epee = "epee",
  UE_SHIP_Banshee = "banshee",
  UE_SHIP_Avenger_SAR = "avenger",
  UE_SHIP_Avenger_B = "avengerb",
  UE_SHIP_Avenger_FX = "avengerfx",
  UE_SHIP_Bearcat = "bearcat",

  UE_SHIP_Marine_LC = "bwshutt",          // Hermes shuttle from WC4
  UE_SHIP_Shuttle = "bwshutt",            // need a different one here

  UE_SHIP_Box = "box",              // Our inanimate carbon rod ;)

  // ************************* ShipIDs *************************

  UE_SHIPID_Scimitar = 17,
  UE_SHIPID_Scimitar_Bomber = 41,

  UE_SHIPID_Gratha_Fighter = 20,
  UE_SHIPID_Gratha_Bomber = 44,
  UE_SHIPID_Gratha_Fighter_BW = 42,
  UE_SHIPID_Gratha_Bomber_BW = 43,

  UE_SHIPID_Salthi = 39,
  UE_SHIPID_ConfedDrone = 38,
  UE_SHIPID_Ferret = 18,
  UE_SHIPID_Khahaf = 15,
  UE_SHIPID_Epee = 12,
  UE_SHIPID_Banshee = 16,
  UE_SHIPID_Avenger_SAR = 22,
  UE_SHIPID_Avenger_B = 23,
  UE_SHIPID_Marine_LC = 21,
  UE_SHIPID_Shuttle = 21,
  UE_SHIPID_Bearcat = 40,
  UE_SHIPID_Box = 50,

  UE_SHIPID_Vampire = SHIP_Vampire,
  UE_SHIPID_Excalibur = SHIP_Excalibur,
  UE_SHIPID_Devastator = SHIP_Devastator,
  UE_SHIPID_Thunderbolt = SHIP_Thunderbolt,

  UE_SHIPID_Vaktoth_Fighter = SHIP_Vaktoth,
  UE_SHIPID_Vaktoth_Bomber = SHIP_Vaktoth_B,
  UE_SHIPID_Dralthi = SHIP_Dralthi,

  UE_SHIPID_Moray = SHIP_Moray,
  UE_SHIPID_Manta = SHIP_Manta,
  UE_SHIPID_Manta_B = SHIP_Manta_B,
  UE_SHIPID_Warlord = SHIP_Warlord,
  UE_SHIPID_Stingray = SHIP_Stingray,
  UE_SHIPID_Barracuda = SHIP_Barracuda,
  UE_SHIPID_Squid = SHIP_Squid,
  UE_SHIPID_Lamprey = SHIP_Lamprey,

  // ****************** Briefing Appearances *******************

  UE_APPEARANCE_Dralthi = 14,
  UE_APPEARANCE_Asteroid = 17,
  UE_APPEARANCE_Avenger = 18,
  UE_APPEARANCE_Vampire = 20,
  UE_APPEARANCE_Ralari = 22,
  UE_APPEARANCE_Fralthi = 25,
  UE_APPEARANCE_Khahaf = 26,
  UE_APPEARANCE_Devastator = 27,
  UE_APPEARANCE_Banshee = 29,
  UE_APPEARANCE_Ferret = 30,
  UE_APPEARANCE_Marine_LC = 31,
  UE_APPEARANCE_Beaufort = 36,
  UE_APPEARANCE_Dauntless = 47,
  UE_APPEARANCE_Scimitar = 49,
  UE_APPEARANCE_Gratha = 57,
  UE_APPEARANCE_JumpBuoy = 58,
  UE_APPEARANCE_Vaktoth = 60,
  UE_APPEARANCE_Vesuvius = 67,
  UE_APPEARANCE_Epee = 68,
  UE_APPEARANCE_Murphy = 70,
  UE_APPEARANCE_Intrepid = 71,
  UE_APPEARANCE_Excalibur = 74,
  UE_APPEARANCE_Thunderbolt = 75,

  // ****************** Ship Selector ***************************
  // (For use with MS_ShipSelector or MCP_ShipSelector)

  UE_SELECTOR_Avenger_B = 14,
  UE_SELECTOR_Scimitar_No_Dust = 15,
  UE_SELECTOR_Ferret = 16,
  UE_SELECTOR_Scimitar = 17,
  UE_SELECTOR_Epee = 18,
  UE_SELECTOR_Bearcat = 19,
  UE_SELECTOR_Banshee = 20;

