//******************************************************************************
//
// Unknown Enemy
// Mission 1 - First Strike
//
// Created by: Thomas Bruckner <thomas.bruckner@aon.at>
// Modified by: Jakub Majewski  <qmajewski@yahoo.co.uk>
// Last modified: Apr 9th, 2004
//
//******************************************************************************

mission ue1;

#sector: "t.sec";
#SetRooms ("cic.rom", "rec.rom");

#include consts;

#AddToSearchPath("$uesrc$");

#SetOutputPath("$wcue$\mission\");

#AddToSearchPath("$wcue$\language\");

#include WCP;
#include uepilots;
#include UE;
#include comms;

#strings objectiv;
#strings spacefli;
#strings targetid;

#SetOutputPath("$wcue$\mission\");

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);

// **************  Main Program  **************

var
  m_Failed = true,
  m_Event,
  m_AliveEnemies,
  m_DeadEnemies,
  m_Player_Returns,
  m_Timer,
  m_Comm,
  xpos, ypos, zpos;

external
  g_UE_1_Won;

const
  NAV_Dauntless = 1,
  NAV_1 = 2,
  NAV_2 = 3,
  NAV_3 = 4,
  NAV_Gratha = 5,
  NAV_Dralthi = 6,
  NAV_Fralthi = 7,

  EVENT_Fralthi_Disabled = 1,
  EVENT_Fralthi_Friendly = 2,
  EVENT_Kilrathi_Surrendered = 3,
  EVENT_Can_Return = 4,
  EVENT_Takeoff_Start = 5,
  EVENT_Takeoff_Complete = 6,
  EVENT_Land_Player = 7,
  EVENT_Activate_Landing_Cam = 8,
  EVENT_Dauntless_Ready = 9,
  EVENT_Final_Approach = 10;

#name: 2;

objective mobj_locate_fralthi
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Locate Fralthi"];
  status: MOBJ_Incomplete;
  counter: false;
end;

objective mobj_defend_marines
  hidden: true;
  type: MOBJ_Secondary;
  text: objectiv["Defend Marine LC"];
  status: MOBJ_Incomplete;
  counter: false;
end;

objective mobj_kill
  hidden: false;
  type: MOBJ_Bonus;
  text: objectiv["Eliminate 33% of Hostile Fighters"];
  status: MOBJ_Incomplete;
  counter: true;
end;

object Dauntless(Capship) as "BWS Dauntless"
  obj: UE_SHIP_Dauntless;
  x: 0;
  y: 200;
  z: 4000;
  main: M_Dauntless;
  brief: B_Dauntless;
  direction: 0, 0, 0;
  color: 0, 0.5, 0.5, 1.0;
  pilot: PILOT_Dauntless;
end;

function MAIN;
begin
  MS_RunGameflow(0);
  MS_RunBriefing;
  MS_ShipSelector(UE_SELECTOR_Scimitar, UE_SELECTOR_Epee);
  MS_RunSpaceflight(0);
  MS_RunDebriefing;
end;

function S_EnemyFighter;
begin
  SF_SetObjectFlag(OF_vulnerable, true);
  SF_SetObjectFlag(OF_alignment, ALIGN_Evil_Kilrathi);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(AO_appear);
  m_AliveEnemies := m_AliveEnemies + 1;

  SF_ObjectiveIncrementTotal(mobj_kill);
  SF_ObjectiveSetTotalNeededForSuccess(mobj_kill, (m_AliveEnemies * 33) / 100);

  //AI_AttackEnemies;

  until (m_Event = EVENT_Fralthi_Friendly) do AI_WaitMilliSeconds(1);
  //SYS_PlaySFX(10);
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(NAV_Fralthi);
  //AI_WaitSeconds(2);

  until (m_Event = EVENT_Kilrathi_Surrendered) do AI_WaitMilliSeconds(1);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  //AI_WaitSeconds(1);
  SF_ObjectiveDecrementTotal(mobj_kill);
  SF_ObjectiveSetTotalNeededForSuccess(mobj_kill, (m_AliveEnemies * 33) / 100);


  while (1) do
    AI_WaitSeconds(1);
end;

function S_EnemyFighterDeath;
begin
  m_DeadEnemies := m_DeadEnemies + 1;
  if (SF_KilledBy = PILOT_Casey1) then
    SF_ObjectiveIncrementCount(mobj_kill);
end;

function M_Spawn(shipId, count, x, y, z);
//
// this function spawns "count" ships of type "shipID"
// at coordinates around x, y, z
//
var
  ox, oy, oz;
begin
  while(count > 0) do begin
    ox := x + SYS_Random(600) - 300;
    oy := y + SYS_Random(600) - 300;
    oz := z + SYS_Random(600) - 300;

    NAV_CreateShip(shipId, 84, 0, @S_EnemyFighter, @S_EnemyFighterDeath, ox, oy, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;

function M_SpawnNearObject(shipId, count, obj);
//
// this function spawns "count" ships of type "shipID"
// at coordinates near the object given in "obj"
//
var
  x, y, z,
  ox, oy, oz;
begin
  x := SF_GetXObj(obj);
  y := SF_GetYObj(obj);
  z := SF_GetZObj(obj);

  while(count > 0) do begin
    ox := x + SYS_Random(600) + 500;
    oy := y + SYS_Random(600) + 500;
    oz := z + SYS_Random(600) + 500;

    NAV_CreateShip(shipId, 84, 0, @S_EnemyFighter, @S_EnemyFighterDeath, ox, oy, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;

function M_CountEnemies;
begin
  Result := m_AliveEnemies - m_DeadEnemies;
end;

function M_WaitUntilDead;
//
// this function waits until all enemies spawned by M_Spawn*
// have been killed.
//
begin
  until(m_DeadEnemies = m_AliveEnemies) do
    AI_WaitSeconds(1);
end;

function M_GetPos(ShipID);
begin
  xpos := SF_GetXObj(ShipID);
  ypos := SF_GetYObj(ShipID);
  zpos := SF_GetZObj(ShipID);
end;

function F_InitLanding; forward;
function F_PlayerTakeoff; forward;
function F_PlayerLanding; forward;
function F_DauntlessLanding; forward;
// ************************* Dauntless NAV *************************

object NavD(Navpoint)
  x: 0;
  y: 0;
  z: 2000;
  main: M_NavD;
  brief: B_NavD;
  name: spacefli["Dauntless Nav"];
  color: 0, 1.0, 1.0, 1.0;
  navdata: 1, 25000;
end;

object Player(Player)
  obj: UE_SHIP_Scimitar;
  x: 20;
  y: 200;
  z: 4300;
  main: M_Player;
  brief: B_Player;
  pilot: PILOT_Casey1;
  color: 0, 1.0, 1.0, 0.0;
end;

object Alpha2(Ship)
  obj: UE_SHIP_Scimitar;
  x: 500;
  y: 100;
  z: 4100;
  main: M_Alpha;
  brief: B_Alpha1;
  targstr: 1;
  pilot: PILOT_Defender;
  color: 0, 0.2, 0.2, 1.0;
end;

object Alpha3(Ship)
  obj: UE_SHIP_Epee;
  x: -500;
  y: 100;
  z: 4500;
  main: M_Alpha;
  brief: B_Alpha2;
  targstr: 1;
  pilot: PILOT_Phantom;
  color: 0, 0.2, 0.2, 1.0;
end;

object Cap1(Ship)
  obj: UE_SHIP_Scimitar;
  x: 200;
  y: 200;
  z: 4000;
  main: M_ScimPatrol;
  targstr: targetid["CAP 1"];
  pilot: PILOT_Night;
end;

object Cap2(Ship)
  obj: UE_SHIP_Scimitar;
  x: 200;
  y: 0;
  z: 4000;
  main: M_ScimPatrol;
  targstr: targetid["CAP 2"];
  pilot: PILOT_Gold;
end;

object Cap3(Ship)
  obj: UE_SHIP_Scimitar;
  x: -200;
  y: 0;
  z: 4000;
  main: M_ScimPatrol;
  targstr: targetid["CAP 3"];
  pilot: PILOT_Mage;
end;

object Cap4(Ship)
  obj: UE_SHIP_Scimitar;
  x: -200;
  y: 200;
  z: 4000;
  main: M_ScimPatrol;
  targstr: targetid["CAP 2"];
  pilot: PILOT_Gryphon;
end;

function M_NavD;
var
  setup = true;
begin
  NAV_SetEjectSequence(ES_SAR_pickup);

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      //debug:
      //SF_ActivateObject(Dauntless, AO_appear);
      //AI_WaitSeconds(25);
      //m_Failed := true;
      //m_Player_Returns := true;

      if (m_Player_Returns) then begin
        if (m_Failed > 0) then begin
          if (m_Failed = 2) then
          begin
            g_UE_1_Won := false;
            AI_WaitSeconds(3);
            m_Comm := 21;
          end else
          begin
            SF_ObjectiveSetFailure(mobj_locate_fralthi);
            SF_SetMissionFailure;
            g_UE_1_Won := false;
            AI_WaitSeconds(3);
            m_Comm := 18;
          end;
          // Dauntless: Damn, those cats are just too slippery. None of the other
          //            patrols have found the capship either.
          // Dauntless: The Captain wants you to launch another search as soon as
          //            possible, so you've got clearance to land immediately, sir.
          //SF_PrintText(208);

          AI_WaitSeconds(11);
        end else begin
          g_UE_1_Won := true;
          SF_SetMissionSuccess;
          AI_WaitSeconds(2);
          // Dauntless: The Captain sends his congratulations, sir. You're cleared to land.
          //SF_PrintText(209);
          m_Comm := 20;
          AI_WaitSeconds(8);
        end;

        // now landing
        F_InitLanding;

        //while(1) do
        //  AI_WaitSeconds(1);
        AI_WaitSeconds(60);
        SF_Exit;
      end;

      if (setup) then begin
        //let's activate the CAP
        SF_ActivateObject(Dauntless, AO_appear);
        SF_ActivateObject(CAP1, AO_appear);
        SF_ActivateObject(CAP2, AO_appear);
        SF_ActivateObject(CAP3, AO_appear);
        SF_ActivateObject(CAP4, AO_appear);

        // 2 Gratha (Kilrathi Aces, 83 and 84), bomber variant.
        NAV_CreateShip(UE_SHIPID_Gratha_Bomber, 83, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 500, 0, 8300);
        NAV_CreateShip(UE_SHIPID_Gratha_Bomber, 84, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 0, 200, 8200);
        //Additionals
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 87, 0, @S_EnemyFighter, @S_EnemyFighterDeath, -560, 0, 8300);
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 88, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 0, 200, 8300);

        // "Take out those incoming Gratha and get going!"
        //SF_PrintText(201);
        //m_Comm := 1;

        setup := false;
        m_Player_Returns := true;

        M_WaitUntilDead;
      end;

      NAV_SetPlayerNav(NAV_1);

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_ScimPatrol;
var
  rad;
begin
// Standard Startup, again...
// Wait for activation, set vulnerable, set friendly.
  AI_WaitUntilActive;

  SF_SetObjectFlag(OF_vulnerable, 0);
  SF_SetObjectFlag(OF_alignment, ALIGN_CONFED);

  // Bind to 1.. so we can say hello when we get back.
  SF_BindToActionSphere(NAV_Dauntless);

  AI_ClearDefendList;
  AI_AttackNothing(1);

  rad := 1500;

  while (1) do begin
    AI_GotoObjRelFrame(Dauntless, -rad, 100, -rad);
    AI_GotoObjRelFrame(Dauntless, -rad, 100, rad);
    AI_GotoObjRelFrame(Dauntless, rad, 100, rad);
    AI_GotoObjRelFrame(Dauntless, rad, 100, -rad);
  end;
end;

function M_Player;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  SF_SetBaseShip(Dauntless);
  F_PlayerTakeoff;

  while (1) do begin
    if (m_Event = EVENT_Land_Player) then
      F_PlayerLanding;

    if (m_Comm = 2) then begin
      AI_SendSpecialCommFrom(21, 2, PILOT_Dauntless);
      AI_SendSpecialCommFrom(21, 3, PILOT_Dauntless);
      AI_SendSpecialCommFrom(21, 4, PILOT_Dauntless);
      AI_SendSpecialCommFrom(21, 5, PILOT_Dauntless);
      m_Comm := 0;
    end;

    if (m_Comm = 6) then begin
      AI_SendSpecialCommFrom(21, 6, PILOT_Dauntless);
      AI_SendSpecialCommFrom(21, 7, PILOT_Dauntless);
      AI_SendSpecialCommFrom(21, 8, PILOT_Dauntless);
      m_Comm := 0;
    end;

    if (m_Comm = 15) then begin
      AI_SendSpecialCommFrom(21, 15, PILOT_Sar1);
      m_Comm := 0;
    end;

    if (m_Comm = 18) then begin
      AI_SendSpecialCommFrom(21, 18, PILOT_Dauntless);
      AI_SendSpecialCommFrom(21, 19, PILOT_Dauntless);
      m_Comm := 0;
    end;

    if (m_Comm = 20) then begin
      AI_SendSpecialCommFrom(21, 20, PILOT_Dauntless);
      m_Comm := 0;
    end;

    if (m_Comm = 21) then begin
      AI_SendSpecialCommFrom(23, 18, PILOT_Dauntless);
      m_Comm := 0;
    end;

    AI_WaitMilliseconds(150);
  end;
end;

function M_Alpha;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_WaitSeconds(1);
  m_Event := 0;
  AI_AddToWing(Player);

  while(1) do begin
    AI_WaitMilliSeconds(1);
    if ((m_Event = EVENT_Land_Player) or (m_Event = EVENT_Activate_Landing_Cam)) then begin
      AI_RemoveFromWing;
      AI_IgnoreCollisions(1);
      AI_AttackNothing(1);
      AI_SetThrottle(0);
      while (1) do AI_WaitSeconds(1);
    end;
    if (m_Event = EVENT_Fralthi_Friendly) then
      AI_AttackNothing(1);
  end;
end;

function M_Dauntless;
begin
  AI_WaitUntilActive;
  SF_SaveObjectState(true);

  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(NAV_Dauntless);

  AI_WaitSeconds(1);
  AI_SendSpecialCommFrom(21, 1, PILOT_Dauntless);

  SF_SetPilotImmortal(PILOT_Gryphon, 1);
  SF_SetPilotImmortal(PILOT_Gold, 1);
  SF_SetPilotImmortal(PILOT_Mage, 1);
  SF_SetPilotImmortal(PILOT_Night, 1);
  SF_SetPilotImmortal(PILOT_Phantom, 1);
  SF_SetPilotImmortal(PILOT_Defender, 1);
  SF_SetPilotImmortal(PILOT_Faris, 1);
  SF_SetPilotImmortal(PILOT_Huntress, 1);
  SF_SetPilotImmortal(PILOT_Hellcat, 1);
  SF_SetPilotImmortal(PILOT_Warrior, 1);
  SF_SetPilotImmortal(PILOT_Ocelot, 1);
  SF_SetPilotImmortal(PILOT_Doc, 1);

  while(1) do begin
    if (m_Event = EVENT_Activate_Landing_Cam) then begin
      F_DauntlessLanding;
      while(1) do AI_WaitSeconds(100);
    end;
    AI_WaitMilliSeconds(1);
  end;
end;

// ***************************** NAV 1 *****************************

object Nav1(Navpoint)
  x: -40000;
  y: 20000;
  z: 3000;
  main: M_Nav1;
  brief: B_Nav1;
  name: spacefli["Nav 1"];
  navdata: 2, 25000;
  color: 0, 1.0, 1.0, 1.0;
end;

function M_Nav1;
var
  setup = true;
begin
  while(1) do begin
    NAV_SetEjectSequence(ES_SAR_pickup);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        // 2 Gratha (Kilrathi Pilots, 87, 88), fighter variant.
        //NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 87, 0, @S_EnemyFighter, @S_EnemyFighterDeath, -40260, 20000, 3000);
        //NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 88, 0, @S_EnemyFighter, @S_EnemyFighterDeath, -40000, 20400, 3000);

        setup := false;

        M_WaitUntilDead;
      end;

      NAV_SetPlayerNav(NAV_2);

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

// ***************************** NAV 2 *****************************

object Nav2(Navpoint)
  x: 20000;
  y: 80000;
  z: 3000;
  main: M_Nav2;
  brief: B_Nav2;
  name: spacefli["Nav 2"];
  navdata: 3, 25000;
  color: 0, 1.0, 1.0, 1.0;
end;

function M_Nav2;
var
  setup = true;
begin
  while(1) do begin
    NAV_SetEjectSequence(ES_SAR_pickup);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;


      if (setup) then begin
        // 2 Vaktoth (Kilrathi Aces, 84, 85), fighter variant.

        NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 84, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 20060, 80000, 150);
        NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 85, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 20000, 80020, 200);

        setup := false;

        M_WaitUntilDead;
      end;

      NAV_SetPlayerNav(NAV_3);

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

// ***************************** NAV 3 *****************************

//Nav 3:
//2 Gratha (Kilrathi Aces, 83, 86), fighter variant
//[Comm Message, Dauntless, played 15 seconds after arrival] (Block 202)
//

object Nav3(Navpoint)
  x: 40000;
  y: 20000;
  z: 3000;
  main: M_Nav3;
  brief: B_Nav3;
  name: spacefli["Nav 3"];
  navdata: 4, 25000;
  color: 0, 1.0, 1.0, 1.0;
end;

function M_Nav3;
var
  setup = true;
begin
  while(1) do begin
    NAV_SetEjectSequence(ES_SAR_pickup);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        // 2 Gratha (Kilrathi Aces, 83, 86), fighter variant
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 83, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 43060, 19000, 5500);
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 86, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 43000, 19020, 5000);
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 85, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 43100, 19000, 5700);

        AI_WaitSeconds(6);
        // Dauntless: Sir! The last sensor data package from your ship indicates that
        //            there is a group of fighters... wait, make that two groups of
        //            fighters, heading your way.
        // Dauntless: Now, we can't be sure of this, but judging from their speed, we
        //            believe the first group are Gratha, while the second group are
        //            either Dralthi or Vaktoths."
        // Dauntless: One of those groups may be coming in from their capship, so if
        //            you intercept now, you just might get within sensor range and
        //            find it."
        // Dauntless: We're sending you a nav map update... but don't take too long
        //            deciding which to intercept, or they'll reach your position
        //            first."
        m_Comm := 2;

        AI_WaitSeconds(10);

        NAV_ShowNav(NAV_Gratha);
        NAV_ShowNav(NAV_Dralthi);
        NAV_SetPlayerNav(NAV_3);

// !!   need to hide navpoint after 60 seconds

        setup := false;

        M_WaitUntilDead;
      end;

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

// **************************** Gratha NAV ****************************

object NavG(Navpoint)
  x: 100000;
  y: -5000;
  z: 2000;
  main: M_NavG;
  name: spacefli["Gratha Nav"];
  navdata: 5, 25000;
end;

function M_NavG;
var
  setup = true;
begin
  NAV_HideSelf;
  while(1) do begin
    NAV_SetEjectSequence(ES_SAR_pickup);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        NAV_HideNav(NAV_Dralthi);

        // 4 Gratha (Kilrathi Pilots, 88, 87, 89, 90), fighter variant
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 88, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 100060, -5000, 150);
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 87, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 100100, -5020, -200);
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 89, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 100060, -5000, 15);
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 90, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 100600, -5060, -20);
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 83, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 100700, -5000, -20);
        NAV_CreateShip(UE_SHIPID_Gratha_Fighter, 86, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 100400, -5060, 30);

        setup := false;

        M_WaitUntilDead;
      end;

      NAV_SetPlayerNav(NAV_Dauntless);

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

// **************************** Dralthi NAV ****************************

object NavV(Navpoint)
  x: 80000;
  y: 80000;
  z: 3000;
  main: M_NavV;
  name: spacefli["Dralthi/Vaktoth Nav"];
  navdata: 6, 25000;
end;

function M_NavV;
var
  setup = true;
begin
  NAV_HideSelf;
  while(1) do begin
    NAV_SetEjectSequence(ES_SAR_pickup);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        //Note: If the player has reached this nav point, the Gratha Nav should
        //disappear from the map, and the player's autopilot should be disabled
        //altogether.
        NAV_HideNav(NAV_Gratha);
        SF_AutopilotDisable;

        // 4 Vaktoth (Kilrathi Aces, 82, 83, 84, 85), fighter variant.
        NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 82, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80060, 80000, 1150);
        NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 83, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80100, 80020, 1200);
        NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 84, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80060, 80000, 2115);
        NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 85, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80600, 80060, 2220);

        //[Comm message, Dauntless, played 5 seconds after arrival] "Sir, that's it!
        //We've got a reading on the capital ship... except that it's moving towards the
        //asteroid belt. We won't be able to track it there, so you must intercept now!
        //We're updating your nav map... forget those Vaktoths, punch the burners and
        //GO!"

        AI_WaitSeconds(4);
        m_Comm := 6;
        //SF_PrintText(203);

        //At this point, "Fralthi Nav" should appear on the map. The player must get
        //there within 70 seconds (the nav point should be roughly 65,000 away, which
        //gives the player no more than 10 seconds to spare). If he doesn't, the "Fail"
        //version of the navpoint should be activated.
        //If he reaches it in time, it's the "Success" version.

        //wait until the player got the chance to read it
        AI_WaitSeconds(4);

        NAV_ShowNav(NAV_Fralthi);
        NAV_SetPlayerNav(NAV_Fralthi);

        AI_WaitSeconds(4);

        m_Timer := SYS_Clock;

        setup := false;
      end;

      NAV_SetPlayerNav(NAV_Fralthi);
      NAV_DeactivateSelf;

      // we don't want this nav to activate itself again
      while(1) do
        AI_WaitSeconds(10);
    end;
    AI_WaitSeconds(1);
  end;
end;

// **************************** Fralthi NAV ****************************

object NavF(Navpoint)
  x: 82000;
  y: 86500;
  z: -5000;
  main: M_NavF;
  name: spacefli["Fralthi Nav"];
  navdata: 7, 6500;
end;

object Fralthi(Capship) as "Fralthi"
  obj: UE_SHIP_Fralthi;
  x: 82000;
  y: 87000;
  z: -5000;
  main: M_Fralthi;
  death: D_Fralthi;
  brief: B_Fralthi;
  color: 0, 1.0, 0.4, 0.4;
  pilot: PILOT_Kat_Capship;
end;

object Gamma1(Ship)
  obj: UE_SHIP_Ferret;
  x: 82000;
  y: 89000;
  z: -4950;
  main: M_Gamma;
  brief: B_Gamma1;
  targstr: targetid["Gamma 1"];
  pilot: PILOT_Confed;
  color: 0, 0.2, 0.2, 1.0;
end;

object Gamma2(Ship)
  obj: UE_SHIP_Ferret;
  x: 82000;
  y: 89000;
  z: -5050;
  main: M_Gamma;
  brief: B_Gamma2;
  targstr: targetid["Gamma 2"];
  pilot: PILOT_Confed;
  color: 0, 0.2, 0.2, 1.0;
end;

object Marines(Ship)
  obj: UE_SHIP_Marine_LC;
  x: 82000;
  y: 89000;
  z: -5000;
  main: M_Marines;
  brief: B_Marines;
  death: D_Marines;
  targstr: targetid["Marine LC"];
  color: 0, 0.3, 0.3, 1.0;
  pilot: PILOT_SAR1;
end;

function M_Beta; forward;
function D_Beta; forward;

function M_NavF;
var
  setup = true;
begin
  NAV_HideSelf;

  while(1) do begin
    NAV_SetEjectSequence(ES_SAR_pickup);
    // SYS_Message(m_Timer + 70 - SYS_Clock);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        m_Failed := ((SYS_Clock - m_Timer) > 60);//70);

        if (m_Failed) then begin
          //Fralthi Nav ("Fail" version):
          //4 Vaktoth (Kilrathi Aces, 82, 83, 85, 86), fighter variant.
          //Once these are taken out, the player has no choice but to go back to the
          //Dauntless (autopilot is enabled).
          NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 83, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80060, 86000, -4010);
          NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 84, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80100, 87020, -4120);
          NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 85, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80060, 87000, -4215);
          NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 86, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80600, 86060, -4220);
          NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 87, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80400, 87000, -4180);

          M_WaitUntilDead;
        end else begin
          SF_ObjectiveSetComplete(mobj_locate_fralthi);
          SF_ObjectiveEnable(mobj_defend_marines);
          SF_ActivateObject(Fralthi, AO_appear);
          //2 Vaktoths (Kilrathi Aces, 83, 84, 85, 86), fighter variant
          //4 Dralthi (Kilrathi Pilots, 87, 88).
          NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 83, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80060, 80000, 150);
          //NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 84, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80100, 80020, 100);
          NAV_CreateShip(UE_SHIPID_Dralthi, 85, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80060, 80000, 215);
          NAV_CreateShip(UE_SHIPID_Dralthi, 86, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80600, 80060, 220);
          //NAV_CreateShip(UE_SHIPID_Dralthi, 87, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80060, 80000, 215);
          //NAV_CreateShip(UE_SHIPID_Dralthi, 88, 0, @S_EnemyFighter, @S_EnemyFighterDeath, 80600, 80060, 220);

          //wait a bit before reinforcement appears
          AI_WaitSeconds(5);

          // 1st Kilrahi Wave
          M_SpawnNearObject(UE_SHIPID_Dralthi, 4, Fralthi);

          //BW reinforcements include 2 wings (3 Scimitars dust cannon variant, per
          //wing(Sprite, Comet, Indigo in the first wing, Veil, Foxtrot, Wyvern in the
          //second) - these should be set to autopilot with player, but not be on his
          //wing)
          AI_WaitSeconds(25);
          NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Faris, 1, @M_BetaLead, @D_Beta, 77600, 77060, 2220);
          NAV_CreateShip(UE_SHIPID_Banshee, PILOT_Huntress, 1, @M_Beta, @D_Beta, 77060, 77000, 2115);
          NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Hellcat, 1, @M_Beta, @D_Beta, 77060, 77000, 2115);

          // 2nd Kilrahi Wave
          AI_WaitSeconds(5);
          M_SpawnNearObject(UE_SHIPID_Dralthi, 2, Fralthi);

          // 3rd Kilrahi Wave
          AI_WaitSeconds(30);
          M_SpawnNearObject(UE_SHIPID_Dralthi, 2, Fralthi);

          // 2nd BW Force
          AI_WaitSeconds(25);
          NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Warrior, 1, @M_Beta, @D_Beta, 77600, 77060, 2220);
          NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Ocelot, 1, @M_Beta, @D_Beta, 77060, 77000, 2115);
          NAV_CreateShip(UE_SHIPID_Epee, PILOT_Doc, 1, @M_BetaLead, @D_Beta, 77060, 77000, 2115);

          // Returning Vaktoth Kilrahi Wave
          AI_WaitSeconds(30);
          M_Spawn(UE_SHIPID_Vaktoth_Fighter, 2, 85000, 88000, 0);

          SYS_TimerSet(45);

          while(m_Event <> EVENT_Can_Return) do begin
            AI_WaitSeconds(1);

            if ((SYS_TimerGet = 0) and (m_Event < EVENT_Fralthi_Friendly)) then
            begin
              if (m_Event < EVENT_Fralthi_Disabled) then
              begin
                 //1 additional wave every 45 seconds...
                 M_SpawnNearObject(UE_SHIPID_Dralthi, 2, Fralthi);
                 SYS_TimerSet(45);
              end
              else
//              if (m_Event = EVENT_Fralthi_Disabled) then
                begin
                  // A big wave during the capture
                  AI_WaitSeconds(15);
                  M_SpawnNearObject(UE_SHIPID_Dralthi, 2, Fralthi);
                  M_Spawn(UE_SHIPID_Gratha_Fighter, 5, 87000, 88000, 0);
                  AI_WaitSeconds(20);
                  M_Spawn(UE_SHIPID_Gratha_Fighter, 5, 77000, 86000, 0);
                  until (m_Event <> EVENT_Fralthi_Disabled) do begin
                    AI_WaitSeconds(1);
                    if (m_Failed) then begin
                     M_WaitUntilDead;
                     m_Event := EVENT_Can_Return;
                    end;
                  end;
                end;
            end;

            if (m_Failed > 0) then begin
              M_WaitUntilDead;
              m_Event := EVENT_Can_Return;
            end;
          end;
        end;
        setup := false;
      end;

      NAV_SetPlayerNav(NAV_Dauntless);
      SF_AutopilotResumeNormal;

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Fralthi;
begin
  AI_WaitUntilActive;
  SF_SaveObjectState(true);

  SF_SetObjectFlag(OF_alignment, ALIGN_Evil_Kilrathi);
  SF_BindToActionSphere(NAV_Fralthi);
  SF_SetChildObjectVulnerable(Fralthi, PART_ChildBridge, false);

  AI_WaitSeconds(3);
  AI_SendSpecialCommFrom(21, 9, PILOT_Dauntless);

  while(1) do begin
    if ((m_Event = 0) and (SF_GetNumComponentParts(PART_ChildGunTurret) = 0)) then begin
      m_Event := EVENT_Fralthi_Disabled;
    end;

    if (m_Event = EVENT_Fralthi_Friendly) then begin
      SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
      SF_SetChildObjectVulnerable(Fralthi, PART_ChildBridge, true);

      // Fralthi: Pilots, cease fire and land immediately!
      // Fralthi: This is Shintahr Vak'kaha. I repeat, do not fire on the Terrans,
      //          and land now!
      //note: send this only if there are still ships around!
      if (M_CountEnemies > 0) then begin
        AI_SendSpecialComm(21, 13);
        AI_SendSpecialComm(21, 14);
      end;
      AI_WaitSeconds(5);

      m_Event := EVENT_Kilrathi_Surrendered;

      AI_WaitSeconds(10);
      m_Event := EVENT_Can_Return;

      while(1) do
        AI_WaitSeconds(5);
    end;

    AI_WaitMilliseconds(200);
  end;
end;

function D_Fralthi;
begin
  m_Failed := 2;
end;

function M_Beta;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);

  AI_SetAutopilotData(SYS_Random(100) - 50, SYS_Random(100) - 50, SYS_Random(100) - 200);

  //AI_AttackEnemies;

  while(1) do begin
    AI_WaitMilliSeconds(1);
    if (m_Event = EVENT_Land_Player) then begin
      AI_SetAutopilotData(SYS_Random(100) + 500, SYS_Random(100) + 500, SYS_Random(100) + 500);
      AI_IgnoreCollisions(1);
      AI_AttackNothing(1);
      AI_SetThrottle(0);
    end;
    if (m_Event = EVENT_Fralthi_Friendly) then
      AI_AttackNothing(1);
  end;
end;

function M_BetaLead;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_SendComm(COMM_Leader_Report_Arriving);

  AI_SetAutopilotData(SYS_Random(100) - 50, SYS_Random(100) - 50, SYS_Random(100) - 200);

  //AI_AttackEnemies;

  while(1) do begin
    AI_WaitMilliSeconds(1);
    if (m_Event = EVENT_Land_Player) then begin
      AI_SetAutopilotData(SYS_Random(100) + 500, SYS_Random(100) + 500, SYS_Random(100) + 500);
      AI_IgnoreCollisions(1);
      AI_AttackNothing(1);
      AI_SetThrottle(0);
    end;
    if (m_Event = EVENT_Fralthi_Friendly) then
      AI_AttackNothing(1);
  end;
end;

function D_Beta;
begin
end;

function M_Marines;
begin
  while(m_Event <> EVENT_Fralthi_Disabled) do
    AI_WaitSeconds(1);

  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(NAV_Fralthi);

  SF_ActivateSelf(0);
  AI_AttackNothing(1);

  AI_WaitSeconds(4);
  // LC: This is the Beaufort Station Marine Detachment.
  // LC: We're going for their capship.
  AI_SendSpecialComm(21, 10);
  AI_SendSpecialComm(21, 11);

  AI_SetThrottle(100);
  AI_GotoObjRelFrame(Fralthi, 0, 300, 0);

  // LC: This is the Marines. We're on final approach... wish us luck!
  AI_SendSpecialComm(21, 12);
  AI_IgnoreCollisions(1);

  AI_DockTo(Fralthi, 0, 4, 45, 4);

  m_Event := EVENT_Fralthi_Friendly;

  AI_WaitSeconds(5);
  // LC: Sir, this is the Marine Detachment.
  // LC: The Kilrathi have given up, and we're in control of all key positions.
  // LC: You can return to your carrier now, but be sure to send us an escort
  //     as soon as you can."
  AI_SendSpecialComm(21, 15);
  AI_SendSpecialComm(21, 16);
  AI_SendSpecialComm(21, 17);

  SF_ObjectiveSetComplete(mobj_defend_marines);
  AI_DockTo(Fralthi, 0, 4, 600, 4);

  while(1) do
    AI_WaitSeconds(1);
end;

function D_Marines;
begin
  m_Failed := 2;
  SF_ObjectiveSetFailure(mobj_defend_marines);
  SF_SetMissionFailure;
end;

function M_Gamma;
begin
  while(m_Event <> EVENT_Fralthi_Disabled) do
    AI_WaitSeconds(1);

  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(NAV_Fralthi);

  SF_ActivateSelf(0);
  AI_SendComm(COMM_Leader_Report_Arriving);
  AI_AddToWing(Marines);

  AI_MuteComms;

  AI_AddToDefendList(Marines, 100);
  //AI_AttackEnemies;

  while(1) do begin
    AI_WaitMilliSeconds(1);
    if (m_Event = EVENT_Fralthi_Friendly) then begin
      AI_AttackNothing(1);
    end;
  end;
end;

// ************************* Briefing *************************

var
  m_Fralthi_Show,
  m_Fralthi_blowup,
  m_GammaWing,
  m_GammaKillCats,
  m_EnterMarines,
  m_BlueFralthi;

object BAlienFighter1(System)
  x: 80000;
  y: 85050;
  z: -22000;
  color: 0, 1.0, 0.2, 0.2;
  brief: B_AlienFighter;
  direction: 90, 0, 0;
end;

object BAlienFighter2(System)
  x: 80000;
  y: 89150;
  z: -28000;
  color: 0, 1.0, 0.2, 0.2;
  brief: B_AlienFighter;
  direction: 90, 0, 0;
end;

object BAlienFighter3(System)
  x: 80000;
  y: 93100;
  z: -30050;
  color: 0, 1.0, 0.2, 0.2;
  brief: B_AlienFighter;
  direction: 90, 0, 0;
end;

object BlueFralthi(System)
  obj: UE_SHIP_Fralthi;
  x: 82000;
  y: 87000;
  z: -5000;
  brief: B_BlueFralthi;
  color: 0, 0.5, 0.5, 1.0;
end;

function B_NavD;
begin
  BRIEF_SetAppearance(1);
  BRIEF_DisplayName(1);
  BRIEF_SetSize(120);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Nav1;
begin
  BRIEF_SetAppearance(1);
  BRIEF_DisplayName(1);
  BRIEF_SetSize(100);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Nav2;
begin
  BRIEF_SetAppearance(1);
  BRIEF_DisplayName(1);
  BRIEF_SetSize(100);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Nav3;
begin
  BRIEF_SetAppearance(1);
  BRIEF_DisplayName(1);
  BRIEF_SetSize(100);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Player;
begin
  BRIEF_CAM_SetPos(20, 80, 800);
  BRIEF_CAM_SetActive(1);
  BRIEF_CAM_TrackObj(Player);

  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_Activate;
  BRIEF_WaitSeconds(1);

  // This mission is of the highest priority.

  BRIEF_Voiceover(21, 0, 3);
  BRIEF_WaitSeconds(3);

  // You and two wingmen are to patrol this NAV route in order to find
  // the Kilrathi capital ship.

  BRIEF_Voiceover(21, 1, 6);

  BRIEF_MoveObjSeconds(Nav1, 4);
  SYS_PlaySFX(SFX_BRIEF_Activate);

  BRIEF_MoveObjSeconds(Nav2, 4);
  SYS_PlaySFX(SFX_BRIEF_Activate);

  BRIEF_MoveObjSeconds(Nav3, 4);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  BRIEF_WaitSeconds(1);

  m_Fralthi_Show := true;

  // Once the capital ship is identified, it must be disabled by inflicting
  // sufficient damage to its outer structure.

  BRIEF_VoiceOver(21, 2, 6);
  BRIEF_GotoObjRelFrameSeconds(Fralthi, 0, 0, -80, 4, 0);

  BRIEF_WaitSeconds(5);

  // Other wings will proceed to reinforce you as soon as possible.

  m_GammaWing := true;
  BRIEF_VoiceOver(21, 3, 5);
  BRIEF_WaitSeconds(8);

  // Having disabled the capital ship, you must protect the Marine LC
  // from Beaufort Station as it attempts to board and capture the vessel.

  BRIEF_VoiceOver(21, 4, 8);
  m_EnterMarines := true;
  BRIEF_WaitSeconds(9);

  m_Fralthi_blowup := true;

  BRIEF_MoveObjSeconds(NavD, 6);

  BRIEF_WaitSeconds(2);
  BRIEF_Exit;
end;

function B_Alpha1;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, -20, 15, -20);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Alpha2;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, 20, 15, -20);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Gamma1;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Nav3, 0, 0, 0);
  BRIEF_DetachFromObj(Nav3);

  until(m_GammaWing) do
    BRIEF_WaitMilliseconds(200);

  BRIEF_Activate;
  BRIEF_GotoObjRelFrameSeconds(BAlienFighter2, 0, 0, 0, 4, 0);

  m_GammaKillCats := true;

  while(1) do
    BRIEF_WaitSeconds(150);
end;

function B_Gamma2;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Gamma1, 25, 20, -20);

  until(m_GammaWing) do
    BRIEF_WaitMilliseconds(200);

  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(150);
end;

function B_Marines;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Marine_LC);
  BRIEF_AttachToObj(Nav3, 0, 0, 0);
  BRIEF_DetachFromObj(Nav3);

  until(m_EnterMarines) do
    BRIEF_WaitMilliseconds(500);

  BRIEF_Activate;
  BRIEF_GotoObjRelFrameSeconds(Fralthi, 0, 5, 20, 4, 0);

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Dauntless;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Dauntless);
  BRIEF_Activate;
  while (1) do
    BRIEF_WaitSeconds(10);
end;

function B_AlienFighter;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Dralthi);

  until (m_Fralthi_Show) do BRIEF_WaitMilliseconds(150);

  BRIEF_Activate;
  BRIEF_WaitSeconds(1);

  while(1) do begin
    BRIEF_WaitMilliseconds(400);
    if (m_GammaKillCats) then begin
      BRIEF_WaitMilliSeconds(600);
      SYS_PlaySFX(SFX_BRIEF_Blowup);
      BRIEF_WaitMilliseconds(50);
      BRIEF_Deactivate;
      while(1) do BRIEF_WaitSeconds(99);
    end;
  end;
end;

function B_Fralthi;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Fralthi);

  while(1) do begin
    BRIEF_WaitMilliseconds(150);
    if (m_Fralthi_Show) then begin
      BRIEF_CAM_TrackObj(Fralthi);
      BRIEF_CAM_SetPos(0, 0, 0);
      BRIEF_Activate;
      m_Fralthi_Show := false;
    end;

    if (m_Fralthi_blowup) then begin
      //Why doesn't SetColor work???
      //BRIEF_SetColor(200, 200, 200);
      m_BlueFralthi := true;
      BRIEF_WaitMilliseconds(150);
      BRIEF_Deactivate;
      while(1) do BRIEF_WaitSeconds(99);
    end;
  end;
end;

function B_BlueFralthi;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Fralthi);
  until (m_BlueFralthi) do BRIEF_WaitMilliseconds(150);
  BRIEF_Activate;
  while(1) do BRIEF_WaitSeconds(99);
end;


// **************** Takeoff/Landing routines **************
// ********************************************************
// Camera stuff

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

function F_Takeoff(select); forward;
function F_Landing(select); forward;

function M_Camera;
begin
  while(1) do
  begin
    if (m_Event = EVENT_Takeoff_Start) then
      F_Takeoff(SYS_Random(3));
    if (m_Event = EVENT_Activate_Landing_Cam) then
      F_Landing(SYS_Random(3));
    AI_WaitMilliSeconds(15);
  end;
end;

function F_Takeoff(select);
begin
  SF_CAM_TrackObj(Player);

  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -30, 35, -40);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, -10, 35, 80);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, 0, 5, 40);

  SF_ActivateSelf(0);
  until (m_Event = EVENT_Takeoff_Complete) do
    AI_WaitSeconds(1);
  SF_CAM_TrackNothing;
  SF_DeactivateSelf(0);
end;

function F_Landing(select);
begin
  SF_CAM_HideDust;
  SF_CAM_TrackObj(NavD);
  SF_CAM_SetFollowObj(NavD, 0, 1, 0);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(1);
  SF_CAM_TrackObj(Dauntless);

  if (select = 0) then
    SF_CAM_SetFollowObj(Dauntless, -200, 200, -350);
  if (select = 1) then
    SF_CAM_SetFollowObj(Dauntless, -50, 200, 500);
  if (select = 2) then
    SF_CAM_SetFollowObj(Dauntless, 400, 100, 300);

  until (m_Event = EVENT_Final_Approach) do
    AI_WaitMilliSeconds(5);
  SF_CAM_TrackObj(Player);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -3, 2, 15);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, 3, 4, -15);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, -9, 2, 5);

  AI_WaitSeconds(30);
end;

// Navpoint Landing Launcher

function F_InitLanding;
begin
  SF_AutopilotDisable;
  m_Event := EVENT_Land_Player;
  until (M_Event = EVENT_Activate_Landing_Cam) do AI_WaitSeconds(1);
  AI_WaitSeconds(30);
  SF_Exit;
end;

// Player stuff

function F_PlayerTakeoff;
begin
  M_GetPos(Dauntless);
  SF_SetWorldPosition(xpos+15, ypos-25, zpos);
  SF_SetObjectFlag(OF_Collidable, false);
  AI_PLR_ControlAssume;
  AI_SetThrottle(0);
  AI_WaitSeconds(1);
  SF_ActivateSelf(0);
  AI_WaitSeconds(1);
  AI_SetThrottle(100);
  AI_WaitMilliSeconds(1500);
  M_Event := EVENT_Takeoff_Start;
  while (SF_GetDistance(Dauntless) < 500) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, 15, -20, 700);
  M_Event := EVENT_Takeoff_Complete;
  SF_SetObjectFlag(OF_Collidable, true);
  AI_PLR_ControlResume;
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
end;

function F_PlayerLanding;
begin
  while (SF_GetDistance(Dauntless) > 300) do AI_WaitMilliSeconds(1);
  AI_PLR_ControlAssume;
  SF_SetObjectFlag(OF_Collidable, false);
  M_Event := EVENT_Activate_Landing_Cam;
  HCL_EmptyFuel;
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Player) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless
  M_GetPos(Dauntless);
  SF_SetWorldPosition(xpos, ypos, zpos-350);
  AI_FaceObject(Dauntless);
    SF_SetWorldPosition(xpos, ypos-25, zpos-350);
  AI_SetThrottle(50);
  until (SF_GetDistance(Dauntless) < 50) do AI_WaitMilliSeconds(5);
  M_Event := EVENT_Final_Approach;
  SYS_PlaySFX(SFX_Engines_Power_Down);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  AI_WaitSeconds(5);
  SF_Exit;
end;

// Dauntless stuff

function F_DauntlessLanding;
begin
  if (SF_GetVelocityObject(Dauntless) > 0) then
  begin
    AI_SetThrottle(0);
    AI_WaitSeconds(5);
  end;

  // Teleport to position relative to NavD, face NavD
  M_GetPos(NavD);
  SF_SetWorldPosition(xpos, ypos, zpos+1000);
  AI_FaceObject(NavD);
  m_Event := EVENT_Dauntless_Ready;
  AI_WaitSeconds(25);
  SF_Exit;
end;
