//******************************************************************************
//
// Unknown Enemy
// Mission 10B
//
// Created by:
//               Alex Barnfield  <alex@crius.net>
// Modified by:  Jakub Majewski <qmajewski@yahoo.co.uk>
// Last modified: May 12th, 2004
//
//******************************************************************************

mission ue10b;

#Addtosearchpath("$uesrc$");

#SetOutputPath("$wcue$\language\pilots\");
#file "strings\pilots\srs30.pas";
#SetRooms ("cic.rom", "rec.rom");
#SetOutputPath("$wcue$\comms\");
#file "comms\srs30.pas";

// 0 = "Everyone's ready to go, Colonel."

// 1 = "Here we go, people. Take out the fighters, then go after the Orcas."

// 2 = "Damn it, they've got their whole bloody fleet here! Colonel, clear out
//  those fighters or the Eisen will get sliced to bits!"

// 3 = "It's damned great to see you, TCS Eisen!"

// 4 = "Unbelieveable! We won! You're cleared to land, Colonel!"

// 5 = "We're launching the rest of the squadron now, sir!"

// 6 = "Sir, land immediately! We've got a few minutes to spare, and it will be
// faster to rearm everybody on the deck!"


#sector: "t.sec";

#name: 21;

#AddToSearchPath("$wcue$\language\");

#include wcp, consts, uepilots, comms, ue;

#strings targetid, objectiv, spacefli;

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior, PILOT_Drago);

#SetOutputPath("$wcue$\mission\");

const
  EVENT_Takeoff_Start = 4,
  EVENT_Takeoff_Complete = 5,
  EVENT_Land_Player = 6,
  EVENT_Activate_Landing_Cam = 7,
  EVENT_Dauntless_Ready = 8,
  EVENT_Final_Approach = 9,
  EVENT_Reached_Nav1 = 10,
  EVENT_Killed_Off = 11,
  EVENT_Reached_NavJ = 12,
  EVENT_Takeoff_Scimitar = 14,
  EVENT_Refuel =15,
  EVENT_Refuel_Complete = 16,
  EVENT_Eisen_Jumped_In = 17,
  EVENT_Mission_Complete = 18,
  EVENT_Vampire_Leader_Jumped_In = 19,
  EVENT_Scene_Finished = 20;


var
  m_Nav,
  m_Event,
  m_Event2,
  x,
  y,
  z,
  wave2bugcount = 0,
  bugcount=0,
  wingmancount=0,
  rearm=0,
  inbox=0,
  tcseisenjumpedin=0,
  m_Nav1KillBugs=0,
  m_Nav2KillBugs=0,
  DeltaLead_dead = 0,
  GammaLead_dead = 0,
  LevDead = false,
  m_OrcaDead = 0,
  m_HydraDead = 0;

objective mobj_escortdaunt
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Escort the Dauntless to the jump point"];
  status: MOBJ_Incomplete;
  counter: false;
end;

objective mobj_jumpin
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Ensure the Eisen's safe jump in-system"];
  status: MOBJ_Incomplete;
  counter: false;
end;

function M_Spawn(shipId, count, ax, ay, az);
//
// this function spawns "count" ships of type "shipID"
// at coordinates around x, y, z
//
var
  ox, oy, oz, pilotnum;
begin
  while(count > 0) do begin
    ox := ax + SYS_Random(1600) - 800;
    oy := ay + SYS_Random(1600) - 800;
    oz := az + SYS_Random(1600) - 800;
    pilotnum := 107 + SYS_Random(7);
    if(pilotnum = 111) then pilotnum:=115;

    NAV_CreateShip(shipId, pilotnum, 0, @M_Bug, @D_Bug, ox, oy, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;

function M_SpawnWave2(shipId, count, ax, ay, az);
//
// this function spawns "count" ships of type "shipID"
// at coordinates around ax, ay, az
//
var
  ox, oy, oz, pilotnum;
begin
  while(count > 0) do begin
    ox := ax + SYS_Random(1600) - 800;
    oy := ay + SYS_Random(1600) - 800;
    oz := az + SYS_Random(1600) - 800;
    pilotnum := 107 + SYS_Random(7);
    if(pilotnum = 111) then pilotnum:=115;

    NAV_CreateShip(shipId, pilotnum, 0, @M_Wave2Bug, @D_Wave2Bug, ox, oy, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;

object Dauntless(capship) as "BWS Dauntless"
  obj: UE_SHIP_Dauntless;
  x: -5000;
  y: 0;
  z: 1000;
  main: M_Dauntless;
  brief: B_Dauntless;
  death: D_Dauntless;
  color: 0, 0.35, 0.35, 1;
  direction: 0, 0, 0;
  pilot: PILOT_Dauntless;
end;

object Player(Player)
  obj: UE_SHIP_Scimitar_Bomber;
  x: 0;
  y: 0;
  z: 0;
  main: M_Player;
  brief: B_Player;
  color: 0, 0.8, 0.8, 0;
  pilot: PILOT_Casey1;
end;

object Defender(Ship)
  obj: UE_SHIP_Scimitar_Bomber;
  x: -5100;
  y: 0;
  z: 2000;
  main: M_Wingman;
  brief: B_Defender;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Defender;
end;

object Night(Ship)
  obj: UE_SHIP_Scimitar_Bomber;
  x: -4900;
  y: 0;
  z: 2000;
  main: M_Wingman;
  brief: B_Night;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Night;
end;

object Edge(Ship)
  obj: UE_SHIP_Scimitar_Bomber;
  x: -5000;
  y: 50;
  z: 2200;
  main: M_Wingman;
  brief: B_Edge;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Edge;
end;

object Drago(Ship)
  obj: vampire;
  x: -5000;
  y: 0;
  z: 2100;
  main: M_Wingman;
  brief: B_Drago;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Drago;
end;

object JumpPoint(JumpPoint)
  x: 10000;
  y: 25000;
  z: 140000;
  actionsphere: 3;
end;

function MAIN;
begin
  MS_ChangePilotSquadron(PILOT_Drago, 1);
  MS_ChangePilotSquadron(PILOT_Steel, 1);
  MS_ChangePilotSquadron(PILOT_November, 1);
  MS_ChangePilotSquadron(PILOT_Echo, 1);
  MS_ChangePilotSquadron(PILOT_Professor, 1);
  MS_ChangePilotSquadron(PILOT_Ogre, 1);
  MS_ChangePilotSquadron(PILOT_Ninja, 1);
  MS_RunGameflow(0);
  MS_RunBriefing;
  MS_RunSpaceflight(0);
  MS_RunDebriefing;
end;

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;
function M_GetXYZDistance(ShipID1, ShipID2);
var
  dx, dy, dz;
begin
  dx := SF_GetXObj(ShipID1)-SF_GetXObj(ShipID2);
  dy := SF_GetYObj(ShipID1)-SF_GetYObj(ShipID2);
  dz := SF_GetZObj(ShipID1)-SF_GetZObj(ShipID2);

  if(dx>(-50) and dx<50 and dy>(-25) and dy<30 and dz>30 and dz<200) then
    inbox:=1;
  SYS_Message(inbox);
end;


function F_InitLanding; forward;
function F_PlayerTakeoff; forward;
function F_PlayerLanding; forward;
function F_DauntlessLanding; forward;

function D_Dauntless;
begin
  SF_ObjectiveSetFailure(mobj_escortdaunt);
end;

//**********************Dauntless Nav****************************


object NavD(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_DNav;
  brief: B_DNav;
  color: 0, 1, 1, 1;
  name: spacefli["Dauntless Nav"];
  navdata: 1, 20000;
end;


object Field1(ABStart)
  x: -5000;
  y:0;
  z:1000;
  absdata: 2,  600, 3500;
  color: 0, 0, 0, 1;
//  brief: B_Asteroid;
end;


object Faris(Ship)
  obj: banshee;
  x: -5100;
  y: 100;
  z: 2000;
  main: M_BravoLeader;
  brief: B_Faris;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Faris;
end;

object Ocelot(Ship)
  obj: banshee;
  x: -4900;
  y: 100;
  z: 2000;
  main: M_BravoWing;
  brief: B_Ocelot;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Ocelot;
end;

object Doc(Ship)
  obj: scim;
  x: -5000;
  y: 100;
  z: 2000;
  main: M_BravoWing;
  brief: B_Doc;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Doc;
end;

object Shark(Ship)
  obj: scim;
  x: -5100;
  y: 0;
  z: 2000;
  main: M_CharlieLeader;
//  brief: B_Shark;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Shark;
end;

object Mage(Ship)
  obj: scim;
  x: -4900;
  y: 0;
  z: 2000;
  main: M_CharlieWing1;
//  brief: B_Mage;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Mage;
end;

object Phantom(Ship)
  obj: scim;
  x: -5000;
  y: 0;
  z: 2000;
  main: M_CharlieWing2;
//  brief: B_Phantom;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Phantom;
end;

object Hellcat(Ship)
  obj: epee;
  x: -4900;
  y: -100;
  z: 1000;
  main: M_DeltaLeader;
//  brief: B_Hellcat;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Hellcat;
end;

object Ghost(Ship)
  obj: epee;
  x: -5000;
  y: -100;
  z: 2000;
  main: M_DeltaWing;
//  brief: B_Ghost;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Ghost;
end;

function M_DNav;
var
  setup = true;
begin
  m_Nav := 1;
  NAV_SetEjectSequence(ES_Alien_pickup_MIA);
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_SetPlayerNav(2);
      if (setup) then begin
        setup := false;
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;

function M_Player;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  F_PlayerTakeoff;

  while (1) do begin
    if(m_EVENT=EVENT_Vampire_Leader_Jumped_In) then begin
      AI_PLR_ControlAssume;
      SF_SetObjectFlag (OF_Collidable, false);
      AI_SetThrottle(0);
    end;

    if(m_EVENT=EVENT_Scene_Finished) then begin
      AI_PLR_ControlResume;
      SF_PlayerSwitchToCam(CamID_cockpit, Player);
      SF_SetObjectFlag (OF_Collidable, true);
    end;
    if (m_Event = EVENT_Land_Player) then begin
      F_PlayerLanding;
    end;
    if(rearm) then begin
//      M_GetXYZDistance(Player, Dauntless);
      SF_AutopilotDisable;
      AI_WaitSeconds(3);
//      if(inbox=1) then
//      begin
        m_EVENT:=EVENT_Refuel;
        AI_PLR_ControlAssume;
        HCL_EmptyFuel;
        AI_SetThrottle(0);
        AI_Ignorecollisions(1);
        AI_WaitSeconds(3);
        M_GetPos(Dauntless);
        SF_SetWorldPosition(x+0, y-25, z+500);
        rearm := 2;
        SF_SetObjectFlag (OF_Collidable, false);
        AI_FaceObject(Dauntless);
        AI_GotoObjRelWorld(Dauntless, 0, -25, 3);
        AI_SetThrottle(0);
        HCL_ChangeDirection(0, 0, 0);
        AI_WaitSeconds(2);
        while (SF_GetDistance(Dauntless) < 450) do
          HCL_AI_GotoObjRelWorld_nonblock(Dauntless, 0, -25, 500);
        AI_SetThrottle(100);
        AI_ReplenishMissilesAndFuel;
        AI_Ignorecollisions(0);
        SF_AutopilotResumeNormal;
        SF_SetObjectFlag (OF_Collidable, true);
        m_EVENT:=EVENT_Refuel_Complete;
        AI_PLR_ControlResume;
        SF_PlayerSwitchToCam(CamID_cockpit, Player);
        rearm:=0;
//        end;
      end;
    AI_WaitSeconds(1);
  end;
end;

function M_Dauntless;
begin
  SF_SaveObjectState(false);
  SF_ActivateSelf(0);
  SF_SetPilotImmortal(PILOT_Drago, 1);
  SF_SetPilotImmortal(PILOT_Steel, 1);
  SF_SetPilotImmortal(PILOT_November, 1);
  SF_SetPilotImmortal(PILOT_Echo, 1);
  SF_SetPilotImmortal(PILOT_Professor, 1);
  SF_SetPilotImmortal(PILOT_Ogre, 1);
  SF_SetPilotImmortal(PILOT_Ninja, 1);
  SF_SetChildObjectVulnerable(Dauntless, PART_ChildEngine, false);
  SF_SetChildObjectVulnerable(Dauntless, PART_ChildBridge, false);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  AI_SetAutopilotData(-400, 0, 150);
  AI_WaitSeconds(5);
  AI_SendSpecialComm(30, 0);
  AI_SetThrottle(100);
  until(m_Event=EVENT_Reached_Nav1) do
    AI_WaitSeconds(1);

  AI_WaitSeconds(2);
  AI_SendSpecialComm(30, 5);           //Report launching last of the fighters
  AI_WaitSeconds(1);
  until(wave2bugcount > 0) do
    AI_WaitSeconds(1);

  AI_WaitSeconds(5);
  until((wave2bugcount=0) AND (m_OrcaDead = 2)) do //Wait until all nav1 bugs are dead
    AI_WaitSeconds(1);                             //and then order a rearm

  AI_WaitSeconds(2);
  AI_SendSpecialComm(30, 6);
  AI_SetThrottle(0);
  AI_WaitSeconds(2);
  rearm:=1;

  until(m_EVENT=EVENT_Reached_NavJ) do
    AI_WaitSeconds(1);

  AI_WaitSeconds(2);
  AI_SendSpecialComm(30, 2);
  AI_FaceObjRelFrame(JumpPoint, -400, 0, 0);
  AI_SetThrottle(100);
  until ((SF_GetDistance(JumpPoint) < 2500) OR (m_EVENT=EVENT_Eisen_Jumped_In)) do AI_WaitSeconds(1);
  AI_SetThrottle(0);
  until(m_EVENT=EVENT_Eisen_Jumped_In) do AI_WaitSeconds(1);
  AI_WaitSeconds(5);
  AI_SendSpecialComm(30, 3);
  until(m_EVENT=EVENT_Mission_Complete) do
    AI_WaitSeconds(1);
  SF_ObjectiveSetComplete(mobj_escortdaunt);
  SF_SetMissionSuccess;
  AI_WaitSeconds(2);
  AI_SendSpecialCommFrom(30, 4, PILOT_Dauntless);
  while(1) do begin
    if (m_Event = EVENT_Activate_Landing_Cam) then
      F_DauntlessLanding;
    AI_WaitMilliseconds(1);
  end;
end;

function M_Wingman;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_AddToWing(Player);
  inc(wingmancount);

  until (M_Event = EVENT_Refuel) do
    AI_WaitMilliSeconds(1);
  AI_ReplenishMissilesAndFuel;

  until (m_Event = EVENT_Vampire_Leader_Jumped_In) do
    AI_WaitMilliSeconds(1);
  SF_SetObjectFlag(OF_Vulnerable, true);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;


function M_BravoLeader;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_SetAutopilotData(-10, -30, -50);
  inc(wingmancount);
  SF_SetObjectFlag (OF_Vulnerable, false);

  until (M_Event = EVENT_Refuel) do
    AI_WaitMilliSeconds(1);
  AI_ReplenishMissilesAndFuel;
  HCL_ReloadAmmo(8, 400);
  until (m_Event = EVENT_Vampire_Leader_Jumped_In) do
    AI_WaitMilliSeconds(1);
  SF_SetObjectFlag (OF_Vulnerable, true);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;


function M_BravoWing;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AddToWing(Faris);
  inc(wingmancount);
  until (M_Event = EVENT_Refuel) do
    AI_WaitMilliSeconds(1);
  AI_ReplenishMissilesAndFuel;
  HCL_ReloadAmmo(8, 400);

  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;

function M_CharlieLeader;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  AI_SetAutopilotData(-10, -30, -500);

  until(m_EVENT=EVENT_Reached_Nav1) do
    AI_WaitSeconds(1);

  AI_WaitSeconds(12);
  M_GetPos(Dauntless);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  SF_SetObjectFlag (OF_Collidable, false);
  SF_SetObjectFlag (OF_Vulnerable, false);
  SF_SetWorldPosition(x, y-23, z);
  SF_ActivateSelf(0);
  m_EVENT:= EVENT_takeoff_scimitar;
  AI_GotoObjRelFrame(Dauntless, 0, -23, 400);
  SF_SetObjectFlag (OF_Collidable, true);
  AI_IgnoreCollisions(0);
  AI_AttackNothing(0);
  inc(wingmancount);

  until (M_Event = EVENT_Refuel) do
    AI_WaitMilliSeconds(1);
  AI_ReplenishMissilesAndFuel;
  until (m_Event = EVENT_Vampire_Leader_Jumped_In) do
    AI_WaitMilliSeconds(1);

  SF_SetObjectFlag (OF_Vulnerable, true);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;


function M_CharlieWing1;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag (OF_Collidable, false);
  SF_BindToActionSphere(0);
  until(m_EVENT=EVENT_Reached_Nav1) do
    AI_WaitSeconds(1);

  AI_WaitSeconds(12);
  M_GetPos(Dauntless);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  SF_SetWorldPosition(x-10, y-25, z-3);
  SF_ActivateSelf(0);
  AI_GotoObjRelFrame(Dauntless, -15, -25, 400);
  SF_SetObjectFlag (OF_Collidable, true);
  AI_IgnoreCollisions(0);
  AI_AttackNothing(0);
  AI_AddToWing(Shark);
  inc(wingmancount);

  until (M_Event = EVENT_Refuel) do
    AI_WaitMilliSeconds(1);
  AI_ReplenishMissilesAndFuel;
  until (m_Event = EVENT_Vampire_Leader_Jumped_In) do
    AI_WaitMilliSeconds(1);
  SF_SetObjectFlag(OF_Vulnerable, true);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;

function M_CharlieWing2;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  until(m_EVENT=EVENT_Reached_Nav1) do
    AI_WaitSeconds(1);

  AI_WaitSeconds(12);
  M_GetPos(Dauntless);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  SF_SetObjectFlag (OF_Collidable, false);
  SF_SetWorldPosition(x+10, y-25, z-3);
  SF_ActivateSelf(0);
  AI_GotoObjRelFrame(Dauntless, 10, -25, 400);
  SF_SetObjectFlag (OF_Collidable, true);
  AI_IgnoreCollisions(0);
  AI_AttackNothing(0);
  AI_AddToWing(Shark);
  inc(wingmancount);
  until (M_Event = EVENT_Refuel) do
    AI_WaitMilliSeconds(1);
  AI_ReplenishMissilesAndFuel;
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;

function M_DeltaLeader;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_SetAutopilotData(10, -5, -150);
  inc(wingmancount);
  until(m_EVENT=EVENT_Reached_Nav1) do
    AI_WaitSeconds(1);
  AI_SendComm(COMM_Enemies_Heavy);
  until (M_Event = EVENT_Refuel) do
    AI_WaitMilliSeconds(1);
  AI_ReplenishMissilesAndFuel;
  HCL_ReloadAmmo(8, 300);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;


function M_DeltaWing;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AddToWing(Shark);
  inc(wingmancount);
  until(m_EVENT2=EVENT_Killed_Off) do
    AI_WaitMilliSeconds(1);
//  if (DeltaLead_dead = true) then begin
//    AI_RemoveFromWing;
//    AI_SetAutopilotData(10, -5, -150);
//    AI_AddToWing(Shark);
//  end;
  until (M_Event = EVENT_Refuel) do
    AI_WaitMilliSeconds(1);
  AI_ReplenishMissilesAndFuel;
  HCL_ReloadAmmo(8, 300);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;

function D_Wingman;
begin
  dec(wingmancount);
end;

// **************************  Nav 1 **************************

object Nav1(Navpoint)
  x: 5000;
  y: 12500;
  z: 65000;
  main: M_Nav1;
  brief: B_Nav1;
  name: spacefli["Nav 1"];
  color: 0, 1.0, 1.0, 1.0;
  navdata: 2, 25000;
end;

object Orca_Alpha(capship) as "Orca Alpha"
  obj: orca;
  x: 5990;
  y: 12300;
  z: 66200;
  main: M_Orca1;
  death: D_Orca;
  direction: 270, 0, 0;
  pilot: PILOT_Corvette;
end;

object Orca_Bravo(capship) as "Orca Bravo"
  obj: orca;
  x: 3880;
  y: 12700;
  z: 66100;
  main: M_Orca2;
  death: D_Orca;
  direction: 80, 0, 0;
  pilot: PILOT_Corvette;
end;

function M_Nav1;
var
  setup = true;
begin
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_SetPlayerNav(3);
      if (setup) then begin
        NAV_HideNav(1);
        m_Nav := 2;
        NAV_SetEjectSequence(ES_alien_pickup_MIA);
        SF_AutopilotDisable;
        SF_ActivateObject(Orca_Alpha, 0);
        SF_ActivateObject(Orca_Bravo, 0);
        m_EVENT:=EVENT_Reached_Nav1;
        setup := false;
        M_Spawn(2, 8, 5000, 12500, 66000);
        M_Spawn(3, 6, 5000, 12500, 66000);
        M_Spawn(7, 6, 5000, 12500, 66000);
        until(bugcount<4) do
          AI_WaitSeconds(1);
        M_GetPos(Dauntless);
        M_SpawnWave2(7, 4, 5000, 12500, z+2000);
        if (m_OrcaDead < 2) then
          M_SpawnWave2(30, 2, 5000, 12500, z+2000)
        else
          M_SpawnWave2(30, 1, 5000, 12500, z+2000);
        if (m_OrcaDead = 0) then
          M_SpawnWave2(3, 4, 5000, 12500, z+2000)
        else
          M_SpawnWave2(3, 2, 5000, 12500, z+2000);
        M_SpawnWave2(2, 8, 5000, 12500, z+2000);
        until(wave2bugcount<9)do               //Start killing off wingmen
          AI_WaitSeconds(1);                   //as needs be

        m_EVENT2:=EVENT_Killed_Off;
        until (m_EVENT=EVENT_Refuel) do
          AI_WaitSeconds(1);
        SF_AutopilotResumeNormal;
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;

function M_Orca1;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(2);
  while(1) do
    AI_Waitseconds(1);
end;

function D_Orca;
begin
  m_OrcaDead := m_OrcaDead + 1;
end;

function M_Orca2;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(2);
  while(1) do
    AI_Waitseconds(1);
end;

function M_Bug;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(0);
  inc(bugcount);
  AI_AddToAttackList(Dauntless, 10000);
  if (SYS_Random(10) > 3) then AI_AddToIgnoreList(Player, 10000);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_BugLaunch;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_SetObjectFlag (OF_Collidable, false);
  AI_IgnoreCollisions(1);
  SF_ActivateSelf(0);
  inc(bugcount);
  AI_WaitSeconds(5);
  SF_SetObjectFlag (OF_Collidable, true);
  AI_IgnoreCollisions(0);
  AI_AddToAttackList(Dauntless, 10000);
  if (SYS_Random(10) > 3) then AI_AddToIgnoreList(Player, 10000);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Wave2Bug;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  inc(wave2bugcount);
  SF_ActivateSelf(0);
  AI_AddToAttackList(Dauntless, 6000);
  if (SYS_Random(10) > 3) then AI_AddToIgnoreList(Player, 5000);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function D_Bug;
begin
  dec(bugcount);
end;

function D_Wave2Bug;
begin
  dec(wave2bugcount);
end;

// **************************  Jumppoint Nav **************************

object NavJ(Navpoint)
  x: 10000;
  y: 25000;
  z: 129000;
  main: M_NavJ;
  brief: B_NavJ;
  name: spacefli["Jump Point Nav"];
  color: 0, 1.0, 1.0, 1.0;
  navdata: 3, 25000;
end;

// Not activated
object Orca3(capship) as "Orca Charlie"
  obj: orca;
  x: 8700;
  y: 25050;
  z: 131900;
  main: M_Orca3;
  direction: 80, 0, 0;
  pilot: PILOT_Corvette;
end;

object Hydra(capship)
  obj: marlin;
  x: 11300;
  y: 24950;
  z: 134800;
  main: M_Hydra1;
  death: D_Hydra;
  direction: 280, 0, 0;
  pilot: PILOT_Cruiser;
end;

object Hydra_Bravo(capship) as "Hydra Bravo"
  obj: marlin;
  x: 8500;
  y: 25000;
  z: 137500;
  main: M_Hydra2;
  death: D_Hydra;
  direction: 70, 0, 0;
  pilot: PILOT_Cruiser;
end;

object Leviathan(capship)
  obj: osprey;
  x: 10400;
  y: 25500;
  z: 139400;
  main: M_Leviathan;
  death: D_Leviathan;
  direction: 200, 0, 0;
  pilot: PILOT_Carrier;
end;

object Eisen(capship) as "TCS Eisen"
  obj: wc3cv;
  x: 10000;
  y: 24800;
  z: 139600;
  main: M_TCSEisen;
  direction: 180, 0, 0;
  pilot: 169;
end;

object Leonov(Capship) as "TCS Leonov"
  obj: wc3dstry;
  x: 10275;
  y: 25150;
  z: 139500;
  main: M_Murphy;
  direction: 180, 0, 0;
  pilot: 169;
end;

object Arkhangelsk(Capship) as "TCS Arkhangelsk"
  obj: wc3dstry;
  x: 9725;
  y: 25150;
  z: 139500;
  main: M_Murphy;
  direction: 180, 0, 0;
  pilot: 167;
end;


function M_NavJ;
var
  setup = true;

begin
  NAV_SetEjectSequence(ES_alien_pickup_MIA);

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_HideNav(2);
      m_Nav := 3;
      if (setup) then begin
        setup := false;
//        SF_ActivateObject(Orca3,0);
        SF_ActivateObject(Hydra,0);
        //SF_ActivateObject(Hydra_Bravo,0);
        SF_ActivateObject(Leviathan,0);
        m_EVENT:=EVENT_Reached_NavJ;
        M_GetPos(Dauntless);
        M_Spawn(2, 8, x, y, z+3500);      //Wave 1
        M_Spawn(3, 4, x, y, z+3500);
        M_Spawn(8, 2, x, y, z+3500);
        M_Spawn(35, 1, x, y, z+3500);

        AI_WaitSeconds(80);

        M_GetPos(Dauntless);
        M_Spawn(2, 6, x, y, z+3500);

        AI_WaitSeconds(90);

        M_GetPos(Dauntless);
        M_Spawn(2, 2, x, y, z+3500);      //Wave 2
        M_Spawn(6, 4, x, y, z+3500);
        //M_Spawn(5, 2, x, y, z+3500);

        AI_WaitSeconds(60);
        until(bugcount<15) do
          AI_WaitSeconds(1);

        M_GetPos(Dauntless);
        if (m_HydraDead = 0) then
          M_Spawn(3, 4, x, y, z+3500)      //Wave 3
        else
          M_Spawn(3, 2, x, y, z+3500);
        if (m_HydraDead = 0) then
          M_Spawn(6, 4, x, y, z+3500)
        else
          M_Spawn(6, 2, x, y, z+3500);
        M_Spawn(5, 2, x, y, z+3500);

        until(bugcount<18)do
          AI_WaitSeconds(1);
        NAV_SetEjectSequence(ES_SAR_pickup);
        //Confed Wave 1
        NAV_CreateShip(UE_SHIPID_Vampire, PILOT_Steel, 0, @M_VampireLeader, @D_NULL, 10000, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Vampire, PILOT_November, 0, @M_Vampire, @D_NULL, 10030, 25010, 139700);
        NAV_CreateShip(UE_SHIPID_Vampire, PILOT_Echo, 0, @M_Vampire, @D_NULL, 10060, 25000, 139700);
        m_EVENT:= EVENT_Vampire_Leader_Jumped_In;
        NAV_CreateShip(UE_SHIPID_Vampire, PILOT_Professor, 0, @M_Vampire, @D_NULL, 10090, 25010, 139700);
        NAV_CreateShip(UE_SHIPID_Vampire, PILOT_Ogre, 0, @M_Vampire, @D_NULL, 10120, 25000, 139700);
//        NAV_CreateShip(UE_SHIPID_Vampire, PILOT_Confed, 1, @M_Vampire, @D_NULL, 10150, 25010, 139700);

        NAV_CreateShip(UE_SHIPID_Excalibur, PILOT_Echo, 0, @M_ExcaliburLeader, @D_NULL, 10300, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Excalibur, PILOT_Steel, 0, @M_Excalibur, @D_NULL, 10350, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Excalibur, PILOT_November, 0, @M_Excalibur, @D_NULL, 10400, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Excalibur, PILOT_Ninja, 0, @M_Excalibur, @D_NULL, 10450, 25000, 139700);
//        NAV_CreateShip(UE_SHIPID_Excalibur, PILOT_Confed, 1, @M_Excalibur, @D_NULL, 10500, 25000, 139700);
//        NAV_CreateShip(UE_SHIPID_Excalibur, PILOT_Confed, 1, @M_Excalibur, @D_NULL, 10550, 25000, 139700);

        AI_WaitSeconds(70);
        //Wait 2 minutes
        if (LevDead = false) then
          NAV_CreateShipLaunch(3, 107, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
        if (LevDead = false) then
          NAV_CreateShipLaunch(3, 108, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
        if (LevDead = false) then
          NAV_CreateShipLaunch(2, 109, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(2, 110, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(3, 114, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(3, 112, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(3, 107, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(5, 108, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(5, 109, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);

//        NAV_CreateShip(2, 107, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(1);
//        NAV_CreateShip(2, 108, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(1);
//        NAV_CreateShip(2, 109, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(1);
        NAV_CreateShip(2, 110, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(1);
        NAV_CreateShip(2, 114, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(1);
        //NAV_CreateShip(2, 112, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(1);
        //NAV_CreateShip(3, 113, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(1);
        //NAV_CreateShip(5, 107, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(1);
        NAV_CreateShip(5, 108, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(1);


        AI_WaitSeconds(50);

        //Confed Wave 2
        NAV_CreateShip(UE_SHIPID_Devastator, PILOT_Professor, 0, @M_DevastatorLeader, @D_NULL, 10000, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Devastator, PILOT_Ogre, 0, @M_Devastator, @D_NULL, 10050, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Devastator, PILOT_Ninja, 0, @M_Devastator, @D_NULL, 10100, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Devastator, PILOT_Steel, 0, @M_Devastator, @D_NULL, 10150, 25000, 139700);
//        NAV_CreateShip(UE_SHIPID_Devastator, PILOT_Confed, 1, @M_Devastator, @D_NULL, 10200, 25000, 139700);
//        NAV_CreateShip(UE_SHIPID_Devastator, PILOT_Confed, 1, @M_Devastator, @D_NULL, 10250, 25000, 139700);

        NAV_CreateShip(UE_SHIPID_Thunderbolt, PILOT_Ogre, 0, @M_ThunderboltLeader, @D_NULL, 10300, 25000, 134700);
        NAV_CreateShip(UE_SHIPID_Thunderbolt, PILOT_Echo, 0, @M_Thunderbolt, @D_NULL, 10350, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Thunderbolt, PILOT_Professor, 0, @M_Thunderbolt, @D_NULL, 10400, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Thunderbolt, PILOT_November, 0, @M_Thunderbolt, @D_NULL, 10450, 25000, 139700);
//        NAV_CreateShip(UE_SHIPID_Thunderbolt, PILOT_Confed, 1, @M_Thunderbolt, @D_NULL, 10500, 25000, 139700);
//        NAV_CreateShip(UE_SHIPID_Thunderbolt, PILOT_Confed, 1, @M_Thunderbolt, @D_NULL, 10550, 25000, 139700);

        SF_ActivateObject(Leonov,1);
        SF_ActivateObject(Arkhangelsk,1);

        AI_WaitSeconds(40);

        M_GetPos(Dauntless);
        M_Spawn(3, 1, x, y, z+3500);      //Wave 4
        M_Spawn(6, 4, x, y, z+3500);
        M_Spawn(3, 5, x, y, z+3500);

        AI_WaitSeconds(30);

        //Confed Wave 3
        NAV_CreateShip(UE_SHIPID_Excalibur, PILOT_Ninja, 0, @M_Excalibur, @D_NULL, 10350, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Excalibur, PILOT_Steel, 0, @M_Excalibur, @D_NULL, 10400, 25000, 139700);
//        NAV_CreateShip(UE_SHIPID_Excalibur, PILOT_Confed, 1, @M_Excalibur, @D_NULL, 10450, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Vampire, PILOT_November, 0, @M_Vampire, @D_NULL, 10050, 25000, 139700);
        NAV_CreateShip(UE_SHIPID_Vampire, PILOT_Echo, 0, @M_Vampire, @D_NULL, 10100, 25000, 139700);
//        NAV_CreateShip(UE_SHIPID_Vampire, PILOT_Confed, 1, @M_Vampire, @D_NULL, 10150, 25000, 139700);

        m_EVENT:=EVENT_Eisen_Jumped_In;
        SYS_PlayMovie(9030);
        //AI_WaitSeconds(2);
        SF_ActivateObject(Eisen,0);

        until(bugcount<15) do
          AI_WaitSeconds(1);

        SF_ObjectiveSetComplete(mobj_jumpin);
        AI_WaitSeconds(1);
        AI_WaitSeconds(60);
        until(bugcount<10) do
          AI_WaitSeconds(1);

        if (LevDead = false) then
          NAV_CreateShipLaunch(2, 107, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
        if (LevDead = false) then
          NAV_CreateShipLaunch(2, 108, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
        if (LevDead = false) then
          NAV_CreateShipLaunch(2, 109, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
        if (LevDead = false) then
          NAV_CreateShipLaunch(2, 110, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
        if (LevDead = false) then
          NAV_CreateShipLaunch(6, 114, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
        if (LevDead = false) then
          NAV_CreateShipLaunch(2, 112, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
        if (LevDead = false) then
          NAV_CreateShipLaunch(5, 107, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
        if (LevDead = false) then
          NAV_CreateShipLaunch(5, 108, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(5, 109, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(5, 110, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(5, 114, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(6, 112, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(6, 113, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(2, 107, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(2, 108, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(2, 109, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(6, 110, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(6, 114, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);
//        NAV_CreateShipLaunch(2, 112, 0, @M_BugLaunch, @D_Bug, Leviathan);AI_WaitSeconds(2);

//        NAV_CreateShip(2, 107, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
//        NAV_CreateShip(2, 108, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
//        NAV_CreateShip(2, 109, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
//        NAV_CreateShip(2, 110, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
//        NAV_CreateShip(6, 114, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
//        NAV_CreateShip(2, 112, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
        if (m_HydraDead = 0) then  begin
          NAV_CreateShip(2, 113, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
          NAV_CreateShip(2, 107, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
          NAV_CreateShip(2, 108, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
          NAV_CreateShip(3, 107, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
          NAV_CreateShip(3, 108, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
        end;

        NAV_CreateShip(3, 109, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
        NAV_CreateShip(6, 110, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
        NAV_CreateShip(3, 114, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
        NAV_CreateShip(3, 112, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
        NAV_CreateShip(3, 113, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
//        NAV_CreateShip(5, 107, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
//        NAV_CreateShip(5, 108, 0, @M_Bug, @D_Bug, 9800, 25500, 139400); AI_WaitSeconds(2);
        until((bugcount=0) AND (m_HydraDead = 1) AND (LevDead = true)) do
          AI_WaitSeconds(1);
        m_EVENT:=EVENT_Mission_Complete;
        AI_WaitSeconds(5);
        F_InitLanding;
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;

function M_Orca3;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(3);
  while(1) do
    AI_Waitseconds(1);
end;

function M_Hydra1;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(3);
  while(1) do
    AI_Waitseconds(1);
end;

function D_Hydra;
begin
  m_HydraDead := m_HydraDead + 1;
end;


function M_Hydra2;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(3);
  while(1) do
    AI_Waitseconds(1);
end;

function M_Leviathan;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(3);
  while(1) do
    AI_Waitseconds(1);
end;

function D_Leviathan;
begin
  LevDead := true;
end;

function M_TCSEisen;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(3);
  SF_SetChildObjectVulnerable(Eisen, PART_ChildEngine, false);
  SF_SetChildObjectVulnerable(Eisen, PART_ChildBridge, false);
  while(1) do
    AI_Waitseconds(1);
end;

function D_NULL;  // Death function for ships that don't need one but must have one
begin
end;

function M_VampireLeader;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(3);
  SF_ActivateSelf(1);
  AI_SendComm(10);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Vampire;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(3);
  SF_ActivateSelf(1);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;


function M_ExcaliburLeader;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(3);
  SF_ActivateSelf(1);
  AI_SendComm(10);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;


function M_Excalibur;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(3);
  SF_ActivateSelf(1);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;

function M_DevastatorLeader;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(3);
  SF_ActivateSelf(1);
  AI_SendComm(10);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Devastator;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(3);
  SF_ActivateSelf(1);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;


function M_ThunderboltLeader;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(3);
  SF_ActivateSelf(1);
  AI_SendComm(10);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Thunderbolt;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(3);
  SF_ActivateSelf(1);
  while(1)do begin
    AI_WaitSeconds(1);
  end;
end;

function M_Murphy;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(3);
  AI_WaitUntilActive;
  AI_SendComm(51);
  SF_SetChildObjectVulnerable(Arkhangelsk, PART_ChildEngine, false);
  SF_SetChildObjectVulnerable(Leonov, PART_ChildBridge, false);
  while(1) do
    AI_Waitseconds(1);
end;

// ******************** Begin Briefing ********************

object BAsteroid1(System)
  x: -6000;
  y: 5000;
  z: 2000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 0, 0;
end;

object BAsteroid2(System)
  x: 9000;
  y: -6000;
  z: 5000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 0, 0, 0;
end;

object BAsteroid3(System)
  x: 0;
  y: 2000;
  z: 4000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 0, 0;
end;

object BAsteroid4(System)
  x: 1700;
  y: 100;
  z: 7000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 180, 0;
end;

object BAsteroid5(System)
  x: -15000;
  y: -100;
  z: -7000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 0, 45;
end;

object BAsteroid6(System)
  x: -7000;
  y: 2000;
  z: -4000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 180, 180, 270;
end;

object BAsteroid7(System)
  x: 9150;
  y: 0;
  z: -100;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 15, 0;
end;

object BAsteroid8(System)
  x: -3000;
  y: 10000;
  z: 1000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 0, 65;
end;

object BAlienFighter1(System)
  x: 0;
  y: 12500;
  z: 60000;
  color: 0, 1.0, 0.2, 0.2;
  brief: B_AlienFighter1;
  direction: 170, 0, 0;
end;

object BAlienFighter2(System)
  x: 0;
  y: 12500;
  z: 65000;
  color: 0, 1.0, 0.2, 0.2;
  brief: B_AlienFighter1;
  direction: 200, 0, 0;
end;

object BAlienFighter3(System)
  x: 10000;
  y: 12500;
  z: 60000;
  color: 0, 1.0, 0.2, 0.2;
  brief: B_AlienFighter1;
  direction: 190, 0, 0;
end;

object BAlienFighter4(System)
  x: 12000;
  y: 23000;
  z: 129000;
  color: 0, 1.0, 0.2, 0.2;
  brief: B_AlienFighter2;
  direction: 160, 0, 0;
end;

object BAlienFighter5(System)
  x: 7000;
  y: 25000;
  z: 129000;
  color: 0, 1.0, 0.2, 0.2;
  brief: B_AlienFighter2;
  direction: 170, 0, 0;
end;

object BAlienFighter6(System)
  x: 14000;
  y: 21000;
  z: 125000;
  color: 0, 1.0, 0.2, 0.2;
  brief: B_AlienFighter2;
  direction: 180, 0, 0;
end;

object BTCSEisen(System)
  x: 10000;
  y: 30000;
  z: 139000;
  color: 0, 1.0, 1.0, 1.0;
  brief: B_TCSEisen;
  direction: 180, 0, 0;
end;

function B_Player;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_FaceObject(Nav1);
  BRIEF_Activate;
  // "It is imperative that we rendezvous with the Eisen Carrier Group as
  // soon as possible. Your Alpha wing will escort the Dauntless to the jump point."
  BRIEF_VoiceOver(30, 3, 9);
  BRIEF_CAM_SetActive(1);
  BRIEF_CAM_SetPos(0, 250, -100);
  BRIEF_SetZoomSeconds(5, 7);
  BRIEF_CAM_TrackObj(Player);
  BRIEF_WaitSeconds(3);
  BRIEF_MoveObjSeconds(Nav1, 7);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  m_Nav1KillBugs:=1;
  BRIEF_WaitSeconds(2);
  // "The Eisen Carrier Group should come through the jump point several
  // minutes after we arrive."
  BRIEF_VoiceOver(30, 1, 5);
  BRIEF_FaceObject(NavJ);
  BRIEF_MoveObjSeconds(NavJ, 7);
  m_Nav2KillBugs:=1;
  // "However, Nephilem capital ships may attempt to cut us off from the jump
  // point; they must be prevented from doing so."
  BRIEF_VoiceOver(30, 2, 7);
  tcseisenjumpedin:=1;
  BRIEF_WaitSeconds(4);
end;

function B_DNav;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);
  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Nav1;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);
  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_NavJ;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);
  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Defender;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, 20, 0, -5);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Night;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, -20, 0, -5);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Edge;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, 40, 0, -5);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Drago;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Vampire);
  BRIEF_AttachToObj(Player, -40, 0, -5);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;


function B_Faris;
begin
  BRIEF_SetAppearance(UE_Appearance_Scimitar);
  BRIEF_AttachToObj(Player, 0, 0, -20);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Ocelot;
begin
  BRIEF_SetAppearance(UE_Appearance_Scimitar);
  BRIEF_AttachToObj(Player, -25, 0, -25);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Doc;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, 25, 0, -25);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Dauntless;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Dauntless);
  BRIEF_FaceObject(Nav1);
  BRIEF_Activate;
  BRIEF_AttachToObj(Player, -100, 0, -10);

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_AlienFighter1;
begin
  BRIEF_SetAppearance(44);
  BRIEF_Activate;
  BRIEF_WaitSeconds(1);
  while(1) do begin
    BRIEF_WaitMilliseconds(400);
    if (m_Nav1KillBugs) then begin
      BRIEF_WaitMilliSeconds(600);
      SYS_PlaySFX(SFX_BRIEF_Blowup);
      BRIEF_WaitMilliseconds(50);
      BRIEF_Deactivate;
      while(1) do BRIEF_WaitSeconds(99);
    end;
  end;
end;

function B_AlienFighter2;
begin
  BRIEF_SetAppearance(44);
  BRIEF_Activate;
  BRIEF_WaitSeconds(1);
  while(1) do begin
    BRIEF_WaitMilliseconds(400);
    if (m_Nav2KillBugs) then begin
      BRIEF_WaitMilliSeconds(600);
      SYS_PlaySFX(SFX_BRIEF_Blowup);
      BRIEF_WaitMilliseconds(50);
      BRIEF_Deactivate;
      while(1) do BRIEF_WaitSeconds(99);
    end;
  end;
end;

function B_TCSEisen;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Vesuvius);
  until(tcseisenjumpedin) do
  BRIEF_WaitSeconds(1);
  BRIEF_Activate;
  SYS_PlaySFX(SFX_Jump);
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Asteroid;
begin
  BRIEF_SetAppearance(17);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

/*  // Nope, too annoying
// ***************** View Takeoff routines ****************
// ********************************************************

object Camera2(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera2;
end;


function M_Camera2;
begin
  while(1) do
  begin
    until (m_Event = EVENT_Takeoff_Scimitar) do
      AI_WaitSeconds(1);
    M_GetPos(Dauntless);
    SF_CAM_SetFollowObj(Dauntless, -10, 10, 300);
    SF_CAM_TrackObj(shark);
    SF_CAM_TrackNothing;
    AI_WaitSeconds(4);
    m_EVENT:=EVENT_Scene_Finished;
    SF_CAM_SetActive(0);
  end;
end;

*/

// ***************** View Vampire Jump In ****************
// ********************************************************

object Camera4(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera4;
end;


function M_Camera4;
begin
  while(1) do
  begin
    until (m_Event = EVENT_Vampire_Leader_Jumped_In) do
      AI_WaitSeconds(1);
    SF_CAM_SetPos(10060, 25000, 139550);
    SF_CAM_TrackObj(JumpPoint);

    SF_CAM_SetActive(1);
    AI_WaitSeconds(2);
    m_Event:= EVENT_Scene_Finished;
    SF_CAM_SetActive(0);
  end;
end;


/* // Not needed
// **************** View TCS Eisen Jump In ****************
// ********************************************************

object Camera5(Camera)
  x: 9950;
  y: 24960;
  z: 138700;
  main: M_Camera5;
end;


function M_Camera5;
begin
  while(1) do
  begin
    until (m_Event = EVENT_Eisen_Jumped_In) do
      AI_WaitSeconds(1);
    SF_CAM_TrackObj(Eisen);

    SF_CAM_SetActive(1);
    AI_WaitSeconds(4);
    m_Event:= EVENT_Scene_Finished;
    SF_CAM_SetActive(0);
  end;
end;
*/

// ******************* Refueling routines *****************
// ********************************************************


object Camera3(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera3;
end;


function M_Camera3;
begin
  while(1) do
  begin
    until (m_Event = EVENT_Refuel) do
//      AI_WaitMilliSeconds(100);
      SF_CAM_SetFollowObj(Dauntless, 500, 400, 600);
      SF_CAM_TrackObj(Dauntless);
      SF_CAM_SetActive(1);
      until (rearm = 2) do AI_WaitMilliSeconds(1);
      SF_CAM_SetFollowObj(Player, -10, 5, -20);
      SF_CAM_TrackObj(Player);
      AI_WaitSeconds(5);
      SF_CAM_SetFollowObj(Dauntless, 500, 400, 600);
      AI_WaitSeconds(13);
      SF_CAM_SetFollowObj(Player, -10, 5, -20);

   until (m_EVENT = EVENT_Refuel_Complete) do
     AI_WaitMilliSeconds(100);

    AI_WaitMilliSeconds(15);
    SF_PlayerSwitchToCam(CamID_cockpit, Player);
    SF_DeactivateSelf(0);
  end;
end;






// **************** Takeoff/Landing routines **************
// ********************************************************
// Camera stuff

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

function F_Takeoff(select); forward;
function F_Landing(select); forward;

function M_Camera;
begin
  while(1) do
  begin
    if (m_Event = EVENT_Takeoff_Start) then
      F_Takeoff(SYS_Random(3));
    if (m_Event = EVENT_Activate_Landing_Cam) then
      F_Landing(SYS_Random(3));
    AI_WaitMilliSeconds(15);
  end;
end;

function F_Takeoff(select);
begin
  SF_CAM_TrackObj(Player);

  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -30, 35, -40);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, -10, 35, 80);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, 0, 5, 40);

  SF_ActivateSelf(0);
  until (m_Event = EVENT_Takeoff_Complete) do
    AI_WaitSeconds(1);
  SF_CAM_TrackNothing;
  SF_DeactivateSelf(0);
end;

function F_Landing(select);
begin
  SF_CAM_HideDust;
  SF_CAM_TrackObj(NavD);
  SF_CAM_SetFollowObj(NavD, 0, 1, 0);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(1);
  SF_CAM_TrackObj(Dauntless);

  if (select = 0) then
    SF_CAM_SetFollowObj(Dauntless, -200, 200, -350);
  if (select = 1) then
    SF_CAM_SetFollowObj(Dauntless, -50, 200, 500);
  if (select = 2) then
    SF_CAM_SetFollowObj(Dauntless, 400, 100, 300);

  until (m_Event = EVENT_Final_Approach) do
    AI_WaitMilliSeconds(5);
  SF_CAM_TrackObj(Player);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -3, 2, 15);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, 3, 4, -15);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, -9, 2, 5);

  AI_WaitSeconds(30);
end;

// Player stuff

function F_InitLanding;
begin
  SF_AutopilotDisable;
  m_Event := EVENT_Land_Player;
  until (M_Event = EVENT_Activate_Landing_Cam) do AI_WaitSeconds(1);
  AI_WaitSeconds(30);
  SF_Exit;
end;

function F_PlayerTakeoff;
begin
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x+15, y-25, z);
  SF_SetObjectFlag(OF_Collidable, false);
  AI_PLR_ControlAssume;
  AI_SetThrottle(0);
  AI_WaitSeconds(1);
  SF_ActivateSelf(0);
  AI_WaitSeconds(1);
  AI_SetThrottle(100);
  AI_WaitMilliSeconds(1500);
  M_Event := EVENT_Takeoff_Start;
  while (SF_GetDistance(Dauntless) < 500) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, 15, -20, 700);
  M_Event := EVENT_Takeoff_Complete;
  SF_SetObjectFlag(OF_Collidable, true);
  AI_PLR_ControlResume;
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
end;

function F_PlayerLanding;
begin
  while (SF_GetDistance(Dauntless) > 300) do AI_WaitMilliSeconds(1);
  AI_PLR_ControlAssume;
  SF_SetObjectFlag(OF_Collidable, false);
  M_Event := EVENT_Activate_Landing_Cam;
  HCL_EmptyFuel;
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Player) = 0) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z-550);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x, y-25, z-350);
  AI_SetThrottle(50);
  until (SF_GetDistance(Dauntless) < 50) do AI_WaitMilliSeconds(5);
  M_Event := EVENT_Final_Approach;
  SYS_PlaySFX(SFX_Engines_Power_Down);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  AI_WaitSeconds(5);
  SF_Exit;
end;

// Dauntless stuff

function F_DauntlessLanding;
begin
  if (SF_GetVelocityObject(Dauntless) > 0) then
  begin
    AI_SetThrottle(0);
    until (SF_GetVelocityObject(Dauntless) = 0) do AI_WaitMilliSeconds(1);
  end;

  // Teleport to position relative to NavD, face NavD
  M_GetPos(NavD);
  SF_SetWorldPosition(x, y, z+10000);
  AI_FaceObject(NavD);
  m_Event := EVENT_Dauntless_Ready;
  AI_WaitSeconds(25);
  SF_Exit;
end;
