//******************************************************************************
//
// Unknown Enemy
// Mission 3a - Storm
//
// Created by: Thomas Bruckner <thomas.bruckner@aon.at>
// Modified by: Alex Barnfield <alex@crius.net>
//              Jakub Majewski <qmajewski@yahoo.co.uk>
// Last modified: May 20th, 2004
//
//******************************************************************************

mission ue3a;

#sector: "t.sec";
#SetRooms ("cic.rom", "rec.rom");

#SetOutputPath("$wcue$\mission\");

#AddToSearchPath("$uesrc$");
#AddToSearchPath("$wcue$\language\");
#include wcp, consts, uepilots;
#include UE;
#include Comms;

#strings objectiv;
#strings spacefli;
#strings targetid;

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);

#SetOutputPath("$wcue$\mission\");

var
  x, y, z,
  m_AliveEnemies,
  m_DeadEnemies,
  m_Land_Player,
  m_Dauntless_Dead,
  m_Nav,
  m_SurpriseAttack,
  m_Beaufort_Attack = 0,
  m_Dauntless_Attack = 0,
  m_Beaufort_Dead = 0,
  m_Timer,
  m_Complete = 0,
  m_Link_Fralthi = 0,
  m_EVENT,
  refuelmsg = 0,
  endmessage = 0;

external
  g_Fralthi_Dead,
  g_UE_3a_Won;

const
  NAV_D = 1,
  NAV_I = 2,
  NAV_1 = 3,
  NAV_B = 4,
  NAV_2 = 5,
  NAV_3 = 6,
  NAV_4 = 7,
  NAV_5 = 8,
  EVENT_Takeoff_Start = 9,
  EVENT_Takeoff_Complete = 10,
  EVENT_Land_Player = 11,
  EVENT_Activate_Landing_Cam = 12,
  EVENT_Dauntless_Ready = 13,
  EVENT_Final_Approach = 14,
  EVENT_Refuel_On_Beaufort = 15,
  EVENT_Refuel_Complete = 16,
  EVENT_Refuel_Scene = 17;

#name: 6;

objective mobj_find_intrepid
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Find the Intrepid"];
  status: MOBJ_Incomplete;
  counter: false;
end;

objective mobj_protect_beaufort
  hidden: true;
  type: MOBJ_Primary;
  text: objectiv["Defend Beaufort Station"];
  status: MOBJ_Incomplete;
  counter: false;
end;

objective mobj_protect_civis
  hidden: false;
  type: MOBJ_Secondary;
  text: objectiv["Ensure safety of civilian ships"];
  status: MOBJ_Incomplete;
  counter: true;
end;

objective mobj_escort_fralthi
  hidden: false;
  type: MOBJ_Secondary;
  text: objectiv["Escort Fralthi to Beaufort Station"];
  status: MOBJ_Incomplete;
  counter: false;
end;

function MAIN;
begin
  MS_RunGameflow(0);
  MS_RunBriefing;
  MS_ShipSelector(UE_SELECTOR_Scimitar, UE_SELECTOR_Banshee);
  MS_RunSpaceflight(0);
  MS_RunDebriefing;
end;


object Beaufort(CapShip) as "Beaufort Station"
  obj: UE_SHIP_Beaufort;
  x: 125000;
  y: 80000;
  z: 4000;
  main: M_Beaufort;
  death: D_Beaufort;
  brief: B_Beaufort;
  pilot: PILOT_Beaufort;
  color: 0, 0.5, 0.5, 1.0;
  direction: 0, 0, 0;
end;


object Player(Player)
  obj: UE_SHIP_Scimitar;
  x: 300;
  y: 200;
  z: -500;
  main: M_Player;
  brief: B_Player;
  color: 0, 1.0, 1.0, 0.0;
  direction: 180, 0, 0;
  pilot: PILOT_Casey1;
end;

object Alpha2(Ship)
  obj: UE_SHIP_Scimitar;
  x: 0;
  y: 500;
  z: 200;
  main: M_Alpha2;
  brief: B_Alpha2;
  targstr: 1;
  color: 0, 0.2, 0.2, 1.0;
  pilot: PILOT_Edge;
end;

object Alpha3(Ship)
  obj: UE_SHIP_Banshee;
  x: 0;
  y: 500;
  z: 400;
  main: M_Alpha3;
  brief: B_Alpha3;
  targstr: 1;
  color: 0, 0.2, 0.2, 1.0;
  pilot: PILOT_Ocelot;
end;

object Dauntless(Capship) as "BWS Dauntless"
  obj: UE_SHIP_Dauntless;
  x: 0;
  y: 200;
  z: -500;
  main: M_Dauntless;
  death: D_Dauntless;
  brief: B_Dauntless;
  color: 0, 0.5, 0.5, 1.0;
  direction: 180, 0, 0;
  pilot: PILOT_Dauntless;
end;

object Fralthi(Capship) as "Fralthi"
  obj: UE_SHIP_Fralthi;
  x: 2400;
  y: 830;
  z: 0;
  main: M_Fralthi;
  death: D_Fralthi;
  //brief: B_Fralthi;
  direction: 10, 7, 5;
  color: 0, 0.5, 0.5, 1.0;
  pilot: PILOT_Fralthi;
end;

object Intrepid(Capship) as "BWS Intrepid"
  obj: UE_SHIP_Intrepid_Wreck;
  x: -175000;
  y: 50;
  z: 8000;
  main: M_Intrepid;
  brief: B_Intrepid;
  color: 0, 0.7, 0.7, 0.7;
  direction: 0, 45, 45;
  pilot: PILOT_Instructor; //he doesn't speak
end;

object Refuel_Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Refuel_Camera;
end;

function NULL;
begin
  AI_WaitMilliSeconds(1);
end;

// ********************** Spawning Functions **********************

function M_Spawn(shipId, pilot, count, ax, ay, az);
var
  ox, oy, oz;
begin
  while(count > 0) do begin
    ox := ax + SYS_Random(1600) - 800;
    oy := ay + SYS_Random(1600) - 800;
    oz := az + SYS_Random(1600) - 800;

    NAV_CreateShip(shipId, pilot, 0, @S_EnemyFighter, @S_EnemyFighterDeath, ox, oy, oz);
    AI_WaitMilliseconds(25);
    count := count - 1;
  end;
end;

function M_Spawn2(shipId, pilot, count, ax, ay, az);
var
  ox, oy, oz;
begin
  while(count > 0) do begin
    ox := ax + SYS_Random(1600) - 800;
    oy := ay + SYS_Random(1600) - 800;
    oz := az + SYS_Random(1600) - 800;

    NAV_CreateShip(shipId, pilot, 0, @S_EnemyFighter2, @S_EnemyFighterDeath, ox, oy, oz);
    AI_WaitMilliseconds(25);
    count := count - 1;
  end;
end;

function M_SpawnNearObject(shipId, pilot, count, obj);
var
  ax, ay, az,
  ox, oy, oz;
begin
  ax := SF_GetXObj(obj);
  ay := SF_GetYObj(obj);
  az := SF_GetZObj(obj);

  while(count > 0) do begin
    ox := ax + SYS_Random(400) + 300;
    oy := ay + SYS_Random(400) + 300;
    oz := az + SYS_Random(200) + 150;

    NAV_CreateShip(shipId, pilot, 0, @S_EnemyFighter, @S_EnemyFighterDeath, ox, oy, oz);
    AI_WaitMilliseconds(25);
    count := count - 1;
  end;
end;

function M_SpawnNearObject2(shipId, pilot, count, obj);
var
  ax, ay, az,
  ox, oy, oz;
begin
  x := SF_GetXObj(obj);
  y := SF_GetYObj(obj);
  z := SF_GetZObj(obj);

  while(count > 0) do begin
    ox := ax + SYS_Random(300) + 200;
    oy := ay + SYS_Random(300) + 200;
    oz := az + SYS_Random(200) + 150;

    NAV_CreateShip(shipId, pilot, 0, @S_EnemyFighter2, @S_EnemyFighterDeath, ox, oy, oz);
    AI_WaitMilliseconds(25);
    count := count - 1;
  end;
end;

function M_SpawnNearObjectShuttle(shipId, count, obj);
var
  ax, ay, az,
  ox, oy, oz;
begin
  ax := SF_GetXObj(obj);
  ay := SF_GetYObj(obj);
  az := SF_GetZObj(obj);

  while(count > 0) do begin
    ox := ax + SYS_Random(200) + 100;
    oy := ay + SYS_Random(200) + 100;
    oz := az + SYS_Random(200) + 100;

    NAV_CreateShip(shipId, PILOT_SAR1, 0, @S_Shuttle, @D_Transport, ox, oy, oz);
    AI_WaitMilliseconds(25);
    count := count - 1;
  end;
end;

function M_WaitUntilDead;
//
// this function waits until all enemies spawned by M_Spawn*
// have been killed.
//
begin
  until(m_DeadEnemies = m_AliveEnemies) do
    AI_WaitSeconds(4);
end;

function M_WaitUntilDeadTimeOut(sec);
begin
  AI_WaitSeconds(1);
  SYS_TimerSet(sec - 1);
  until ((SYS_TimerGet = 0) or (m_DeadEnemies = m_AliveEnemies)) do begin
    AI_WaitSeconds(1);
  end;
end;

function S_EnemyFighterDeath;
begin
  m_DeadEnemies := m_DeadEnemies + 1;
end;

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

function F_InitLanding; forward;
function F_PlayerTakeoff; forward;
function F_PlayerLanding; forward;
function F_DauntlessLanding; forward;
function F_PlayerRefuel; forward;

// ********** BEGIN Spawning Routines for CatPatrol **********
function S_CatPatrol;
var
  rad;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Kilrathi);
  SF_ActivateSelf(0);

  AI_WaitSeconds(1);
  SF_BindToActionSphere(1);

  rad := SYS_Random(400)+100;

  while(1) do begin
    if (m_DeadEnemies = m_AliveEnemies) then begin
      if (SF_GetActiveStatus(Fralthi) = AS_Active) then
        AI_GotoObjRelWorld(Fralthi, rad, rad, 0);
    end;
    AI_WaitMilliSeconds(50);
  end;
end;

function M_SpawnNearObjectCatPatrol(shipId, count, obj);
var
  ax, ay, az,
  ox, oy, oz;
begin
  ax := SF_GetXObj(obj);
  ay := SF_GetYObj(obj);
  az := SF_GetZObj(obj);

  while(count > 0) do begin
    ox := ax + SYS_Random(100) + 100;
    oy := ay + SYS_Random(100) + 100;
    oz := az + SYS_Random(100) + 100;

    NAV_CreateShip(shipId, 85, 0, @S_CatPatrol, @NULL, ox, oy, oz);
    AI_WaitMilliseconds(100);
    count := count - 1;
  end;
end;
// *********** END Spawning Routines for CatPatrol ***********

function S_ConfedPatrol;
var
  rad;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_ActivateSelf(0);

  AI_WaitSeconds(1);
  SF_BindToActionSphere(1);

  rad := 100 - SYS_Random(400);

  while(1) do begin
    if (m_DeadEnemies = m_AliveEnemies) then
      if (SF_GetActiveStatus(Dauntless) = AS_Active) then
        AI_GotoObjRelWorld(Dauntless, rad, rad, 200);
    AI_WaitSeconds(1);
  end;
end;

// ************************* Dauntless NAV *************************

object NavD(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_NavD;
  brief: B_NavD;
  name: spacefli["Dauntless Nav"];
  color: 0, 1.0, 1.0, 1.0;
  navdata: NAV_D, 35000;
end;

function M_NavD;
var
  setup = true;
begin
  while(1) do begin
    NAV_SetEjectSequence(ES_alien_pickup_MIA);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      m_Nav := NAV_D;

      if (setup) then begin
        SF_ActivateObject(Dauntless, 0);
        NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Phantom, 1, @S_ConfedPatrol, @NULL, 500, 400, 500);
        NAV_CreateShip(UE_SHIPID_Scimitar, PILOT_Hellcat, 1, @S_ConfedPatrol, @NULL, 400, 300, 500);

        //if (not g_Fralthi_Dead) then begin
          SF_ActivateObject(Fralthi, 0);
          M_SpawnNearObjectCatPatrol(UE_SHIPID_Dralthi, 2, Fralthi);
        //end;

        NAV_SetPlayerNav(NAV_I);

// tb: debug
//        m_Beaufort_Attack := 2;
//        NAV_SetPlayerNav(NAV_B);

        setup := false;
      end;

      if (m_Dauntless_Attack = 1) then begin
        SF_AutopilotDisable;
      /* // Never mind the extra fighters, that's just too cruel
        if (m_Beaufort_Dead) then begin
          // if Beaufort is destroyed extra enemies will show up
          M_SpawnNearObject(UE_SHIPID_Manta, PILOT_Alien_Ace, 2, NavD);
          M_SpawnNearObject(UE_SHIPID_Barracuda, PILOT_Alien1, 1, NavD);
          M_SpawnNearObject(UE_SHIPID_Moray, PILOT_Alien3, 3, NavD);
        end;
      */
        // 4 Manta Bs (two are aces), 4 Morays. No priority targets.
        M_SpawnNearObject(UE_SHIPID_Moray, PILOT_Alien2, 4, NavD);
        M_SpawnNearObject(UE_SHIPID_Manta_B, PILOT_Alien4, 2, Dauntless);
        M_SpawnNearObject(UE_SHIPID_Manta_B, PILOT_Alien_Ace, 2, NavD);

        // wait until only 3 enemies remain before spawning the next wave...
        while((m_AliveEnemies - m_DeadEnemies) > 3) do
          AI_WaitSeconds(6);

        // Second wave - 6 Mantas, 4 Morays. No priority targets.
        M_SpawnNearObject(UE_SHIPID_Moray, PILOT_Alien3, 2, NavD);
        M_SpawnNearObject(UE_SHIPID_Manta, PILOT_Alien8, 6, Dauntless);

        M_WaitUntilDead;

        m_Dauntless_Attack := 0;
        AI_WaitSeconds(5);

        if ((not g_Fralthi_Dead) and (not m_Beaufort_Dead)) then begin
          NAV_SetPlayerNav(NAV_B);
          SF_AutopilotResumeNormal;
        end;
      end;

      if (m_Complete) then begin
        if ((m_Beaufort_Dead = false) and (g_Fralthi_Dead = false)) then
        begin
          SF_SetMissionSuccess;
          g_UE_3a_Won := true;
        end else begin
          SF_SetMissionFailure;
          g_UE_3a_Won := false;
        end;
        endmessage := 1;
        AI_WaitSeconds(8);
        F_InitLanding;
      end;

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_WaitUntilDeadHiddenAlien; forward;

function M_Player;
var
  a = true,
  b = true,
  c = true,
  d = true;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  SF_SetBaseShip(Dauntless);
  F_PlayerTakeoff;
//  F_PlayerRefuel;

  while (1) do begin
    if (endmessage = true) then begin
      if (g_UE_3a_Won) then
        AI_SendSpecialCommFrom(23, 19, PILOT_Dauntless)
      else
        AI_SendSpecialCommFrom(23, 18, PILOT_Dauntless);
      endmessage := false;
    end;

    if (m_Event = EVENT_Land_Player) then
      F_PlayerLanding;

    if ((m_Nav = NAV_D) and (m_Dauntless_Attack = 1)) then begin
      while(m_Dauntless_Attack = 1) do
        AI_WaitSeconds(1);

      AI_WaitSeconds(2);

      if ((g_Fralthi_Dead) or (m_Beaufort_Dead)) then begin
        m_Complete := 1;
      end else begin
        // Thanks, sir. Before you land, though, we still need you to
        // escort the Fralthi to Beaufort Station.
        AI_SendSpecialCommFrom(23, 17, PILOT_Dauntless);
        m_Link_Fralthi := 1;
        m_Beaufort_Attack := 3;
      end;
    end;

    AI_WaitMilliseconds(100);

    if ((m_Nav = NAV_I) and (a)) then begin
      AI_WaitSeconds(60);
      M_WaitUntilDeadHiddenAlien;
      AI_WaitSeconds(4);

      // Colonel, we've just received a distress call from two civilian transports.
      // We're transmitting you their location, as NAV 1.
      // Proceed to respond to their call.
      AI_SendSpecialCommFrom(23, 4, PILOT_Dauntless);
      AI_SendSpecialCommFrom(23, 5, PILOT_Dauntless);
      AI_SendSpecialCommFrom(23, 6, PILOT_Dauntless);

      a := false;
    end;

    if ((m_Nav = NAV_1) and (b)) then begin
      AI_WaitSeconds(30);
      M_WaitUntilDead;
      AI_WaitSeconds(3);

      // Sir, we have another distress call for you to attend.
      // A convoy of three freighters over at NAV 2.
      AI_SendSpecialCommFrom(23, 7, PILOT_Dauntless);
      AI_SendSpecialCommFrom(23, 8, PILOT_Dauntless);

      b := false;
    end;

    if ((m_Nav = NAV_2) and (c)) then begin
      AI_WaitSeconds(30);

      while((m_AliveEnemies - m_DeadEnemies) > 3) do
        AI_WaitSeconds(1);

      m_Timer := SYS_Clock;

      AI_WaitSeconds(3);
      // Colonel, this is Beaufort! We've got incoming hostile fighters!
      // Proceed to our location immediately!
      AI_SendSpecialCommFrom(23, 9, PILOT_Beaufort);
      AI_SendSpecialCommFrom(23, 10, PILOT_Beaufort);
      m_Beaufort_Attack := 1;
      while (m_Nav = NAV_2) do
        AI_WaitSeconds(1);
    end;

    AI_WaitMilliseconds(100);

    if ((m_Nav = NAV_B) and (m_Beaufort_Attack = 1)) then begin
      AI_WaitSeconds(30);
      M_WaitUntilDead;
      SF_AutopilotDisable;
      AI_WaitSeconds(2);

      until (refuelmsg) do AI_WaitSeconds(1);

      refuelmsg:=0;
      if (not m_Beaufort_Dead) then begin
        AI_SendSpecialCommFrom(23, 20, PILOT_Beaufort);
        while(m_EVENT=EVENT_Refuel_On_Beaufort) do begin
          AI_WaitMilliSeconds(10);
          if (SF_GetDistance(Beaufort)<500) then
            F_PlayerRefuel;
        end;
      end;
      // Sir, we've received five more distress calls in the last few minutes.
      // We've dispatched other wings to take care of four of those, but there's
      // one more for you to investigate. A civilian convoy at NAV 3... proceed
      // with all due haste."
      AI_SendSpecialCommFrom(23, 11, PILOT_Dauntless);
      AI_SendSpecialCommFrom(23, 12, PILOT_Dauntless);
      AI_SendSpecialCommFrom(23, 13, PILOT_Dauntless);
      SF_AutopilotResumeNormal;
    end;

    if ((m_Nav = NAV_B) and (m_Beaufort_Attack = 2)) then begin
      AI_WaitSeconds(30);
      M_WaitUntilDead;
      SF_AutopilotDisable;
      AI_WaitSeconds(2);

      until (refuelmsg) do AI_WaitSeconds(1);

      refuelmsg:=0;
      if (not m_Beaufort_Dead) then begin
        AI_SendSpecialCommFrom(23, 20, PILOT_Beaufort);
        while(m_EVENT=EVENT_Refuel_On_Beaufort) do begin
          AI_WaitMilliSeconds(10);
          if (SF_GetDistance(Beaufort)<500) then
            F_PlayerRefuel;
        end;
      end;
      // That's the last of the distress calls for now, sir, but we're
      // tracking in-bound hostiles over here!
      AI_SendSpecialCommFrom(23, 16, PILOT_Dauntless);
      SF_AutopilotResumeNormal;
    end;

    // this function is too complex. need to wait a bit or
    // SO complains about too many instructions executed.
    AI_WaitMilliseconds(50);

    if ((m_Nav = NAV_3) and (d)) then begin
      AI_WaitSeconds(30);

      M_WaitUntilDead;
      // make sure that the next wave has been spawned
      AI_WaitSeconds(2);
      M_WaitUntilDead;

      if (not m_Beaufort_dead) then begin
        // Colonel, we're tracking another in-bound Nephilem force.
        // We request assistance.
        AI_SendSpecialCommFrom(23, 14, PILOT_Beaufort);
        AI_SendSpecialCommFrom(23, 15, PILOT_Beaufort);
      end;
      m_Beaufort_Attack := 2;
      d := false;
    end;

    AI_WaitMilliseconds(250);
  end;
end;

function M_Alpha2;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  AI_AttackNothing(1);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Takeoff_Complete) do AI_WaitMilliSeconds(1);
  AI_AddToWing(Player);
  //AI_MuteComms;

  while(1) do begin
    AI_WaitSeconds(1);
    if (m_NAV = NAV_B) then
      SF_SetObjectFlag(OF_vulnerable, true);
    if ((m_Event = EVENT_Land_Player) or (m_Event = EVENT_Activate_Landing_Cam)) then
      AI_RemoveFromWing;
    if (m_Event = EVENT_Refuel_Scene) then begin
      AI_RemoveFromWing;
      AI_SetThrottle(0);
      AI_ReplenishMissilesAndFuel;
      until (m_Event = EVENT_Refuel_Complete) do AI_WaitMilliSeconds(1);
      AI_AddToWing(Player);
    end;
    if (m_Nav = NAV_I) then begin
      AI_MuteComms;
      until (m_SurpriseAttack) do AI_WaitMilliSeconds(1);
      AI_ResumeComms;
      AI_AttackNothing(0);
    end;
  end;
end;

function M_Alpha3;
var
  a = true;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  // make this one invulnerable since he will control gameflow...
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AttackNothing(1);
  until (m_Event = EVENT_Takeoff_Complete) do AI_WaitMilliSeconds(1);
  AI_AddToWing(Player);
  //AI_MuteComms;

  while(1) do begin
    if ((m_Nav = NAV_I) and a) then begin
      AI_MuteComms;
      AI_WaitSeconds(2);
      // Holy... All I've got on my scanners is wreckage.
      AI_SendSpecialComm(23, 0);
      AI_WaitSeconds(2);
      // I'm gonna go in for a closer look on the... what's left of the Intrepid.
      AI_SendSpecialComm(23, 1);
      AI_WaitSeconds(1);
      AI_RemoveFromWing;
      AI_GotoObjRange(Intrepid, 600);
      AI_SetThrottle(0);
      // Sir? I'm detecting energy readings from the flight bay... whoa!
      AI_SendSpecialComm(23, 3);
      a := false;
      AI_WaitSeconds(1);
      AI_ResumeComms;
      m_SurpriseAttack := true;
      AI_WaitSeconds(5);
      AI_AttackNothing(0);
      AI_AddToWing(Player);
    end;

    if (m_NAV = NAV_B) then
      SF_SetObjectFlag(OF_vulnerable, true);
    AI_WaitSeconds(1);
    if ((m_Event = EVENT_Land_Player) or (m_Event = EVENT_Activate_Landing_Cam)) then
      AI_RemoveFromWing;
    if (m_Event = EVENT_Refuel_Scene) then begin
      AI_RemoveFromWing;
      AI_SetThrottle(0);
      AI_ReplenishMissilesAndFuel;
      HCL_ReloadAmmo(8, 400);
      until (m_Event = EVENT_Refuel_Complete) do AI_WaitMilliSeconds(1);
      AI_AddToWing(Player);
    end;
  end;
end;

function M_Dauntless;
begin
  AI_WaitUntilActive;
  //SF_SaveObjectState(true);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(1);
  AI_SetThrottle(0);
  AI_WaitMilliSeconds(50);
  //SF_SetChildObjectVulnerable(Dauntless, PART_ChildEngine, false);

  SF_SetPilotImmortal(PILOT_Gryphon, 1);
  SF_SetPilotImmortal(PILOT_Gold, 1);
  SF_SetPilotImmortal(PILOT_Mage, 1);
  SF_SetPilotImmortal(PILOT_Night, 1);
  SF_SetPilotImmortal(PILOT_Phantom, 1);
  SF_SetPilotImmortal(PILOT_Defender, 1);
  SF_SetPilotImmortal(PILOT_Faris, 1);
  SF_SetPilotImmortal(PILOT_Huntress, 1);
  SF_SetPilotImmortal(PILOT_Hellcat, 1);
  SF_SetPilotImmortal(PILOT_Warrior, 1);
  SF_SetPilotImmortal(PILOT_Ocelot, 1);
  SF_SetPilotImmortal(PILOT_Doc, 1);
  SF_SetPilotImmortal(PILOT_Edge, 1);
  SF_SetPilotImmortal(PILOT_Shark, 1);

  while(1) do begin
    AI_WaitMilliSeconds(1);
    if (m_Event = EVENT_Activate_Landing_Cam) then begin
      if (m_Beaufort_Dead) then begin
        SF_SaveObjectState(false);
      end
      else
        SF_SaveObjectState(true);
      F_DauntlessLanding;
    end;
  end;
end;

function D_Dauntless;
begin
  m_Dauntless_Dead := true;
end;

function M_Fralthi;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Kilrathi);
  AI_WaitUntilActive;
  AI_WaitSeconds(1);
  SF_BindToActionSphere(1);
  AI_SetThrottle(0);

  while(1) do begin
    if (m_Link_Fralthi) then begin
      AI_SetThrottle(30);
      AI_SetAutopilotData(-300, 0, 100);
      SF_BindToActionSphere(0);
      m_Link_Fralthi := 0;
      while (m_Nav <> NAV_B) do AI_WaitMilliSeconds(1);
      AI_SetAutopilotData(-350, -1000, -10100);
      SF_BindToActionSphere(Nav_B);
    end;
    if (m_Complete) then begin
      if (not m_Beaufort_Dead) then begin
        SF_ObjectiveSetComplete(mobj_escort_fralthi);
        SF_SaveObjectState(false);
      end
      else
        SF_SaveObjectState(true);
    end;
    AI_WaitSeconds(1);
  end;
end;

function D_Fralthi;
begin
  SF_ObjectiveSetFailure(mobj_escort_fralthi);
  g_Fralthi_Dead := true;
end;

// ************************** Intrepid Nav **************************

object NavI(Navpoint)
  x: -175000;
  y: 0;
  z: 4800;
  main: M_NavI;
  brief: B_NavI;
  name: spacefli["Intrepid Nav"];
  color: 0, 1.0, 1.0, 1.0;
  navdata: NAV_I, 35000;
end;

object Debries1(Debrsfld)
  x: -175000;
  y: 50;
  z: 8000;
  absdata: 1, 200, 400;
end;

object Debries2(Debrsfld)
  x: -175000;
  y: 50;
  z: 8000;
  absdata: 1, 200, 800;
end;

// ********** BEGIN Spwaning Routines for HiddenAlien **********
var
  m_AliveHiddenAliens,
  m_DeadHiddenAliens;

function S_HiddenAlien;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  //SF_SetObjectFlag(OF_collidable, false);
  AI_IgnoreCollisions(1);
  AI_AttackNothing(1);
  SF_BindToActionSphere(0);
  AI_SetThrottle(0);
  m_AliveHiddenAliens := m_AliveHiddenAliens + 1;
  SF_ActivateSelf(0);

  //until(m_SurpriseAttack) do AI_WaitSeconds(1);

  AI_FaceObjRelFrame(Intrepid, -45, 0, -250);
  AI_SetThrottle(100);

  AI_WaitSeconds(4);
  //SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  AI_WaitSeconds(2);

  AI_IgnoreCollisions(0);
  AI_AttackNothing(0);
  AI_AddToIgnoreList(Intrepid, 1);
  AI_WaitSeconds(1);

  //SF_SetObjectFlag(OF_collidable, true);

  if (SYS_Random(3) = 2) then AI_SendComm(COMM_Taunt);

  AI_AttackEnemies;

  while (1) do
    AI_WaitSeconds(1);
end;

function S_HiddenAlienDeath;
begin
  m_DeadHiddenAliens := m_DeadHiddenAliens + 1;
end;

function M_SpawnNearObjectHiddenAlien(shipId, pilot, count, obj);
var
  ax, ay, az,
  ox, oy, oz;
begin
  ax := SF_GetXObj(obj);
  ay := SF_GetYObj(obj);
  az := SF_GetZObj(obj);

  while(count > 0) do begin
    ox := ax + SYS_Random(10) - 5;
    oy := ay + SYS_Random(10) - 5;
    oz := az + SYS_Random(15) - 5;

    NAV_CreateShip(shipId, pilot, 2, @S_HiddenAlien, @S_HiddenAlienDeath, ox, oy, oz);
    AI_WaitMilliseconds(100);
    count := count - 1;
  end;
end;

function M_WaitUntilDeadHiddenAlien;
begin
  until(m_DeadHiddenAliens = m_AliveHiddenAliens) do
    AI_WaitSeconds(1);
end;
// *********** END Spwaning Routines for HiddenAlien ***********

function M_NavI;
var
  setup = true;
begin
  while(1) do begin
    NAV_SetEjectSequence(ES_alien_pickup_MIA);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      m_Nav := NAV_I;

      if (setup) then begin
        SF_ActivateObject(Intrepid, 0);
        SF_ObjectiveSetComplete(mobj_find_intrepid);

        until(m_SurpriseAttack) do AI_WaitSeconds(1);
        //AI_WaitSeconds(2);

        M_SpawnNearObjectHiddenAlien(SHIP_Manta, PILOT_Alien_Ace, 3, Intrepid);
        M_SpawnNearObjectHiddenAlien(SHIP_Moray, PILOT_Alien1, 3, Intrepid);

        M_WaitUntilDeadHiddenAlien;
        AI_WaitSeconds(10);

        NAV_ShowNav(NAV_1);
        NAV_SetPlayerNav(NAV_1);
        setup := false;
      end;

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Intrepid;
begin
  SF_BindToActionSphere(NAV_I);
  SF_SetObjectFlag(OF_alignment, ALIGN_Neutral);
  SF_SetObjectFlag(OF_vulnerable, false);
  AI_WaitUntilActive;
  while(1) do
    AI_WaitMilliSeconds(1);
end;

// ****************************** Nav 1 ******************************

object Nav1(Navpoint)
  x: -125000;
  y: 80000;
  z: 0;
  main: M_Nav1;
  name: spacefli["Nav 1"];
  color: 0, 1.0, 1.0, 1.0;
  navdata: NAV_1, 25000;
end;

object Penobscot(Capship)
  obj: UE_SHIP_Freighter;
  x: -125050;
  y: 80300;
  z: 3500;
  main: M_Transport;
  death: D_Transport;
  color: 0, 0.5, 0.5, 1.0;
  direction: 10, 0, 5;
  pilot: PILOT_Capship_Male2;//PILOT_Confed;
end;

object Sherbrooke(Capship)
  obj: UE_SHIP_Freighter;
  x: -125000;
  y: 80000;
  z: 3600;
  main: M_Transport;
  death: D_Transport;
  color: 0, 0.5, 0.5, 1.0;
  direction: 10, 0, 5;
  pilot: PILOT_Base_Female1;//PILOT_Confed;
end;

function M_Nav1;
var
  setup = true;
begin
  NAV_HideSelf;
  while(1) do begin
    NAV_SetEjectSequence(ES_alien_pickup_MIA);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      m_Nav := NAV_1;

      if (setup) then begin
        SF_ActivateObject(Sherbrooke, 0);
        SF_ActivateObject(Penobscot, 0);
        M_Spawn(UE_SHIPID_Moray, PILOT_Alien2, 4, -125000, 80000, 3500);
        M_Spawn2(UE_SHIPID_Stingray, PILOT_Alien3, 4, -125000, 80000, 3500);

        M_WaitUntilDead;

        AI_WaitSeconds(5);

        NAV_HideSelf;
        NAV_ShowNav(NAV_2);
        NAV_SetPlayerNav(NAV_2);

        setup := false;
      end;

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Transport;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  AI_WaitUntilActive;

  SF_ObjectiveIncrementTotal(mobj_protect_civis);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_protect_civis);
  SF_ObjectiveIncrementCount(mobj_protect_civis);

  AI_WaitSeconds(1);
  SF_BindToActionSphere(m_Nav);
  AI_SetThrottle(SYS_Random(50)+50);

  while(1) do
    AI_WaitSeconds(6);
end;

function D_Transport;
begin
  SF_ObjectiveDecrementCount(mobj_protect_civis);
end;

// ****************************** Nav 2 ******************************

object Nav2(Navpoint)
  x: -125000;
  y: 150000;
  z: 0;
  main: M_Nav2;
  name: spacefli["Nav 2"];
  color: 0, 1.0, 1.0, 1.0;
  navdata: NAV_2, 26000;
end;

object Trumpetfish(Capship)
  obj: UE_SHIP_Freighter;
  x: -125050;
  y: 150300;
  z: 3000;
  main: M_Transport;
  death: D_Transport;
  color: 0, 0.5, 0.5, 1.0;
  direction: 10, 0, 5;
  pilot: PILOT_Base_Female2;//PILOT_Confed;
end;

object Celeste(Capship)
  obj: UE_SHIP_Freighter;
  x: -125000;
  y: 150000;
  z: 3600;
  main: M_Transport;
  death: D_Transport;
  color: 0, 0.5, 0.5, 1.0;
  direction: 0, 3, 2;
  pilot: PILOT_Base_Male1;//PILOT_Confed;
end;

object Dinwiddie(Capship)
  obj: UE_SHIP_Freighter;
  x: -124200;
  y: 150000;
  z: 4300;
  main: M_Transport;
  death: D_Transport;
  color: 0, 0.5, 0.5, 1.0;
  direction: 4, 0, 1;
  pilot: PILOT_Base_Male2;//PILOT_Confed;
end;





function M_Nav2;
var
  setup = true;
begin
  NAV_HideSelf;
  while(1) do begin
    NAV_SetEjectSequence(ES_alien_pickup_MIA);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      m_Nav := NAV_2;

      if (setup) then begin
        SF_ActivateObject(Trumpetfish, 0);
        SF_ActivateObject(Celeste, 0);
        SF_ActivateObject(Dinwiddie, 0);

        M_Spawn(UE_SHIPID_Moray, PILOT_Alien2, 4, -125000, 150000, 4000);
        M_Spawn2(UE_SHIPID_Manta_B, PILOT_Alien3, 3, -125000, 150000, 4500);

        M_WaitUntilDead;

        AI_WaitSeconds(4);

        NAV_HideSelf;
        NAV_SetPlayerNav(NAV_B);

        setup := false;
      end;

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

// ****************************** Nav 3 ******************************

object Nav3(Navpoint)
  x: 125000;
  y: 80000;
  z: 137000;
  main: M_Nav3;
  name: spacefli["Nav 3"];
  color: 0, 1.0, 1.0, 1.0;
  navdata: NAV_3, 29000;
end;

object ShuttleLeader(Ship)
  obj: UE_SHIP_Shuttle;
  x: 125050;
  y: 80300;
  z: 138000;
  main: M_ShuttleLeader;
  death: D_Transport;
  color: 0, 0.5, 0.5, 1.0;
  direction: 10, 0, 5;
  pilot: PILOT_SAR1;//PILOT_Confed;
end;

function M_Nav3;
var
  setup = true,
  i = 0;
begin
  NAV_HideSelf;
  while(1) do begin
    NAV_SetEjectSequence(ES_alien_pickup_MIA);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      m_Nav := NAV_3;

      if (setup) then begin
        SF_ActivateObject(ShuttleLeader, 0);
        M_SpawnNearObjectShuttle(UE_SHIPID_Shuttle, 5, ShuttleLeader);

        // 3 waves - 3 Mantas, 3 Morays (one is an ace)
        for i := 1 to 2 do begin
          M_SpawnNearObject(UE_SHIPID_Moray, PILOT_Alien6, 2, Nav3);
          M_SpawnNearObject2(UE_SHIPID_Manta_B, PILOT_Alien7, 2, ShuttleLeader);
          M_SpawnNearObject2(UE_SHIPID_Manta, PILOT_Alien_Ace, 1, ShuttleLeader);

          // wait until only 2 enemies remain before spawning the next wave...
          while((m_AliveEnemies - m_DeadEnemies) > 2) do
            AI_WaitSeconds(1);
        end;

        // wait until M_Player has played the comms
        while (m_Beaufort_Attack <> 2) do
          AI_WaitSeconds(2);

        NAV_HideSelf;

        // if Beaufort is dead the player will return home
        if (not m_Beaufort_Dead) then begin
//          m_Beaufort_Attack := 0;     EDITME This didn't seem to have any real purpose
          NAV_SetPlayerNav(NAV_B);
        end else begin
          m_Dauntless_Attack := 1;
          NAV_SetPlayerNav(NAV_D);
        end;

        setup := false;
      end;

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

// ************************ Beaufort Nav ************************

object NavB(Navpoint)
  x: 125000;
  y: 80000;
  z: 0;
  main: M_NavB;
  brief: B_NavB;
  name: spacefli["Beaufort Nav"];
  color: 0, 1.0, 1.0, 1.0;
  navdata: NAV_B, 30000;
end;



function M_Beaufort;
begin
  AI_WaitUntilActive;
  HCL_DestroyChild(PART_ChildBridge, 1);
  HCL_DestroyChild(PART_ChildAntenna, 1);
  //HCL_DestroyChild(PART_ChildGunTurret, 3);

  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(NAV_B);
  //AI_MuteComms;

  while(1) do begin
    AI_WaitSeconds(1);
    if (m_Event = EVENT_Refuel_Scene) then begin
      m_timer := SYS_Clock;
      while (m_Event = EVENT_Refuel_Scene) do begin
        AI_WaitSeconds(1);
        if ((SYS_Clock - m_Timer) > 45) then
          SF_Exit;
      end;
    end;
  end;
end;

function D_Beaufort;
begin
  SF_ObjectiveSetFailure(mobj_protect_beaufort);
  m_Beaufort_Dead := true;
end;

function M_NavB;
var
  setup = true;
begin
  while(1) do begin
    NAV_SetEjectSequence(ES_alien_pickup_MIA);
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      m_Nav := NAV_B;

      if (setup) then begin
        // NAV setup
        SF_ActivateObject(Beaufort, 0);

        // 3 Scims without dust cannons (Pilot_Confed).
        NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @S_BeaufortPatrol, @NULL, 125000, 80500, 4200);
        NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @S_BeaufortPatrol, @NULL, 125000, 80700, 4200);
        NAV_CreateShip(UE_SHIPID_Ferret, PILOT_Confed, 0, @S_BeaufortPatrol, @NULL, 125000, 80900, 4200);

        // 3 Vaktoths (Kilrathi Aces, 85, 86, 87).
        NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 85, 0, @S_BeaufortPatrolCat, @NULL, 125200, 80500, 4400);
        NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 86, 0, @S_BeaufortPatrolCat, @NULL, 125000, 80300, 4400);
        NAV_CreateShip(UE_SHIPID_Vaktoth_Fighter, 87, 0, @S_BeaufortPatrolCat, @NULL, 125200, 80100, 4400);

        setup := false;
      end;

      if (m_Beaufort_Attack = 1) then begin
        SF_ObjectiveEnable(mobj_protect_beaufort);
        // first attack at Beafort
        SF_AutopilotDisable;
        // 4 Mantas, 4 Manta Bs, 4 Morays (two are aces).
        M_Spawn(UE_SHIPID_Manta, PILOT_Alien4, 3, 125200, 80000, 4500);
        M_Spawn(UE_SHIPID_Manta_B, PILOT_Alien_Ace, 4, 124600, 80000, 8500);
        M_Spawn2(UE_SHIPID_Manta_B, PILOT_Alien1, 2, 125100, 81000, 9000);
        M_Spawn(UE_SHIPID_Moray, PILOT_Alien3, 4, 125900, 81200, 5000);

        // now comes the fun part: 1 extra moray for each 15 seconds
        // after the distress call
        M_Spawn(UE_SHIPID_Moray, PILOT_Alien5, ((SYS_Clock - m_Timer) / 15), 125000, 80500, 2800);

        m_Beaufort_Attack := 0;

        M_WaitUntilDead;
        refuelmsg:=1;
        m_EVENT:=EVENT_Refuel_on_Beaufort;
        AI_WaitSeconds(5);
        NAV_ShowNav(NAV_3);
        NAV_SetPlayerNav(NAV_3);
      end;

      if (m_Beaufort_Attack = 2) then begin
        // second attack at Beafort
        SF_AutopilotDisable;
        // 4 Mantas, 3 Manta Bs, 4 Morays (two are aces)
        M_Spawn(UE_SHIPID_Manta_B, PILOT_Alien_Ace, 4, 124600, 80000, 9500);
        M_Spawn(UE_SHIPID_Manta, PILOT_Alien1, 2, 125100, 81000, 7000);
        M_Spawn2(UE_SHIPID_Barracuda, PILOT_Alien1, 1, 125100, 81000, 9000);
        M_Spawn(UE_SHIPID_Moray, PILOT_Alien3, 5, 125900, 81200, 4500);

        AI_WaitSeconds(30);
        M_Spawn(UE_SHIPID_Moray, PILOT_Alien5, 2, 125900, 81200, 4500);
        M_Spawn2(UE_SHIPID_Barracuda, PILOT_Alien1, 1, 125100, 81000, 7000);

        M_WaitUntilDead;
        refuelmsg:=1;
        m_EVENT:=EVENT_Refuel_on_Beaufort;

        m_Beaufort_Attack := 0;
        m_Dauntless_Attack := 1;

        AI_WaitSeconds(5);
        NAV_SetPlayerNav(NAV_D);
      end;

      if (m_Beaufort_Attack = 3) then begin
        // third attack at Beafort

        // 4 Mantas, 3 Manta Bs, 4 Morays (two are aces)
        M_Spawn(UE_SHIPID_Manta_B, PILOT_Alien_Ace, 2, 124600, 80000, 11500);
        M_Spawn(UE_SHIPID_Moray, PILOT_Alien3, 6, 125900, 81200, 5000);
        M_WaitUntilDead;

        if (not m_Beaufort_Dead) then
          SF_ObjectiveSetComplete(mobj_protect_beaufort);

        m_Beaufort_Attack := 0;
        m_Complete := 1;

        AI_WaitSeconds(5);
        NAV_SetPlayerNav(NAV_D);
      end;

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function S_BeaufortPatrol;
var
  ax, ay;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_ActivateSelf(0);

  AI_WaitSeconds(1);
  SF_BindToActionSphere(NAV_B);

  AI_AddToDefendList(Beaufort, 1000);

  ax := SYS_Random(800) + 1000;
  ay := SYS_Random(800) + 1000;

  while(1) do begin
    if (m_DeadEnemies = m_AliveEnemies) then begin
      AI_ReplenishMissilesAndFuel;
      if (SF_GetActiveStatus(Beaufort) = AS_Active) then
        AI_GotoObjRelWorld(Beaufort, ax, ay, 1000);
    end;
    AI_WaitSeconds(1);
  end;
end;

function S_BeaufortPatrolCat;
var
  ax, ay;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Kilrathi);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_ActivateSelf(0);

  AI_WaitSeconds(1);
  SF_BindToActionSphere(NAV_B);

  ax := SYS_Random(1000) + 1500;
  ay := SYS_Random(1000) + 1500;

  while(1) do begin
    if (m_DeadEnemies = m_AliveEnemies) then begin
      AI_ReplenishMissilesAndFuel;
      if (SF_GetActiveStatus(Beaufort) = AS_Active) then
        AI_GotoObjRelWorld(Beaufort, ax, ay, 1400);
    end;
    AI_WaitSeconds(1);
  end;
end;

// ***************** General Spawn Functions *****************

function S_EnemyFighter;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  SF_ActivateSelf(AO_appear);
  m_AliveEnemies := m_AliveEnemies + 1;
  AI_WaitSeconds(1);
  SF_BindToActionSphere(0);//m_Nav);

  while (1) do begin
    AI_WaitSeconds(1);
  end;
end;

function S_EnemyFighter2;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Alien);
  SF_ActivateSelf(AO_appear);
  m_AliveEnemies := m_AliveEnemies + 1;
  AI_WaitSeconds(1);
  SF_BindToActionSphere(0);//m_Nav);

  if (m_Nav = NAV_1) then begin
    AI_AddToAttackList(Sherbrooke, 500);
    AI_AddToAttackList(Penobscot, 500);
  end;

  if (m_Nav = NAV_2) then begin
    AI_AddToAttackList(Trumpetfish, 500);
    AI_AddToAttackList(Celeste, 500);
    AI_AddToAttackList(Dinwiddie, 500);
  end;

  if (m_Nav = NAV_B) then begin
    AI_AddToAttackList(Beaufort, 1000);
  end;

  if (m_Nav = NAV_3) then begin
    if (SYS_Random(3) = 2) then
      AI_AddToIgnoreList(Player, 1);
  end;

  AI_AddToIgnoreList(Alpha2, 1);
  AI_AddToIgnoreList(Alpha3, 1);

  //AI_AttackEnemies;

  while (1) do
    AI_WaitSeconds(1);
end;

function M_ShuttleLeader;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  AI_WaitUntilActive;

  SF_ObjectiveIncrementTotal(mobj_protect_civis);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_protect_civis);
  SF_ObjectiveIncrementCount(mobj_protect_civis);

  AI_WaitSeconds(1);
  SF_BindToActionSphere(m_Nav);
  AI_SetThrottle(40);
//  AI_AttackNothing(1);

//  AI_GotoObjRange(NavB, 1000);

  while(1) do
    AI_WaitSeconds(6);
end;

function S_Shuttle;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_ActivateSelf(0);

  AI_AddToWing(ShuttleLeader);

  SF_ObjectiveIncrementTotal(mobj_protect_civis);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_protect_civis);
  SF_ObjectiveIncrementCount(mobj_protect_civis);

  AI_WaitSeconds(1);
  SF_BindToActionSphere(m_Nav);
  AI_AttackNothing(1);

  while(1) do
    AI_WaitSeconds(6);
end;

// ****************** Here starts the briefing ******************

var m_BEvent = 0;

object BFralthi(System)
  x: 5000;
  y: 10000;
  z: -45000;
  brief: B_Fralthi;
  direction: 90, 0, 0;
  color: 0, 0.5, 0.5, 1.0;
end;

function B_Player;
begin
  BRIEF_CAM_SetPos(0, 800, -50);
  BRIEF_CAM_SetActive(1);
  BRIEF_CAM_TrackObj(Player);
  BRIEF_Activate;

  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_Activate;
  BRIEF_WaitSeconds(1);

  // Your Alpha Wing will proceed immediately to the Intrepid's
  // last known location.
  BRIEF_Voiceover(23, 0, 5);
  BRIEF_WaitSeconds(1);
  BRIEF_MoveObjSeconds(NavI, 5);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  BRIEF_WaitSeconds(2);

  // If there are any survivors, you will be responsible for
  // escorting them back to the Dauntless.
  BRIEF_Voiceover(23, 1, 5);
  BRIEF_WaitSeconds(3);
  BRIEF_MoveObjSeconds(NavD, 5);
  BRIEF_WaitSeconds(1);

  // Respond to all calls for help from civilian craft and Beaufort Station.
  BRIEF_Voiceover(23, 2, 5);
  BRIEF_WaitSeconds(6);

  // Finally, escort the Fralthi to Beaufort Station where it will undergo repairs.
  BRIEF_Voiceover(23, 3, 5);
  BRIEF_WaitSeconds(2);
  m_BEvent := 1;
  BRIEF_MoveObjSeconds(NavB, 5);
  SYS_PlaySFX(SFX_BRIEF_Activate);

  BRIEF_WaitSeconds(3);
  BRIEF_MoveObjSeconds(NavD, 7);

  BRIEF_WaitSeconds(3);
  BRIEF_Exit;
end;

function B_Alpha2;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, -20, 15, -20);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Alpha3;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, 20, 15, -20);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Dauntless;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Dauntless);
  BRIEF_FaceObject(Beaufort);
  BRIEF_Activate;
  while (1) do
    BRIEF_WaitSeconds(10);
end;

function B_Fralthi;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Fralthi);
  BRIEF_Activate;
  while (1) do begin
    if (m_BEvent = 1) then begin
      //BRIEF_MoveObjSeconds(NavB, 5);
      BRIEF_GotoObjRelFrameSeconds(Beaufort, 0, 10, -110, 5, 0);
      m_BEvent := 0;
    end;
    BRIEF_WaitMilliseconds(100);
  end;
end;

function B_Intrepid;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Intrepid);
  BRIEF_Activate;
  while (1) do
    BRIEF_WaitSeconds(10);
end;

function B_Beaufort;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Beaufort);
  BRIEF_Activate;
  while (1) do
    BRIEF_WaitSeconds(10);
end;

function B_NavD;
begin
  BRIEF_SetAppearance(1);
  BRIEF_DisplayName(1);
  BRIEF_SetSize(160);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_NavI;
begin
  BRIEF_SetAppearance(1);
  BRIEF_DisplayName(1);
  BRIEF_SetSize(120);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_NavB;
begin
  BRIEF_SetAppearance(1);
  BRIEF_DisplayName(1);
  BRIEF_SetSize(160);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;





// **************** Takeoff/Landing routines **************
// ********************************************************
// Camera stuff

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

function F_Takeoff(select); forward;
function F_Landing(select); forward;

function M_Camera;
begin
  while(1) do
  begin
    if (m_Event = EVENT_Takeoff_Start) then
      F_Takeoff(SYS_Random(3));
    if (m_Event = EVENT_Activate_Landing_Cam) then
      F_Landing(SYS_Random(3));
    AI_WaitMilliSeconds(15);
  end;
end;

function F_Takeoff(select);
begin
  SF_CAM_TrackObj(Player);

  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -30, 35, -40);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, -10, 35, 80);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, 0, 5, 40);

  SF_ActivateSelf(0);
  until (m_Event = EVENT_Takeoff_Complete) do
    AI_WaitSeconds(1);
  SF_CAM_TrackNothing;
  SF_DeactivateSelf(0);
end;

function F_Landing(select);
begin
  SF_CAM_HideDust;
  SF_CAM_TrackObj(NavD);
  SF_CAM_SetFollowObj(NavD, 0, 1, 0);
  SF_ActivateSelf(0);
  while (m_Event <> EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(1);
  SF_CAM_TrackObj(Dauntless);

  if (select = 0) then
    SF_CAM_SetFollowObj(Dauntless, -200, 200, -350);
  if (select = 1) then
    SF_CAM_SetFollowObj(Dauntless, -50, 200, 500);
  if (select = 2) then
    SF_CAM_SetFollowObj(Dauntless, 400, 100, 300);

  until (m_Event = EVENT_Final_Approach) do
    AI_WaitMilliSeconds(5);
  SF_CAM_TrackObj(Player);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -3, 2, 15);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, 3, 4, -15);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, -9, 2, 5);

  AI_WaitSeconds(30);
end;

// Player stuff

function F_InitLanding;
begin
  SF_AutopilotDisable;
  m_Event := EVENT_Land_Player;
  until (M_Event = EVENT_Activate_Landing_Cam) do AI_WaitSeconds(1);
  AI_WaitSeconds(30);
  SF_Exit;
end;

function F_PlayerTakeoff;
begin
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x+15, y-25, z);
  SF_SetObjectFlag(OF_Collidable, false);
  AI_PLR_ControlAssume;
  AI_SetThrottle(0);
  AI_WaitSeconds(1);
  SF_ActivateSelf(0);
  AI_WaitSeconds(2);
  AI_SetThrottle(100);
  AI_WaitMilliSeconds(1800);
  M_Event := EVENT_Takeoff_Start;
  while (SF_GetDistance(Dauntless) < 500) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, 15, -20, -700);
  M_Event := EVENT_Takeoff_Complete;
  SF_SetObjectFlag(OF_Collidable, true);
  AI_PLR_ControlResume;
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
  AI_WaitSeconds(10);
  M_Event := 0;
end;

function F_PlayerLanding;
begin
  while (SF_GetDistance(Dauntless) > 300) do AI_WaitMilliSeconds(1);
  AI_PLR_ControlAssume;
  SF_SetObjectFlag(OF_Collidable, false);
  M_Event := EVENT_Activate_Landing_Cam;
  HCL_EmptyFuel;
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Player) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z-350);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x, y-25, z-350);
  AI_SetThrottle(50);
  until (SF_GetDistance(Dauntless) < 50) do AI_WaitMilliSeconds(5);
  M_Event := EVENT_Final_Approach;
  SYS_PlaySFX(SFX_Engines_Power_Down);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  AI_WaitSeconds(5);
  SF_Exit;
end;

// Dauntless stuff

function F_DauntlessLanding;
begin
  if (SF_GetVelocityObject(Dauntless) > 0) then
  begin
    AI_SetThrottle(0);
    AI_WaitSeconds(5);
  end;

  // Teleport to position relative to NavD, face NavD
  M_GetPos(NavD);
  SF_SetWorldPosition(x, y, z+1000);
  AI_FaceObject(NavD);
  m_Event := EVENT_Dauntless_Ready;
  AI_WaitSeconds(25);
  SF_Exit;
end;


//******************Beaufort Refueling****************************





function M_Refuel_Camera;
begin
  until(m_EVENT=EVENT_Refuel_Scene) do
    AI_WaitSeconds(1);
  M_GetPos(Beaufort);
  SF_CAM_SetPos(x, y-20, z-200);
  SF_CAM_TrackPos(x+20, y-20, z-140);
  SF_ActivateSelf(0);
  AI_WaitSeconds(1);
  SF_CAM_SetMotion(x, y+20, z-200, x-350, y+20, z-300, 5);
//  SF_CAM_SetPos(x-350, y+20, z-300);

//  AI_WaitSeconds(1);
  //EXPERIMENTAL Camera work
  AI_WaitSeconds(3);
  SF_CAM_SetMotion(x-350, y+20, z-300, x+350, y+20, z-300, 6);

  until(m_Event = EVENT_Refuel_Complete) do
    AI_WaitMilliSeconds(10);

  SF_DeactivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);

  until(m_Beaufort_Attack = 2) do
    AI_WaitSeconds(1);
  until(m_EVENT=EVENT_Refuel_Scene) do
    AI_WaitSeconds(1);

  //SF_ActivateSelf(0);
  M_GetPos(Beaufort);
  SF_CAM_SetPos(x, y-20, z-200);
  SF_ActivateSelf(0);
  AI_WaitSeconds(1);
  SF_CAM_SetMotion(x, y+20, z-200, x+350, y+20, z-300, 5);
//  AI_WaitSeconds(1);
  AI_WaitSeconds(3);
  SF_CAM_SetMotion(x+350, y+20, z-300, x-350, y+20, z-300, 6);

  until(m_Event = EVENT_Refuel_Complete) do
    AI_WaitMilliSeconds(10);

  SF_DeactivateSelf(0);
  SF_PlayerSwitchToCam(CamID_cockpit, Player);

  while(1) do
    AI_WaitSeconds(1);
end;



function F_PlayerRefuel;
begin
  m_EVENT:= EVENT_Refuel_Scene;
  AI_PLR_ControlAssume;
  HCL_EmptyFuel;
  AI_SetThrottle(0);
  AI_WaitSeconds(3);
  M_GetPos(Beaufort);
  SF_SetWorldPosition(x, y-17, z-440);
  AI_FaceObject(Beaufort);
  AI_FaceObjRelWorld(Beaufort, 0, -17, -140);
  SF_SetObjectFlag(OF_Collidable, false);
  AI_SetThrottle(75);
  until(SF_GetDistance(Beaufort)<160) do
    AI_WaitMilliSeconds(1);

  AI_SetThrottle(0);
  SYS_PlaySFX(221);

  AI_WaitSeconds(9);
  AI_FaceObjRelWorld(Beaufort, 0, -17, -440);
  AI_SetThrottle(25);
  AI_WaitSeconds(1);
  AI_SetThrottle(100);
  AI_WaitSeconds(3);
  SF_SetObjectFlag(OF_Collidable, true);
  AI_ReplenishMissilesAndFuel;
  HCL_ReloadAmmo(8, 400);
  M_Event := EVENT_Refuel_Complete;
  AI_WaitMilliSeconds(5);
  AI_PLR_ControlResume;
end;


