//******************************************************************************
//
// Unknown Enemy
// Mission 5A
//
// Created by:
//               Alex Barnfield  <alex@crius.net>
// Modified by:  Jakub Majewski <qmajewski@yahoo.co.uk>
//
//
// Last modified: Apr 9th, 2004
//
//******************************************************************************


mission ue5a;

#Addtosearchpath("$uesrc$");

#SetRooms ("cic.rom", "rec.rom");

#SetOutputPath("$wcue$\language\pilots\");
#file "strings\pilots\srs25.pas";

#SetOutputPath("$wcue$\comms\");
#file "comms\srs25.pas";


// 0 = "Thanks for the escort, Lt. Colonel."

// 1 = "You look like you'll need to refuel... get within 5000 klicks, and slow down to 200 kps."

// 2 = "Sir, we're assigning Hellcat to your wing for the second escort run."

// 3 = "Sir, we're assigning Hellcat and Gryphon to your wing for the second escort run."

// 4 = "Sir, we're tracking a capship approaching at high speed! It looks like it will get here soon, so you'd better hold it off until we jump!"

// 5 = "Sir, you'd better de-fang that thing before it gets here!"

// 6 = "Good work out there, sir. You're cleared to land."

// 7 = "You did your best, sir. You're cleared to land."

// 8 = "We're not waiting any longer for Epsilon, Colonel. Set course for the jump point."


#sector: "t.sec";

#name: 9;

#AddToSearchPath("$wcue$\language\");
#SetRooms ("cic.rom", "rec.rom");
#include wcp, consts, uepilots, comms, ue;

#strings targetid, objectiv, spacefli;

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);

#SetOutputPath("$wcue$\mission\");

const
  EVENT_Takeoff_Start = 4,
  EVENT_Takeoff_Complete = 5,
  EVENT_Land_Player = 6,
  EVENT_Activate_Landing_Cam = 7,
  EVENT_Dauntless_Ready = 8,
  EVENT_Final_Approach = 9;

var
  x=0,
  y=0,
  z=0,
  m_Event=0,
  bugcount=0,
  reachedjumpnav=0,
  EVENT_libraescorted=0,
  deadlibra=0,
  EVENT_aquariusescorted=0,
  deadaquarius=0,
  EVENT_Aquariusreached=0,
  wingmendead=0,
  addhellcat=0,
  addgryphon=0,
  deadtotal=0,
  turrets=0,
  totalturrets=0,
  lostturrets=0,
  atlibra=0,
  librajump=0,
  ataquarius=0,
  aquariusjump=0,
  m_Nav,
  aquariuscomm=1;



objective mobj_libra
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Ensure Libra Convoy's safe jump out-system"];
  status: MOBJ_Incomplete;
  counter: true;
end;

objective mobj_aquarius
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Ensure Aquarius Convoy's safe jump out-system"];
  status: MOBJ_Incomplete;
  counter: true;
end;

objective mobj_destroy_turrets
  hidden: true;
  type: MOBJ_Bonus;
  text: objectiv["Destroy all turrets on Orca-class destroyer"];
  status: MOBJ_Incomplete;
  counter: true;
end;


object Dauntless(capship) as "BWS Dauntless"
  obj: UE_SHIP_Dauntless;
  x: 0;
  y: 0;
  z: 0;
  main: M_Dauntless;
  brief: B_Dauntless;
  death: D_Dauntless;
  color: 0, 0.35, 0.35, 1;
  targstr: targetid["Dauntless"];
  direction: 0, 0, 0;
  pilot: PILOT_Dauntless;
end;


object Player(Player)
  obj: scim;
  x: 0;
  y: 1000;
  z: 0;
  main: M_Player;
  brief: B_Player;
  color: 0, 0.8, 0.8, 0;
  pilot: PILOT_Casey1;
end;

object Gold(Ship)
  obj: scim;
  x: -350;
  y: 0;
  z: 50;
  main: M_Gold;
  death: D_Wing;
  brief: B_Gold;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Gold;
end;

object Mage(Ship)
  obj: scim;
  x: -300;
  y: 0;
  z: 50;
  main: M_Mage;
  death: D_Wing;
  brief: B_Mage;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Mage;
end;

function MAIN;
begin
  MS_SetPilotDead(PILOT_Killer, 1);
  MS_RunGameflow(0);
  MS_RunBriefing;
  MS_RunSpaceflight(0);
  MS_RunDebriefing;
end;

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;


function F_InitLanding; forward;
function F_PlayerTakeoff; forward;
function F_PlayerLanding; forward;
function F_DauntlessLanding; forward;

function D_Dauntless;
begin
  AI_Waitseconds(20);
  SF_ExitEndGame(2);
end;

object Jumppoint(JumpPoint)
  x: -10000;
  y: 20000;
  z: 233500;
  actionsphere: 4;
end;

function D_Wing;
begin
  wingmendead:=wingmendead+1;
end;






//**********************Dauntless Nav****************************

object NavD(Navpoint)
  x: 0;
  y: 0;
  z: 1000;
  main: M_DNav;
  brief: B_DNav;
  color: 0, 1, 1, 1;
  name: spacefli["Dauntless Nav"];
  navdata: 1, 20000;
end;


object Faris(Ship)
  obj: scim;
  x: 350;
  y: 0;
  z: 50;
  main: M_Genericwingman;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Faris;
end;

object Gryphon(Ship)
  obj: scim;
  x: 300;
  y: 0;
  z: 50;
  main: M_Gryphon;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Gryphon;
end;

object Edge(Ship)
  obj: scim;
  x: 350;
  y: 0;
  z: -50;
  main: M_Genericwingman;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Edge;
end;

object Ocelot(Ship)
  obj: scim;
  x: 300;
  y: 0;
  z: -50;
  main: M_Genericwingman;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Ocelot;
end;


object Hellcat(Ship)
  obj: scim;
  x: 300;
  y: 0;
  z: -50;
  main: M_Hellcat;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Hellcat;
end;

object Refueler(Ship)
  obj: avenger;
  x: 350;
  y: 0;
  z: 250;
  main: M_Refueler;
  color: 0, 0, 0, 1;
  //targstr: 1;
  pilot: PILOT_SAR1;
end;


function M_DNav;

var setup = true;

begin
  NAV_SetEjectSequence(ES_SAR_pickup);

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      m_Nav:=1;
      if(setup) then begin
        NAV_SetPlayerNav(2);
        SF_ActivateObject(Faris, 0);
        SF_ActivateObject(Gryphon, 0);
        SF_ActivateObject(Edge, 0);
        SF_ActivateObject(Ocelot, 0);
        SF_ActivateObject(Hellcat, 0);
        SF_ActivateObject(Dauntless, 0);
        SF_ActivateObject(Refueler, 0);
        setup:= false;
      end;
      if(EVENT_libraescorted) then begin
        NAV_SetPlayerNav(5);
        reachedjumpnav:=0;
      end;
      if ((EVENT_Aquariusescorted) and (EVENT_libraescorted = 2)) then begin
        deadtotal:=deadaquarius+deadlibra;
        if(deadtotal<3) then begin
          SF_SetmissionSuccess;
          AI_Waitseconds(5);
        end;
        if(deadtotal>2) then begin
          SF_SetmissionFailure;
          AI_Waitseconds(5);
        end;
          F_InitLanding;
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;


function M_Player;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_SetBaseShip(Dauntless);
  SF_ActivateSelf(0);
  F_PlayerTakeoff;
  while (1) do begin
    if (m_Event = EVENT_Land_Player) then begin
      F_PlayerLanding;
    end;

    AI_WaitSeconds(1);
  end;
end;


function M_Dauntless;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_WaitUntilActive;
  SF_SaveObjectState(true);
  SF_SetPilotImmortal(PILOT_Gold, 1);
  SF_SetPilotImmortal(PILOT_Mage, 1);
  SF_SetPilotImmortal(PILOT_Faris, 1);
  SF_SetPilotImmortal(PILOT_Gryphon, 1);
  SF_SetPilotImmortal(PILOT_Hellcat, 1);
  SF_SetPilotImmortal(PILOT_Edge, 1);
  SF_SetPilotImmortal(PILOT_Ocelot, 1);
  SF_BindToActionSphere(1);
  while(1) do begin
    AI_WaitMilliSeconds(1);
    if(EVENT_libraescorted=1) then begin
      if(wingmendead=1) then begin
        AI_SendSpecialComm(25, 2);
        addhellcat:=1;
      end;
      if(wingmendead=2) then begin
        AI_SendSpecialComm(25, 3);
        addgryphon:=1;
        addhellcat:=1;
      end;
      until(EVENT_Libraescorted=2) do
        AI_Waitseconds(1);
    end;
    if ((EVENT_Aquariusescorted) and (EVENT_libraescorted = 2)) then begin
      deadtotal:=deadaquarius+deadlibra;
      if(deadtotal>1) then begin
        AI_SendSpecialComm(25, 7);
        until (m_Event = EVENT_Activate_Landing_Cam) do AI_WaitMilliSeconds(1);
        F_DauntlessLanding;
      end
      else begin
        AI_SendSpecialComm(25, 6);
        until (m_Event = EVENT_Activate_Landing_Cam) do AI_WaitMilliSeconds(1);
        F_DauntlessLanding;
      end;
    end;
  end;
end;


function M_Genericwingman;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
//  SF_Activateself(0);
  AI_WaitUntilActive;
  SF_BindToActionSphere(1);
  while(1) do begin
    AI_GotoObjRelFrame(Dauntless, -1000, 400, -1000);
    AI_GotoObjRelFrame(Dauntless, -1000, 350, 1000);
    AI_GotoObjRelFrame(Dauntless, 1000, 400, 1000);
    AI_GotoObjRelFrame(Dauntless, 1000, 350, -1000);
  end;
end;



function M_Gold;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_Activateself(0);
  AI_Waitseconds(1);
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_AddToWing(Player);

  while(1) do begin
    AI_Waitseconds(1);
    if ((EVENT_libraescorted=1) and (m_Nav = 1)) then
      AI_ReplenishMissilesAndFuel;
  end;
end;

function M_Mage;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_Activateself(0);
  AI_Waitseconds(1);
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_AddToWing(Player);

  while(1) do begin
    AI_Waitseconds(1);
    if ((EVENT_libraescorted=1) and (m_Nav = 1)) then
      AI_ReplenishMissilesAndFuel;
  end;
end;

function M_Gryphon;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
//  SF_Activateself(0);
  SF_BindToActionSphere(1);
  AI_AddToWing(Faris);
  until(addgryphon=1) do
    AI_Waitseconds(1);

  AI_RemoveFromWing;
  SF_BindToActionSphere(0);
  AI_AddToWing(Player);

  while(1) do
    AI_Waitseconds(1);

end;

function M_Hellcat;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
//  SF_Activateself(0);
  SF_BindToActionSphere(1);
  AI_AddToWing(Faris);
  until(addhellcat=1) do
    AI_Waitseconds(1);

  AI_RemoveFromWing;
  SF_BindToActionSphere(0);
  AI_AddToWing(Player);

  while(1) do
    AI_Waitseconds(1);

end;

function M_Refueler;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
//  SF_Activateself(0);
  AI_WaitUntilActive;
  SF_BindToActionSphere(1);
  AI_AddToWing(Faris);
  while(1) do begin
    AI_Waitseconds(1);
    if(EVENT_libraescorted=1) then begin
      AI_SendSpecialComm(25, 1);
      AI_RemoveFromWing;
      SF_AutopilotDisable;
      while(EVENT_libraescorted=1) do begin
        AI_Waitseconds(1);
        if (SF_GetDistance(Player)<500) then begin
          if (SF_GetVelocityObject(Player) < 20) then begin
            AI_RefuelCutscene(Player, Refueler);
            AI_ReplenishMissilesAndFuel;
            EVENT_libraescorted:=2;
            SF_AutopilotResumeNormal;
          end;
        end;
      end;
    end;
  end;
end;



//**********************Libra Nav****************************


object NavL(Navpoint)
  x: -130000;
  y: 10000;
  z: 6000;
  main: M_LNav;
  brief: B_LNav;
  color: 0, 1, 1, 1;
  name: spacefli["Libra Nav"];
  navdata: 2, 20000;
end;

object Marigold(capship)
  obj: UE_SHIP_Freighter;
  x: -129750;
  y: 9900;
  z: 7000;
  main: M_Marigold;
  brief: B_Marigold;
  death: D_Libracarrier;
  color: 0, 0, 0, 1;
  pilot: PILOT_Capship_Male2;
end;

object Solomon(capship)
  obj: UE_SHIP_Freighter;
  x: -129950;
  y: 9900;
  z: 7000;
  main: M_Solomon;
  brief: B_Solomon;
  death: D_Libracarrier;
  color: 0, 0, 0, 1;
  pilot: PILOT_Base_Male1;
end;

object Stettin(capship)
  obj: UE_SHIP_Freighter;
  x: -130150;
  y: 9900;
  z: 7000;
  main: M_Stettin;
  death: D_Libracarrier;
  pilot: PILOT_Base_Female1;
end;

object Fairfax(capship)
  obj: UE_SHIP_Freighter;
  x: -130350;
  y: 9900;
  z: 7000;
  main: M_Fairfax;
  death: D_Libracarrier;
  pilot: PILOT_Base_Female2;
end;

object LibraArrow(ship)
  obj: UE_SHIP_Ferret;
  x: -130000;
  y: 10100;
  z: 7000;
  main: M_Arrow;
  pilot: PILOT_Confed;
end;


function M_LNav;

var setup = true;

begin
  NAV_SetEjectSequence(ES_SAR_pickup);
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
     NAV_ActivateSelf;
     m_Nav := 2;
      if(setup) then begin
        SF_ObjectiveSetTotal(mobj_libra, 4);
        SF_ObjectiveSetTotalNeededForSuccess(mobj_libra, 3);
        SF_ActivateObject(Marigold, 0);
        SF_ActivateObject(Solomon, 0);
        SF_ActivateObject(Stettin, 0);
        SF_ActivateObject(Fairfax, 0);
        SF_ActivateObject(LibraArrow, 0);
        NAV_SetPlayerNav(3);
        setup:= false;
      end;
    end
    else
     NAV_DeactivateSelf;
  end;
end;


function M_Marigold;
begin
  AI_WaitUntilActive;
  AI_SendComm(COMM_Welcome);
  SF_BindToActionSphere(0);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_SetAutopilotData(600, -30, -50);
  SF_SetChildObjectVulnerable(Marigold, PART_ChildEngine, false);
  until(reachedjumpnav=1) do
    AI_Waitseconds(1);

  SF_BindToActionSphere(m_Nav);
  AI_GotoObjRelWorld(Jumppoint, 600, -30, -50);
  SF_ObjectiveIncrementCount(mobj_libra);
  EVENT_libraescorted:=1;
  AI_SendSpecialComm(25, 0);
  AI_WaitSeconds(5);
  SF_AutopilotResumeNormal;
  SF_DeactivateSelf(1);

  while(1)do
    AI_Waitseconds(1);
end;



function M_Solomon;
begin
  SF_BindToActionSphere(0);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_SetAutopilotData(400, -30, -50);
  until(reachedjumpnav=1) do begin
    AI_Waitseconds(1);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;

  SF_BindToActionSphere(m_Nav);
  while (EVENT_libraescorted <> 1) do begin
    HCL_AI_GotoObjRelWorld_nonblock(Jumppoint, 400, -30, -50);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;
  //AI_GotoObjRelWorld(Jumppoint, 400, -30, -50);
  //SF_AutopilotResumeNormal;
  //EVENT_libraescorted:=1;
  SF_ObjectiveIncrementCount(mobj_libra);
  AI_Waitseconds(1);
  SF_DeactivateSelf(1);
  while(1) do
    AI_Waitseconds(1);
end;


function M_Stettin;
begin
  SF_BindToActionSphere(0);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_SetAutopilotData(200, -30, -50);
  until(reachedjumpnav=1) do begin
    AI_Waitseconds(1);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;

  SF_BindToActionSphere(m_Nav);
  while (EVENT_libraescorted <> 1) do begin
    HCL_AI_GotoObjRelWorld_nonblock(Jumppoint, 200, -30, -50);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;
 // AI_GotoObjRelWorld(Jumppoint, 200, -30, -50);
  SF_ObjectiveIncrementCount(mobj_libra);
  //SF_AutopilotResumeNormal;
  //EVENT_libraescorted:=1;
  AI_Waitseconds(2);
  SF_DeactivateSelf(1);
  while(1) do
    AI_Waitseconds(1);
end;


function M_Fairfax;
begin
  SF_BindToActionSphere(0);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_SetAutopilotData(-200, -30, -50);
  until(reachedjumpnav=1) do begin
    AI_Waitseconds(1);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;

  SF_BindToActionSphere(m_Nav);
  while (EVENT_libraescorted <> 1) do begin
    HCL_AI_GotoObjRelWorld_nonblock(Jumppoint, -200, -30, -50);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;
  //AI_GotoObjRelWorld(Jumppoint, -200, -30, -50);
  SF_ObjectiveIncrementCount(mobj_libra);
  //SF_AutopilotResumeNormal;
  //EVENT_libraescorted:=1;
  AI_Waitseconds(1);
  SF_DeactivateSelf(1);
  while(1) do
    AI_Waitseconds(1);
end;

function M_Arrow;
begin
  SF_BindToActionSphere(2);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  while(1) do
    AI_GotoObjRelFrame(NavL, -1500, 100, -1500);
    AI_GotoObjRelFrame(NavL, -1500, 100, 1500);
    AI_GotoObjRelFrame(NavL, 1500, 100, 1500);
    AI_GotoObjRelFrame(NavL, 1500, 100, -1500);
end;


function D_Libracarrier;
begin
  SF_BindToActionSphere(m_Nav);
  deadlibra:=deadlibra+1;
  if(deadlibra=4) then begin
    SF_AutopilotResumeNormal;
      EVENT_libraescorted:=1;
  end;

end;




//**********************Nav 1****************************



object Nav1(Navpoint)
  x: -100000;
  y: 0;
  z: 230000;
  main: M_Nav1;
  brief: B_Nav1;
  color: 0, 1, 1, 1;
  name: spacefli["Nav 1"];
  navdata: 3, 20000;
end;


function M_Nav1;

var setup = true;

begin
  NAV_SetEjectSequence(ES_SAR_pickup);
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
     NAV_ActivateSelf;
     m_Nav := 3;
      if(setup) then begin
        Nav_CreateShip(2, PILOT_Alien1, 0, @M_Bug, @D_Bug, -100000, 1000, 230400);
        Nav_CreateShip(2, PILOT_Alien2, 0, @M_Bug, @D_Bug, -100050, 1000, 230400);
        Nav_CreateShip(2, PILOT_Alien3, 0, @M_Bug, @D_Bug, -100100, 1000, 230400);
        Nav_CreateShip(3, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, -100150, 1000, 230400);
        AI_Waitseconds(1);
        until(bugcount=0) do
          AI_Waitseconds(1);

        Nav_CreateShip(3, PILOT_Alien4, 0, @M_Bug, @D_Bug, -100000, 1400, 230800);
        Nav_CreateShip(3, PILOT_Alien5, 0, @M_Bug, @D_Bug, -100050, 1450, 230800);
        Nav_CreateShip(30, PILOT_Alien6, 0, @M_Bug, @D_Bug, -100100, 1400, 230800);
        Nav_CreateShip(30, PILOT_Alien7, 0, @M_Bug, @D_Bug, -100150, 1400, 230800);
        Nav_CreateShip(30, PILOT_Alien8, 0, @M_Bug, @D_Bug, -100100, 1450, 230800);
        Nav_CreateShip(30, PILOT_Alien9, 0, @M_Bug, @D_Bug, -100150, 1450, 230800);
        AI_Waitseconds(1);
        until(bugcount=0) do
          AI_Waitseconds(1);

        Nav_CreateShip(3, PILOT_Alien4, 0, @M_Bug, @D_Bug, -100000, 1900, 230800);
        Nav_CreateShip(3, PILOT_Alien5, 0, @M_Bug, @D_Bug, -100050, 1900, 230800);
        //Nav_CreateShip(3, PILOT_Alien6, 0, @M_Bug, @D_Bug, -100100, 1900, 230800);
        //Nav_CreateShip(3, PILOT_Alien7, 0, @M_Bug, @D_Bug, -100150, 1900, 230800);
        Nav_CreateShip(7, PILOT_Alien8, 0, @M_Bug, @D_Bug, -100000, 1950, 230800);
        Nav_CreateShip(7, PILOT_Alien9, 0, @M_Bug, @D_Bug, -100050, 1950, 230800);
        Nav_CreateShip(7, PILOT_Alien8, 0, @M_Bug, @D_Bug, -100100, 1950, 230800);
        Nav_CreateShip(7, PILOT_Alien9, 0, @M_Bug, @D_Bug, -100150, 1950, 230800);
        Nav_CreateShip(35, PILOT_Alien9, 0, @M_Bug, @D_Bug, -100200, 1950, 230800);

        NAV_SetPlayerNav(4);
        setup:= false;
      end;
    end
    else
     NAV_DeactivateSelf;
  end;
end;


function M_Bug;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(0);
  bugcount:=bugcount+1;
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;


function D_Bug;
begin
  bugcount:=bugcount-1;
end;


//**********************Jump Point Nav****************************



object JumpNav(Navpoint)
  x: -10000;
  y: 20000;
  z: 230000;
  main: M_JNav;
  brief: B_JNav;
  color: 0, 1, 1, 1;
  name: spacefli["Jump Point Nav"];
  navdata: 4, 20000;
end;


object Orca(capship)
  obj: orca;
  x: -10450;
  y: 20000;
  z: 238350;
  main: M_Orca;
  pilot: PILOT_Cruiser;
  direction: 180, 0, 0;
end;




function M_JNav;

var setup = true;

begin
  NAV_SetEjectSequence(ES_SAR_pickup);
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
     NAV_ActivateSelf;
     SF_SetOtherObjectFlag(Jumppoint, OF_Collidable, false);
     m_Nav := 4;
      if(setup) then begin
        reachedjumpnav:=1;
        SF_AutopilotDisable;
        Nav_CreateShip(7, PILOT_Alien4, 0, @M_Bug, @D_Bug, -10050, 21000, 230400);
        Nav_CreateShip(7, PILOT_Alien5, 0, @M_Bug, @D_Bug, -10100, 21000, 230400);
        Nav_CreateShip(7, PILOT_Alien6, 0, @M_Bug, @D_Bug, -10150, 21000, 230400);
        Nav_CreateShip(7, PILOT_Alien7, 0, @M_Bug, @D_Bug, -10000, 21050, 230400);
        Nav_CreateShip(7, PILOT_Alien8, 0, @M_Bug, @D_Bug, -10050, 21050, 230400);
        Nav_CreateShip(7, PILOT_Alien9, 0, @M_Bug, @D_Bug, -10150, 21050, 230400);

        AI_Waitseconds(60);

        Nav_CreateShip(7, PILOT_Alien1, 0, @M_Bug, @D_Bug, -10050, 21000, 230400);
        Nav_CreateShip(7, PILOT_Alien2, 0, @M_Bug, @D_Bug, -10100, 21000, 230400);
        Nav_CreateShip(7, PILOT_Alien3, 0, @M_Bug, @D_Bug, -10150, 21000, 230400);
        Nav_CreateShip(30, PILOT_Alien4, 0, @M_Bug, @D_Bug, -10050, 21050, 230400);
        Nav_CreateShip(30, PILOT_Alien5, 0, @M_Bug, @D_Bug, -10000, 21050, 230400);

        NAV_SetPlayerNav(1);
        setup:= false;
      end;
      if(EVENT_Aquariusreached) then begin
        NAV_SetEjectSequence(ES_alien_pickup_MIA);
        SF_AutopilotDisable;
        reachedjumpnav:=2;
        SF_ActivateObject(Orca, 0);
        SF_ObjectiveEnable(mobj_destroy_turrets);
        Nav_CreateShip(2, PILOT_Alien4, 0, @M_Bug, @D_Bug, -10050, 21000, 230400);
        Nav_CreateShip(2, PILOT_Alien5, 0, @M_Bug, @D_Bug, -10100, 21000, 230400);
        Nav_CreateShip(2, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, -10150, 21000, 230400);
        Nav_CreateShip(2, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, -10000, 21050, 230400);

        AI_Waitseconds(60);
        Nav_CreateShip(2, PILOT_Alien1, 0, @M_Bug, @D_Bug, -10050, 21000, 230400);
        Nav_CreateShip(2, PILOT_Alien2, 0, @M_Bug, @D_Bug, -10100, 21000, 230400);
        Nav_CreateShip(2, PILOT_Alien3, 0, @M_Bug, @D_Bug, -10150, 21000, 230400);
        //Nav_CreateShip(2, PILOT_Alien6, 0, @M_Bug, @D_Bug, -10000, 21050, 230400);

        AI_WaitSeconds(30);
        Nav_CreateShip(2, PILOT_Alien1, 0, @M_Bug, @D_Bug, -10050, 20000, 234500);
        Nav_CreateShip(2, PILOT_Alien2, 0, @M_Bug, @D_Bug, -10100, 20000, 234500);
        Nav_CreateShip(2, PILOT_Alien3, 0, @M_Bug, @D_Bug, -10150, 20000, 234500);
        //Nav_CreateShip(30, PILOT_Alien6, 0, @M_Bug, @D_Bug, -10000, 20050, 234500);
        //Nav_CreateShip(30, PILOT_Alien7, 0, @M_Bug, @D_Bug, -10000, 20050, 234500);

        EVENT_Aquariusreached:=0;
        NAV_SetPlayerNav(1);
      end;
    end
    else
     NAV_DeactivateSelf;
  end;
end;


function M_Orca;
begin
  SF_SaveObjectState(true);
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  AI_Waituntilactive;
  SF_BindToActionSphere(4);
  SF_SetChildObjectVulnerable(Orca, PART_ChildBridge, false);
  SF_SetChildObjectVulnerable(Orca, PART_ChildEngine, false);
//  AI_GotoObjRelWorld(Jumppoint, -450, 30, -250);
//  AI_SetThrottle(0);
  totalturrets := SF_GetNumComponentPartsObj(Orca, PART_ChildGunTurret);
  SF_ObjectiveSetTotal(mobj_destroy_turrets, totalturrets);
  SF_ObjectiveSetTotalNeededForSuccess(mobj_destroy_turrets, totalturrets);
  while (1) do begin
    if (SF_GetDistance(Jumppoint) > 500) then
       HCL_AI_GotoObjRelWorld_nonblock(Jumppoint, -450, 30, -250)
    else
      AI_SetThrottle(0);

    turrets := SF_GetNumComponentPartsObj(Orca, PART_ChildGunTurret);
    lostturrets := totalturrets - turrets;

    SF_ObjectiveSetCount(mobj_destroy_turrets, lostturrets);

//    if (SF_GetNumComponentPartsObj(Orca, PART_ChildGunTurret)=0) then begin
//      SF_ObjectiveSetComplete(mobj_destroy_turrets);
    //end;
    AI_WaitMilliseconds(50);
  end;
end;



//**********************Aquarius Nav****************************


object NavA(Navpoint)
  x: 110000;
  y: -30000;
  z: 20000;
  main: M_ANav;
  brief: B_ANav;
  color: 0, 1, 1, 1;
  name: spacefli["Aquarius Nav"];
  navdata: 5, 20000;
end;


object Bohemia(capship)
  obj: UE_SHIP_Freighter;
  x: 110250;
  y: -30100;
  z: 21000;
  main: M_Bohemia;
  brief: B_Bohemia;
  color: 0, 0, 0, 1;
  death: D_aquariuscarrier;
  pilot: PILOT_Base_Male1;
end;

object Palofax(capship)
  obj: UE_SHIP_Freighter;
  x: 110050;
  y: -30100;
  z: 21000;
  main: M_Palofax;
  brief: B_Palofax;
  color: 0, 0, 0, 1;
  death: D_aquariuscarrier;
  pilot: PILOT_Base_Female1;
end;

object Quare(capship)
  obj: UE_SHIP_Freighter;
  x: 109850;
  y: -30100;
  z: 21000;
  main: M_Quare;
  death: D_aquariuscarrier;
  pilot: PILOT_Base_Female2;
end;



object AquariusArrow(ship)
  obj: UE_SHIP_Ferret;
  x: 110000;
  y: -29930;
  z: 21000;
  main: M_Arrow2;
  pilot: PILOT_Confed;
end;


function M_ANav;

var setup = true;

begin
  NAV_SetEjectSequence(ES_SAR_pickup);
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
     NAV_ActivateSelf;
     m_Nav := 5;
      if(setup) then begin
        if (EVENT_libraescorted = 2) then begin
          EVENT_Aquariusreached:=1;
          SF_ObjectiveSetTotal(mobj_aquarius, 3);
          SF_ObjectiveSetTotalNeededForSuccess(mobj_aquarius, 2);
          NAV_SetPlayerNav(6);
        end;
        SF_ActivateObject(Bohemia, 0);
        SF_ActivateObject(Palofax, 0);
        SF_ActivateObject(Quare, 0);

        SF_ActivateObject(AquariusArrow, 0);
        setup:= false;
      end;
    end
    else
     NAV_DeactivateSelf;
  end;
end;

function M_Arrow2;
begin
  SF_BindToActionSphere(5);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  while(1) do
    AI_GotoObjRelFrame(NavA, -1500, 100, -1500);
    AI_GotoObjRelFrame(NavA, -1500, 100, 1500);
    AI_GotoObjRelFrame(NavA, 1500, 100, 1500);
    AI_GotoObjRelFrame(NavA, 1500, 100, -1500);
end;


function M_Bohemia;
begin
  AI_Waituntilactive;
  SF_BindToActionSphere(5);
  until (EVENT_Aquariusreached=1) do AI_WaitMilliseconds(1);
  SF_BindToActionSphere(0);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_SetAutopilotData(600, -30, -50);
  SF_SetChildObjectVulnerable(Bohemia, PART_ChildEngine ,0);
  until(reachedjumpnav=2) do begin
    AI_Waitseconds(1);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;

  SF_BindToActionSphere(m_Nav);
  AI_SendSpecialComm(25, 4);

  while (SF_GetDistance(Jumppoint) > 800) do begin
    HCl_AI_GotoObjRelWorld_nonblock(Jumppoint, 600, -30, -300);
    if ((SF_GetDistance(Orca) < 2500) and (aquariuscomm = 1)) then begin
      AI_SendSpecialComm(25, 5);
      aquariuscomm := 0;
    end;
    AI_WaitMilliseconds(50);
  end;

  EVENT_aquariusescorted:=1;
  AI_SetThrottle(50);
  AI_WaitSeconds(12);
  AI_SendSpecialComm(25, 0);
  AI_WaitSeconds(5);
  SF_ObjectiveIncrementCount(mobj_aquarius);
  SF_AutopilotResumeNormal;
  SF_DeactivateSelf(1);
  while(1)do
    AI_Waitseconds(1);
end;



function M_Palofax;
begin
  AI_Waituntilactive;
  AI_SendComm(COMM_Welcome);
  SF_BindToActionSphere(5);
  until (EVENT_Aquariusreached=1) do AI_WaitMilliseconds(1);
  SF_BindToActionSphere(0);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_SetAutopilotData(400, -30, -50);

  until(reachedjumpnav=2) do begin
    AI_Waitseconds(1);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;

  SF_BindToActionSphere(m_Nav);
  while (EVENT_aquariusescorted <> 1) do begin
    HCL_AI_GotoObjRelWorld_nonblock(Jumppoint, 400, -30, -300);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;

  //AI_GotoObjRelWorld(Jumppoint, 400, -30, -290);
  AI_WaitSeconds(4);
  if (turrets < 8) then begin
    SF_ObjectiveIncrementCount(mobj_aquarius);
    SF_DeactivateSelf(1);
  end else
    SF_DestroySelf;

  //SF_ObjectiveIncrementCount(mobj_aquarius);

//  SF_AutopilotResumeNormal;
  //SF_DeactivateSelf(1);
  while(1) do
    AI_Waitseconds(1);
end;


function M_Quare;
begin
  AI_Waituntilactive;
  SF_BindToActionSphere(5);
  until (EVENT_Aquariusreached=1) do AI_WaitMilliseconds(1);
  SF_BindToActionSphere(0);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_SetAutopilotData(200, -30, -50);

  until(reachedjumpnav=2) do begin
    AI_Waitseconds(1);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;

  SF_BindToActionSphere(m_Nav);
  while (EVENT_aquariusescorted <> 1) do begin
    HCL_AI_GotoObjRelWorld_nonblock(Jumppoint, 200, -30, -350);
    if (SF_GetNumComponentParts(PART_ChildEngine) = 0) then
      SF_DestroySelf;
  end;

//  AI_GotoObjRelWorld(Jumppoint, 200, -30, -340);
  AI_WaitSeconds(1);
  if (turrets < 4) then begin
    SF_ObjectiveIncrementCount(mobj_aquarius);
    SF_DeactivateSelf(1);
  end else
    SF_DestroySelf;

  //SF_ObjectiveIncrementCount(mobj_aquarius);

  //SF_AutopilotResumeNormal;
//  EVENT_aquariusescorted:=1;
  //SF_DeactivateSelf(1);
  while(1) do
    AI_Waitseconds(1);
end;


function D_aquariuscarrier;
begin
  SF_BindToActionSphere(m_Nav);
  deadaquarius:=deadaquarius+1;
  if(deadaquarius=3) then begin
    SF_AutopilotResumeNormal;
      EVENT_aquariusescorted:=1;
  end;

end;



//**********************Nav 2****************************



object Nav2(Navpoint)
  x: 110000;
  y: 0;
  z: 220000;
  main: M_Nav2;
  brief: B_Nav2;
  color: 0, 1, 1, 1;
  name: spacefli["Nav 2"];
  navdata: 6, 20000;
end;


function M_Nav2;

var setup = true;

begin
  NAV_SetEjectSequence(ES_SAR_pickup);
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
     NAV_ActivateSelf;
     m_Nav := 6;
      if(setup) then begin
        if (EVENT_Aquariusreached=1) then begin
          Nav_CreateShip(2, PILOT_Alien1, 0, @M_Bug, @D_Bug, 110000, 1000, 220400);
          Nav_CreateShip(2, PILOT_Alien2, 0, @M_Bug, @D_Bug, 110050, 1000, 220400);
          Nav_CreateShip(2, PILOT_Alien3, 0, @M_Bug, @D_Bug, 110100, 1000, 220400);
          Nav_CreateShip(3, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, 110150, 1000, 220400);
          AI_Waitseconds(1);
          until(bugcount=0) do
            AI_Waitseconds(1);

          Nav_CreateShip(2, PILOT_Alien4, 0, @M_Bug, @D_Bug, 110000, 1400, 221000);
          Nav_CreateShip(2, PILOT_Alien5, 0, @M_Bug, @D_Bug, 110050, 1450, 221000);
          Nav_CreateShip(2, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, 110100, 1400, 221000);
          Nav_CreateShip(2, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, 110150, 1400, 221000);
          Nav_CreateShip(30, PILOT_Alien8, 0, @M_Bug, @D_Bug, 110100, 1450, 221000);
          Nav_CreateShip(30, PILOT_Alien9, 0, @M_Bug, @D_Bug, 110150, 1450, 221000);
          Nav_CreateShip(30, PILOT_Alien1, 0, @M_Bug, @D_Bug, 110000, 2050, 221000);
          Nav_CreateShip(30, PILOT_Alien2, 0, @M_Bug, @D_Bug, 110050, 2000, 221000);
          Nav_CreateShip(35, PILOT_Alien3, 0, @M_Bug, @D_Bug, 110100, 2100, 221000);
          Nav_CreateShip(35, PILOT_Alien6, 0, @M_Bug, @D_Bug, 110150, 2000, 221200);


          NAV_SetPlayerNav(4);
        end;
        setup:= false;
      end;
    end
    else
     NAV_DeactivateSelf;
  end;
end;







// ******************** Begin Briefing ********************

function B_Player;
begin



  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_FaceObject(NavL);

  BRIEF_Activate;

  // "Your Alpha wing will be responsible for two civilian convoys designated
  // Libra and Aquarius heading towards the Rostov jump point."
  BRIEF_VoiceOver(25,0,8);


  BRIEF_CAM_SetActive(1);
  BRIEF_CAM_SetPos(0, 250, -100);
  BRIEF_SetZoomSeconds(5, 7);

  BRIEF_CAM_TrackObj(Player);
  BRIEF_WaitSeconds(6);

  BRIEF_MoveObjSeconds(NavL, 3);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  BRIEF_SetZoomSeconds(50, 4);
  // Protect each convoy from all hostiles.
  BRIEF_VoiceOver(25, 1, 3);
  BRIEF_FaceObject(Nav1);
  atlibra:=1;
  BRIEF_WaitSeconds(2);
  BRIEF_MoveObjSeconds(Nav1, 5);

  BRIEF_SetZoomSeconds(100, 3);
// You will first escort Libra Convoy. Alien presence is likely to be extremely high.
  BRIEF_VoiceOver(25, 2, 6);

//  BRIEF_WaitSeconds(1);
  BRIEF_MoveObjSeconds(JumpNav, 3);

  BRIEF_Waitseconds(2);
  librajump:=1;
  SYS_PlaySFX(SFX_Jump);
  BRIEF_Waitseconds(1);
// "You will therefore rearm and refuel at this NAV point before your rendezvous with Aquarius Convoy."
  BRIEF_VoiceOver(25, 3, 7);
  BRIEF_MoveObjSeconds(NavD, 7);
  BRIEF_Waitseconds(2);
  BRIEF_MoveObjSeconds(NavA, 3);
  BRIEF_FaceObject(Nav2);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  ataquarius:=1;
  BRIEF_WaitSeconds(2);
  BRIEF_MoveObjSeconds(Nav2, 5);
  BRIEF_MoveObjSeconds(JumpNav, 3);
  BRIEF_Waitseconds(2);
  SYS_PlaySFX(SFX_Jump);
  aquariusjump:=1;

// "Once you have escorted both convoys return to the Dauntless."
  BRIEF_VoiceOver(25, 4, 4);
  BRIEF_Waitseconds(2);
  BRIEF_MoveObjSeconds(NavD, 7);

  BRIEF_Exit;

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Gold;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, -25, 0, -5);

  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;


function B_Mage;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, 25, 0, -5);

  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Dauntless;
begin

  BRIEF_SetAppearance(UE_APPEARANCE_Dauntless);
  BRIEF_FaceObject(JumpNav);
  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Marigold;
begin

  BRIEF_GotoObjRelWorldSeconds(NavL, 50, 0, -10, 4, 0);
  BRIEF_FaceObject(Nav1);
  BRIEF_SetAppearance(32);
  BRIEF_Activate;

  until(atlibra) do
    BRIEF_Waitseconds(1);

  BRIEF_AttachToObj(Player, 50, 0, -10);

  until(librajump) do
    BRIEF_Waitseconds(1);

  BRIEF_Deactivate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Solomon;
begin

  BRIEF_GotoObjRelWorldSeconds(NavL, 100, 0, -10, 4, 0);
  BRIEF_FaceObject(Nav1);
  BRIEF_SetAppearance(32);
  BRIEF_Activate;

  until(atlibra) do
    BRIEF_Waitseconds(1);

  BRIEF_AttachToObj(Player, 100, 0, -10);

  until(librajump) do
    BRIEF_Waitseconds(1);

  BRIEF_Deactivate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Bohemia;
begin
  until(atlibra) do
    BRIEF_Waitseconds(1);
  BRIEF_GotoObjRelWorldSeconds(NavA, 50, 0, -10, 4, 0);
  BRIEF_FaceObject(Nav2);
  BRIEF_SetAppearance(32);

  BRIEF_Activate;
  until(ataquarius) do
    BRIEF_Waitseconds(1);

  BRIEF_AttachToObj(Player, 50, 0, -10);
  until(aquariusjump) do
    BRIEF_Waitseconds(1);

  BRIEF_Deactivate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Palofax;
begin
  until(atlibra) do
    BRIEF_Waitseconds(1);
  BRIEF_GotoObjRelWorldSeconds(NavA, 100, 0, -10, 4, 0);
  BRIEF_FaceObject(Nav2);
  BRIEF_SetAppearance(32);

  BRIEF_Activate;
  until(ataquarius) do
    BRIEF_Waitseconds(1);

  BRIEF_AttachToObj(Player, 100, 0, -10);
  until(aquariusjump) do
    BRIEF_Waitseconds(1);

  BRIEF_Deactivate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;


function B_DNav;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Nav1;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Nav2;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_JNav;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_LNav;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_ANav;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;



// **************** Takeoff/Landing routines **************
// ********************************************************
// Camera stuff

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

function F_Takeoff(select); forward;
function F_Landing(select); forward;

function M_Camera;
begin
  while(1) do
  begin
    if (m_Event = EVENT_Takeoff_Start) then
      F_Takeoff(SYS_Random(3));
    if (m_Event = EVENT_Activate_Landing_Cam) then
      F_Landing(SYS_Random(3));
    AI_WaitMilliSeconds(15);
  end;
end;

function F_Takeoff(select);
begin
  SF_CAM_TrackObj(Player);

  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -30, 35, -40);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, -10, 35, 80);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, 0, 5, 40);

  SF_ActivateSelf(0);
  until (m_Event = EVENT_Takeoff_Complete) do
    AI_WaitSeconds(1);
  SF_CAM_TrackNothing;
  SF_DeactivateSelf(0);
end;

function F_Landing(select);
begin
  SF_CAM_HideDust;
  SF_CAM_TrackObj(NavD);
  SF_CAM_SetFollowObj(NavD, 0, 1, 0);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(1);
  SF_CAM_TrackObj(Dauntless);

  if (select = 0) then
    SF_CAM_SetFollowObj(Dauntless, -200, 200, -350);
  if (select = 1) then
    SF_CAM_SetFollowObj(Dauntless, -50, 200, 500);
  if (select = 2) then
    SF_CAM_SetFollowObj(Dauntless, 400, 100, 300);

  until (m_Event = EVENT_Final_Approach) do
    AI_WaitMilliSeconds(5);
  SF_CAM_TrackObj(Player);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -3, 2, 15);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, 3, 4, -15);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, -9, 2, 5);

  AI_WaitSeconds(30);
end;

// Player stuff

function F_InitLanding;
begin
  SF_AutopilotDisable;
  m_Event := EVENT_Land_Player;
  until (M_Event = EVENT_Activate_Landing_Cam) do AI_WaitSeconds(1);
  AI_WaitSeconds(30);
  SF_Exit;
end;

function F_PlayerTakeoff;
begin
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x+15, y-25, z);
  SF_SetObjectFlag(OF_Collidable, false);
  AI_PLR_ControlAssume;
  AI_SetThrottle(0);
  AI_WaitSeconds(1);
  SF_ActivateSelf(0);
  AI_WaitSeconds(1);
  AI_SetThrottle(100);
  AI_WaitMilliSeconds(1500);
  M_Event := EVENT_Takeoff_Start;
  while (SF_GetDistance(Dauntless) < 500) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, 15, -20, 700);
  M_Event := EVENT_Takeoff_Complete;
  SF_SetObjectFlag(OF_Collidable, true);
  AI_PLR_ControlResume;
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
end;

function F_PlayerLanding;
begin
  while (SF_GetDistance(Dauntless) > 300) do AI_WaitMilliSeconds(1);
  AI_PLR_ControlAssume;
  SF_SetObjectFlag(OF_Collidable, false);
  M_Event := EVENT_Activate_Landing_Cam;
  HCL_EmptyFuel;
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Player) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z-350);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x, y-25, z-350);
  AI_SetThrottle(50);
  until (SF_GetDistance(Dauntless) < 50) do AI_WaitMilliSeconds(5);
  M_Event := EVENT_Final_Approach;
  SYS_PlaySFX(SFX_Engines_Power_Down);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  AI_WaitSeconds(5);
  SF_Exit;
end;

// Dauntless stuff

function F_DauntlessLanding;
begin
  if (SF_GetVelocityObject(Dauntless) > 0) then
  begin
    AI_SetThrottle(0);
    AI_WaitSeconds(5);
  end;

  // Teleport to position relative to NavD, face NavD
  M_GetPos(NavD);
  SF_SetWorldPosition(x, y, z+1000);
  AI_FaceObject(NavD);
  m_Event := EVENT_Dauntless_Ready;
  AI_WaitSeconds(25);
  SF_Exit;
end;

