//******************************************************************************
//
// Unknown Enemy
// Mission 5B
//
// Created by:   Alex Barnfield  <alex@crius.net>
// Modified by:  Jakub Majewski <qmajewski@yahoo.co.uk>
//
//
// Last modified: May 12th, 2004
//
//******************************************************************************


mission ue5b;

#Addtosearchpath("$uesrc$");

#SetOutputPath("$wcue$\language\pilots\");
#file "strings\pilots\srs25.pas";

#SetOutputPath("$wcue$\comms\");
#file "comms\srs25.pas";

#SetRooms ("cic.rom", "rec.rom");


// 0 = "Thanks for the escort, Lt. Colonel."

// 1 = "You look like you'll need to refuel... get within 5000 klicks, and slow down to 200 kps."

// 2 = "Sir, we're assigning Hellcat to your wing for the second escort run."

// 3 = "Sir, we're assigning Hellcat and Gryphon to your wing for the second escort run."

// 4 = "Sir, we're tracking a capship approaching at high speed! It looks like it will get here soon, so you'd better hold it off until we jump!"

// 5 = "Sir, you'd better de-fang that thing before it gets here!"

// 6 = "Good work out there, sir. You're cleared to land."

// 7 = "You did your best, sir. You're cleared to land."

// 8 = "We're not waiting any longer for Epsilon, Colonel. Set course for the jump point."

// 9 = "We're almost at the jump point, you need to get back here now Colonel!"


#sector: "t.sec";

#name: 10;

#AddToSearchPath("$wcue$\language\");

#include wcp, consts, uepilots, comms, ue;

#strings targetid, objectiv, spacefli;

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);

#SetOutputPath("$wcue$\mission\");

const
  EVENT_Takeoff_Start = 4,
  EVENT_Takeoff_Complete = 5,
  EVENT_Land_Player = 6,
  EVENT_Activate_Landing_Cam = 7,
  EVENT_Dauntless_Ready = 8,
  EVENT_Final_Approach = 9,
  EVENT_Jump_Scene = 10,
  EVENT_At_Jump=11;

var
  x=0,
  y=0,
  z=0,
  m_Event=0,
  EVENT_DCam_Activated=0,
  dnavbugs=22,
  stingraycount=0,
  moraycount=0,
  jumpnavreached=0,
  dauntlesscheck1=0,
  dauntlesscheck2=0,
  dauntlesscheck3=0,
  atbriefjumpnav=0,
  landingcheck=0,
  landinginprogress=0,
  D_Dead = 0;

objective mobj_jump
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Ensure Dauntless' safe jump out-system"];
  status: MOBJ_Incomplete;
  counter: false;
end;

objective mobj_land
  hidden: false;
  type: MOBJ_Secondary;
  text: objectiv["Land before the Dauntless jumps"];
  status: MOBJ_Incomplete;
  counter: false;
end;


object Dauntless (capship) as "BWS Dauntless"
  obj: UE_SHIP_Dauntless;
  x: 0;
  y: 0;
  z: -1000;
  main: M_Dauntless;
  brief: B_Dauntless;
  death: D_Dauntless;
  color: 0, 0.35, 0.35, 1;
  direction: 0, 0, 0;
  pilot: PILOT_Dauntless;
end;

object Player(Player)
  obj: scim;
  x: 0;
  y: 1000;
  z: 0;
  main: M_Player;
  brief: B_Player;
  color: 0, 0.8, 0.8, 0;
  pilot: PILOT_Casey1;
end;


object Gold(Ship)
  obj: scim;
  x: 0;
  y: -250;
  z: -450;
  main: M_Wingman;
  brief: B_Gold;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Gold;
end;

object Mage(Ship)
  obj: scim;
  x: 50;
  y: -300;
  z: -450;
  main: M_Wingman2;
  brief: B_Mage;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Mage;
end;


object Phantom(Ship)
  obj: scim;
  x: -50;
  y: -300;
  z: -450;
  main: M_Wingman3;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Phantom;
end;

object Edge(Ship)
  obj: scim;
  x: 0;
  y: -300;
  z: -450;
  main: M_Wingman4;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Edge;
end;


function MAIN;
begin
  MS_RunGameflow(0);
  MS_RunBriefing;
  MS_RunSpaceflight(0);
  MS_RunDebriefing;
end;


function F_InitLanding; forward;
function F_PlayerTakeoff; forward;
function F_PlayerLanding; forward;
function F_DauntlessLanding; forward;
function F_PilotLanding1; forward;
function F_PilotLanding2; forward;
function F_PilotLanding3; forward;
function F_PilotLanding4; forward;
function F_PilotLanding5; forward;


function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

function D_Dauntless;
begin
  D_Dead := 1;
end;

function M_SpawnNearObjectMoray(shipId, count, obj);
var
  x1, y1, z1,
  ox, oy, oz;
begin
  x1 := SF_GetXObj(obj);
  y1 := SF_GetYObj(obj);
  z1 := SF_GetZObj(obj);

  while(count > 0) do begin
    ox := x1 + SYS_Random(600) + 1000;
    oy := y1 + SYS_Random(600) + 1000;
    oz := z1 + SYS_Random(600) + 1000;

    NAV_CreateShip(shipId, PILOT_Alien1, 0, @M_BugM, @D_BugM, ox, oy, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;

function M_SpawnNearObjectStingray(shipId, count, obj);
var
  x1, y1, z1,
  ox, oy, oz;
begin
  x1 := SF_GetXObj(obj);
  y1 := SF_GetYObj(obj);
  z1 := SF_GetZObj(obj);

  while(count > 0) do begin
    ox := x1 + SYS_Random(600) + 1000;
    oy := y1 + SYS_Random(600) + 1000;
    oz := z1 + SYS_Random(600) + 1000;

    NAV_CreateShip(shipId, PILOT_Alien1, 0, @M_BugS, @D_BugS, ox, oy, oz);
    AI_WaitMilliseconds(275);
    count := count - 1;
  end;
end;

object JumpPoint(JumpPoint)
  x: -10000;
  y: 50000;
  z: 110000;
  actionsphere: 2;
end;

//**********************Dauntless Nav****************************

object NavD(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_NavD;
  brief: B_NavD;
  color: 0, 1, 1, 1;
  name: spacefli["Dauntless Nav"];
  navdata: 1, 20000;
end;

object Faris(Ship)
  obj: scim;
  x: 450;
  y: 40;
  z: 1050;
  main: M_Betaleader;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Faris;
end;

object Ocelot(Ship)
  obj: scim;
  x: 350;
  y: 370;
  z: -1000;
  main: M_Betawing;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Ocelot;
end;

object Hellcat(Ship)
  obj: scim;
  x: 350;
  y: 350;
  z: -1000;
  main: M_Betawing;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Hellcat;
end;

object Gryphon(Ship)
  obj: scim;
  x: 400;
  y: 350;
  z: -1000;
  main: M_Betawing;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Gryphon;
end;

object Defender(Ship)
  obj: scim;
  x: 350;
  y: 40;
  z: -1100;
  main: M_Gammaleader;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Defender;
end;

object Night(Ship)
  obj: scim;
  x: 350;
  y: -300;
  z: -1100;
  main: M_Gammawing;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Night;
end;

object Blade(Ship)
  obj: scim;
  x: 350;
  y: -30;
  z: -1100;
  main: M_Gammawing;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Blade;
end;


object Doc(Ship)
  obj: epee;
  x: 350;
  y: 40;
  z: -900;
  main: M_Deltaleader;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Doc;
end;

object Warrior(Ship)
  obj: epee;
  x: 350;
  y: 400;
  z: -900;
  main: M_Deltawing;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Warrior;
end;

object Ghost(Ship)
  obj: epee;
  x: 450;
  y: 400;
  z: -900;
  main: M_Deltawing;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Ghost;
end;


object Refueler1(Ship)
  obj: avenger;
  x: -20;
  y: 5;
  z: -200;
  main: M_Refueler1;
  color: 0, 0, 0, 1;
  direction: 180, 0, 0;
  targstr: 1;
  pilot: PILOT_SAR1;
end;

object Refueler2(Ship)
  obj: avenger;
  x: 20;
  y: -15;
  z: -200;
  main: M_Refueler2;
  color: 0, 0, 0, 1;
  direction: 180, 0, 0;
  targstr: 1;
  pilot: PILOT_SAR1;
end;

object Refuelerkiller(Ship)
  obj: Manta;
  x: 20;
  y: 10;
  z: -50;
  main: M_Refuelkill;
  color: 0, 0, 0, 1;
  direction: 180, 0, 0;
  pilot: PILOT_Alien1;
end;

object DauntlessCamera(Camera)
  x: 820;
  y: 30;
  z: -1020;
  main: M_DauntlessCamera;
end;

function M_Player;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  SF_SetBaseShip(Dauntless);
  F_PlayerTakeoff;
  while (1) do begin
    if (m_Event = EVENT_Land_Player) then begin
      F_PlayerLanding;
    end;
    if(EVENT_DCam_Activated) then begin
      AI_PLR_ControlAssume;
      SF_SetObjectFlag(OF_Collidable, false);
      AI_FaceObjRelWorld(Dauntless, 600, 300, 0);
      AI_SetThrottle(100);
      until(EVENT_DCam_Activated=0) do
        AI_Waitmilliseconds(1);

      SF_SetObjectFlag(OF_Collidable, true);
      AI_Plr_ControlResume;
      SF_PlayerSwitchToCam(CamID_cockpit, Player);
    end;
    if(dauntlesscheck3) then begin
      if(SF_GetDistance(Dauntless)<300) then
        Landingcheck:=1;
    end;
    if (D_Dead) then begin
      AI_Waitseconds(10);
      SF_ExitEndGame(2);
    end;

    AI_WaitSeconds(1);
  end;
end;


function M_NavD;
var
  setup = true;
begin
  NAV_SetEjectSequence(ES_alien_pickup_MIA);

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      if (setup) then begin
        SF_ActivateObject(Dauntless, 0);
        Nav_CreateShip(2, PILOT_Alien1, 0, @M_Bug, @D_Bug, 0, 100, 600);
        Nav_CreateShip(2, PILOT_Alien2, 0, @M_Bug, @D_Bug, -50, 100, 600);
        Nav_CreateShip(2, PILOT_Alien3, 0, @M_Bug, @D_Bug, 75, 100, 600);
        Nav_CreateShip(2, PILOT_Alien4, 0, @M_Bug, @D_Bug, 0, 140, 600);
        Nav_CreateShip(2, PILOT_Alien5, 0, @M_Bug, @D_Bug, -50, 170, 600);
        Nav_CreateShip(2, PILOT_Alien6, 0, @M_Bug, @D_Bug, 50, 160, 600);
        Nav_CreateShip(2, PILOT_Alien7, 0, @M_Bug, @D_Bug, 0, -100, 900);
        Nav_CreateShip(2, PILOT_Alien8, 0, @M_Bug, @D_Bug, -50, -120, 900);
        Nav_CreateShip(2, PILOT_Alien9, 0, @M_Bug, @D_Bug, 50, -100, 900);
        Nav_CreateShip(2, PILOT_Alien10, 0, @M_Bug, @D_Bug, 0, -150, 900);
        Nav_CreateShip(2, PILOT_Alien1, 0, @M_Bug, @D_Bug, -75, -150, 900);
        //Nav_CreateShip(2, PILOT_Alien2, 0, @M_Bug, @D_Bug, 50, -150, 900);
        //Nav_CreateShip(3, PILOT_Alien1, 0, @M_Bug, @D_Bug, 400, 100, 600);
        Nav_CreateShip(3, PILOT_Alien2, 0, @M_Bug, @D_Bug, -450, 100, 600);
        Nav_CreateShip(3, PILOT_Alien3, 0, @M_Bug, @D_Bug, 450, 100, 600);
        Nav_CreateShip(3, PILOT_Alien4, 0, @M_Bug, @D_Bug, -400, 150, 600);
        Nav_CreateShip(30, PILOT_Alien5, 0, @M_Bug, @D_Bug, 450, 150, 600);
        Nav_CreateShip(3, PILOT_Alien6, 0, @M_Bug, @D_Bug, -450, 150, 600);
        Nav_CreateShip(30, PILOT_Alien7, 0, @M_Bug, @D_Bug, 400, -100, 900);
        Nav_CreateShip(3, PILOT_Alien8, 0, @M_Bug, @D_Bug, -450, -100, 900);
        Nav_CreateShip(30, PILOT_Alien9, 0, @M_Bug, @D_Bug, 450, -100, 900);
        Nav_CreateShip(3, PILOT_Alien10, 0, @M_Bug, @D_Bug, -400, -150, 900);
        Nav_CreateShip(3, PILOT_Alien1, 0, @M_Bug, @D_Bug, 450, -150, 900);
        Nav_CreateShip(30, PILOT_Alien2, 0, @M_Bug, @D_Bug, -450, -150, 900);
        setup := false;
      end;

      NAV_SetPlayerNav(2);

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Dauntless;
begin
  AI_WaitUntilActive;
  SF_SaveObjectState(true);
  AI_MuteComms;
  AI_SetAutopilotData(-350, 0, 100);
  SF_SetChildObjectVulnerable(Dauntless, PART_ChildEngine, false);
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  AI_AddToIgnoreList(RefuelerKiller, 1000);
  until(dnavbugs=0) do
    AI_Waitseconds(1);

  AI_ResumeComms;

  AI_SendSpecialComm(25, 8);

  until(jumpnavreached) do
    AI_Waitseconds(1);

  AI_MuteComms;

  AI_GotoObjRange(JumpPoint, 8000);
  dauntlesscheck1:=1;
  AI_GotoObjRange(JumpPoint, 5000);
  dauntlesscheck2:=1;
  AI_GotoObjRange(JumpPoint, 3000);
  AI_SendSpecialComm(25, 9);
  dauntlesscheck3:=1;

  while(1) do begin
    AI_SetThrottle(100);
    if(SF_GetDistance(JumpPoint)<700) then begin
      if(landinginprogress=0) then begin
        SF_ObjectiveSetComplete(mobj_jump);
        SF_ObjectiveSetFailure(mobj_land);
        SF_SetMissionSuccess;
        SF_DeactivateSelf(1);
      end;
    end;
    if ((m_Event = EVENT_Land_Player) or (m_Event = EVENT_Activate_Landing_Cam)) then begin
      AI_SetThrottle(0);
      F_DauntlessLanding;
      SF_SetMissionSuccess;
      SF_ObjectiveSetComplete(mobj_jump);
      SF_ObjectiveSetComplete(mobj_land);

      until(m_Event = EVENT_Jump_Scene) do
        AI_Waitseconds(1);
      AI_WaitSeconds(2);

      AI_SetThrottle(100);
      m_Event:=EVENT_At_Jump;
      AI_Waitseconds(5);
      SF_DeactivateSelf(1);

    end;
  AI_WaitMilliseconds(1);
  end;
end;



function M_Wingman;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AddToWing(Player);
  until (dnavbugs = 0) do AI_WaitMilliSeconds(1);
  SF_SetObjectFlag(OF_vulnerable, true);
  until (landinginprogress) do
    AI_WaitMilliSeconds(1);

  F_PilotLanding1;
  while(1) do
    AI_Waitseconds(1);
end;

function M_Wingman2;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AddToWing(Player);
  until (dnavbugs = 0) do AI_WaitMilliSeconds(1);
  SF_SetObjectFlag(OF_vulnerable, true);
  until (landinginprogress) do
    AI_WaitMilliSeconds(1);

  F_PilotLanding2;
  while(1) do
    AI_Waitseconds(1);
end;

function M_Wingman3;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AddToWing(Player);
  until (dnavbugs = 0) do AI_WaitMilliSeconds(1);
  SF_SetObjectFlag(OF_vulnerable, true);
  until (landinginprogress) do
    AI_WaitMilliSeconds(1);

  F_PilotLanding3;
  while(1) do
    AI_Waitseconds(1);
end;

function M_Wingman4;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_AddToWing(Player);
  until (dnavbugs = 0) do AI_WaitMilliSeconds(1);
  SF_SetObjectFlag(OF_vulnerable, true);
  until (landinginprogress) do
    AI_WaitMilliSeconds(1);

  F_PilotLanding4;
  while(1) do
    AI_Waitseconds(1);
end;

function M_Betaleader;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_SetAutopilotData(0, -30, 100);
  SF_SetObjectFlag(OF_vulnerable, false);

  until (dnavbugs = 0) do AI_WaitMilliSeconds(1);
  SF_SetObjectFlag(OF_vulnerable, true);

  while(1) do begin
    AI_Waitseconds(1);
  end;
end;

function M_Gammaleader;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  SF_SubHitPoints(45);
  AI_SetAutopilotData(0, -30, -100);
  SF_SetObjectFlag(OF_vulnerable, true);

  until (dnavbugs<7) do AI_WaitSeconds(1);
  SF_DestroySelf;
  while(1) do begin
    AI_Waitseconds(1);
  end;
end;

function M_Deltaleader;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  SF_SubHitPoints(30);
  AI_SetAutopilotData(0, -30, -200);
  SF_SetObjectFlag(OF_vulnerable, false);
  until (dnavbugs = 0) do AI_WaitMilliSeconds(1);
  SF_SetObjectFlag(OF_vulnerable, true);

  until (m_Event = EVENT_Final_Approach) do AI_WaitMilliSeconds(1);
  AI_WaitSeconds(1);
  SF_DeactivateSelf(0);

  while(1) do begin
    AI_Waitseconds(1);
  end;
end;


function M_Betawing;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_AddToWing(Faris);

  until (m_Event = EVENT_Final_Approach) do AI_WaitMilliSeconds(1);
  SF_DeactivateSelf(0);

  while(1) do
    AI_Waitseconds(1);
end;


function M_Gammawing;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  SF_SubHitPoints(60);
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_AddToWing(Defender);

  until (dnavbugs<(SYS_Random(8)+1)) do AI_WaitSeconds(1);
  SF_DestroySelf;

  while(1) do
    AI_Waitseconds(1);
end;


function M_Deltawing;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  SF_SubHitPoints(30);
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_AddToWing(Doc);

  until (m_Event = EVENT_Final_Approach) do AI_WaitMilliSeconds(1);
  SF_DeactivateSelf(0);

  while(1) do
    AI_Waitseconds(1);
end;


function M_Refueler1;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_Attacknothing(1);
//  until (M_Event = EVENT_Takeoff_Complete) do
//    AI_WaitMilliSeconds(1);

  SF_SetObjectFlag (OF_Collidable, false);
  AI_Ignorecollisions(1);
  AI_Attacknothing(1);
  AI_GotoObjRelFrame(Dauntless, -10, -25, -15);
  SF_DeactivateSelf(0);


  while(1) do
    AI_Waitseconds(1);
end;


function M_Refueler2;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  AI_Attacknothing(1);

//  until (M_Event = EVENT_Takeoff_Complete) do
//    AI_WaitMilliSeconds(1);
  AI_Ignorecollisions(1);
  AI_Attacknothing(1);
  AI_GotoObjRange(Dauntless, 450);
  SF_SetObjectFlag (OF_Collidable, false);
  SF_DestroySelf;

  while(1) do
    AI_Waitseconds(1);
end;



function M_DauntlessCamera;
begin
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
//  SF_CAM_SetFollowObj(Refueler1, -15, 10, -70);
  EVENT_DCam_Activated:=1;
  SF_CAM_SetPos(10, -25, -990);
  SF_ActivateSelf(0);
  SF_CAM_TrackObj(Refueler1);
  AI_Waitseconds(2);
  SF_CAM_TrackNothing;
  AI_Waitseconds(2);
  EVENT_DCam_Activated:=0;
  SF_DeactivateSelf(0);

end;

function M_Refuelkill;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(0);
  SF_SetObjectFlag(OF_Vulnerable, false);
  AI_AddToIgnoreList(Refueler1, 1);
  AI_Ignorecollisions(1);
  AI_Waitseconds(3);
  SF_SetObjectFlag(OF_Vulnerable, true);
  SF_DestroySelf;
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;


function M_Bug;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(0);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function D_Bug;
begin
  dnavbugs:=dnavbugs-1;
end;



//**********************Jump Point Nav****************************

object NavJ(Navpoint)
  x: -10000;
  y: 50000;
  z: 100000;
  main: M_NavJ;
  brief: B_NavJ;
  color: 0, 1, 1, 1;
  name: spacefli["Jump Point Nav"];
  navdata: 2, 20000;
end;




object Hydra_Alpha(Capship) as "Hydra Alpha"
  obj: marlin;
  x: -11500;
  y: 50100;
  z: 103000;
  main: M_Leviathan1;
  direction: 80, 0, 0;
  pilot: PILOT_Cruiser;
end;

object Hydra_Bravo(Capship) as "Hydra Bravo"
  obj: marlin;
  x: -8000;
  y: 50100;
  z: 108000;
  main: M_Leviathan;
  direction:130, 0, 0;
  pilot: PILOT_Cruiser;
end;




function M_NavJ;
var
  setup = true;
begin
  NAV_SetEjectSequence(ES_alien_pickup_MIA);

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      if (setup) then begin
        jumpnavreached:=1;

       SF_ActivateObject(Hydra_Alpha, 0);
       SF_ActivateObject(Hydra_Bravo, 0);
        Nav_CreateShip(2, PILOT_Alien1, 0, @M_BugM, @D_BugM, -10000, 50100, 101600);
        Nav_CreateShip(7, PILOT_Alien2, 0, @M_BugS, @D_BugS, -9950, 50100, 101600);
        Nav_CreateShip(2, PILOT_Alien3, 0, @M_BugM, @D_BugM, -9925, 50100, 101600);
        //Nav_CreateShip(2, PILOT_Alien4, 0, @M_BugM, @D_BugM, -10000, 50140, 101600);
        Nav_CreateShip(7, PILOT_Alien5, 0, @M_BugS, @D_BugS, -9950, 50170, 101600);
        Nav_CreateShip(2, PILOT_Alien6, 0, @M_BugM, @D_BugM, -1050, 50160, 101600);
        Nav_CreateShip(2, PILOT_Alien7, 0, @M_BugM, @D_BugM, -1000, 49900, 101900);
        Nav_CreateShip(7, PILOT_Alien8, 0, @M_BugS, @D_BugS, -9950, 49880, 101900);
        Nav_CreateShip(2, PILOT_Alien9, 0, @M_BugM, @D_BugM, -1050, 49900, 101900);
        //Nav_CreateShip(2, PILOT_Alien10, 0, @M_BugM, @D_BugM, -10000, 49850, 101900);
        Nav_CreateShip(7, PILOT_Alien1, 0, @M_BugS, @D_BugS, -9925, 49850, 101900);
        Nav_CreateShip(2, PILOT_Alien2, 0, @M_BugM, @D_BugM, -10050, 49850, 101900);
        Nav_CreateShip(7, PILOT_Alien1, 0, @M_BugS, @D_BugS, -10400, 50100, 101600);
        Nav_CreateShip(2, PILOT_Alien2, 0, @M_BugM, @D_BugM, -9550, 50100, 101600);
        Nav_CreateShip(7, PILOT_Alien3, 0, @M_BugS, @D_BugS, -10450, 50100, 101600);
        Nav_CreateShip(2, PILOT_Alien4, 0, @M_BugM, @D_BugM, -9600, 50150, 101600);
        Nav_CreateShip(7, PILOT_Alien5, 0, @M_BugS, @D_BugS, -10450, 50150, 101600);
        //Nav_CreateShip(7, PILOT_Alien6, 0, @M_BugS, @D_BugS, -9650, 50150, 101600);
        Nav_CreateShip(2, PILOT_Alien7, 0, @M_BugM, @D_BugM, -10400, 49900, 101900);
        //Nav_CreateShip(7, PILOT_Alien8, 0, @M_BugS, @D_BugS, -9550, 49900, 101900);
        Nav_CreateShip(7, PILOT_Alien9, 0, @M_BugS, @D_BugS, -10450, 49900, 101900);
        Nav_CreateShip(2, PILOT_Alien10, 0, @M_BugM, @D_BugM, -9600, 49850, 101900);
        Nav_CreateShip(7, PILOT_Alien1, 0, @M_BugS, @D_BugS, -10450, 49850, 101900);
        Nav_CreateShip(7, PILOT_Alien2, 0, @M_BugS, @D_BugS, -9550, 49850, 101900);
        Nav_CreateShip(35, PILOT_Alien9, 0, @M_Bug, @D_Bug, -9550, 49850, 102100);
        Nav_CreateShip(35, PILOT_Alien9, 0, @M_Bug, @D_Bug, -9950, 49750, 102100);
        Nav_CreateShip(35, PILOT_Alien9, 0, @M_Bug, @D_Bug, -10250, 49950, 102100);
        until(dauntlesscheck2) do begin
          AI_Waitseconds(30);

          if(moraycount<6) then begin
            M_SpawnNearObjectMoray(2, 3, Dauntless);
          end;

          if(stingraycount<3) then begin
            M_SpawnNearObjectStingray(7, 3, Dauntless);
          end;
        end;

        until(dauntlesscheck3) do begin
          AI_Waitseconds(25);

          if(moraycount<1) then begin
            M_SpawnNearObjectMoray(2, 3, Dauntless);
          end;

          if(stingraycount<10) then begin
            M_SpawnNearObjectStingray(3, 2, Dauntless);
            M_SpawnNearObjectStingray(7, 1, Dauntless);
          end;
        end;
        until ((Landingcheck) or (SF_GetActiveStatus(Dauntless) = AS_Deactivated)) do
          AI_WaitSeconds(1);

        if (SF_GetActiveStatus(Dauntless) = AS_Deactivated) then begin
          while (1) do begin
            AI_Waitseconds(25);
            if(moraycount<1) then begin
              M_SpawnNearObjectMoray(2, 3, Dauntless);
            end;
            if(stingraycount<10) then begin
              M_SpawnNearObjectStingray(3, 2, Dauntless);
              M_SpawnNearObjectStingray(7, 1, Dauntless);
            end;
          end;
        end else begin
          F_InitLanding;
          setup := false;
          //AI_WaitSeconds(40);
          //SF_Exit;
        end;
      end;
    end;
  AI_Waitseconds(1);
  end;
end;



function M_BugM;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(0);
  moraycount:=moraycount+1;
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function D_BugM;
begin
  moraycount:=moraycount-1;
end;


function M_BugS;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(0);
  stingraycount:=stingraycount+1;
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function D_BugS;
begin
  stingraycount:=stingraycount-1;
end;


function M_Leviathan;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(2);
  while(1) do
    AI_Waitseconds(1);
end;

function M_Leviathan1;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(2);
  until(dauntlesscheck2) do
    AI_Waitseconds(1);

  AI_FaceObject(JumpPoint);
  AI_SetThrottle(70);

  while(1) do
    AI_Waitseconds(1);
end;





//**************************Briefing************************

function B_NavD;
begin
  BRIEF_SetAppearance(1);
  BRIEF_DisplayName(1);
  BRIEF_SetSize(120);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_NavJ;
begin
  BRIEF_SetAppearance(1);
  BRIEF_DisplayName(1);
  BRIEF_SetSize(100);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;


function B_Player;
begin
  BRIEF_CAM_SetPos(200, 80, 300);
  BRIEF_CAM_SetActive(1);
  BRIEF_CAM_TrackObj(Player);

  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_Activate;
  BRIEF_WaitSeconds(1);

  // Escort the Dauntless as it tries to get to the jump point.
  BRIEF_Voiceover(25, 5, 4);
  BRIEF_WaitSeconds(5);
  BRIEF_Voiceover(25, 6, 7);
  BRIEF_MoveObjSeconds(NavJ, 10);

  // The ship will jump as soon as she can; you may therefore be left behind if you fail to land on time.
  BRIEF_WaitSeconds(2);
  atbriefjumpnav:=1;
  SYS_PlaySFX(SFX_Jump);
  BRIEF_WaitSeconds(2);
  BRIEF_Exit;
end;


function B_Gold;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, -20, 15, -20);
  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Mage;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, 20, 15, -20);
  BRIEF_Activate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Dauntless;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Dauntless);
  BRIEF_FaceObject(NavJ);
  BRIEF_Activate;
  BRIEF_AttachToObj(Player, -100, 0, -10);
  until(atbriefjumpnav) do
    BRIEF_Waitseconds(1);
  BRIEF_Deactivate;
  while(1) do
    BRIEF_WaitSeconds(10);
end;



// **************** Takeoff/Landing routines **************
// ********************************************************
// Camera stuff

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

function F_Takeoff; forward;
function F_Landing; forward;

function M_Camera;
begin
  while(1) do
  begin
    if (m_Event = EVENT_Takeoff_Start) then
      F_Takeoff;
    if (m_Event = EVENT_Activate_Landing_Cam) then
      F_Landing;
    AI_WaitMilliSeconds(15);
  end;
end;

function F_Takeoff;
var select;
begin
  SF_CAM_TrackObj(Player);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -30, 35, -40);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, -10, 35, 80);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, 0, 5, 40);

  SF_ActivateSelf(0);
  until (m_Event = EVENT_Takeoff_Complete) do
    AI_WaitSeconds(1);
  SF_CAM_TrackNothing;
  SF_DeactivateSelf(0);
end;

function F_Landing;
var select;
begin
  SF_CAM_HideDust;
  SF_CAM_TrackObj(JumpPoint);
  SF_CAM_SetFollowObj(JumpPoint, 0, 1, 0);
  SF_CAM_TrackNothing;
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(1);
  SF_CAM_TrackObj(Dauntless);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Dauntless, -200, 200, -350);
  if (select = 1) then
    SF_CAM_SetFollowObj(Dauntless, -50, 200, 500);
  if (select = 2) then
    SF_CAM_SetFollowObj(Dauntless, 400, 100, 300);

  until (m_Event = EVENT_Final_Approach) do
    AI_WaitMilliSeconds(5);
  SF_CAM_TrackObj(Player);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -3, 2, 15);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, 3, 4, -15);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, -9, 2, 5);
  until(M_EVENT=EVENT_Jump_Scene) do
    AI_WaitMilliSeconds(1);
  SF_CAM_SetFollowObj(Dauntless, -300, 240, -700);
  SF_CAM_TrackObj(Dauntless);
  until(M_Event=EVENT_At_Jump) do
    AI_Waitseconds(1);
  SF_CAM_TrackNothing;
  AI_WaitSeconds(30);
end;

// Player stuff

function F_InitLanding;
begin
  SF_AutopilotDisable;
  m_Event := EVENT_Land_Player;
  until (M_Event = EVENT_Activate_Landing_Cam) do AI_WaitSeconds(1);
  AI_WaitSeconds(40);
  SF_Exit;
end;

function F_PlayerTakeoff;
begin
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x+15, y-25, z);
  SF_SetObjectFlag(OF_Collidable, false);
  AI_PLR_ControlAssume;
  AI_SetThrottle(0);
  AI_WaitSeconds(1);
  SF_ActivateSelf(0);
  AI_WaitSeconds(1);
  AI_SetThrottle(100);
  AI_WaitMilliSeconds(1500);
  M_Event := EVENT_Takeoff_Start;
  while (SF_GetDistance(Dauntless) < 500) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, 15, -20, 700);
  M_Event := EVENT_Takeoff_Complete;
  SF_SetObjectFlag(OF_Collidable, true);
  AI_PLR_ControlResume;
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
end;

function F_PlayerLanding;
begin
  while (SF_GetDistance(Dauntless) > 300) do AI_WaitMilliSeconds(1);
  AI_PLR_ControlAssume;
  AI_AttackNothing(1);
  landinginprogress:=1;
  SF_SetObjectFlag(OF_Collidable, false);
  M_Event := EVENT_Activate_Landing_Cam;
  HCL_EmptyFuel;
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Player) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z+350);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x, y-25, z+350);
  AI_SetThrottle(100);
  until (SF_GetDistance(Dauntless) < 80) do AI_WaitMilliSeconds(5);
  AI_SetThrottle(50);
  M_Event := EVENT_Final_Approach;
  SYS_PlaySFX(SFX_Engines_Power_Down);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  AI_WaitSeconds(2);
  M_Event := EVENT_Jump_Scene;
  until(M_EVENT=EVENT_At_Jump) do
    AI_WaitMilliseconds(1);
  SF_SetWorldPosition(0, 0, 0);
  AI_WaitSeconds(10);

  SF_Exit;
end;

function F_PilotLanding1;
begin
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_Collidable, false);
  HCL_EmptyFuel;
  AI_IgnoreCollisions(1);
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Gold) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless

  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z+380);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x-10, y-25, z+380);
  AI_SetThrottle(100);
  until (SF_GetDistance(Dauntless) < 100) do AI_WaitMilliSeconds(5);
  AI_SetThrottle(50);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  until(M_EVENT=EVENT_At_Jump) do
    AI_WaitMilliseconds(1);

  SF_DeactivateSelf(0);
end;

function F_PilotLanding2;
begin
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_Collidable, false);
  HCL_EmptyFuel;
  AI_IgnoreCollisions(1);
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Mage) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless

  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z+380);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x+10, y-25, z+380);
  AI_SetThrottle(100);
  until (SF_GetDistance(Dauntless) < 100) do AI_WaitMilliSeconds(5);
  AI_SetThrottle(50);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  until(M_EVENT=EVENT_At_Jump) do
    AI_WaitMilliseconds(1);

  SF_DeactivateSelf(0);
end;

function F_PilotLanding3;
begin
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_Collidable, false);
  HCL_EmptyFuel;
  AI_IgnoreCollisions(1);
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Phantom) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless

  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z+430);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x-10, y-25, z+400);
  AI_SetThrottle(100);
  until (SF_GetDistance(Dauntless) < 120) do AI_WaitMilliSeconds(5);
  AI_SetThrottle(50);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  until(M_EVENT=EVENT_At_Jump) do
    AI_WaitMilliseconds(1);

  SF_DeactivateSelf(0);
end;

function F_PilotLanding4;
begin
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_Collidable, false);
  HCL_EmptyFuel;
  AI_IgnoreCollisions(1);
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Edge) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless

  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z+430);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x+10, y-25, z+400);
  AI_SetThrottle(100);
  until (SF_GetDistance(Dauntless) < 120) do AI_WaitMilliSeconds(5);
  AI_SetThrottle(50);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  until(M_EVENT=EVENT_At_Jump) do
    AI_WaitMilliseconds(1);

  SF_DeactivateSelf(0);
end;

function F_PilotLanding5;
begin
  AI_AttackNothing(1);
  SF_SetObjectFlag(OF_Collidable, false);
  HCL_EmptyFuel;
  AI_IgnoreCollisions(1);
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(this) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless

  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z+460);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x-20, y-25, z+460);
  AI_SetThrottle(100);
  until (SF_GetDistance(Dauntless) < 140) do AI_WaitMilliSeconds(5);
  AI_SetThrottle(50);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  until(M_EVENT=EVENT_At_Jump) do
    AI_WaitMilliseconds(1);

  SF_DeactivateSelf(0);
end;

// Dauntless stuff

function F_DauntlessLanding;
begin
  until (m_Event = EVENT_Activate_Landing_Cam) do AI_WaitMilliSeconds(1);
  if (SF_GetVelocityObject(Dauntless) > 0) then
  begin
    AI_SetThrottle(0);
    until (SF_GetVelocityObject(Dauntless) < 5) do
    AI_WaitMilliSeconds(5);
  end;

  // Teleport to position relative to NavD, face NavD
  M_GetPos(JumpPoint);
  SF_SetWorldPosition(x, y, z-1000);
  AI_FaceObject(JumpPoint);
  m_Event := EVENT_Dauntless_Ready;
end;

