//******************************************************************************
//
//      Unknown Enemy
//      Mission 6 - Scramble 2
//
//      Created by Alex Barnfield  <alex@crius.net>
//                 Jakub Majewski  <qmajewski@yahoo.co.uk>
//                 Thomas Bruckner <thomas.bruckner@aon.at>
//
// Last modified: Apr 9th, 2004
//
//******************************************************************************


mission ue6;

#AddToSearchPath("$wcue$\language\");
#AddToSearchPath("$uesrc$");

#include wcp, consts, ships, uepilots, UE, comms;

#strings targetid, objectiv;

#SetRooms ("cic.rom", "rec.rom");
#gfproc: "GF_Main";
#mainproc: "MAIN";

//Note: the gfproc and mainproc properties were implemented in WCPPas r24d, but do
// not work properly (which is why nobody uses r24d ;) ). These properties (in theory)
// simply tell the game which functions to use as the main mission function and the
// main gameflow function. We all know what the main mission function is (see MAIN).
// As for the main gameflow function, this is used if you want to have any functions
// in the gameplay that are NOT implemented as part of the room file. Normally, this
// property is therefore not needed. In UE, however, we used it in missions 2B, 4 and 6
// to repeatedly play the "all pilots to your ships" sound in the gameflow.
//
// In any case, if you compile this mission in WCPPas, you will find that this will
// no longer work (24c doesn't support gfproc and mainproc, but it won't crash
// or anything like that) - the gameflow function will be missing (but the MAIN function
// will work as normal).
// In order to compile this mission with the gameflow function working, do this:
// 1. Use the compile and edit option.
// 2. When the compiled mission opens, look for the FORM "PROP" containing MAIN.
// 3. Between MAIN's FORM "PROP" and the end-bracket of the preceding FORM, add this form:
// FORM "PROP"
//      {
//        CHUNK $59F32AC2
//        {
//          cstring "GF_Main"
//        }
//      }
// 4. Now use the build option. You do not need to bother saving when the
// save dialogue opens up.


#SetOutputPath("$wcue$\mission\");

//*************Main Program**********


#sector: "t.sec";

#name: 11;

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);


var bugsalive, comm1check=0, m_Event, x, y, z, D_Dead = 0;

const
  EVENT_Takeoff_Start = 4,
  EVENT_Takeoff_Complete = 5,
  EVENT_Land_Player = 6,
  EVENT_Activate_Landing_Cam = 7,
  EVENT_Dauntless_Ready = 8,
  EVENT_Final_Approach = 9;


objective mobj_Defend
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Defend the Dauntless"];
  status: MOBJ_Incomplete;
  counter: false;
end;


object Player(Player)
  obj: scim;
  x: 0;
  y: -50;
  z: 1600;
  main: M_Player;
  pilot: PILOT_Casey1;
end;


object Dauntless(Capship) as "BWS Dauntless"
  obj: UE_SHIP_Dauntless;
  x: 0;
  y: 0;
  z: 0;
  main: M_Dauntless;
  pilot: PILOT_Dauntless;
  death: M_Carrierlost;
  targstr: targetid["Dauntless"];
end;


object NavD(navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_DNav;
  navdata: 1, 5000;
end;


object Gold(ship)
  obj: scim;
  x: 0;
  y: 400;
  z: 0;
  main: M_Wingmen;
  targstr: 1;
  pilot: PILOT_Gold;
end;


object Mage(ship)
  obj: scim;
  x: -100;
  y: 400;
  z: 0;
  main: M_Wingmen;
  targstr: 1;
  pilot: PILOT_Mage;
end;


object Faris(ship)
  obj: epee;
  x: 500;
  y: 0;
  z: 0;
  main: M_EpeeLead;
  targstr: 1;
  pilot: PILOT_Faris;
end;


object Phantom(ship)
  obj: epee;
  x: 500;
  y: 50;
  z: 0;
  main: M_Epee;
  targstr: 1;
  pilot: PILOT_Phantom;
end;


object Gryphon(ship)
  obj: epee;
  x: 500;
  y: -50;
  z: 0;
  main: M_Epee;
  targstr: 1;
  pilot: PILOT_Gryphon;
end;


object SkateT1(cluster)
  obj: trirayt;
  x: 800;
  y: 200;
  z: 0;
  main: M_Skate;
  pilot: 117;
  EVENT_1: M_BugCount;
  EVENT_0: M_Child;
end;


object SkateT2(cluster)
  obj: trirayt;
  x: 800;
  y: 200;
  z: 100;
  main: M_Skate;
  pilot: 117;
  EVENT_1: M_BugCount;
  EVENT_0: M_Child;
end;

object SkateT3(cluster)
  obj: trirayt;
  x: -800;
  y: 200;
  z: 0;
  main: M_Skate;
  pilot: 117;
  EVENT_1: M_BugCount;
  EVENT_0: M_Child;
end;


object SkateT4(cluster)
  obj: trirayt;
  x: -800;
  y: 200;
  z: 100;
  main: M_Skate;
  pilot: 117;
  EVENT_1: M_BugCount;
  EVENT_0: M_Child;
end;


object SkateB1(cluster)
  obj: trirayb;
  x: 800;
  y: 200;
  z: 100;
  main: M_Skate;
  pilot: 117;
  EVENT_1: M_BugCount;
  EVENT_0: M_Child;
end;


object SkateB2(cluster)
  obj: trirayb;
  x: 800;
  y: 100;
  z: 100;
  main: M_Skate;
  pilot: 117;
  EVENT_1: M_BugCount;
  EVENT_0: M_Child;
end;


object SkateB3(cluster)
  obj: trirayb;
  x: 800;
  y: 0;
  z: 100;
  main: M_Skate;
  pilot: 117;
  EVENT_1: M_BugCount;
  EVENT_0: M_Child;
end;


object SkateB4(cluster)
  obj: trirayb;
  x: 800;
  y: 100;
  z: 0;
  main: M_Skate;
  pilot: 117;
  EVENT_1: M_BugCount;
  EVENT_0: M_Child;
end;


object SkateB5(cluster)
  obj: trirayb;
  x: 800;
  y: 100;
  z: 200;
  main: M_Skate;
  pilot: 117;
  EVENT_1: M_BugCount;
  EVENT_0: M_Child;
end;


function F_InitLanding; forward;
function F_PlayerTakeoff; forward;
function F_PlayerLanding; forward;
function F_DauntlessLanding; forward;

function MAIN;
begin
 MS_RunGameflow(0);
 MS_RunSpaceFlight(0);
 MS_RunDebriefing;
end;

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

function M_Player;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_SetBaseShip(Dauntless);
  SF_ActivateSelf(0);
  SF_SubHitPoints(30);
  F_PlayerTakeoff;
  while (1) do begin
    if (m_Event = EVENT_Land_Player) then begin
      F_PlayerLanding;
    end;
    AI_WaitSeconds(1);
  end;
end;

function M_Dauntless;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  SF_SetPilotImmortal(PILOT_Gold, 1);
  SF_SetPilotImmortal(PILOT_Mage, 1);
  SF_SetPilotImmortal(PILOT_Faris, 1);
  SF_SetPilotImmortal(PILOT_Phantom, 1);
  SF_SetPilotImmortal(PILOT_Gryphon, 1);
  until (comm1check=1) do
    AI_Waitseconds(1);

  AI_SendSpecialComm(26, 0);
  comm1check:=0;

  while(1) do begin
    AI_WaitMilliSeconds(1);
    if (m_Event = EVENT_Activate_Landing_Cam) then begin
      SF_SaveObjectState(false);
      F_DauntlessLanding;
    end;
  end;
end;

function M_Wingmen;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  AI_Waitseconds(1);
  SF_SubHitPoints(30);
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_AddToWing(Player);

  while(1) do begin
    if (m_Event = EVENT_Land_Player) then begin
      AI_RemoveFromWing;
      AI_IgnoreCollisions(1);
      AI_AttackNothing(1);
      AI_SetThrottle(0);
    end;
    AI_WaitMilliseconds(100);
  end;
end;

function M_EpeeLead;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  while(1) do begin
    AI_Waitseconds(1);
  end;
end;

function M_Epee;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_ActivateSelf(0);
  AI_Waitseconds(1);
  AI_AddToWing(Faris);
  while(1) do begin
    AI_Waitseconds(1);
  end;
end;

function M_Skate;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Alien);
  while(1) do begin
    AI_Waitseconds(1);
  end;
end;

function M_Child;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Alien);
  while(1) do begin
    AI_Waitseconds(1);
  end;
end;

function M_Bug;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Alien);
  SF_ActivateSelf(0);
  while(1) do begin
    AI_Waitseconds(1);
  end;
end;

function M_DAttack;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Alien);
  SF_ActivateSelf(0);
  AI_Waitseconds(1);
  AI_AddToAttackList(Dauntless, 1);
  while(1) do begin
    AI_Waitseconds(1);
  end;
end;

function M_BugCount;
begin
 bugsalive:=bugsalive-1;
end;

function M_DNav;
begin
  Nav_ActivateSelf;
  NAV_SetEjectSequence(ES_alien_pickup_MIA);
  AI_Waitseconds(1);
  bugsalive:=12;
  NAV_Createship(2, 108, 0, @M_Bug, @M_BugCount, 1000, 100, 0);
  NAV_Createship(2, 109, 0, @M_Bug, @M_BugCount, 1000, 0, 0);
  NAV_Createship(2, 110, 0, @M_Bug, @M_BugCount, 1000, -100, 0);
  NAV_Createship(2, 112, 0, @M_Bug, @M_BugCount, 1000, 0, 100);
  NAV_Createship(2, 113, 0, @M_Bug, @M_BugCount, 1000, 0, -100);
  NAV_Createship(2, 114, 0, @M_Bug, @M_BugCount, 900, 0, 0);
//  SF_ActivateObject(SkateT1, 0);   Crashes on death
//  SF_ActivateObject(SkateT2, 0);    you can use SF_GetActiveStatus with your skates to determine if they are still alive
  NAV_Createship(2, 108, 0, @M_Bug, @M_BugCount, -1000, 100, 0);
  NAV_Createship(2, 109, 0, @M_Bug, @M_BugCount, -1000, 0, 0);
  NAV_Createship(2, 110, 0, @M_Bug, @M_BugCount, -1000, -100, 0);
  NAV_Createship(2, 112, 0, @M_Bug, @M_BugCount, -1000, 0, 100);
  NAV_Createship(2, 113, 0, @M_Bug, @M_BugCount, -1000, 0, -100);
  NAV_Createship(2, 114, 0, @M_Bug, @M_BugCount, -900, 0, 0);
//  SF_ActivateObject(SkateT3, 0);   Crashes on death
//  SF_ActivateObject(SkateT4, 0);    you can use SF_GetActiveStatus with your skates to determine if they are still alive



  until (bugsalive=0) do
    AI_WaitSeconds(1);

  bugsalive:=11;
//  Nav_Createship(3, 117, 0, @M_Bug, @M_Bugcount, 700, 100, 3500);
//  Nav_Createship(3, 107, 0, @M_Bug, @M_Bugcount, 700, 0, 3500);
  Nav_Createship(3, 108, 0, @M_Bug, @M_Bugcount, 700, -100, 4000);
  Nav_Createship(3, 117, 0, @M_Bug, @M_Bugcount, 800, 100, 4000);
  Nav_Createship(3, 107, 0, @M_Bug, @M_Bugcount, 700, 0, 4000);
  Nav_Createship(3, 108, 0, @M_Bug, @M_Bugcount, 700, -100, 4000);
  Nav_Createship(30, 113, 0, @M_Dattack, @M_Bugcount, 700, -100, 4500);
  Nav_Createship(30, 114, 0, @M_Dattack, @M_Bugcount, 800, 100, 4500);
  Nav_Createship(30, 115, 0, @M_Dattack, @M_Bugcount, 700, 0, 4500);
  Nav_Createship(30, 116, 0, @M_Dattack, @M_Bugcount, 700, -100, 4500);
  Nav_Createship(8, 117, 0, @M_Dattack, @M_Bugcount, 500, 300, 4000);
  Nav_Createship(8, 107, 0, @M_Dattack, @M_Bugcount, 500, -300, 4000);
  Nav_Createship(35, 107, 0, @M_Dattack, @M_Bugcount, 500, 0, 4000);

  AI_Waitseconds(20);

  bugsalive:=bugsalive+3;
  Nav_Createship(35, 107, 0, @M_Dattack, @M_Bugcount, 500, 0, -2500);
  Nav_Createship(30, 115, 0, @M_Dattack, @M_Bugcount, 700, 0, -4000);
  Nav_Createship(30, 116, 0, @M_Dattack, @M_Bugcount, 700, -100, -4000);

  until (bugsalive=0) do
    AI_WaitSeconds(1);

  bugsalive:=8;
  NAV_Createship(2, 108, 0, @M_Bug, @M_BugCount, 1000, 100, 4500);
  NAV_Createship(2, 109, 0, @M_Bug, @M_BugCount, 1000, 0, 4500);
  NAV_Createship(2, 110, 0, @M_Bug, @M_BugCount, 1000, -100, 4500);
  NAV_Createship(2, 112, 0, @M_Bug, @M_BugCount, 1000, 100, 4000);
  NAV_Createship(2, 113, 0, @M_Bug, @M_BugCount, 1000, 200, 4000);
  NAV_Createship(2, 114, 0, @M_Bug, @M_BugCount, 900, 300, 4500);
  NAV_Createship(2, 113, 0, @M_Bug, @M_BugCount, 1000, 400, 4500);
  NAV_Createship(2, 114, 0, @M_Bug, @M_BugCount, 900, 500, 4000);
//  SF_ActivateObject(SkateB1, 0);
//  SF_ActivateObject(SkateB2, 0);
//  SF_ActivateObject(SkateB3, 0);
//  SF_ActivateObject(SkateB4, 0);
//  SF_ActivateObject(SkateB5, 0);

  until (bugsalive=0) do
    AI_WaitSeconds(1);

  NAV_SetEjectSequence(ES_SAR_pickup);
  SF_ObjectiveSetComplete(mobj_defend);
  SF_Setmissionsuccess;
  AI_Waitseconds(2);
  comm1check:=1;
  AI_Waitseconds(4);
  F_InitLanding;
  while (1) do AI_WaitSeconds(1);
end;

function M_Carrierlost;
begin
  D_Dead := 1;
end;

// **************** Takeoff/Landing routines **************
// ********************************************************
// Camera stuff

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

function F_Takeoff(select); forward;
function F_Landing(select); forward;

function M_Camera;
begin
  while(1) do
  begin
    if (m_Event = EVENT_Takeoff_Start) then
      F_Takeoff(SYS_Random(3));
    if (m_Event = EVENT_Activate_Landing_Cam) then
      F_Landing(SYS_Random(3));
    AI_WaitMilliSeconds(15);
  end;
end;

function F_Takeoff(select);
begin
  SF_CAM_TrackObj(Player);

  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -30, 35, -40);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, -10, 35, 80);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, 0, 5, 40);

  SF_ActivateSelf(0);
  until (m_Event = EVENT_Takeoff_Complete) do
    AI_WaitSeconds(1);
  SF_CAM_TrackNothing;
  SF_DeactivateSelf(0);
end;

function F_Landing(select);
begin
  SF_CAM_HideDust;
  SF_CAM_TrackObj(NavD);
  SF_CAM_SetFollowObj(NavD, 0, 1, 0);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(1);
  SF_CAM_TrackObj(Dauntless);

  if (select = 0) then
    SF_CAM_SetFollowObj(Dauntless, -200, 200, -350);
  if (select = 1) then
    SF_CAM_SetFollowObj(Dauntless, -50, 200, 500);
  if (select = 2) then
    SF_CAM_SetFollowObj(Dauntless, 400, 100, 300);

  until (m_Event = EVENT_Final_Approach) do
    AI_WaitMilliSeconds(5);
  SF_CAM_TrackObj(Player);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -3, 2, 15);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, 3, 4, -15);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, -9, 2, 5);

  AI_WaitSeconds(30);
end;

// Player stuff

function F_InitLanding;
begin
  SF_AutopilotDisable;
  m_Event := EVENT_Land_Player;
  until (M_Event = EVENT_Activate_Landing_Cam) do AI_WaitSeconds(1);
  AI_WaitSeconds(30);
  SF_Exit;
end;

function F_PlayerTakeoff;
begin
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x+15, y-25, z);
  SF_SetObjectFlag(OF_Collidable, false);
  AI_PLR_ControlAssume;
  AI_SetThrottle(0);
  AI_WaitSeconds(1);
  SF_ActivateSelf(0);
  AI_WaitSeconds(1);
  AI_SetThrottle(100);
  AI_WaitMilliSeconds(1500);
  M_Event := EVENT_Takeoff_Start;
  while (SF_GetDistance(Dauntless) < 500) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, 15, -20, 700);
  M_Event := EVENT_Takeoff_Complete;
  SF_SetObjectFlag(OF_Collidable, true);
  AI_PLR_ControlResume;
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
end;

function F_PlayerLanding;
begin
  while (SF_GetDistance(Dauntless) > 300) do AI_WaitMilliSeconds(1);
  AI_PLR_ControlAssume;
  SF_SetObjectFlag(OF_Collidable, false);
  M_Event := EVENT_Activate_Landing_Cam;
  HCL_EmptyFuel;
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Player) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z-350);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x, y-25, z-350);
  AI_SetThrottle(50);
  until (SF_GetDistance(Dauntless) < 50) do AI_WaitMilliSeconds(5);
  M_Event := EVENT_Final_Approach;
  SYS_PlaySFX(SFX_Engines_Power_Down);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  AI_WaitSeconds(5);
  SF_Exit;
end;

// Dauntless stuff

function F_DauntlessLanding;
begin
  if (SF_GetVelocityObject(Dauntless) > 0) then
  begin
    AI_SetThrottle(0);
    AI_WaitSeconds(5);
  end;

  // Teleport to position relative to NavD, face NavD
  M_GetPos(NavD);
  SF_SetWorldPosition(x, y, z+1000);
  AI_FaceObject(NavD);
  m_Event := EVENT_Dauntless_Ready;
  AI_WaitSeconds(25);
  SF_Exit;
end;

function GF_Main;
begin
  SYS_TimerSet(5);
  while (1) do begin
    if (SYS_TimerGet = 0) then begin
      SYS_PlaySFX(UE_SFX_Scramble);
      SYS_TimerSet(20);
    end;
    GF_Exit;
  end;
end;
