//******************************************************************************
//
// Unknown Enemy
// Mission 7a
//
// Created by:
//               Alex Barnfield  <alex@crius.net>
// Modified by:  Jakub Majewski <qmajewski@yahoo.co.uk>
//
//
// Last modified: Apr 9th, 2004
//
//******************************************************************************

mission ue7a;

#Addtosearchpath("$uesrc$");

#SetOutputPath("$wcue$\language\pilots\");
#file "strings\pilots\srs27.pas";

#SetOutputPath("$wcue$\comms\");
#file "comms\srs27.pas";



// 0 = "We're launching supply and crew shuttles."

// 1 = "You're cleared to land, sir... oh, wait a minute. We've got a massive
// electronic signature on our radar.

// 2 = "Sir, if this reading's correct, then this thing is five, six kilometres
// long! Captain Graham wants you to fly over there and get a visual ID of this thing."

// 3 = "We're uploading the coordinates to you now.

// 4 = "Your course has been plotted through NAV 1 again, so that the Nephilem
// can't trace your vector directly back to the Dauntless."

// 5 = "Dauntless, there's no capships here... just a weird looking buoy!"

// 6 = "Sir, something's wrong! My controls aren't working!"

// 7 = "Aaahhh!"

// 8 = "Report Colonel, we lost contact what happened?"

// 9 = "Dauntless, one of those buoys was a jamming device, it disrupted all
// ships systems and we were ambushed by a wing of morays and mantas."

// 10 = "We managed to take out the fighters and the buoy, but not before
// we lost Gryphon"

// 11 = "There was nothing you could do Colonel. We'll have the techs look
// over your data, perhaps they can come up with a defence against the jamming"

// 12 = "Your course has been set through Nav 1 again"

// 13 = "Good work, sir. That signal had us worried... anyway, you're cleared
// for immediate landing."

// 14 = "Good Work Colonel, the shuttles are docked, we're heading for Nav 2."

// 15 = "Damn we need all of the supplies we can get. We're heading for Nav 2, stay alert pilot!"

// 16 = "The first shuttle has docked, hold off the enemy, theres still four more to go."

// 17 = "Thats the third shuttle, two more to go."

//*****************Main Program****************

#sector: "t.sec";
#SetRooms ("cic.rom", "rec.rom");

#name: 13;

#AddToSearchPath("$wcue$\language\");

#include wcp, consts, uepilots, comms, ue;

#strings targetid, objectiv, spacefli;

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);

#SetOutputPath("$wcue$\mission\");

const
  EVENT_Takeoff_Start = 4,
  EVENT_Takeoff_Complete = 5,
  EVENT_Land_Player = 6,
  EVENT_Activate_Landing_Cam = 7,
  EVENT_Dauntless_Ready = 8,
  EVENT_Final_Approach = 9;

external
  g_Fralthi_Dead, g_UE_7_Won;

var
  m_Event,
  x,
  y,
  z,
  reachedbeaufort=0,
  reachednav2,
  reachednav3,
  passednav1=0,
  investigate=0,
  buoyactive=0,
  buoydestroyed=0,
  gryphondead=0,
  EVENT_GCam_Activated=0,
  EVENT_PCam_Activated=0,
  xrand,
  yrand,
  zrand,
  atbeaufort=0,
  bugkills=0,
  missioncomplete=0,
  playonce=0,
  shuttlecount=0,
  dockingcomplete=0,
  nav1checks=0,
  bugcount,
  deadshuttle=0,
  m_Nav;


objective mobj_escort
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Escort Dauntless into the asteroid belt"];
  status: MOBJ_Incomplete;
  counter: false;
end;

objective mobj_meet_ZuBaka
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Rendezvous with Fralthi and escort it into the asteroid belt"];
  status: MOBJ_Incomplete;
  counter: false;
end;

objective mobj_protect_beaufort
  hidden: false;
  type: MOBJ_Secondary;
  text: objectiv["Protect Beaufort Station"];
  status: MOBJ_Incomplete;
  counter: false;
end;

objective mobj_protect_shuttles   //this should have a counter, each shuttle, 20%
  hidden: false;
  type: MOBJ_Secondary;
  text: objectiv["Protect shuttles during transfer of supplies"];
  status: MOBJ_Incomplete;
  counter: true;
end;

objective mobj_investigate
  hidden: true;
  type: MOBJ_Secondary;
  text: objectiv["Investigate electronic signature"];
  status: MOBJ_Incomplete;
  counter: false;
end;

//SF_ObjectiveEnable(mobj_investigate); to enable later

objective mobj_destroy_buoy
  hidden: true;
  type: MOBJ_Bonus;
  text: objectiv["Destroy Nephilim buoy"];
  status: MOBJ_Incomplete;
  counter: false;
end;




object Dauntless(capship) as "BWS Dauntless"
  obj: UE_SHIP_Dauntless;
  x: -5000;
  y: 0;
  z: 1000;
  main: M_Dauntless;
  brief: B_Dauntless;
  death: D_Dauntless;
  color: 0, 0.35, 0.35, 1;
  direction: 0, 0, 0;
  pilot: PILOT_Dauntless;
end;


object Player(Player)
  obj: Scim;
  x: 0;
  y: 0;
  z: 0;
  main: M_Player;
  brief: B_Player;
  color: 0, 0.8, 0.8, 0;
  pilot: PILOT_Casey1;
end;

object Edge(Ship)
  obj: scim;
  x: -5100;
  y: 0;
  z: 2000;
  main: M_Edge;
  brief: B_Edge;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Edge;
end;

object Gryphon(Ship)
  obj: scim;
  x: -4900;
  y: 0;
  z: 2000;
  main: M_Gryphon;
  brief: B_Gryphon;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Gryphon;
end;

object Fakebuoy1(ship)
  obj: al_turr;
  x: 50000;
  y: 5000;
  z: 7400;
  main: M_FakeBuoy;
  death: D_FakeBuoy;
  targstr: 2;
  pilot: PILOT_Alien1;
end;

object Fakebuoy2(ship)
  obj: al_turr;
  x: 50200;
  y: 5100;
  z: 7500;
  main: M_FakeBuoy;
  death: D_FakeBuoy;
  targstr: 2;
  pilot: PILOT_Alien1;
end;

object Fakebuoy3(ship)
  obj: al_turr;
  x: 49900;
  y: 4950;
  z: 7700;
  main: M_FakeBuoy;
  death: D_FakeBuoy;
  targstr: 2;
  pilot: PILOT_Alien1;
end;

object Fakebuoy4(ship)
  obj: al_turr;
  x: 49700;
  y: 4800;
  z: 7500;
  main: M_FakeBuoy;
  death: D_FakeBuoy;
  targstr: 2;
  pilot: PILOT_Alien1;
end;

object Fakebuoy5(ship)
  obj: al_turr;
  x: 49800;
  y: 4900;
  z: 7500;
  main: M_FakeBuoy;
  death: D_FakeBuoy;
  targstr: 2;
  pilot: PILOT_Alien1;
end;


function MAIN;
begin
  MS_RunGameflow(0);
  MS_RunBriefing;
  MS_ShipSelector(UE_SELECTOR_Scimitar, UE_SELECTOR_Epee);
  MS_RunSpaceflight(0);
  MS_SetPilotDead(PILOT_Gryphon, 1);
  MS_RunDebriefing;
end;

function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;


function F_InitLanding; forward;
function F_PlayerTakeoff; forward;
function F_PlayerLanding; forward;
function F_DauntlessLanding; forward;

function D_Dauntless;
begin
  //SF_ExitEndGame(2);
end;


//**********************Dauntless Nav****************************

object NavD(Navpoint)
  x: 0;
  y: 0;
  z: 0;
  main: M_DNav;
  brief: B_DNav;
  color: 0, 1, 1, 1;
  name: spacefli["Dauntless Nav"];
  navdata: 1, 20000;
end;


object Faris(Ship)
  obj: scim;
  x: -5100;
  y: 1000;
  z: 1000;
  main: M_Faris;
//  brief: B_Faris;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Faris;
end;

object Mage(Ship)
  obj: scim;
  x: -4900;
  y: 1000;
  z: 1000;
  main: M_Mage;
//  brief: B_Mage;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Mage;
end;

object Phantom(Ship)
  obj: scim;
  x: -5000;
  y: 1000;
  z: 1000;
  main: M_Phantom;
//  brief: B_Phantom;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Phantom;
end;


function M_DNav;
var
  setup = true;

begin
  m_Nav := 1;
  NAV_SetEjectSequence(ES_alien_pickup_MIA);

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      NAV_SetPlayerNav(2);

      if (setup) then begin
        NAV_HideNav(3);
        NAV_HideNav(4);
        NAV_HideNav(5);
        setup := false;
      end;

    end
    else
      NAV_DeactivateSelf;
  end;
end;

function M_Player;

var missilerand;

begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_SetBaseShip(Dauntless);
  SF_ActivateSelf(0);
  F_PlayerTakeoff;

  while (1) do begin

    if (m_Event = EVENT_Land_Player) then begin
      F_PlayerLanding;
    end;
    if (reachednav3=1) then begin
     SF_AutopilotDisable;
//     AI_Waitseconds(1);
     reachednav3:=2;
     //AI_Waitseconds(7);
     until (EVENT_GCam_Activated=1) do AI_WaitMilliseconds(1);
     AI_PLR_ControlAssume;
     SF_SetWorldPosition(50000, 5000, 6800);
     AI_SetThrottle(0);
     until(EVENT_GCam_Activated=0) do
       AI_WaitSeconds(1);
     AI_PLR_ControlResume;
     SF_PlayerSwitchToCam(CamID_cockpit, Player);
    end;
    if (EVENT_PCam_Activated=1) then begin
      AI_PLR_ControlAssume;
      SF_SetWorldPosition(50000, 5200, 6800);
      SF_PlayerSwitchToCam(CamId_death, Player);
      AI_SetThrottle(100);
      AI_Waitseconds(3);
      AI_SendSpecialCommFrom(27, 8, PILOT_Dauntless);
      AI_SendSpecialComm(27, 9);
      AI_SendSpecialComm(27, 10);
      AI_SendSpecialCommFrom(27, 11, PILOT_Dauntless);
      AI_SendSpecialCommFrom(27, 12, PILOT_Dauntless);
      AI_Waitseconds(28);
      until(EVENT_PCam_Activated=0) do
        AI_WaitMilliseconds(1);
      AI_PLR_ControlResume;
      SF_PlayerSwitchToCam(CamID_cockpit, Player);
      missioncomplete:=1;
    end;
    while(buoyactive=1) do begin
      AI_Waitmilliseconds(500);
      AI_PLR_Unlocktarget;
      AI_Waitmilliseconds(500);
      AI_PLR_Unlocktarget;
      AI_Waitmilliseconds(500);
      AI_PLR_Unlocktarget;
      AI_Waitmilliseconds(500);
      AI_PLR_Unlocktarget;
      AI_Waitmilliseconds(500);
      AI_PLR_Unlocktarget;
      AI_Waitmilliseconds(500);
      AI_PLR_Unlocktarget;
      AI_Waitmilliseconds(500);
      AI_PLR_Unlocktarget;
      AI_Waitmilliseconds(500);
      AI_PLR_Unlocktarget;
      if(buoyactive=1) then begin
        AI_Waitmilliseconds(500);
        AI_PLR_Unlocktarget;
        SYS_PlaySFX(243);
        AI_PLR_ControlAssume;

        AI_Waitmilliseconds(1100);
        AI_PLR_ControlResume;
        AI_PLR_Unlocktarget;
        missilerand:= SYS_Random(20);
        if(missilerand=5) then
          AI_FireMissile(7);
        if(missilerand=15) then
          AI_FireMissile(4);
      end;
    end;
  AI_Waitseconds(1);
  end;
end;


function M_Dauntless;
begin
  SF_SetPilotImmortal(PILOT_Edge, 1);
  SF_SetPilotImmortal(PILOT_Mage, 1);
  SF_SetPilotImmortal(PILOT_Faris, 1);
  SF_SetPilotImmortal(PILOT_Gryphon, 0);
  SF_SetPilotImmortal(PILOT_Phantom, 1);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(0);
  SF_Activateself(0);
  AI_SetAutopilotData(-350, 0, 100);

  until (reachednav2) do begin
    AI_Waitseconds(1);
    if(dockingcomplete = 1) then begin
      if (g_Fralthi_Dead = true) then
        AI_SendSpecialComm(27, 18)
      else
        AI_SendSpecialComm(27, 14);
      dockingcomplete:=0;
    end;
    if(dockingcomplete = 2) then begin
      AI_SendSpecialComm(27, 15);
      dockingcomplete:=0;
    end;
    if((shuttlecount=1) and (deadshuttle = 0)) then begin
      AI_SendSpecialComm(27, 16);
      until(shuttlecount=2) do
        AI_Waitseconds(1);
    end;
    if((shuttlecount=3) and (deadshuttle = 0)) then begin
      AI_SendSpecialComm(27, 17);
      until(shuttlecount=4) do
        AI_Waitseconds(1);
    end;
  end;
  SF_AutopilotDisable;
  SF_BindToActionSphere(4);
  AI_SetAutopilotData(0, 0, 0);
  AI_SendSpecialComm(27, 1);
  AI_Waitseconds(5);
  AI_SendSpecialComm(27, 2);
  AI_Waitseconds(5);
  AI_SendSpecialComm(27, 3);
  AI_Waitseconds(4);
  AI_SendSpecialComm(27, 4);
  SF_AutopilotResumeNormal;
  investigate:=1;
  SF_ObjectiveSetComplete(mobj_escort);
  if (g_Fralthi_Dead = false) then SF_ObjectiveSetComplete(mobj_meet_ZuBaka);
  SF_ObjectiveEnable(mobj_investigate);
  while(1) do begin
    if(playonce) then begin
      SF_Setmissionsuccess;
      AI_Waitseconds(3);
      AI_SendSpecialComm(27, 13);
      if (g_Fralthi_Dead = 0) then g_UE_7_Won := 1;
      playonce:=0;
    end;
    if (m_Event = EVENT_Activate_Landing_Cam) then begin
      SF_SaveObjectState(false);
      F_DauntlessLanding;
    end;
    AI_WaitMilliseconds(1);
  end;
end;


function M_Edge;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_Activateself(0);
  AI_SetAutopilotData(-40, -10, 0);
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_AddToWing(Player);
  until(reachednav3 = 3) do
    AI_WaitMilliseconds(1);
  AI_ReplenishMissilesAndFuel;
  AI_RemoveFromWing;
  AI_Mutecomms;
  until(buoydestroyed) do
    AI_Waitseconds(1);
  AI_AddToWing(Player);
  AI_ResumeComms;
  while(1) do begin
    if (m_Event = EVENT_Land_Player) then begin
      AI_RemoveFromWing;
      AI_IgnoreCollisions(1);
      AI_AttackNothing(1);
      AI_SetThrottle(0);
    end;
    AI_WaitMilliseconds(1);
  end;
end;

function M_Gryphon;
begin
  SF_SetObjectFlag(OF_Vulnerable, false);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_Activateself(0);
  AI_SetAutopilotData(40, -10, 0);
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_AddToWing(Player);

  while(1) do begin
    AI_Waitseconds(1);
    if (reachednav3=2) then begin
     AI_WaitSeconds(1);
     AI_SendSpecialComm(27, 5);
     AI_MuteComms;
     AI_Waitseconds(5);
     AI_ResumeComms;
     AI_SendSpecialComm(27, 6);
     AI_MuteComms;
     SF_SetObjectFlag(OF_Vulnerable, true);
     AI_IgnoreCollisions(1);
     AI_Waitseconds(4);
     reachednav3:=3;
     AI_RemoveFromWing;
     SF_SetWorldPosition(50000, 5100, 7100);
     while (SF_GetDistance(fakebuoy1) > 160) do
       HCL_AI_GotoObjRelWorld_nonblock(fakebuoy1, 0, 0, 0);
//     AI_GotoObjRange(fakebuoy1, 20);
     AI_ResumeComms;
     AI_SendSpecialComm(27, 7);
     AI_MuteComms;
     AI_WaitSeconds(2);
     SF_SetObjectFlag(OF_Alignment, ALIGN_Alien);
     SF_DestroySelf;
     gryphondead:=1;
    end;
  end;
end;

function M_Faris;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_Activateself(0);
  AI_SetAutopilotData(0, -30, -100);

  until (reachednav2) do
   AI_Waitseconds(1);

   SF_BindToActionSphere(4);
   AI_SetAutopilotData(0, 0, 0);

  while(1) do
    AI_Waitseconds(1);
end;


function M_Mage;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_Activateself(0);
  AI_SetAutopilotData(-40, -30, -100);
  AI_AddToWing(Faris);

  until (reachednav2) do
   AI_Waitseconds(1);

   SF_BindToActionSphere(4);
   AI_SetAutopilotData(0, 0, 0);

  while(1) do
    AI_Waitseconds(1);
end;


function M_Phantom;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_Activateself(0);
  AI_SetAutopilotData(40, -30, -100);
  AI_AddToWing(Phantom);

  until (reachednav2) do
   AI_Waitseconds(1);

   SF_BindToActionSphere(4);
   AI_SetAutopilotData(0, 0, 0);

  while(1) do
    AI_Waitseconds(1);
end;

//************************Beaufort Nav***************************



object Beaufort_Nav(Navpoint)
  x: 20000;
  y: 0;
  z: 60000;
  main: M_BNav;
  brief: B_BNav;
  color: 0, 0.35, 0.35, 1;
  name: spacefli["Beaufort Nav"];
  navdata: 2, 20000;
end;


object Beaufort(capship) as "Beaufort Station"
  obj: UE_SHIP_Beaufort;
  x: 19900;
  y: 100;
  z: 64400;
  main: M_Beaufort;
//  brief: B_Beaufort;
  pilot: PILOT_Beaufort;
  color: 0, 0.35, 0.35, 1;
  direction: 0, 0, 0;
  actionsphere: 2;
end;

object Shuttle1(ship)
  obj: UE_SHIP_Shuttle;
  x: 19920;
  y: 83;
  z: 64260;
  main: M_Shuttle;
  death: D_Shuttle;
  targstr: 162;
  direction: 180, 0, 0;
  pilot: Pilot_SAR1;
end;

object Shuttle2(ship)
  obj: UE_SHIP_Shuttle;
  x: 19920;
  y: 83;
  z: 64260;
  main: M_Shuttle;
  death: D_Shuttle;
  targstr: 163;
  direction: 180, 0, 0;
  pilot: Pilot_SAR1;
end;

object Shuttle3(ship)
  obj: UE_SHIP_Shuttle;
  x: 19920;
  y: 83;
  z: 64260;
  main: M_Shuttle;
  death: D_Shuttle;
  targstr:164;
  direction: 180, 0, 0;
  pilot: Pilot_SAR1;
end;

object Shuttle4(ship)
  obj: UE_SHIP_Shuttle;
  x: 19920;
  y: 83;
  z: 64260;
  main: M_Shuttle;
  death: D_Shuttle;
  targstr: 165;
  direction: 180, 0, 0;
  pilot: Pilot_SAR1;
end;

object Shuttle5(ship)
  obj: UE_SHIP_Shuttle;
  x: 19910;
  y: 80;
  z: 64260;
  main: M_Shuttle;
  death: D_Shuttle;
  targstr: 166;
  direction: 180, 0, 0;
  pilot: Pilot_SAR1;
end;

object Arrow1(ship)
  obj: Ferret;
  x: 19750;
  y: 100;
  z: 61100;
  main: M_Arrow;
  pilot: Pilot_Confed;
end;


object Arrow2(ship)
  obj: Ferret;
  x: 19700;
  y: 100;
  z: 61100;
  main: M_Arrow;
  pilot: Pilot_Confed;
end;


object Dralthi1(ship)
  obj: dralthi;
  x: 20100;
  y: 200;
  z: 61200;
  main: M_Dralthi1;
  pilot: 85;
//  brief: B_Dralthi1;
  color: 0, 0, 0, 1;
end;


object Dralthi2(ship)
  obj: dralthi;
  x: 20150;
  y: 200;
  z: 61200;
  main: M_Dralthi2;
  pilot: 86;
//  brief: B_Dralthi2;
  color: 0, 0, 0, 1;
end;


object ZuBaka(capship) as "HRS Zu'Baka"
  obj: Fralthi;
  x: 20400;
  y: 200;
  z: 61400;
  main: M_ZuBaka;
  death: D_ZuBaka;
  pilot: PILOT_Fralthi;
  brief: B_ZuBaka;
  color: 0, 0, 0, 1;
end;

function D_ZuBaka;
begin
  g_Fralthi_Dead := 1;
  SF_BindToActionSphere(m_Nav);
  AI_SetAutopilotData(0, 0, 0);
end;

function M_BNav;
var
  setup = true;
begin

  while (1) do begin

    if(NAV_WithinSphere(Player)) then begin
      m_Nav := 2;
      NAV_ActivateSelf;
//      NAV_SetPlayerNav(3);
      NAV_SetEjectSequence(ES_alien_pickup_MIA);
      reachedbeaufort:=1;

      if (setup) then begin
        SF_AutopilotDisable;
        SF_ActivateObject(Beaufort, 0);
        SF_ActivateObject(Arrow1, 0);
        SF_ActivateObject(Arrow2, 0);
        SF_ActivateObject(Dralthi1, 0);
        SF_ActivateObject(Dralthi2, 0);
        SF_ActivateObject(ZuBaka, 0);
        NAV_HideNav(1);
        NAV_ShowNav(3);
        NAV_SetPlayerNav(3);
        SF_ObjectiveSetTotal(mobj_protect_shuttles, 5);
        SF_ObjectiveSetTotalNeededForSuccess(mobj_protect_shuttles, 5);

        AI_Waitseconds(5);
        SF_ActivateObject(Shuttle1, 0);
        AI_Waitseconds(10);
        Nav_CreateShip(2, PILOT_Alien1, 0, @M_Bug, @D_Bug, 19950, 1100, 61500);
        Nav_CreateShip(2, PILOT_Alien2, 0, @M_Bug, @D_Bug, 19950, 1100, 61550);
        Nav_CreateShip(2, PILOT_Alien3, 0, @M_Bug, @D_Bug, 19900, 1100, 61550);
        Nav_CreateShip(2, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, 19950, 1100, 61600);
        Nav_CreateShip(2, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, 19950, 1100, 61650);
        Nav_CreateShip(30, PILOT_Alien4, 0, @M_Bug, @D_Bug, 19900, 1100, 61500);
        Nav_CreateShip(30, PILOT_Alien4, 0, @M_Bug, @D_Bug, 19900, 1100, 61450);
        Nav_CreateShip(30, PILOT_Alien5, 0, @M_Bug, @D_Bug, 19900, 1100, 61550);
        Nav_CreateShip(30, PILOT_Alien4, 0, @M_Bug, @D_Bug, 19900, 1100, 61650);
        Nav_CreateShip(30, PILOT_Alien5, 0, @M_Bug, @D_Bug, 19900, 1100, 61750);
        AI_Waitseconds(10);
        SF_ActivateObject(Shuttle2, 0);
        AI_Waitseconds(20);
        SF_ActivateObject(Shuttle3, 0);
        AI_Waitseconds(15);
        Nav_CreateShip(2, PILOT_Alien6, 0, @M_Bug, @D_Bug, 19950, 1100, 61500);
        Nav_CreateShip(2, PILOT_Alien7, 0, @M_Bug, @D_Bug, 19950, 1100, 61550);
        Nav_CreateShip(2, PILOT_Alien8, 0, @M_Bug, @D_Bug, 19900, 1100, 61550);
        Nav_CreateShip(7, PILOT_Alien9, 0, @M_Bug, @D_Bug, 19950, 1100, 61600);
        Nav_CreateShip(7, PILOT_Alien10, 0, @M_Bug, @D_Bug, 19950, 1100, 61650);
        Nav_CreateShip(7, PILOT_Alien1, 0, @M_Bug, @D_Bug, 19900, 1100, 61500);
        Nav_CreateShip(7, PILOT_Alien2, 0, @M_Bug, @D_Bug, 19900, 1100, 61550);
        Nav_CreateShip(7, PILOT_Alien1, 0, @M_Bug, @D_Bug, 19900, 1100, 61600);
        Nav_CreateShip(7, PILOT_Alien2, 0, @M_Bug, @D_Bug, 19900, 1100, 61650);
        AI_Waitseconds(10);
        Nav_CreateShip(2, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, 19950, 1100, 61650);
        Nav_CreateShip(30, PILOT_Alien4, 0, @M_Bug, @D_Bug, 19900, 1100, 61500);
        Nav_CreateShip(30, PILOT_Alien5, 0, @M_Bug, @D_Bug, 19900, 1100, 61550);
        Nav_CreateShip(7, PILOT_Alien1, 0, @M_Bug, @D_Bug, 19900, 1100, 61500);
        Nav_CreateShip(7, PILOT_Alien2, 0, @M_Bug, @D_Bug, 19900, 1100, 61550);
        SF_ActivateObject(Shuttle4, 0);
        AI_Waitseconds(20);
        SF_ActivateObject(Shuttle5, 0);
        until (shuttlecount = 5) do
          AI_WaitSeconds(1);
        SF_ObjectiveSetComplete(mobj_protect_beaufort);
        if (deadshuttle > 0) then begin
          SF_ObjectiveSetFailure(mobj_protect_shuttles);
          dockingcomplete:= 2;
        end
        else
          dockingcomplete:= 1;
        NAV_SetEjectSequence(ES_SAR_pickup);
        AI_Waitseconds(3);
        SF_AutopilotResumeNormal;
        setup := false;
      end;

    end
    else
      NAV_DeactivateSelf;
  AI_Waitseconds(1);
  end;
end;


function M_Beaufort;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_SetChildObjectVulnerable(Beaufort, PART_ChildBridge, false);
  SF_BindToActionSphere(2);
  until (reachedbeaufort) do
   AI_Waitseconds(1);

  AI_SendSpecialComm(27, 0);
  while(1) do
    AI_SetThrottle(0);
    AI_Waitseconds(1);
end;

function M_Arrow;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_BindTOActionSphere(2);
  while(1) do
    AI_Waitseconds(1);
end;


function M_Dralthi1;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Kilrathi);
  SF_BindToActionSphere(0);
  AI_SetAutopilotData(-20, 0, 400);

  until (reachednav2) do
   AI_Waitseconds(1);

   SF_BindToActionSphere(4);
   AI_SetAutopilotData(0, 0, 0);

  while(1) do
    AI_Waitseconds(1);
end;


function M_Dralthi2;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Kilrathi);
  SF_BindToActionSphere(0);
  AI_SetAutopilotData(20, 0, 400);

  until (reachednav2) do
   AI_Waitseconds(1);

   SF_BindToActionSphere(4);
   AI_SetAutopilotData(0, 0, 0);

  while(1) do
    AI_Waitseconds(1);
end;


function M_ZuBaka;
begin
  AI_WaitUntilActive;
  SF_SaveObjectState(true);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Kilrathi);
  SF_BindToActionSphere(0);
  AI_SetAutopilotData(250, 0, 100);

  until (reachednav2) do
   AI_Waitseconds(1);

   SF_BindToActionSphere(4);
   AI_SetAutopilotData(0, 0, 0);
  while(1) do
    AI_Waitseconds(1);
end;

function M_Shuttle;
begin
  SF_SetObjectFlag (OF_Collidable, false);
  SF_BindToActionSphere(2);
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  AI_WaitUntilActive;
  AI_AttackNothing(1);
  AI_Ignorecollisions(1);
  AI_SetThrottle(100);
  AI_WaitSeconds(3);
  SF_SetObjectFlag (OF_Collidable, true);
  while (SF_GetDistance(Dauntless) > 700) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, -20, 0, 650);
  AI_FaceObject(Dauntless);
  SF_SetObjectFlag (OF_Collidable, false);
  while (SF_GetDistance(Dauntless) > 350) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, -20, -10, 300);
  while (SF_GetDistance(Dauntless) > 40) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, -20, -25, -70);
  SF_ObjectiveIncrementCount(mobj_protect_shuttles);
  shuttlecount:=shuttlecount+1;
  SF_DeactivateSelf(0);
  while(1)do
    AI_Waitseconds(1);
end;

function D_Shuttle;
begin
  shuttlecount := shuttlecount +1;
  deadshuttle := deadshuttle +1;
end;

//*************************Nav 1***************************


object Nav1(Navpoint)
  x: 46000;
  y: 10000;
  z: 130000;
  main: M_Nav1;
  brief: B_Nav1;
  color: 0, 1, 1, 1;
  name: spacefli["Nav 1"];
  navdata: 3, 20000;
end;


object Field1(ABStart)
  x:46000;
  y:10000;
  z:130000;
  absdata: 1,  500, 3000;
end;



function M_Nav1;
var
  setup = true;
begin
  NAV_SetEjectSequence(ES_alien_pickup_MIA);

  while(1) do begin
   if (NAV_WithinSphere(Player)) then begin
     m_Nav := 3;
     while (NAV_WithinSphere(Player)) do begin
        NAV_ActivateSelf;
        if (setup) then begin
          NAV_ShowNav(4);
          NAV_HideNav(2);
          Nav_CreateShip(2, PILOT_Alien1, 0, @M_Bug, @D_Bug, 46250, 11000, 130250);
          Nav_CreateShip(2, PILOT_Alien2, 0, @M_Bug, @D_Bug, 46300, 11000, 130250);
          Nav_CreateShip(2, PILOT_Alien3, 0, @M_Bug, @D_Bug, 46350, 11000, 130250);
          Nav_CreateShip(2, PILOT_Alien4, 0, @M_Bug, @D_Bug, 46250, 11000, 130300);
          Nav_CreateShip(2, PILOT_Alien5, 0, @M_Bug, @D_Bug, 46300, 11000, 130300);
          Nav_CreateShip(2, PILOT_Alien6, 0, @M_Bug, @D_Bug, 46350, 11000, 130300);
          Nav_CreateShip(7, PILOT_Alien7, 0, @M_Bug, @D_Bug, 46250, 11200, 130200);
          Nav_CreateShip(7, PILOT_Alien8, 0, @M_Bug, @D_Bug, 46300, 11200, 130200);
          Nav_CreateShip(7, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, 46350, 11500, 130200);
          Nav_CreateShip(7, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, 46225, 11200, 130200);
          Nav_CreateShip(7, PILOT_Alien_Ace, 0, @M_Bug, @D_Bug, 46325, 11200, 130200);
          NAV_SetPlayerNav(4);
          setup := false;
        end;

        if(investigate) then begin
          NAV_SetPlayerNav(5);
          nav1checks:=nav1checks+1;
          until(reachednav3=1) do
            AI_WaitMilliseconds(1);
        end;
        if(missioncomplete) then begin
          Nav_SetPlayerNav(4);
          nav1checks:=nav1checks+1;
          while(1) do
            AI_WaitMilliseconds(1);
        end;
      end;
      NAV_DeactivateSelf;
    end;
  end;
end;

function M_Bug;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(0);
  AI_AddToAttackList(ZuBaka, 300);
  while(1) do begin
    AI_WaitSeconds(1);
  end;
end;

function D_Bug;
begin
end;

//*************************Nav 2***************************


object Nav2(Navpoint)
  x: 7000;
  y: 15000;
  z: 140000;
  main: M_Nav2;
  brief: B_Nav2;
  color: 0, 1, 1, 1;
  name: spacefli["Nav 2"];
  navdata: 4, 20000;
end;


object Field2(ABStart)
  x:8100;
  y:15000;
  z:142500;
  absdata: 2,  600, 3500;
  color: 0, 0, 0, 1;
  brief: B_Asteroid;
end;

function M_Nav2;
var
  setup = true;
begin
  NAV_SetEjectSequence(ES_SAR_pickup);
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      m_Nav := 4;
      NAV_ActivateSelf;

      if (setup) then begin
        NAV_ShowNav(2);
        reachednav2:=1;
        NAV_SetPlayerNav(3);
        NAV_ShowNav(5);
        setup := false;
      end;

      if(missioncomplete) then begin
        if(nav1checks<2) then begin
          NAV_SetEjectSequence(ES_alien_pickup_MIA);
          bugcount:=14;
          Nav_CreateShip(7, PILOT_Alien2, 0, @M_Bug, @D_BugD, 7000, 15000, 142000);
          Nav_CreateShip(7, PILOT_Alien3, 0, @M_Bug, @D_BugD, 7350, 15000, 142250);
          Nav_CreateShip(7, PILOT_Alien4, 0, @M_Bug, @D_BugD, 7250, 15000, 142300);
          Nav_CreateShip(7, PILOT_Alien5, 0, @M_Bug, @D_BugD, 7300, 15000, 142300);
          Nav_CreateShip(2, PILOT_Alien6, 0, @M_Bug, @D_BugD, 7350, 15000, 142300);
          Nav_CreateShip(2, PILOT_Alien7, 0, @M_Bug, @D_BugD, 7250, 15200, 142200);
          Nav_CreateShip(2, PILOT_Alien8, 0, @M_Bug, @D_BugD, 7300, 15200, 142200);
          Nav_CreateShip(2, PILOT_Alien1, 0, @M_Bug, @D_BugD, 7350, 15500, 142200);
          Nav_CreateShip(30, PILOT_Alien9, 0, @M_Bug, @D_BugD, 7225, 15200, 142200);
          Nav_CreateShip(30, PILOT_Alien10, 0, @M_Bug, @D_BugD, 7325, 15200, 142200);
          Nav_CreateShip(30, PILOT_Alien9, 0, @M_Bug, @D_BugD, 7225, 15200, 141200);
          Nav_CreateShip(30, PILOT_Alien10, 0, @M_Bug, @D_BugD, 7325, 15200, 141200);
          Nav_CreateShip(30, PILOT_Alien9, 0, @M_Bug, @D_BugD, 7225, 15220, 141200);
          Nav_CreateShip(30, PILOT_Alien10, 0, @M_Bug, @D_BugD, 7325, 15240, 141200);
          until(bugcount=0) do
            AI_Waitseconds(1);
          NAV_SetEjectSequence(ES_SAR_pickup);
        end;
      playonce:=1;
      AI_WaitSeconds(5);
      F_InitLanding;
      while(1) do
        AI_Waitseconds(1);
      end;

    end
    else begin
      NAV_DeactivateSelf;
    end;
  end;
end;


function D_BugD;
begin
  bugcount:=bugcount-1;
end;

//*************************Nav 3***************************



object Nav3(Navpoint)
  x: 50000;
  y: 5000;
  z: 7000;
  main: M_Nav3;
//  brief: B_Nav3;
  color: 0, 1, 1, 1;
  name: spacefli["Nav 3"];
  navdata: 5, 20000;
end;


object Realbuoy(ship)
  obj: al_turr;
  x: 50400;
  y: 5300;
  z: 7600;
  main: M_RealBuoy;
  death: D_Buoy;
  targstr: 2;
  pilot: PILOT_Alien1;
end;

object GryphonCamera(Camera)
  x: 50150;
  y: 5000;
  z: 7150;
  main: M_GryphonCamera;
end;


object PlayerCamera(Camera)
  x: 49990;
  y: 5035;
  z: 6840;
  main: M_PlayerCamera;
end;

function M_Nav3;
var
  setup = true, i=0;
begin
  NAV_SetEjectSequence(ES_alien_pickup_MIA);
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;
      if (setup) then begin
        investigate:=0;
        reachednav3:=1;
        NAV_SetPlayerNav(3);
        SF_ObjectiveEnable(mobj_destroy_buoy);
        SF_ObjectiveSetComplete(mobj_investigate);
        AI_Waitseconds(3);
        setup := false;
      end;

      if(buoyactive) then begin

        for i := 0 to 60 do begin
          xrand := SYS_Random(40000)+30000;
          yrand := SYS_Random(40000)-15000;
          zrand := SYS_Random(40000)-13000;
          Nav_CreateShip(UE_SHIPID_Box, PILOT_Alien1, 0, @M_Radarblipred, @D_blip, xrand, yrand, zrand);end;
        until(gryphondead) do
          AI_Waitseconds(1);

        Nav_CreateShip(2, PILOT_Alien1, 0, @M_BugJ, @D_BugJ, 49850, 5050, 7500);
        Nav_CreateShip(2, PILOT_Alien2, 0, @M_BugJ, @D_BugJ, 49900, 5050, 7500);
        Nav_CreateShip(2, PILOT_Alien3, 0, @M_BugJ, @D_BugJ, 49950, 5050, 7500);
        Nav_CreateShip(2, PILOT_Alien_Ace, 0, @M_BugJ, @D_BugJ, 50000, 5050, 7500);
        Nav_CreateShip(2, PILOT_Alien_Ace, 0, @M_BugJ, @D_BugJ, 49900, 4950, 7500);
        Nav_CreateShip(3, PILOT_Alien4, 0, @M_BugJ, @D_BugJ, 49950, 4950, 7500);
        Nav_CreateShip(3, PILOT_Alien5, 0, @M_BugJ, @D_BugJ, 50000, 4950, 7500);

        until(buoydestroyed) do
          AI_Waitseconds(1);
        NAV_SetEjectSequence(ES_SAR_pickup);
        SF_AutopilotResumeNormal;
        buoyactive:=0;
      end;
    end
    else
      NAV_DeactivateSelf;
  end;
end;


function M_RealBuoy;
begin
  AI_MuteComms;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Neutral);
  SF_BindToActionSphere(5);
  AI_Waitseconds(1);
  SF_Activateself(0);
  SF_SetObjectFlag(OF_Vulnerable, false);
  until(gryphondead) do
    AI_Waitseconds(1);

  SF_SetObjectFlag(OF_Vulnerable, true);
  while (1) do
    AI_Waitseconds(1);

end;

function M_FakeBuoy;
begin
  AI_MuteComms;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Neutral);
  SF_BindToActionSphere(5);
  AI_Waitseconds(1);
  SF_Activateself(0);
  SF_SetObjectFlag(OF_Vulnerable, false);
  until(gryphondead) do
    AI_Waitseconds(1);

  SF_SetObjectFlag(OF_Vulnerable, true);
  while (1) do
    AI_Waitseconds(1);

end;

function D_Buoy;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Alien);
  SF_ObjectiveSetComplete(mobj_destroy_buoy);
  buoydestroyed:=1;
end;

function D_FakeBuoy;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Alien);
end;

function M_Radarblipgrey;

var blipxrand, blipyrand, blipzrand, waitrand;

begin
  AI_MuteComms;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Neutral);
  SF_BindToActionSphere(5);
  AI_Waitseconds(1);
  SF_Activateself(0);
  while(buoydestroyed=0) do begin
    waitrand := SYS_Random(500);
    AI_Waitmilliseconds(waitrand);
    blipxrand := SYS_Random(40000)+30000;
    blipyrand := SYS_Random(40000)-15000;
    blipzrand := SYS_Random(40000)-13000;
    SF_SetWorldPosition(blipxrand, blipyrand, blipzrand);
  end;
  SF_DeactivateSelf(0);

  while (1) do
    AI_Waitseconds(1);
end;

function M_Radarblipred;

var blipxrand, blipyrand, blipzrand, waitrand;

begin
  AI_MuteComms;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Alien);
  SF_BindToActionSphere(5);
  AI_Waitseconds(1);
  SF_Activateself(0);
  AI_MuteComms;
  while(buoydestroyed=0) do begin
    waitrand := SYS_Random(50);
    AI_Waitmilliseconds(waitrand);
    blipxrand := SYS_Random(40000)+30000;
    blipyrand := SYS_Random(40000)-15000;
    blipzrand := SYS_Random(40000)-13000;
    SF_SetWorldPosition(blipxrand, blipyrand, blipzrand);
  end;
  SF_DeactivateSelf(0);
  while (1) do
    AI_Waitseconds(1);
end;

function M_Radarblipblue;

var blipxrand, blipyrand, blipzrand, waitrand;

begin
  AI_MuteComms;
  SF_SetObjectFlag (OF_Alignment, ALIGN_Confed);
  SF_BindToActionSphere(5);
  AI_Waitseconds(1);
  SF_Activateself(0);
  while(buoydestroyed=0) do begin
    waitrand := SYS_Random(50);
    AI_Waitmilliseconds(waitrand);
    blipxrand := SYS_Random(40000)+30000;
    blipyrand := SYS_Random(40000)-15000;
    blipzrand := SYS_Random(40000)-13000;
    SF_SetWorldPosition(blipxrand, blipyrand, blipzrand);
  end;
  SF_DeactivateSelf(0);
  while (1) do
    AI_Waitseconds(1);
end;


function D_blip;
begin
  AI_Waitseconds(1);
end;


function M_GryphonCamera;
var select;
begin
  until(reachednav3=3) do
    AI_Waitseconds(1);

  EVENT_GCam_Activated:=1;

  SF_ActivateSelf(0);
  SF_CAM_TrackPivotObjects(gryphon, fakebuoy1, 2);
  until (gryphondead) do
    AI_WaitSeconds(1);

  AI_Waitseconds(5);
  SF_CAM_TrackNothing;

  AI_Waitseconds(1);
  buoyactive:=1;
  AI_Waitseconds(5);
  EVENT_GCam_Activated:=0;
  SF_DeactivateSelf(0);
  while(1) do
    AI_Waitseconds(1);
end;




function M_BugJ;
begin
  AI_MuteComms;
  SF_SetObjectFlag (OF_Alignment, ALIGN_ALIEN);
  SF_ActivateSelf(1);
  AI_MuteComms;
  AI_AddToIgnoreList(realbuoy, 5000);
  AI_AddToIgnoreList(fakebuoy1, 5000);
  AI_AddToIgnoreList(fakebuoy2, 5000);
  AI_AddToIgnoreList(fakebuoy3, 5000);
  while(1) do begin
    AI_WaitSeconds(1);
    if(buoydestroyed) then
      AI_ResumeComms;
  end;

end;


function D_BugJ;
begin
bugkills:=bugkills+1;
end;


function M_PlayerCamera;
begin
  until(bugkills=7) do
    AI_Waitseconds(1);

  until(buoydestroyed=1) do
    AI_Waitseconds(1);

  EVENT_PCam_Activated:=1;
  AI_Waitseconds(2);
  M_GetPos(Player);
  SF_CAM_SetPos(x+20, y, z);
  SF_CAM_TrackObj(Player);
  SF_CAM_SetFollowObj(Player, 10, 0, 0);
  SF_CAM_TrackObj(Player);
  //SF_ActivateSelf(0);
  AI_Waitseconds(28);
  EVENT_PCam_Activated:=0;
//  SF_DeactivateSelf(0);
end;






// ******************** Begin Briefing ********************

object BAsteroid1(System)
  x: -2000;
  y: 15000;
  z: 120000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 0, 0;
end;

object BAsteroid2(System)
  x: 16000;
  y: 16000;
  z: 145000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 0, 0, 0;
end;

object BAsteroid3(System)
  x: 0;
  y: 20000;
  z: 140000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 0, 0;
end;

object BAsteroid4(System)
  x: 7000;
  y: 15000;
  z: 170000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 180, 0;
end;

object BAsteroid5(System)
  x: 7000;
  y: 15000;
  z: 140000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 0, 45;
end;

object BAsteroid6(System)
  x: 12000;
  y: 20000;
  z: 145000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 180, 180, 270;
end;

object BAsteroid7(System)
  x: 15000;
  y: 20000;
  z: 140000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 15, 0;
end;

object BAsteroid8(System)
  x: -2000;
  y: 10000;
  z: 125000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroid;
  direction: 90, 0, 65;
end;

object BeaufortBrief(System)
  x: -2000;
  y: 10000;
  z: 125000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_BWLab;
  direction: 90, 0, 65;
end;




function B_Player;
begin
  BRIEF_CAM_SetActive(1);
  BRIEF_CAM_SetPos(0, 500, -100);
  BRIEF_CAM_TrackObj(Player);

  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_FaceObject(Beaufort_Nav);
  BRIEF_Activate;

  BRIEF_WaitSeconds(1);

  // "Your Alpha wing will form a part of the Dauntless' escort."
  BRIEF_VoiceOver(27, 0, 3);
  BRIEF_WaitSeconds(3);

  BRIEF_MoveObjSeconds(Beaufort_Nav, 4);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  BRIEF_SetZoomSeconds(50, 4);
  // You will fly along this route, stopping at Beaufort Station to pick up
  //  additional crew, supplies, and rendezvous with the Fralthi."
  BRIEF_VoiceOver(27, 1, 7);
  atbeaufort:=1;
  BRIEF_WaitSeconds(2);
  BRIEF_MoveObjSeconds(Nav1, 6);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  BRIEF_SetZoomSeconds(100, 3);
// You will then continue along this route, into the asteroid belt.
// This route has been plotted specifically to mislead any pursuing craft.
  BRIEF_VoiceOver(27, 2, 10);

//  BRIEF_WaitSeconds(1);
  BRIEF_MoveObjSeconds(Nav2, 3);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  BRIEF_Exit;

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Edge;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, -25, 0, -5);
  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;


function B_Gryphon;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
  BRIEF_AttachToObj(Player, 25, 0, -5);
  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Dauntless;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Dauntless);
  BRIEF_FaceObject(Nav1);
  BRIEF_Activate;
  BRIEF_AttachToObj(Player, -100, 0, -10);

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_ZuBaka;
begin
  BRIEF_GotoObjRelWorldSeconds(Beaufort_Nav, 100, 0, -10, 4, 0);
  BRIEF_FaceObject(Nav1);
  BRIEF_SetAppearance(UE_APPEARANCE_Fralthi);
  BRIEF_Activate;
  until(atbeaufort) do
    BRIEF_Waitseconds(1);
  BRIEF_AttachToObj(Player, 100, 0, -10);

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Beaufort;
begin
  BRIEF_GotoObjRelWorldSeconds(Beaufort_Nav, -30, 0, -10, 4, 0);
  BRIEF_SetAppearance(UE_APPEARANCE_Beaufort);
  BRIEF_FaceObject(Nav1);
  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Asteroid;
begin
  BRIEF_SetAppearance(17);
  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_BWLab;
begin
  //BRIEF_SetSize(1);
  BRIEF_SetAppearance(UE_Appearance_BEAUFORT);
  //BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;



function B_DNav;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Nav1;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(100);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Nav2;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(200);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Nav3;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(120);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_BNav;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(300);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;






// **************** Takeoff/Landing routines **************
// ********************************************************
// Camera stuff

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

function F_Takeoff; forward;
function F_Landing; forward;

function M_Camera;
begin
  while(1) do
  begin
    if (m_Event = EVENT_Takeoff_Start) then
      F_Takeoff;
    if (m_Event = EVENT_Activate_Landing_Cam) then
      F_Landing;
    AI_WaitMilliSeconds(15);
  end;
end;

function F_Takeoff;
var select;
begin
  SF_CAM_TrackObj(Player);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -30, 35, -40);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, -10, 35, 80);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, 0, 5, 40);

  SF_ActivateSelf(0);
  until (m_Event = EVENT_Takeoff_Complete) do
    AI_WaitSeconds(1);
  SF_CAM_TrackNothing;
  SF_DeactivateSelf(0);
end;

function F_Landing;
var select;
begin
  SF_CAM_HideDust;
  SF_CAM_TrackObj(Dauntless);
  SF_CAM_SetFollowObj(Dauntless, 0, 1, 0);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(1);
  SF_CAM_TrackObj(Dauntless);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Dauntless, -200, 200, -350);
  if (select = 1) then
    SF_CAM_SetFollowObj(Dauntless, -50, 200, 500);
  if (select = 2) then
    SF_CAM_SetFollowObj(Dauntless, 400, 100, 300);

  until (m_Event = EVENT_Final_Approach) do
    AI_WaitMilliSeconds(5);
  SF_CAM_TrackObj(Player);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -3, 2, 15);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, 3, 4, -15);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, -9, 2, 5);

  AI_WaitSeconds(30);
end;

// Player stuff

function F_InitLanding;
begin
  SF_AutopilotDisable;
  m_Event := EVENT_Land_Player;
  until (M_Event = EVENT_Activate_Landing_Cam) do AI_WaitSeconds(1);
  AI_WaitSeconds(30);
  SF_Exit;
end;

function F_PlayerTakeoff;
begin
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x+15, y-25, z);
  SF_SetObjectFlag(OF_Collidable, false);
  AI_PLR_ControlAssume;
  AI_SetThrottle(0);
  AI_WaitSeconds(1);
  SF_ActivateSelf(0);
  AI_WaitSeconds(1);
  AI_SetThrottle(100);
  AI_WaitMilliSeconds(1500);
  M_Event := EVENT_Takeoff_Start;
  while (SF_GetDistance(Dauntless) < 500) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, 15, -20, 700);
  M_Event := EVENT_Takeoff_Complete;
  SF_SetObjectFlag(OF_Collidable, true);
  AI_PLR_ControlResume;
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
end;

function F_PlayerLanding;
begin
  while (SF_GetDistance(Dauntless) > 300) do AI_WaitMilliSeconds(1);
  AI_PLR_ControlAssume;
  SF_SetObjectFlag(OF_Collidable, false);
  M_Event := EVENT_Activate_Landing_Cam;
  HCL_EmptyFuel;
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Player) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z-350);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x, y-25, z-350);
  AI_SetThrottle(50);
  until (SF_GetDistance(Dauntless) < 50) do AI_WaitMilliSeconds(5);
  M_Event := EVENT_Final_Approach;
  SYS_PlaySFX(SFX_Engines_Power_Down);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  AI_WaitSeconds(5);
  SF_Exit;
end;

// Dauntless stuff

function F_DauntlessLanding;
begin
  if (SF_GetVelocityObject(Dauntless) > 0) then
  begin
    AI_SetThrottle(0);
    AI_WaitSeconds(5);
  end;

  // Teleport to position relative to NavD, face NavD
  M_GetPos(Nav2);
  SF_SetWorldPosition(x, y, z+1000);
  AI_FaceObject(Nav2);
  m_Event := EVENT_Dauntless_Ready;
  AI_WaitSeconds(25);
  SF_Exit;
end;


