//******************************************************************************
//
// Unknown Enemy
// Mission 8b
//
// Created by:
//               Pierre deshaies  <popsiclepete@angelfire.com>
// Modified by:  Jakub Majewski <qmajewski@yahoo.co.uk>
//
//
// Last modified: May 12th, 2004
//
//******************************************************************************

mission ue8b;

#AddToSearchPath("$uesrc$");

#SetRooms ("cic.rom", "rec.rom");

// **************  Comm Files  **************

#SetOutputPath("$wcue$\language\pilots\");
#file "strings\pilots\srs28.pas";

#SetOutputPath("$wcue$\comms\");
#file "comms\srs28.pas";

#SetOutputPath("$wcue$\language\");
#file "strings\brief28.pas";
#file "strings\sfpt_str.pas";

// **************  Block Files  **************

#SetOutputPath("$wcue$\mission\");
#file "block800.pas";
#file "block801.pas";
#file "block802.pas";
#file "block803.pas";


// **************  Main Program  **************

#sector: "t.sec";
#name: 16;

#AddToSearchPath("$wcue$\language\");
#include wcp;
#include consts;
#include uepilots;
#include UE;
#include comms;

#strings objectiv;
#strings spacefli;
#strings targetid;

#SetKillboard(PILOT_Faris, PILOT_Defender, PILOT_Ocelot, PILOT_Hellcat,
              PILOT_Night, PILOT_Doc, PILOT_Shark, PILOT_Thor,
              PILOT_Killer, PILOT_Bloodhound, PILOT_Edge, PILOT_Mage,
              PILOT_Phantom, PILOT_Gold, PILOT_Blade, PILOT_Huntress,
              PILOT_Ghost, PILOT_Gryphon, PILOT_Warrior);

#SetOutputPath("$wcue$\mission\");

external
  g_Fralthi_Dead,
  g_UE_8_Won;

var
  m_Failed = true,
  m_Event,
  m_Player_Returns,
  m_Comm = -1,
  m_AliveEnemies=0,
  m_DeadEnemies=0,
  Navs_Scanned,
  Ray_Scanned,
  Ray_Killed = 0,
  WelcomingParty = false,
  PlayerBackHome = false,
  PartyMembers = 0,
  x,
  y,
  z;



const
  NAV_Dauntless = 1,
  NAV_1 = 2,
  NAV_2 = 3,
  NAV_3 = 4,


  EVENT_Takeoff_Start = 4,
  EVENT_Takeoff_Complete = 5,
  EVENT_Land_Player = 6,
  EVENT_Activate_Landing_Cam = 7,
  EVENT_Dauntless_Ready = 8,
  EVENT_Final_Approach = 9;

objective mobj_patrol
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Patrol All NAV Points"];
  status: MOBJ_Incomplete;
  counter: false;
end;


objective mobj_ScanRay
  hidden: true;
  type: MOBJ_Bonus;
  text: objectiv["Scan Ray-class vessel"];
  status: MOBJ_Incomplete;
  counter: false;
end;


objective mobj_eliminate_aliens
  hidden: false;
  type: MOBJ_Primary;
  text: objectiv["Eliminate Alien Presence"];
  status: MOBJ_Incomplete;
  counter: true;
end;



object Player(Player)
  obj: UE_SHIP_Scimitar;
  x: -10000;
  y: 5;
  z: 2100;
  main: M_Player;
  brief: B_Player;
  color: 0, 0.8, 0.8, 0.0;
  pilot: PILOT_Casey1;
end;


object RayCluster(cluster)
  obj: raynode2;
  x: 70500;
  y: 21500;
  z: -33200;
  main: S_RayCluster;
  pilot: PILOT_ALIEN4;
  EVENT_1: S_DeathAlienNav3;
  EVENT_0: M_Child;
end;



function MAIN;
begin
  MS_RunGameflow(0);
  MS_RunBriefing;
  MS_ShipSelector(UE_SELECTOR_Scimitar, UE_SELECTOR_Epee);
  MS_RunSpaceflight(0);
  MS_RunDebriefing;
end;


function NULL;
begin
  Result := 0;
end;



function M_CountEnemies;
begin
  Result := m_AliveEnemies - m_DeadEnemies;
end;


function M_GetPos(ShipID);
begin
  x := SF_GetXObj(ShipID);
  y := SF_GetYObj(ShipID);
  z := SF_GetZObj(ShipID);
end;

function F_InitLanding; forward;
function F_PlayerTakeoff; forward;
function F_PlayerLanding; forward;
function F_DauntlessLanding; forward;


// *****************************************************************
// *****************************************************************
// ************************* Dauntless NAV *************************
// *****************************************************************
// *****************************************************************

object NavD(Navpoint)
  x: -10000;
  y: 0;
  z: 2000;
  main: M_NavD;
  brief: B_NavD;
  color: 0, 1, 1, 1;
  name: spacefli["Dauntless Nav"];
  navdata: 1, 30000;
end;


object Asteroids_NavD(ABStart)
  x: -10000;
  y: 0;
  z: 2000;
  absdata: 0, 6000, 10000;
  actionsphere: NAV_Dauntless;
end;


object Dauntless(Capship) as "BWS Dauntless"
  obj: UE_SHIP_Dauntless;
  x: -9500;
  y: 0;
  z: 4100;
  main: M_Dauntless;
  death: D_Dauntless;
  brief: B_Dauntless;
  color: 0, 0.35, 0.35, 1;
  direction: 0, 0, 0;
  pilot: PILOT_Dauntless;
end;


object Ocelot(Ship)
  obj: "epee";
  x: -10500;
  y: 300;
  z: 4100;
  main: M_DauntCAP3;
//  targstr: targetid["CAP 1"];
  targstr: 1;
  pilot: PILOT_Ocelot;
end;



object Defender(Ship)
  obj: UE_SHIP_Scimitar;
  x: -9500;
  y: 100;
  z: 4100;
  main: M_Defender;
  brief: B_Defender;
  color: 0, 0, 0, 1;
  targstr: 1;
  pilot: PILOT_Defender;
end;


object Doc(Ship)
  obj: UE_SHIP_Scimitar;
  x: -10500;
  y: 300;
  z: 4100;
  main: M_DauntCAP1;
  targstr: 1;
  pilot: PILOT_Doc;
end;

object Phantom(Ship)
  obj: UE_SHIP_Scimitar;
  x: -9000;
  y: 300;
  z: 4100;
  main: M_DauntCAP2;
  targstr: 1;
  pilot: PILOT_Phantom;
end;


function M_NavD;
var
  setup = true,
  i;
begin
  NAV_SetEjectSequence(ES_SAR_pickup);

  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (m_Player_Returns) then begin
        PlayerBackHome:=true;
        SF_AutopilotDisable;
        if (Navs_Scanned = 3) then begin
            SF_ObjectiveSetComplete(mobj_patrol);
            if (M_CountEnemies = 0) then
               Begin
                    SF_SetMissionSuccess;
                    AI_WaitSeconds(3);
                    m_Comm := 5;
               end
            else
               begin
                    WelcomingParty:=true;
                    SF_ObjectiveSetFailure(mobj_eliminate_aliens);
               end;
        end else begin
          WelcomingParty:=true;
          SF_ObjectiveSetFailure(mobj_patrol);
        end;

        if (WelcomingParty=true) then
            Begin
                 NAV_SetEjectSequence(ES_Alien_pickup_MIA);
                 for i:=1 to 5 do begin
                      NAV_CreateShip(UE_SHIPID_Moray, 107, 0, @S_AlienParty, @S_DeathParty, i*50-10100, 0, 4150);
                 end;
                 SF_SetMissionFailure;
                 for i:=1 to 8 do begin
                      NAV_CreateShip(UE_SHIPID_Manta_B, 95, 0, @S_AlienParty_B, @S_DeathParty, i*50-10500, 0, 4250);
                 end;
                 AI_WaitSeconds(20);
//                 for i:=1 to 3 do begin
                      NAV_CreateShip(UE_SHIPID_Moray, 107, 0, @S_AlienParty, @S_DeathParty, i*50-10100, 0, 4150);
                      NAV_CreateShip(UE_SHIPID_Moray, 107, 0, @S_AlienParty, @S_DeathParty, i*50-10100, 0, 4150);
                      NAV_CreateShip(UE_SHIPID_Moray, 107, 0, @S_AlienParty, @S_DeathParty, i*50-10100, 0, 4150);
//                 end;
                 for i:=1 to 5 do begin    // was 6
                      NAV_CreateShip(UE_SHIPID_Stingray, 95, 0, @S_AlienParty_B, @S_DeathParty, i*50-11100, 0, 4250);
                 end;
                 AI_WaitSeconds(60);
                 for i:=1 to 7 do begin    // was 9
                      NAV_CreateShip(UE_SHIPID_Stingray, 95, 0, @S_AlienParty_B, @S_DeathParty, i*50-11100, 0, 4050);
                 end;
                 AI_WaitSeconds(20);
//                 for i:=1 to 6 do begin
                      NAV_CreateShip(UE_SHIPID_Stingray, 95, 0, @S_AlienParty_B, @S_DeathParty, i*50-11100, 0, 4050);
                      NAV_CreateShip(UE_SHIPID_Stingray, 95, 0, @S_AlienParty_B, @S_DeathParty, i*50-11100, 0, 4050);
                      NAV_CreateShip(UE_SHIPID_Stingray, 95, 0, @S_AlienParty_B, @S_DeathParty, i*50-11100, 0, 4050);
                      NAV_CreateShip(UE_SHIPID_Stingray, 95, 0, @S_AlienParty_B, @S_DeathParty, i*50-11100, 0, 4050);
                      NAV_CreateShip(UE_SHIPID_Stingray, 95, 0, @S_AlienParty_B, @S_DeathParty, i*50-11100, 0, 4050);
                      NAV_CreateShip(UE_SHIPID_Stingray, 95, 0, @S_AlienParty_B, @S_DeathParty, i*50-11100, 0, 4050);
//                 end;
                 AI_WaitSeconds(3);
                 while(PartyMembers) do
                      begin
                           AI_WaitSeconds(1);
                      end;
                 NAV_SetEjectSequence(ES_SAR_pickup);
                 AI_WaitSeconds(3);
                 m_Comm:=4;
            End;
        AI_WaitSeconds(3);

        // now landing
        F_InitLanding;
      end;

      if (setup) then begin
        SF_ActivateObject(Ocelot, 0);
        SF_ActivateObject(Doc, 0);
        SF_ActivateObject(Phantom, 0);
        SF_ActivateObject(Dauntless, 0);
        setup := false;
      end;

      NAV_SetPlayerNav(NAV_1);

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
      m_Player_Returns := true;
    end;
    AI_WaitSeconds(1);
  end;
end;


function M_Player;
begin
  SF_SetObjectFlag(OF_Alignment, ALIGN_CONFED);
  SF_BindToActionSphere(0);
  SF_SetBaseShip(Dauntless);
  F_PlayerTakeoff;

  while (1) do begin
          if (m_Event = EVENT_Land_Player) then
             F_PlayerLanding;
  AI_WaitSeconds(1);
  end;
end;


function M_Defender;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_SetObjectFlag(OF_vulnerable, false);
  SF_BindToActionSphere(0);
  SF_ActivateSelf(0);
  until (M_Event = EVENT_Takeoff_Complete) do
    AI_WaitMilliSeconds(1);
  AI_AddToWing(Player);

  while(1) do begin
    if (m_Comm = 0) then begin
      m_Comm := -1;
    end;
    if (m_Comm = 7) then begin
      AI_SendSpecialComm(28, 2);
      AI_AddToIgnoreList(RayCluster, 1);
      SF_ObjectiveEnable(mobj_ScanRay);
      m_Comm := -1;
    end;
    if (m_Comm = 6) then begin
      AI_SendSpecialComm(28, 3);
      m_Comm := -1;
    end;
    if (m_Comm = 8) then begin
      AI_SendComm(16);
      m_Comm := -1;
    end;
    if (m_Comm = 9) then begin
      AI_SendSpecialComm(28, 6);
      m_Comm := -1;
    end;
    if (m_Event = EVENT_Land_Player) then begin
      AI_RemoveFromWing;
      AI_IgnoreCollisions(1);
      AI_AttackNothing(1);
      AI_SetThrottle(0);
    end;
    AI_WaitMilliseconds(100);
  end;
end;


function M_Dauntless;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(NAV_Dauntless);
  SF_SetPilotImmortal(PILOT_Defender, 1);
  SF_SetPilotImmortal(PILOT_Doc, 1);
  SF_SetPilotImmortal(PILOT_Phantom, 1);
  while(1) do begin
    if (m_Comm = 5) then begin
      AI_SendSpecialComm(28, 4);
      m_Comm := -1;
      until (m_Event = EVENT_Activate_Landing_Cam) do AI_WaitMilliSeconds(1);
      //SF_SaveObjectState(false);
      F_DauntlessLanding;
    end;
    if (m_Comm = 4) then begin
      AI_SendSpecialComm(28, 5);
      m_Comm := -1;
      until (m_Event = EVENT_Activate_Landing_Cam) do AI_WaitMilliSeconds(1);
      //SF_SaveObjectState(false);
      F_DauntlessLanding;
    end;
//    if (m_Event = EVENT_Land_Player) then
//      SF_SaveObjectState(false);
//      F_DauntlessLanding;
    AI_WaitMilliseconds(1);
  end;
end;

function D_Dauntless;
begin
end;


function M_DauntCAP1;
Begin
  AI_WaitUntilActive;

  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(NAV_Dauntless);
     while(1) do
              Begin
                   AI_GotoObjRelFrame(Dauntless,0,100,3000);
                   AI_GotoObjRelFrame(Dauntless,-3000,-30,0);
                   AI_GotoObjRelFrame(Dauntless,0,50,-3000);
                   AI_GotoObjRelFrame(Dauntless,3000,-40,0);
                   AI_WaitSeconds(1);
              End;
End;


function M_DauntCAP2;
Begin
  AI_WaitUntilActive;

  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(NAV_Dauntless);
     while(1) do
              Begin
                   AI_GotoObjRelFrame(Dauntless,0,3000,100);
                   AI_GotoObjRelFrame(Dauntless,-3000,-30,0);
                   AI_GotoObjRelFrame(Dauntless,0,-3000,50);
                   AI_GotoObjRelFrame(Dauntless,3000,-40,0);
                   AI_WaitSeconds(1);
              End;
End;


function M_DauntCAP3;
Begin
  AI_WaitUntilActive;

  SF_SetObjectFlag(OF_alignment, ALIGN_Confed);
  SF_BindToActionSphere(NAV_Dauntless);
     while(1) do
              Begin
                   AI_GotoObjRelFrame(NavD,0,3000,100);
                   AI_GotoObjRelFrame(NavD,-3000,-30,0);
                   AI_GotoObjRelFrame(NavD,0,-3000,50);
                   AI_GotoObjRelFrame(NavD,3000,-40,0);
                   AI_WaitSeconds(1);
              End;
End;



function S_AlienParty;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(NAV_Dauntless);
  PartyMembers:=PartyMembers+1;
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  SF_ActivateSelf(AO_appear);
  while(1) do
      Begin
           AI_WaitSeconds(5);
      End;
end;


function S_AlienParty_B;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(NAV_Dauntless);
  PartyMembers:=PartyMembers+1;
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  SF_ActivateSelf(AO_appear);
  AI_AddToAttackList(Dauntless, 1);
  while(1) do
      Begin
           AI_WaitSeconds(5);
      End;
end;


function S_DeathParty;
begin
     SF_ObjectiveIncrementCount(mobj_eliminate_aliens);
     PartyMembers:=PartyMembers-1;
end;



// *****************************************************************
// *****************************************************************
// ***************************** NAV 1 *****************************
// *****************************************************************
// *****************************************************************


object Nav1(Navpoint)
  x: 46400;
  y: 45000;
  z: 23000;
  main: M_Nav1;
  brief: B_Nav1;
  color: 0, 1, 1, 1;
  name: spacefli["Nav 1"];
  navdata: 2, 30000;
end;

object Asteroids_Nav1(ABStart)
  x: 46000;
  y: 45000;
  z: 23000;
  brief: B_Asteroids;
  color: 0, 1, 1, 1;
  absdata: 2, 4000, 6000;
  actionsphere: NAV_1;
end;

object BAsteroid1a(System)
  x: 46000;
  y: 45000;
  z: 23000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;

object BAsteroid1b(System)
  x: 40000;
  y: 45000;
  z: 32000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;


object BAsteroid1c(System)
  x: 49900;
  y: 44000;
  z: 20000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;

object BAsteroid1d(System)
  x: 45000;
  y: 49000;
  z: 27000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;


object JumpPoint(JumpPoint)
  x: 46200;
  y: 40000;
  z: 19000;
  actionsphere: NAV_1;
end;

object AlienEsc1(Ship)
  obj: "manta";
  x: 46800;
  y: 45000;
  z: 23500;
  main: S_AlienEsc;
  death: S_DeathAlienNav1;
  targstr: 0;
  pilot: PILOT_Confed;
end;

object AlienEsc2(Ship)
  obj: "manta";
  x: 46900;
  y: 45000;
  z: 23500;
  main: S_AlienEsc;
  death: S_DeathAlienNav1;
  targstr: 0;
  pilot: PILOT_Confed;
end;


object AlienLeaderNav1(Ship)
  obj: "moray";
  x: 46950;
  y: 45000;
  z: 23500;
  main: S_AlienLeaderNav1;
  death: S_DeathAlienNav1;
  targstr: 0;
  pilot: PILOT_Confed;
end;



function S_AlienEsc;
begin
  AI_WaitUntilActive;
  SF_SetObjectFlag(OF_alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(NAV_1);
  AI_AddToWing(AlienEsc1);
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  m_AliveEnemies := m_AliveEnemies + 1;
  m_Comm := 9;
  while(1) do
      Begin
          AI_AttackNothing(1);
          AI_GotoObjRange(JumpPoint, 50);
          if (SF_GetDistance(JumpPoint)<100) then
             Begin
                  SF_DeactivateSelf(1);
                  WelcomingParty:=true;
             end;
      End;
end;





function S_DeathAlienNav1;
begin
     SF_ObjectiveIncrementCount(mobj_eliminate_aliens);
     m_DeadEnemies := m_DeadEnemies +1;
end;


function S_AlienNav1;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(NAV_1);
  SF_ActivateSelf(AO_appear);
  AI_AddToWing(AlienLeaderNav1);
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  m_AliveEnemies := m_AliveEnemies +1;
  while(1) do
      Begin
           AI_WaitSeconds(1);
      End;
end;


function S_AlienLeaderNav1;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(NAV_1);
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  m_AliveEnemies := m_AliveEnemies +1;
  while(1) do
      Begin
           AI_WaitSeconds(1);
      End;
end;



function M_Nav1;
var
  setup = true,
  i=0;
 begin
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        Navs_Scanned := Navs_Scanned + 1;
        for i:=1 to 5 do begin
           NAV_CreateShip(UE_SHIPID_Moray, 107, 0, @S_AlienNav1, @S_DeathAlienNav1, i*50+46950, 45000, 23500);
        end;
        SF_ActivateObject(AlienEsc1, 0);
        SF_ActivateObject(AlienEsc2, 0);
        SF_ActivateObject(AlienLeaderNav1, 0);
        setup := false;
      end;

      NAV_SetPlayerNav(NAV_2);

      while(NAV_WithinSphere(Player)) do begin
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;



// *****************************************************************
// *****************************************************************
// ***************************** NAV 2 *****************************
// *****************************************************************
// *****************************************************************

object Nav2(Navpoint)
  x: 110232;
  y: 31200;
  z: 3000;
  main: M_Nav2;
  brief: B_Nav2;
  color: 0, 1, 1, 1;
  name: spacefli["Nav 2"];
  navdata: 3, 30000;
end;


object Asteroids_Nav2(ABStart)
  x: 110232;
  y: 31200;
  z: 3000;
  absdata: 3, 4000, 6000;
  actionsphere: NAV_2;
end;

object BAsteroid2a(System)
  x: 110232;
  y: 31200;
  z: 1000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;

object BAsteroid2b(System)
  x: 129232;
  y: 29000;
  z: 0;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;

object BAsteroid2c(System)
  x: 99232;
  y: 39000;
  z: 4000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;


object BAsteroid2d(System)
  x: 139232;
  y: 20200;
  z: -4000;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;



object AlienLeaderNav2(Ship)
  obj: "moray";
  x: 110780;
  y: 31000;
  z: 5990;
  main: S_AlienLeaderNav2;
  death: S_DeathAlienNav1;
  targstr: 0;
  pilot: PILOT_Confed;
end;




function S_AlienLeaderNav2;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(NAV_2);
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  m_AliveEnemies := m_AliveEnemies +1;
  while(1) do
      Begin
           AI_WaitSeconds(1);
      End;
end;



function S_AlienNav2;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(NAV_2);
  SF_ActivateSelf(AO_appear);
  AI_AddToWing(AlienLeaderNav2);
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  m_AliveEnemies := m_AliveEnemies +1;
  while(1) do
      Begin
           AI_WaitSeconds(1);
      End;
end;


function M_Nav2;
var
  setup = true,
  i = 0;
begin
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        Navs_Scanned := Navs_Scanned + 1;
        SF_ActivateObject(AlienLeaderNav2, 0);
        for i:=1 to 5 do begin
           NAV_CreateShip(UE_SHIPID_Moray, 107, 0, @S_AlienNav2, @S_DeathAlienNav1, i*50+110780, 31000, 5990);
        end;
        for i:=1 to 3 do begin
           NAV_CreateShip(UE_SHIPID_Manta, 107, 0, @S_AlienNav2, @S_DeathAlienNav1, i*50+110780, 31000, 5990);
        end;
        setup := false;
      end;

      NAV_SetPlayerNav(NAV_3);

      while(NAV_WithinSphere(Player)) do begin
          AI_WaitSeconds(1);
        end;

        AI_WaitSeconds(1);
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;

// *****************************************************************
// *****************************************************************
// ***************************** NAV 3 *****************************
// *****************************************************************
// *****************************************************************


object Nav3(Navpoint)
  x: 70000;
  y: 21000;
  z: -33200;
  main: M_Nav3;
  brief: B_Nav3;
  color: 0, 1, 1, 1;
  name: spacefli["Nav 3"];
  navdata: 4, 30000;
end;


object Asteroids_Nav3(ABStart)
  x: 70000;
  y: 21000;
  z: -33200;
  absdata: 1, 4000, 6000;
  actionsphere: NAV_3;
end;

object BAsteroid3a(System)
  x: 70000;
  y: 21000;
  z: -33200;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;

object BAsteroid3b(System)
  x: 61000;
  y: 31000;
  z: -29200;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;

object BAsteroid3c(System)
  x: 72000;
  y: 15000;
  z: -42200;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;


object BAsteroid3d(System)
  x: 92000;
  y: 9000;
  z: -49200;
  color: 0, 0.5, 0.5, 0.25;
  brief: B_Asteroids;
  direction: 90, 0, 0;
end;




object AlienLeaderNav3(Ship)
  obj: "moray";
  x: 70000;
  y: 23000;
  z: -33200;
  main: S_AlienLeaderNav3;
  death: S_DeathAlienNav3;
  targstr: 0;
  pilot: PILOT_Confed;
end;




function S_AlienLeaderNav3;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(NAV_3);
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  m_AliveEnemies := m_AliveEnemies +1;
  while(1) do
      Begin
           AI_WaitSeconds(1);
      End;
end;


function S_RayCluster;
var Currently_Scanning=false,
    MidScan=false;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(NAV_3);
  Ray_Scanned:=false;
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  m_AliveEnemies := m_AliveEnemies +1;
  while(1) do
      Begin
          if ((SF_GetDistance(Player)<51) and (Ray_Scanned=false)) then
              Begin
                   if (Currently_Scanning=false) then
                       Begin
                            Currently_Scanning:=true;
                            SF_PrintText(800);
                            SYS_TimerSet(30);
                       End
                   else
                       Begin
                            if (SYS_TimerGet = 0) then
                                Begin
                                     SF_PrintText(802);
                                     Ray_Scanned:=true;
                                     SF_ObjectiveSetComplete(mobj_ScanRay);
                                     m_Comm:=6
                                End;
                            if ((SYS_TimerGet = 15) and (MidScan=False)) then
                                Begin
                                     SF_PrintText(801);
                                     MidScan:=true;
                                End;
                       End;
              End
          else if ((Currently_Scanning=true) and (Ray_Scanned=false)) then
              Begin
                   Currently_Scanning:=false;
                   MidScan:=false;
                   SF_PrintText(803);
              End;
          AI_WaitMilliSeconds(1);
      End;
end;



function M_Child;
begin
  SF_SetObjectFlag (OF_Alignment, ALIGN_Alien);
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  m_AliveEnemies := m_AliveEnemies +1;
  Ray_Killed:=Ray_Killed + 1;
  while(1) do
      Begin
           AI_WaitSeconds(1);
      End;
end;



function S_DeathAlienNav3;
begin
     SF_ObjectiveIncrementCount(mobj_eliminate_aliens);
     m_DeadEnemies := m_DeadEnemies +1;
end;


function S_AlienNav3;
begin
  SF_SetObjectFlag(OF_alignment, ALIGN_ALIEN);
  SF_BindToActionSphere(NAV_3);
  SF_ActivateSelf(AO_appear);
  AI_AddToWing(AlienLeaderNav3);
  SF_ObjectiveIncrementTotal(mobj_eliminate_aliens);
  SF_ObjectiveIncrementTotalNeededForSuccess(mobj_eliminate_aliens);
  m_AliveEnemies := m_AliveEnemies +1;
  while(1) do
      Begin
           AI_WaitSeconds(1);
      End;
end;



function M_Nav3;
var
  setup = true,
  i = 0;
begin
  while(1) do begin
    if (NAV_WithinSphere(Player)) then begin
      NAV_ActivateSelf;

      if (setup) then begin
        Navs_Scanned := Navs_Scanned + 1;
        setup := false;
        SF_ActivateObject(AlienLeaderNav3, 0);
        for i:=1 to 2 do begin
           NAV_CreateShip(UE_SHIPID_Moray, 107, 0, @S_AlienNav3, @S_DeathAlienNav3, i*50+70000, 21000, -33200);
        end;
        SF_ActivateObject(RayCluster, 0);
        m_Comm:=7;
      end;

      NAV_SetPlayerNav(NAV_Dauntless);

      while(NAV_WithinSphere(Player)) do begin
        if (Ray_killed >0) then
            begin
                 SF_ObjectiveIncrementCount(mobj_eliminate_aliens);
                 Ray_Killed:= -50;
                 m_DeadEnemies := m_DeadEnemies +1;
            end;
        AI_WaitSeconds(1);
      end;
      NAV_DeactivateSelf;
    end;
    AI_WaitSeconds(1);
  end;
end;



// *****************************************************************
// *****************************************************************
// ******************** Begin Briefing *****************************
// *****************************************************************
// *****************************************************************

function B_Player;
begin
  BRIEF_CAM_SetActive(1);
  BRIEF_CAM_SetPos(0, 400, 0);
  BRIEF_CAM_TrackObj(Player);

  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
//  BRIEF_SetAppearance(19);
  BRIEF_FaceObject(Nav1);
  BRIEF_Activate;

  BRIEF_WaitSeconds(1);

  // "Your Alpha wing will patrol these three NAV points around the Dauntless."
  BRIEF_VoiceOver(28, 0, 5);
  BRIEF_WaitSeconds(3);

  BRIEF_MoveObjSeconds(Nav1, 4);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  BRIEF_WaitSeconds(1);

  // "You must eliminate all Nephilem ships to ensure that the Dauntless'
  //  location remains unknown."
  BRIEF_VoiceOver(28, 1, 6);

//  BRIEF_WaitSeconds(1);
  BRIEF_MoveObjSeconds(Nav2, 5);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  BRIEF_WaitSeconds(1);

  // "Flying the K'ha'haf should give you a significant advantage of
  //  surprise in combat."
//  BRIEF_VoiceOver(28, 2, 14);

//  BRIEF_WaitSeconds(1);
  BRIEF_MoveObjSeconds(Nav3, 4);
  SYS_PlaySFX(SFX_BRIEF_Activate);
  BRIEF_WaitSeconds(1);

//  BRIEF_WaitSeconds(1);
  BRIEF_MoveObjSeconds(NavD, 7);

  BRIEF_Exit;

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Defender;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Scimitar);
//  BRIEF_SetAppearance(19);
  BRIEF_AttachToObj(Player, 0, 25, -5);

  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;

function B_Dauntless;
begin
  BRIEF_SetAppearance(UE_APPEARANCE_Dauntless);
  BRIEF_FaceObject(Nav1);
  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;



function B_NavD;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(160);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;



function B_Asteroids;
begin
  BRIEF_SetAppearance(17);
  BRIEF_Activate;

  while(1) do
    BRIEF_WaitSeconds(10);
end;


function B_Nav1;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(150);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Nav2;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(100);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;

function B_Nav3;
begin
  BRIEF_Activate;
  BRIEF_DisplayName(1);
  BRIEF_SetSize(120);
  BRIEF_SetAppearance(1);

  while (1) do
    BRIEF_WaitSeconds(1);
end;




// *****************************************************************
// *****************************************************************
// **************** Takeoff/Landing routines ***********************
// *****************************************************************
// *****************************************************************
// Camera stuff

object Camera(Camera)
  x: 0;
  y: 0;
  z: 0;
  main: M_Camera;
end;

function F_Takeoff(select); forward;
function F_Landing(select); forward;

function M_Camera;
begin
  while(1) do
  begin
    if (m_Event = EVENT_Takeoff_Start) then
      F_Takeoff(SYS_Random(3));
    if (m_Event = EVENT_Activate_Landing_Cam) then
      F_Landing(SYS_Random(3));
    AI_WaitMilliSeconds(15);
  end;
end;

function F_Takeoff(select);
begin
  SF_CAM_TrackObj(Player);

    if (select = 0) then
      SF_CAM_SetFollowObj(Player, -25, -10, 40);
    if (select = 1) then
      SF_CAM_SetFollowObj(Player, -45, -5, 15);
    if (select = 2) then
      SF_CAM_SetFollowObj(Player, -10, 65, 25);

  SF_ActivateSelf(0);
  until (m_Event = EVENT_Takeoff_Complete) do
    AI_WaitSeconds(1);
  SF_CAM_TrackNothing;
  SF_DeactivateSelf(0);
end;

function F_Landing(select);
begin
  SF_CAM_HideDust;
  SF_CAM_TrackObj(NavD);
  SF_CAM_SetFollowObj(NavD, 0, 1, 0);
  SF_ActivateSelf(0);
  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(1);
  SF_CAM_TrackObj(Dauntless);

  if (select = 0) then
    SF_CAM_SetFollowObj(Dauntless, -200, 200, -350);
  if (select = 1) then
    SF_CAM_SetFollowObj(Dauntless, -50, 200, 500);
  if (select = 2) then
    SF_CAM_SetFollowObj(Dauntless, 400, 100, 300);

  until (m_Event = EVENT_Final_Approach) do
    AI_WaitMilliSeconds(5);
  SF_CAM_TrackObj(Player);

  select := SYS_Random(3);
  if (select = 0) then
    SF_CAM_SetFollowObj(Player, -3, 2, 15);
  if (select = 1) then
    SF_CAM_SetFollowObj(Player, 3, 4, -15);
  if (select = 2) then
    SF_CAM_SetFollowObj(Player, -9, 2, 5);

  AI_WaitSeconds(30);
end;

// Player stuff

function F_InitLanding;
begin
  SF_AutopilotDisable;
  m_Event := EVENT_Land_Player;
end;


function F_PlayerTakeoff;
begin
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x+15, y-25, z);
  SF_SetObjectFlag(OF_Collidable, false);
  AI_PLR_ControlAssume;
  AI_SetThrottle(0);
  AI_WaitSeconds(1);
  SF_ActivateSelf(0);
  AI_WaitSeconds(1);
  AI_SetThrottle(100);
  AI_WaitMilliSeconds(1500);
  M_Event := EVENT_Takeoff_Start;
  while (SF_GetDistance(Dauntless) < 500) do
    HCL_AI_GotoObjRelWorld_nonblock(Dauntless, 15, -20, 700);
  M_Event := EVENT_Takeoff_Complete;
  SF_SetObjectFlag(OF_Collidable, true);
  AI_PLR_ControlResume;
  SF_PlayerSwitchToCam(CamID_cockpit, Player);
end;


function F_PlayerLanding;
begin
  while (SF_GetDistance(Dauntless) > 300) do AI_WaitMilliSeconds(1);
  AI_PLR_ControlAssume;
  SF_SetObjectFlag(OF_Collidable, false);
  M_Event := EVENT_Activate_Landing_Cam;
  HCL_EmptyFuel;
  AI_SetThrottle(0);
  until (SF_GetVelocityObject(Player) < 5) do
    AI_WaitMilliSeconds(1);
  AI_SetThrottle(0);

  until (m_Event = EVENT_Dauntless_Ready) do
    AI_WaitMilliSeconds(500);

  // Teleport to position relative to Dauntless
  M_GetPos(Dauntless);
  SF_SetWorldPosition(x, y, z-350);
  AI_FaceObject(Dauntless);
  SF_SetWorldPosition(x, y-25, z-350);
  AI_SetThrottle(50);
  until (SF_GetDistance(Dauntless) < 50) do AI_WaitMilliSeconds(5);
  M_Event := EVENT_Final_Approach;
  SYS_PlaySFX(SFX_Engines_Power_Down);
  AI_WaitSeconds(3);
  AI_SetThrottle(0);
  AI_WaitSeconds(5);
  SF_Exit;
end;

// Dauntless stuff

function F_DauntlessLanding;
begin
  until (m_Event = EVENT_Activate_Landing_Cam) do AI_WaitMilliSeconds(1);
  if (SF_GetVelocityObject(Dauntless) > 0) then
  begin
    AI_SetThrottle(0);
    AI_WaitSeconds(5);
  end;

  // Teleport to position relative to NavD, face NavD
  M_GetPos(NavD);
  SF_SetWorldPosition(x, y, z+1000);
  AI_FaceObject(NavD);
  AI_WaitmilliSeconds(20);
  m_Event := EVENT_Dauntless_Ready;
  AI_WaitSeconds(25);
  SF_Exit;
end;
